olExtension.Service = {
    ApplicationRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Application request sent', 'Url: ' + requestContent.TabMember._internal.GetUrl());
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessApplicationRequest);
            var browserName_ = olData.BrowserName;
            var ajaxData_ = {
                ApplicationRequest: {
                    URL: requestContent.TabMember._internal.GetUrl(),
                    AppId: requestContent.Parameters.AppId,
                    WindowId: requestContent.TabMember.WindowId,
                    RequestType: 0,
                    WindowHandle: requestContent.TabMember.WindowHandle,
                    BrowserType: (browserName_ == olWrap.browser.name.edg ? 'chrome' : browserName_),
                    NewEdgeCompatibility: (browserName_ == olWrap.browser.name.edg)
                }
            };

            if (olExtension._internal.UsernameResolved) {
                ajaxData_.ApplicationRequest.Username = olExtension._internal.Username
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('ApplicationRequest', ajaxData_, requestContent, successFunction_);
            //This is like forcing another before navigate request so service responded flag must go to false
            requestContent.TabMember._internal.ExtensionFlags.ServiceResponded = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ApplicationRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DummyBeforeNavigateRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Dummy Before navigate request sent', 'Url: ' + requestContent.TabMember._internal.GetUrl());
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessDummyBeforeNavigateRequest);
            var browserName_ = olData.BrowserName;
            var ajaxData_ = {
                BeforeNavigateRequest: {
                    URL: requestContent.TabMember._internal.GetUrl(),
                    WindowId: requestContent.TabMember.WindowId,
                    SessionSetId: 1,
                    WindowHandle: requestContent.TabMember.WindowHandle,
                    BrowserType: browserName_
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('BeforeNavigateRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('DummyBeforeNavigateRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    BeforeNavigateRequestSend: function (requestContent, processRequestSuccess) {
        try {
            requestContent.TabMember._internal.ExtensionFlags.BeforeNavigateRequestSent = true;
            var alertContent_ = new olFunctions.AlertContent('API Before navigate request sent', 'Url: ' + requestContent.TabMember._internal.GetUrl());
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessBeforeNavigateRequest);
            var browserName_ = olData.BrowserName;
            var ajaxData_ = {
                BeforeNavigateRequest: {
                    URL: requestContent.TabMember._internal.GetUrl(),
                    WindowId: requestContent.TabMember.WindowId,
                    SessionSetId: 1,
                    WindowHandle: requestContent.TabMember.WindowHandle,
                    BrowserType: (browserName_ == olWrap.browser.name.edg ? 'chrome' : browserName_),
                    NewEdgeCompatibility: (browserName_ == olWrap.browser.name.edg)
                }
            };

            if (olExtension._internal.UsernameResolved) {
                ajaxData_.BeforeNavigateRequest.Username = olExtension._internal.Username
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('BeforeNavigateRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('BeforeNavigateRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    CheckMatterGlobalRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Check matter global request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessCheckMatterGlobalRequest);
            var ajaxData_ = {
                CheckMatterRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    LocalSearch: false,
                    MatterName: requestContent.Parameters.MatterName,
                    MatterNumber: requestContent.Parameters.MatterNumber,
                    PageNumber: requestContent.Parameters.PageNumber,
                    PageNumberSpecified: true
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('CheckMatterGlobalRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestSearchSharedUsersRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Request search shared users request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessRequestSearchSharedUsersRequestSend);
            var ajaxData_ = {
                RequestSearchSharedUsersRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    PageIndex: 1,
                    SearchText: requestContent.Parameters
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('CheckMatterGlobalRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    CheckMatterLocalRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Check matter local request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url)
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessCheckMatterLocalRequest);
            var ajaxData_ = {
                CheckMatterRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    LocalSearch: true,
                    MatterName: '',
                    MatterNumber: '',
                    PageNumber: 1
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('CheckMatterLocalRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterLocalRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ContinueSessionRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Continue session request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url)
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessContinueSessionRequest);

            var ajaxData_ = {
                ContinueSessionRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };

            //reset resource timeout start time because session is resumed
            var tabMembers_ = olExtension._internal.TabMember.Filter(null, null, null, requestContent.TabMember.ApplicationsSessionId);

            for (var i = 0; i < tabMembers_.length; i++) {
                tabMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime = null;
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('ContinueSessionRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ContinueSessionRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DeletePersonalDetailRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Delete personal detail request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessDeletePersonalDetailRequest);
            var ajaxData_ = {
                DeletePersonalDetail: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Id: requestContent.Parameters.Id
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('DeletePersonalDetail', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('DeletePersonalDetailRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    FormSubmitRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Form submit request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessFormSubmitRequest);
            var ajaxData_ = {
                FormSubmitRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('FormSubmitRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('FormSubmitRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    FormFilledSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Form filed sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessFormFilled);
            var ajaxData_ = {
                FormFilled: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    FormIndex: 0
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('FormSubmitRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('FormSubmitRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DocumentCompleteRequestSend: function (requestContent, processRequestSuccess) {
        try {
            if (!requestContent.TabMember._internal.ExtensionFlags.DocumentCompleteRequestSent) {
                requestContent.TabMember._internal.ExtensionFlags.DocumentCompleteRequestSent = true;

                var alertContent_ = new olFunctions.AlertContent('API Document complete request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessDocumentCompleteRequest);
                var ajaxData_ = {
                    DocumentCompleteRequest: {
                        WindowTitle: requestContent.TabMember.DocumentTitle,
                        ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                        Ignore: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].Ignore,
                        TurnAway: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAway,
                        TurnAwaySpecified: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAwaySpecified
                    }
                };
                var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('DocumentCompleteRequest', ajaxData_, requestContent, successFunction_);
                olExtension.Service._internal.SendRequest(sendRequestParams_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('DocumentCompleteRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestGetSharedUsersRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Request get shared users request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessRequestGetSharedUsersRequest);
            var ajaxData_ = {
                RequestGetSharedUsersRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    PageIndex: requestContent.Parameters.pageIndex
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('RequestGetSharedUsersRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('RequestGetSharedUsersRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GetSharedPasswordsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Get shared passwords request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessGetSharedPasswordsRequest);
            var ajaxData_ = {
                GetSharedPasswordsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    UserName: requestContent.Parameters.UserName,
                    PasswordDetailsUserId: requestContent.Parameters.UserId
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('GetSharedPasswordsRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetSharedPasswordsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GetLocalPersonalCodeListRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var bnr0_ = requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0];

            if (bnr0_.RequestPersonalCode && !requestContent.TabMember._internal.ExtensionFlags.PersonalCodeFilled) {
                var alertContent_ = new olFunctions.AlertContent('API Get local personal code list request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessGetLocalPersonalCodeListRequest);

                var ajaxData_ = {
                    GetLocalPersonalCodeListRequest: {
                        ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                    }
                };
                var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('GetLocalPersonalCodeListRequestSend', ajaxData_, requestContent, successFunction_);

                olExtension.Service._internal.SendRequest(sendRequestParams_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } else {
                requestContent.TabMember._internal.ExtensionFlags.PersonalCodeFilled = true;
            }

        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetLocalPersonalCodeListRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    LanguageItemsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Language items request sent', 'Sent by extension');
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessLanguageItemsRequest);
            var ajaxData_ = {
                LanguageItems: {}
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('LanguageItemsRequestSend', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('LanguageItemsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ExtensionOptionsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Extension options request sent', 'Sent by extension');
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessExtensionOptionsRequestSend);
            var ajaxData_ = {
                ExtensionOptions: {}
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('ExtensionOptionsRequestSend', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ExtensionOptionsRequestSend ', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ExtensionStatisticsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Extension statistics request sent', 'Sent by extension');
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessExtensionStatisticsRequestSend);
            var ajaxData_ = {
                ExtensionStatistics: {
                    TimeOfObservationInMins: olOptions.DebugStatisticsPeriod(),
                    Transactions: olData._DebugStatistics.Transactions,
                    Summary: olData._DebugStatistics.Summary
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('ExtensionStatisticsRequestSend', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ExtensionOptionsRequestSend ', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UsernameRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Username request sent', 'Sent by extension');
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessUsernameRequest);
            var ajaxData_ = {
                UsernameRequest: {}
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('UsernameRequestSend', ajaxData_, requestContent, successFunction_);

            sendRequestParams_.AjaxParam.Async = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('UsernameRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    LogoutCompletedRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Logout completed request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessLogoutCompletedRequest);
            var ajaxData_ = {
                LogoutCompleted: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('LogoutCompletedRequestSend', ajaxData_, requestContent, successFunction_);

            sendRequestParams_.AjaxParam.Async = false;
            sendRequestParams_.AjaxParam.Timeout = 100000;

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('LogoutCompletedRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    LogoutWindowRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Logout window request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessLogoutWindowRequest);
            var ajaxData_ = {
                //TODO check why new guid
                LogoutWindowRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    WindowHandle: olWrap.Functions.Guid()
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('LogoutWindowRequestSend', ajaxData_, requestContent, successFunction_);

            sendRequestParams_.AjaxParam.Async = false;
            sendRequestParams_.AjaxParam.Timeout = 100000;

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('LogoutWindowRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    MainWindowClosingRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Main window closing request sent', 'WindowHandle: ' + olExtension.Data.WindowHandle);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessMainWindowClosingRequest);
            var ajaxData_ = {
                MainWindowClosingRequest: {
                    WindowHandle: olExtension.Data.WindowHandle
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('MainWindowClosingRequest', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('MainWindowClosingRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    NavigateCompleteRequestSend: function (requestContent, processRequestSuccess) {
        try {
            if (!requestContent.TabMember._internal.ExtensionFlags.NavigateCompleteRequestSent) {
                requestContent.TabMember._internal.ExtensionFlags.NavigateCompleteRequestSent = true;
                var alertContent_ = new olFunctions.AlertContent('API Navigate complete request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessNavigateCompleteRequest);
                var browserName_ = olData.BrowserName;
                var ajaxData_ = {
                    NavigateCompleteRequest: {
                        URL: requestContent.TabMember.PageInfo.Url,
                        ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                        WindowId: requestContent.TabMember.WindowId,
                        SessionSetId: 1,
                        WindowHandle: requestContent.TabMember.WindowHandle,
                        RecordPageInfoSpecified: false,
                        BrowserType: (browserName_ == olWrap.browser.name.edg ? 'chrome' : browserName_),
                        NewEdgeCompatibility: (browserName_ == olWrap.browser.name.edg)
                    }
                };

                if (olExtension._internal.UsernameResolved) {
                    ajaxData_.NavigateCompleteRequest.Username = olExtension._internal.Username
                }

                var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('NavigateCompleteRequest', ajaxData_, requestContent, successFunction_);
                olExtension.Service._internal.SendRequest(sendRequestParams_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('NavigateCompleteRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    NewWindowRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API New window request sent', 'WindowId: ' + requestContent.TabMember.WindowId);

            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessNewWindowRequest);
            var ajaxData_ = {
                NewWindowRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Ignore: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].Ignore,
                    SessionSetId: 1,
                    TurnAway: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAway,
                    NewWindowURL: '',
                    ParentWindowHandle: requestContent.TabMember.WindowHandle
                }
            };

            if (olExtension._internal.UsernameResolved) {
                ajaxData_.NewWindowRequest.Username = olExtension._internal.Username
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('NewWindowRequest', ajaxData_, requestContent, successFunction_);

            sendRequestParams_.AjaxParam.Async = false;
            sendRequestParams_.AjaxParam.Timeout = 100000;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('NewWindowRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PersonalDetailsChosenRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Personal details chosen request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessPersonalDetailsChosenRequest);
            var ajaxData_ = {
                PersonalDetailsChosen: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('PersonalDetailsChosenRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('PersonalDetailsChosenRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PulseRequestSend: function (requestContent, processRequestSuccess) {
        try {
            if (olFunctions.IsFilledArray(olData.TabInfoArray.TabMembers)) {
                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, requestContent, null, null);
                if (olFunctions.IsFilledArray(tabMembers_)) {
                    for (var i = 0; i < tabMembers_.length; i++) {
                        var alertContent_ = new olFunctions.AlertContent('API Pulse request sent', 'App: ' + tabMembers_[i].ApplicationName);
                        var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessPulseRequest);
                        var ajaxData_ = {
                            PulseRequest: {
                                WindowId: tabMembers_[i].WindowId
                            }
                        };
                        var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('PulseRequestSend', ajaxData_, requestContent, successFunction_);

                        olExtension.Service._internal.SendRequest(sendRequestParams_);

                        if (!olOptions.DevelopmentVersion()) {
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        }
                    }
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('PulseRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetPersonalDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set personal details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetPersonalDetailsRequest);
            var ajaxData_ = {
                SetPersonalDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Details: requestContent.Parameters.Details,
                    New: requestContent.Parameters.New,
                    Id: requestContent.Parameters.Id,
                    InitialRequestSpecified: requestContent.Parameters.InitialRequestSpecified
                }
            };

            if (requestContent.Parameters.InitialRequestSpecified) {
                ajaxData_.SetPersonalDetailsRequest.InitialRequest = requestContent.Parameters.InitialRequest;
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetPersonalDetailsRequest', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommonDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set common details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetCommonDetailsRequest);
            var ajaxData_ = {
                SetCommonDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    InitialRequestSpecified: requestContent.Parameters.InitialRequestSpecified,
                    Variable: requestContent.Parameters.Variable
                }
            };

            if (requestContent.Parameters.InitialRequestSpecified) {
                ajaxData_.SetCommonDetailsRequest.InitialRequest = requestContent.Parameters.InitialRequest;
            }

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetCommonDetailsRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set comment request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetCommentRequest);
            var ajaxData_ = {
                SetCommentRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Comment: requestContent.Parameters.Comment,
                    PredefinedComment: requestContent.Parameters.PredefinedComment
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetCommentRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCommentRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentEditRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set comment edit request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetCommentEditRequest);
            var ajaxData_ = {
                SetCommmentEditRequest: {
                    CurrentApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    MatterName: requestContent.Parameters.MatterName,
                    MatterNumber: requestContent.Parameters.MatterNumber,
                    PersonalCode: requestContent.Parameters.PersonalCode,
                    Comment: requestContent.Parameters.Comment,
                    PredefinedComment: requestContent.Parameters.PredefinedComment
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetCommentEditRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCommentEditRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentPersonalDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set current personal details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetCurrentPersonalDetailsRequest);
            var ajaxData_ = {
                SetCurrentPersonalDetails: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Id: requestContent.Parameters.Id,
                    PersonalDetail: [requestContent.Parameters.Details],
                    Shared: requestContent.Parameters.Shared ? requestContent.Parameters.Shared : false
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetCurrentPersonalDetailsRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentSharedPasswordRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set current shared password request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetCurrentSharedPasswordRequest);
            var ajaxData_ = {
                SetCurrentSharedPasswordRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    UserId: requestContent.Parameters.UserId,
                    UserName: requestContent.Parameters.UserName,
                    PersonalDetail: [requestContent.Parameters.Details]
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetCurrentPersonalDetailsRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentSharedPasswordRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UnSetCurrentSharedPasswordRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Unset current personal details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessUnSetCurrentSharedPasswordRequest);
            var ajaxData_ = {
                UnSetCurrentSharedPasswordRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('UnSetCurrentPersonalDetailsRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('UnSetCurrentPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetTempPersonalDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set temp personal details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetTempPersonalDetailsRequest);
            var ajaxData_ = {
                SetTempPersonalDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Id: requestContent.Parameters.Id,
                    Details: {
                        Name: requestContent.Parameters.Details.Name,
                        Variables: requestContent.Parameters.Details.Variables
                    }
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetTempPersonalDetailsRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetTempPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    TempRecordDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Temp record details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessTempRecordDetailsRequest);
            var ajaxData_ = {
                TempRecordDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Id: requestContent.Parameters.Id,
                    Details: {
                        Name: requestContent.Parameters.Details.Name,
                        Variables: requestContent.Parameters.Details.Variables
                    }
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('TempRecordDetailsRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('TempRecordDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipMatterDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Skip matter details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSkipMatterDetailsRequest);
            var ajaxData_ = {
                SkipMatterDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SkipMatterDetailsRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SkipMatterDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipPersonalDetailsChosenRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Skip personal details chosen request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSkipPersonalDetailsChosenRequest);
            var ajaxData_ = {
                SkipPersonalDetailsChosen: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SkipPersonalDetailsChosenRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsChosenRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipPersonalDetailsRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Skip personal details request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSkipPersonalDetailsRequest);
            var ajaxData_ = {
                SkipPersonalDetailsRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SkipPersonalDetailsRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    StorePasswordRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Store password request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessStorePassword);
            var ajaxData_ = {
                StorePassword: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Store: requestContent.Parameters.Store,
                    NeverStore: requestContent.Parameters.NeverStore,
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('StorePasswordRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    StorePasswordSharedRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Store password shared request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessStorePasswordShared);
            var ajaxData_ = {
                StorePasswordShared: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Store: requestContent.Parameters.Store
                }
            };

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('StorePasswordRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('StorePasswordSharedRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ValidateSelectedMatterRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Validate selected matter request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessValidateSelectedMatterRequest);

            var ajaxData_ = {
                ValidateMatterRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Comment: requestContent.Parameters.Comment,
                    MatterName: requestContent.Parameters.MatterName,
                    MatterNumber: requestContent.Parameters.MatterNumber,
                    PersonalCode: requestContent.Parameters.PersonalCode,
                    PredefinedComment: requestContent.Parameters.PredefinedComment,
                    RequestNewSession: requestContent.Parameters.RequestNewSession,
                    RequestNewSessionSpecified: requestContent.Parameters.RequestNewSessionSpecified
                }
            };

            if (requestContent.withoutResponse) {
                var requestResult = {
                    ValidateMatterResponse: {
                        ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                        MatterUpdateNewSession: false,
                        RequiresCommentSpecified: false,
                        StartTime: new Date(),
                        StartTimeSpecified: true,
                        ValidPersonalIDSpecified: false,
                        Validated: true,
                        ValidatedSpecified: true,
                        PersonalCodeForSite: null
                    }
                }
                successFunction_(requestResult, requestContent);
                successFunction_ = null;
            }
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('ValidateMatterRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ValidateSelectedMatterRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    WindowClosingRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Window closing request sent', 'WindowId: ' + requestContent.TabMember.WindowId);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessWindowClosingRequest);
            var ajaxData_ = {
                WindowClosingRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Ignore: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].Ignore,
                    TurnAway: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAway,
                    WindowId: requestContent.TabMember.WindowId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('WindowClosingRequest', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            sendRequestParams_.AjaxParam.Timeout = 100000;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('WindowClosingRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    QuittingResourceSessionRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Quitting resource session request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessQuittingResourceSessionRequest);
            var ajaxData_ = {
                QuittingResourceSession: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('QuittingResourceSession', ajaxData_, requestContent, successFunction_);
            sendRequestParams_.AjaxParam.Async = false;
            sendRequestParams_.AjaxParam.Timeout = 100000;
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('QuittingResourceSessionRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    //Analysis service requests
    SetFeaturesRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set features request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetFeaturesRequest);

            var ajaxData_ = {
                SetFeaturesRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    Features: []
                }
            };

            ajaxData_.SetFeaturesRequest.Features = requestContent.Parameters.Features;
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetFeaturesRequest', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetFeaturesRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestFeatureRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Request feature request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessRequestFeatureRequest);
            var ajaxData_ = {
                RequestFeature: {
                    Item: requestContent.TabMember.ApplicationsSessionId,
                    Label: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].Ignore,
                    UID: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAway
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('RequestFeatureRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('RequestFeatureRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestFeatureItemRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Request feature item request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessRequestFeatureItemRequest);
            var ajaxData_ = {
                RequestFeatureItem: {
                    IsCost: requestContent.TabMember.ApplicationsSessionId,
                    IsUnique: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].Ignore,
                    Label: requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].TurnAway,
                    Value: requestContent.TabMember.WindowId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('RequestFeatureItemRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('RequestFeatureItemRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetAnalysisRequest: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Set analysis request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessSetAnalysisRequest);
            var ajaxData_ = {
                SetAnalysisRequest: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId,
                    RequestAnalysisControlItems: [JSON.parse(requestContent.Parameters)]
                }
            };

            var alertContent_ = new olFunctions.AlertContent('Analysis values', requestContent.Parameters);
            olFunctions.Alert(olOptions.DebugAnalysis(), alertContent_, 'default');

            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('SetAnalysisRequestSend', ajaxData_, requestContent, successFunction_);

            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetAnalysisRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    //WebControl service requests
    StartMessageSeenRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Start message seen request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessStartMessageSeenRequest);
            var ajaxData_ = {
                StartMessageSeen: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('StartMessageSeenRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('StartMessageSeenRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    HideStartMessageRequestSend: function (requestContent, processRequestSuccess) {
        try {
            var alertContent_ = new olFunctions.AlertContent('API Hide start message request sent', 'Url: ' + requestContent.TabMember.PageInfo.Url);
            var successFunction_ = olExtension.Service._internal.SetSuccessFunction(processRequestSuccess, olExtension.Service._internal.SuccessHideStartMessageRequest);
            var ajaxData_ = {
                HideStartMessage: {
                    ApplicationSessionId: requestContent.TabMember.ApplicationsSessionId
                }
            };
            var sendRequestParams_ = new olExtension.DataConstructors.SendRequestParameters('HideStartMessageRequestSend', ajaxData_, requestContent, successFunction_);
            olExtension.Service._internal.SendRequest(sendRequestParams_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('HideStartMessageRequestSend', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _internal: {
        HandleLogoutForExistingTabMembers: function (tabMember) {
            try {
                //handle resource end for existing tabMembers with different app session id
                var filterMembers_ = olExtension._internal.TabMember.Filter(tabMember.WindowHandle, tabMember.TabId, null, null);
                if (olFunctions.IsFilledArray(filterMembers_)) {
                    for (var i = 0; i < filterMembers_.length; i++) {
                        if (tabMember.ApplicationsSessionId) {
                            if (tabMember.ApplicationsSessionId != filterMembers_[i].ApplicationsSessionId) {
                                olExtension._internal.TabMember.HandleResourceEnd(filterMembers_[i]);
                            }
                        } else {
                            olExtension._internal.TabMember.HandleResourceEnd(filterMembers_[i]);
                        }
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('HandleLogoutForExistingTabMembers', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SetSuccessFunction: function (processRequestSuccess, successFunction) {
            if (typeof (processRequestSuccess) === 'undefined')
                processRequestSuccess = true;
            if (processRequestSuccess) {
                return successFunction;
            } else {
                return null;
            }
        },
        _SendRequestSuccess: function (sendRequestParameters, requestResult) {
            try {
                if (requestResult && requestResult.ErrorState) {
                    var alertErrorContent_ = new olFunctions.AlertContent(sendRequestParameters.RequestName + ' Error', 'ErrorId: ' + requestResult.ErrorState.ErrorId);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');

                    if (sendRequestParameters.RequestContent.TabMember) {
                        if (sendRequestParameters.RequestName == 'BeforeNavigateRequest' || sendRequestParameters.RequestName == 'NavigateCompleteRequest' || sendRequestParameters.RequestName == 'PulseRequestSend') {
                            if (!sendRequestParameters.RequestContent.TabMember.ApplicationsSessionId) {
                                olExtension._internal.TabMember.Remove(sendRequestParameters.RequestContent.TabMember);
                            }
                        } else {
                            sendRequestParameters.RequestContent.TabMember._internal.ExtensionFlags.ErrorState = true;
                            sendRequestParameters.RequestContent.TabMember._internal.ExtensionFlags.ServiceResponded = true;
                            olExtension._internal.TabMember.RemoveOnErrorState(sendRequestParameters.RequestContent.TabMember);
                        }
                    }
                } else {
                    if (sendRequestParameters.RequestName == 'LanguageItemsRequestSend') {
                        //after success of LanguageItemsRequestSend reset counter
                        olExtension.Service._internal._sendRequestLanguageItemsFailedCounter == 0;
                        olExtension.Service._internal._AppInitSomethingWentWrong = false;
                    }
                    olExtension.Messages._errorState = false;
                    if (sendRequestParameters.RequestSuccessFunction) {
                        sendRequestParameters.RequestSuccessFunction(requestResult, sendRequestParameters.RequestContent);
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_SendRequestSuccess', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _LanguageItemsResolved: false,
        _sendRequestLanguageItemsFailedCounter: 0,
        _AppInitSomethingWentWrong: false,
        _SendRequestError: function (sendRequestParameters, error) {
            try {
                var alertErrorContent_ = new olFunctions.AlertContent(sendRequestParameters.RequestName + ' server response error: ' + error.statusText);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');

                if (sendRequestParameters.RequestName == 'LanguageItemsRequestSend') {
                    // Try only 10 times, if it dosent pass for 10 times it is most likely client is not installed and it will slow down computer where extension is installed
                    //https://henchman.atlassian.net/browse/ON-2280
                    if (olExtension.Service._internal._sendRequestLanguageItemsFailedCounter < 10) {
                        // no language items, send in 5 second
                        setTimeout(function () {
                            olExtension.Service._internal.SendRequest(sendRequestParameters);
                        }, 5000);
                        olExtension.Service._internal._sendRequestLanguageItemsFailedCounter++;
                    } else {
                        olExtension.Service._internal._AppInitSomethingWentWrong = true;
                        var alertErrorContent_ = new olFunctions.AlertContent('Client service seems not to be installed, contact your administrator!');
                        olFunctions.Alert(true, alertErrorContent_, 'error');

                    }
                } else {
                    if (sendRequestParameters.RequestContent.TabMember) {
                        if (error.status == 0) {
                            // timeout error
                            sendRequestParameters.RequestContent.TabMember._internal.ExtensionFlags.ServiceResponded = true;
                        }
                        if (sendRequestParameters.RequestName == 'BeforeNavigateRequest' || sendRequestParameters.RequestName == 'NavigateCompleteRequest' || sendRequestParameters.RequestName == 'PulseRequestSend') {
                            if (!sendRequestParameters.RequestContent.TabMember.ApplicationsSessionId) {
                                olExtension._internal.TabMember.Remove(sendRequestParameters.RequestContent.TabMember);
                            }
                        } else {
                            sendRequestParameters.RequestContent.TabMember._internal.ExtensionFlags.ErrorState = true;
                            sendRequestParameters.RequestContent.TabMember._internal.ExtensionFlags.ServiceResponded = true;
                            olExtension._internal.TabMember.RemoveOnErrorState(sendRequestParameters.RequestContent.TabMember);

                            var messageContent_ = new olExtension.DataConstructors.MessageContent(sendRequestParameters.RequestContent.TabMember);
                            olExtension.Messages.Error(messageContent_);
                        }
                    }
                }
            }
            catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_SendRequestError', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        appInitSomethingWentWrong_: null,
        _SendRequest: async function (sendRequestParameters) {
            if (sendRequestParameters.RequestName == 'UsernameRequestSend') {
                olExtension.Data.NativeChromePort.onMessage.addListener(function handleOnelogServiceRequest2(requestResult) {
                    clearTimeout(olExtension.Service._internal.appInitSomethingWentWrong_);
                    olExtension.Service._internal._AppInitSomethingWentWrong = false;

                    olExtension.Data.NativeChromePort.onMessage.removeListener(handleOnelogServiceRequest2);
                    olExtension.Service._internal._SendRequestSuccess(sendRequestParameters, requestResult);
                });
                // Backward compatibility with server version 9
                setTimeout(function () {
                    olExtension._internal.UsernameResolved = true;
                }, 1000)

                olExtension.Service._internal.appInitSomethingWentWrong_ = setTimeout(function () {
                    clearTimeout(olExtension.Service._internal.appInitSomethingWentWrong_);
                    olExtension.Service._internal._AppInitSomethingWentWrong = true;

                    var alertErrorContent_ = new olFunctions.AlertContent('Terminal service problem, contact your administrator!');
                    olFunctions.Alert(true, alertErrorContent_, 'error');
                }, 30000)

                try {
                    olExtension.Data.NativeChromePort.postMessage(sendRequestParameters.AjaxParam.Data);
                } catch (error) {
                    var alertErrorContent_ = new olFunctions.AlertContent('_SendRequest postMessage, contact your administrator!');
                    olFunctions.Alert(true, alertErrorContent_, 'error');
                }
            } else {
                olExtension.Service._internal._SendRequestFetch(sendRequestParameters, JSON.stringify(sendRequestParameters.AjaxParam.Data))
                    .then((data) => {
                        olExtension.Service._internal._SendRequestSuccess(sendRequestParameters, data);
                    })
                    .catch(err => {
                        olExtension.Service._internal._SendRequestError(sendRequestParameters, err);
                    });
            }
        },
        _SendRequestFetch: async function (sendRequestParameters) {
            const response = await fetch(olOptions.General.Extension.ServerUrl(), {
                method: sendRequestParameters.AjaxParam.Type,
                cache: 'no-cache',
                timeout: sendRequestParameters.AjaxParam.Timeout,
                headers: {
                    'Content-Type': 'application/json'
                },
                body: JSON.stringify(sendRequestParameters.AjaxParam.Data) // body data type must match "Content-Type" header
            });
            return response.json();
        },
        _DelayRequest: function (sendRequestParameters) {
            var alertErrorContent_ = new olFunctions.AlertContent('Error! ' + sendRequestParameters.RequestName + ' not sent. App waiting on initialization. Sending again in 1sec!');
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');

            if (!olExtension.Service._internal._AppInitSomethingWentWrong) {
                var sendRequestParameters_ = sendRequestParameters;
                setTimeout(function () {
                    olExtension.Service._internal.SendRequest(sendRequestParameters_);
                }, 1000);
            }
        },
        SendRequest: function (sendRequestParameters) {
            // this is main request sending function that gets info ONLY from locally installed service app
            try {
                if (
                    sendRequestParameters.RequestName == 'UsernameRequestSend' ||
                    sendRequestParameters.RequestName == 'LanguageItemsRequestSend' ||
                    sendRequestParameters.RequestName == 'ExtensionOptionsRequestSend'
                ) {
                    olExtension.Service._internal._SendRequest(sendRequestParameters);
                } else if (olExtension._internal.LanguageItemsResolved) {
                    switch (olExtension.Version) {
                        case 'TerminalServer':
                            if (olWrap.browser.getName() == olWrap.browser.name.chrome && !olExtension._internal.UsernameResolved) {
                                olExtension.Service._internal._DelayRequest(sendRequestParameters);
                            } else {
                                olExtension.Service._internal._SendRequest(sendRequestParameters);
                            }
                            break;
                        default:
                            olExtension.Service._internal._SendRequest(sendRequestParameters);
                            break;
                    }
                }
                //TODO ???????????????????????????????????????????????????????? Should we comment this?
                else {
                    olExtension.Service._internal._DelayRequest(sendRequestParameters);
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SendRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SortMatterDetails: function (requestResult, requestContent) {
            try {
                //sort matter numbers
                var matterDetails_ = requestContent.TabMember.PageInfo.Response.CheckMatterResponse.MatterDetails;
                var matterDetail_;
                var matterIndex_ = -1;
                for (var i = 0; i < matterDetails_.length; i++) {
                    if (matterDetails_[i].MatterNumber == requestContent.Parameters.MatterNumber) {
                        matterIndex_ = i;
                        break;
                    }
                }

                if (matterIndex_ > -1) {
                    matterDetail_ = matterDetails_.splice(matterIndex_, 1)[0];
                } else {
                    matterDetail_ = {
                        MatterName: '',
                        MatterNumber: requestContent.Parameters.MatterNumber
                    };
                }

                if (requestResult.ValidateMatterResponse.ValidatedSpecified && requestResult.ValidateMatterResponse.Validated) {
                    matterDetails_.reverse();
                    matterDetails_.push(matterDetail_);
                    matterDetails_.reverse();
                    while (matterDetails_.length > 10) {
                        matterDetails_.pop();
                    }
                }

                //sort Timekeeper Numbers
                if (requestContent.TabMember._internal.PageFlags.PersonalCodeNeeded) {
                    var timekeeper_ = requestContent.Parameters.PersonalCode;
                    var localPersonalCodes_ = requestContent.TabMember.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes;
                    if (olFunctions.IsFilledArray(localPersonalCodes_)) {
                        var personalCodeIndex_ = -1;
                        for (i = 0; i < localPersonalCodes_.length; i++) {
                            if (localPersonalCodes_[i] == timekeeper_) {
                                personalCodeIndex_ = i;
                                break;
                            }
                        }

                        if (personalCodeIndex_ > -1) {
                            localPersonalCodes_.splice(personalCodeIndex_, 1)[0];
                        }

                        if (requestResult.ValidateMatterResponse.ValidatedSpecified && requestResult.ValidateMatterResponse.Validated) {
                            localPersonalCodes_.reverse();
                            localPersonalCodes_.push(timekeeper_);
                            localPersonalCodes_.reverse();
                            while (localPersonalCodes_.length > 10) {
                                localPersonalCodes_.pop();
                            }
                        }
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SortMatterDetails', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessApplicationRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Application request succeeded', 'Url: ' + requestContent.TabMember._internal.GetUrl());
                requestResult.BeforeNavigateResponses[0].ApplicationName = requestContent.Parameters.ApplicationName;

                olExtension.Service._internal.SuccessBeforeNavigateRequest(requestResult, requestContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessApplicationRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessDummyBeforeNavigateRequest: function (requestResult, requestContent) {
            try {
                if (requestResult && requestResult.BeforeNavigateResponses && requestResult.BeforeNavigateResponses[0] && requestResult.BeforeNavigateResponses[0].AppIdSpecified) {
                    //Update StartTime and PauseDuration
                    var bnr0_ = requestResult.BeforeNavigateResponses[0];
                    var alertContent_ = new olFunctions.AlertContent('API Success Dummy Before navigate request succeeded', 'App: ' + requestContent.TabMember.ApplicationName + '\nStart time: ' + bnr0_.StartTime + '\nPauseDuration: ' + bnr0_.PauseDuration);
                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                    if (requestContent.TabMember.PageInfo.Response) {
                        if (!requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses) {
                            requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses = [];
                            requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses.push(bnr0_);
                        }

                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].StartTime = bnr0_.StartTime;
                        //and send pause duration
                        if (!(bnr0_.PauseDuration && bnr0_.PauseDuration > 0)) {
                            bnr0_.PauseDuration = 0;
                        }

                        //Change state of InOfflineMode
                        if (bnr0_.InOfflineModeSpecified) {
                            requestContent.TabMember._internal.PageFlags.InOfflineMode = bnr0_.InOfflineMode;
                        }

                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = bnr0_.PauseDuration;
                        var messageContent1_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                        olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent1_);

                        //sending NavigateCompleteRequest
                        var requestContent1_ = new olExtension.DataConstructors.RequestContent(requestContent.TabMember);
                        olExtension.Service.NavigateCompleteRequestSend(requestContent1_);
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessDummyBeforeNavigateRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _sbnCreateDefinedNames: function (tabMember, requestResult) {
            try {
                var bnr0_ = requestResult.BeforeNavigateResponses[0];
                var usernameArray_ = [];
                var passwordArray_ = [];
                var matterArray_ = ['matter'];
                var customArray_ = [];
                var timeKeeperArray_ = ['time keeper', 'timekeeper'];
                var commentArray_ = ['comment'];
                var currentForm_;
                if (bnr0_) {
                    if (bnr0_.Forms == null) {
                        bnr0_.Forms = [];
                    }
                    // if automatic or collect login type check change pass form
                    if (bnr0_.PasswordManagementTypeSpecified && bnr0_.PasswordManagementType == 2 && bnr0_.ChangePassword && olFunctions.IsFilledArray(bnr0_.ChangePassword)) {
                        for (var a = 0; a < bnr0_.ChangePassword.length; a++) {
                            bnr0_.Forms.push(bnr0_.ChangePassword[a]);
                        }
                    }
                    if (bnr0_.Forms && olFunctions.IsFilledArray(bnr0_.Forms)) {
                        for (var p = 0; p < bnr0_.Forms.length; p++) {
                            currentForm_ = bnr0_.Forms[p];
                            var currentElement_;
                            for (var o = 0; o < currentForm_.Elements.length; o++) {
                                currentElement_ = currentForm_.Elements[o];

                                if (currentElement_.DefinedName) {
                                    switch (currentElement_.Type) {
                                        case 0:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, usernameArray_) == -1) {
                                                usernameArray_.push(String(currentElement_.DefinedName));
                                            }
                                            break;
                                        case 1:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, passwordArray_) == -1) {
                                                passwordArray_.push(String(currentElement_.DefinedName));
                                            }

                                            break;
                                        case 2:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, matterArray_) == -1) {
                                                matterArray_.push(String(currentElement_.DefinedName));
                                            }
                                            break;
                                        case 3:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, customArray_) == -1) {
                                                customArray_.push(String(currentElement_.DefinedName));
                                            }
                                            break;
                                        case 4:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, timeKeeperArray_) == -1) {
                                                timeKeeperArray_.push(String(currentElement_.DefinedName));
                                            }
                                            break;
                                        case 5:
                                            if (ol$Functions.inArray(currentElement_.DefinedName, commentArray_) == -1) {
                                                commentArray_.push(String(currentElement_.DefinedName));
                                            }
                                            break;
                                    }
                                }
                            }
                        }
                        // username and password are filled only if there are forms
                        tabMember.PageInfo.DefinedNames.UsernameArray = usernameArray_;
                        tabMember.PageInfo.DefinedNames.PasswordArray = passwordArray_;
                    }
                    // matter, custom, timekeeper and comment are filled always
                    tabMember.PageInfo.DefinedNames.MatterArray = matterArray_;
                    tabMember.PageInfo.DefinedNames.CustomArray = customArray_;
                    tabMember.PageInfo.DefinedNames.TimeKeeperArray = timeKeeperArray_;
                    tabMember.PageInfo.DefinedNames.CommentArray = commentArray_;
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_sbnCreateDefinedNames', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _sbnSetInternalData: function (tabMember, requestResult) {
            try {
                //Service responded FIRST LINE
                tabMember._internal.ExtensionFlags.ServiceResponded = true;

                //we have all that we need for new tab member, just to check if it is hash event
                if (tabMember.PageInfo.Response.BeforeNavigateResponses == null || tabMember.PageInfo.Response.BeforeNavigateResponses[0] == null || !tabMember.PageInfo.Response.BeforeNavigateResponses[0].AppIdSpecified) {
                    // this is new tab member
                    tabMember.PageInfo.Response.BeforeNavigateResponses = requestResult.BeforeNavigateResponses;
                }

                if (tabMember.PageInfo.Response.BeforeNavigateResponses != null) {
                    tabMember.PageInfo.LanguageItemsLabels = {};

                    for (var i = 0; i < olData.LanguageItems.length; i++) {
                        tabMember.PageInfo.LanguageItemsLabels[olData.LanguageItems[i].Key] = olData.LanguageItems[i].Value;
                    }

                    var bnr0_ = requestResult.BeforeNavigateResponses[0];
                    tabMember.ApplicationsSessionId = bnr0_.ApplicationsSessionId;

                    //Check application name
                    if (bnr0_.ApplicationName && bnr0_.ApplicationName != null) {
                        tabMember.ApplicationName = bnr0_.ApplicationName;
                    }

                    //LicenceLimitReached
                    if (bnr0_.LicenceLimitReachedSpecified) {
                        tabMember._internal.PageFlags.LicenceLimitReachedNeeded = bnr0_.LicenceLimitReached;
                    }

                    //PooledDetailsLimitReached
                    if (bnr0_.PooledDetailsLimitReachedSpecified) {
                        tabMember._internal.PageFlags.PooledDetailsLimitReachedNeeded = bnr0_.PooledDetailsLimitReached;
                    }

                    //Matter format
                    if (bnr0_.MatterFormat) {
                        tabMember._internal.PageFlags.MatterFormat = bnr0_.MatterFormat;
                    }

                    //Matter free input
                    if (bnr0_.MatterFreeInput) {
                        tabMember._internal.PageFlags.MatterFreeInput = bnr0_.MatterFreeInput;
                    }

                    //Matter use in script
                    if (bnr0_.UseMatterInScript) {
                        tabMember._internal.PageFlags.UseMatterInScript = bnr0_.UseMatterInScript;
                    }

                    //In offline mode
                    if (bnr0_.InOfflineModeSpecified) {
                        tabMember._internal.PageFlags.InOfflineMode = bnr0_.InOfflineMode;
                    }

                    //Logon details
                    if (bnr0_.LogonDetailsFreeInputSpecified) {
                        tabMember._internal.PageFlags.LogonDetailsFreeInput = bnr0_.LogonDetailsFreeInput;
                    }

                    //Matter details if filled in set matter done to true!
                    if (bnr0_.MatterDetails && bnr0_.MatterDetails.MatterNumber) {
                        tabMember._internal.PageFlags.MatterDone = true;
                    }

                    //Unauthorised access
                    if (bnr0_.UnauthorisedSpecified) {
                        tabMember._internal.PageFlags.Unauthorised = bnr0_.Unauthorised;
                        if (bnr0_.Unauthorised) {
                            //if Unauthorised access ALWAYS let free input on logn fields and matter fileds, ignore bnr value
                            tabMember._internal.PageFlags.LogonDetailsFreeInput = true;
                            tabMember._internal.PageFlags.MatterFreeInput = true;
                        }
                    }

                    //LoginType
                    try {
                        tabMember._internal.PageFlags.PmtUser = bnr0_.PasswordManagementTypeSpecified && bnr0_.PasswordManagementType == 0;
                        tabMember._internal.PageFlags.PmtAdmin = bnr0_.PasswordManagementTypeSpecified && bnr0_.PasswordManagementType == 1;
                        tabMember._internal.PageFlags.PmtAutomatic = (bnr0_.PasswordManagementTypeSpecified && bnr0_.PasswordManagementType == 2);
                        tabMember._internal.PageFlags.PassDetailsToSite = (!tabMember._internal.PageFlags.PmtAutomatic || (bnr0_.PassDetailsToSiteSpecified && bnr0_.PassDetailsToSite));

                        if (tabMember._internal.PageFlags.PmtUser) {
                            tabMember._internal.PageFlags.LoginType = 'User';
                        } else if (tabMember._internal.PageFlags.PmtAdmin) {
                            tabMember._internal.PageFlags.LoginType = 'Admin';
                        } else {
                            if (tabMember._internal.PageFlags.PmtAutomatic && tabMember._internal.PageFlags.PassDetailsToSite) {
                                tabMember._internal.PageFlags.LoginType = 'Automatic';
                            } else if (tabMember._internal.PageFlags.PmtAutomatic && !tabMember._internal.PageFlags.PassDetailsToSite) {
                                tabMember._internal.PageFlags.LoginType = 'Collect';
                            }
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('_sbnSetInternalData', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                    olExtension.Service._internal._sbnCreateDefinedNames(tabMember, requestResult);
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_sbnSetInternalData', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _sbnSetDataFromExistingTabMembers: function (tabMember) {
            try {
                var filterMembers_ = olExtension._internal.TabMember.Filter(null, null, null, tabMember.ApplicationsSessionId);

                if (olFunctions.IsFilledArray(filterMembers_)) {
                    for (var i = 0; i < filterMembers_.length; i++) {
                        if (filterMembers_[i].Id != tabMember.Id) {
                            if (filterMembers_[i]._internal.ExtensionFlags.ServiceResponded) {
                                if (filterMembers_[i].PageInfo.Response.BeforeNavigateResponses && filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0]) {
                                    tabMember.PageInfo.Response.BeforeNavigateResponses[0].ShowStartMessage = filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].ShowStartMessage ? filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].ShowStartMessage : false;
                                    if (filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement) {
                                        tabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement = filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement;
                                    }

                                    if (filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime) {
                                        tabMember.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime = filterMembers_[i].PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime;
                                    }

                                }
                            }

                            if (filterMembers_[i]._internal.ExtensionFlags.BasicAuthDoneOrNotNeeded) {
                                tabMember._internal.ExtensionFlags.BasicAuthDoneOrNotNeeded = true;
                            }

                            if (filterMembers_[i]._internal.ExtensionFlags.BeforeNavigateRequestSent) {
                                tabMember._internal.ExtensionFlags.BeforeNavigateRequestSent = true;
                            }

                            if (filterMembers_[i]._internal.ExtensionFlags.MatterDetailFilled) {
                                tabMember._internal.ExtensionFlags.MatterDetailFilled = true;
                                tabMember.PageInfo.Response.CheckMatterResponse = filterMembers_[i].PageInfo.Response.CheckMatterResponse;
                            }

                            if (filterMembers_[i]._internal.ExtensionFlags.PersonalCodeFilled) {
                                tabMember._internal.ExtensionFlags.PersonalCodeFilled = true;
                                tabMember.PageInfo.Response.GetLocalPersonalCodeListResponse = filterMembers_[i].PageInfo.Response.GetLocalPersonalCodeListResponse;
                            }

                            if (filterMembers_[i]._internal.SelectedUser) {
                                tabMember._internal.SelectedUser = filterMembers_[i]._internal.SelectedUser;
                            }

                            filterMembers_[i].PageInfo.LastUrl = tabMember.PageInfo.LastUrl;
                            tabMember._internal.PageFlags = filterMembers_[i]._internal.PageFlags;
                            for (var j in tabMember.Domains) {
                                if (ol$Functions.inArray(tabMember.Domains[j], filterMembers_[i].Domains) == -1) {
                                    filterMembers_[i].Domains.push(tabMember.Domains[j]);
                                }
                            }

                            tabMember.Domains = filterMembers_[i].Domains;
                            tabMember.PageInfo.Response.SharedPasswordsResponse = filterMembers_[i].PageInfo.Response.SharedPasswordsResponse;
                            tabMember.PageInfo.Response.SharedUsersResponse = filterMembers_[i].PageInfo.Response.SharedUsersResponse;

                            // this next part has to be last in this if branch!!!
                            if ((filterMembers_[i].TabId == tabMember.TabId) && (filterMembers_[i].WindowHandle == tabMember.WindowHandle)) {
                                olExtension._internal.TabMember.Remove(filterMembers_[i], false);
                                // failsafe
                                olExtension._internal.TabMember.Add(tabMember);
                            }
                        }
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_sbnSetDataFromExistingTabMembers', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _populateVariableReplacements: function (definedNamesArray, variableReplacement) {
            try {
                for (var i = 0; i < definedNamesArray.length; i++) {
                    var shouldSet = true;
                    for (var j = 0; j < variableReplacement.Variables.length; j++) {
                        if (String(variableReplacement.Variables[j].DefinedName) == String(definedNamesArray[i])) {
                            shouldSet = false;
                            break;
                        }
                    }
                    if (shouldSet) {
                        var variable_ = {
                            olAdded: true,
                            AutomaticValue: null,
                            DefinedName: String(definedNamesArray[i]),
                            IsCommonSpecified: false,
                            IsPersonalSpecified: false,
                            Label: String(definedNamesArray[i]),
                            Value: ''
                        };
                        variableReplacement.Variables.push(variable_);
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_populateVariableReplacements', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _clearPersonalDetails: function (bnr0) {
            try {
                if (bnr0 && bnr0.VariableReplacement && bnr0.VariableReplacement.PersonalDetail && bnr0.VariableReplacement.Variables) {
                    for (var i = 0; i < bnr0.VariableReplacement.PersonalDetail.length; i++) {
                        var currentPersonalDetail = bnr0.VariableReplacement.PersonalDetail[i];
                        if (currentPersonalDetail.Variables) {
                            var clearedVariablesArray = [];
                            for (var j = 0; j < currentPersonalDetail.Variables.length; j++) {
                                var currentVariable = currentPersonalDetail.Variables[j];
                                for (var k = 0; k < bnr0.VariableReplacement.Variables.length; k++) {
                                    var variableFound = false;
                                    var currentRepVariable = bnr0.VariableReplacement.Variables[k];
                                    if (currentRepVariable.DefinedName == currentVariable.DefinedName) {
                                        if (currentRepVariable.IsPersonal) {
                                            clearedVariablesArray.push(currentVariable);
                                        }
                                        variableFound = true;
                                        break;
                                    }
                                }
                                if (!variableFound) {
                                    clearedVariablesArray.push(currentVariable);
                                }
                            }
                            currentPersonalDetail.Variables = clearedVariablesArray;
                        }
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_clearPersonalDetails', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _sbnSetDataForResource: function (requestContent, requestResult) {
            try {
                var bnr0_ = requestResult.BeforeNavigateResponses[0];

                // OnelogSubFrame
                for (var i = 0; i < bnr0_.Forms.length; i++) {
                    var currentForm_ = bnr0_.Forms[i];
                    //Special Form !!!! indicates should we process subframes or not, if exist we process subframes
                    if (currentForm_.Name == 'OnelogSubFrame') {
                        //I have 2 flags for easier handling because it will be needed on page side as well
                        requestContent.TabMember._internal.PageFlags.ProcessSubframes = true;
                        requestContent.TabMember._internal.ExtensionFlags.ProcessSubframes = true;
                        requestContent.TabMember._internal.ExtensionFlags.ProcessSubframesDomains = currentForm_.URL;
                        break;
                    }
                }

                //Logon needed?
                requestContent.TabMember._internal.PageFlags.LogonNeededForUsername = false;
                requestContent.TabMember._internal.PageFlags.LogonNeededForPassword = false;
                requestContent.TabMember._internal.PageFlags.LogonCommonNeededForUsername = false;
                requestContent.TabMember._internal.PageFlags.LogonCommonNeededForPassword = false;


                requestContent.TabMember._internal.PageFlags.LogonUsingSharedDetailsPossible = bnr0_.EnablePasswordSharing;
                requestContent.TabMember._internal.PageFlags.LogonSharingDetailsPossible = bnr0_.ShowPasswordSharingLink;
                // requestContent.TabMember._internal.PageFlags.EnablePasswordComplianceTracking = bnr0_.EnablePasswordComplianceTracking;

                var usernameArray_ = requestContent.TabMember.PageInfo.DefinedNames.UsernameArray;
                var passwordArray_ = requestContent.TabMember.PageInfo.DefinedNames.PasswordArray;
                var matterArray_ = requestContent.TabMember.PageInfo.DefinedNames.MatterArray;
                var timeKeeperArray_ = requestContent.TabMember.PageInfo.DefinedNames.TimeKeeperArray;
                var commentArray_ = requestContent.TabMember.PageInfo.DefinedNames.CommentArray;

                if (bnr0_.VariableReplacement && olFunctions.IsFilledArray(bnr0_.VariableReplacement.Variables)) {
                    for (var i = 0; i < bnr0_.VariableReplacement.Variables.length; i++) {
                        var definedNameVariables_ = String(bnr0_.VariableReplacement.Variables[i].DefinedName);
                        if ((ol$Functions.inArray(definedNameVariables_, usernameArray_) > -1) && bnr0_.VariableReplacement.Variables[i].IsPersonal) {
                            requestContent.TabMember._internal.PageFlags.LogonNeededForUsername = bnr0_.VariableReplacement.Variables[i].IsPersonal;
                        }
                        if ((ol$Functions.inArray(definedNameVariables_, usernameArray_) > -1) && bnr0_.VariableReplacement.Variables[i].IsCommon) {
                            requestContent.TabMember._internal.PageFlags.LogonCommonNeededForUsername = bnr0_.VariableReplacement.Variables[i].IsCommon;
                        }
                        if ((ol$Functions.inArray(definedNameVariables_, passwordArray_) > -1) && bnr0_.VariableReplacement.Variables[i].IsPersonal) {
                            requestContent.TabMember._internal.PageFlags.LogonNeededForPassword = bnr0_.VariableReplacement.Variables[i].IsPersonal;
                        }
                        if ((ol$Functions.inArray(definedNameVariables_, passwordArray_) > -1) && bnr0_.VariableReplacement.Variables[i].IsCommon) {
                            requestContent.TabMember._internal.PageFlags.LogonCommonNeededForPassword = bnr0_.VariableReplacement.Variables[i].IsCommon;
                        }

                        //set automatic values
                        if (!bnr0_.VariableReplacement.Variables[i].AutomaticValue) {
                            bnr0_.VariableReplacement.Variables[i].AutomaticValue = null;
                        }
                    }
                    //if there are variables fill usernames and passwords
                    olExtension.Service._internal._populateVariableReplacements(usernameArray_, bnr0_.VariableReplacement);
                    olExtension.Service._internal._populateVariableReplacements(passwordArray_, bnr0_.VariableReplacement);
                } else {
                    if (!bnr0_.VariableReplacement) {
                        bnr0_.VariableReplacement = {};
                    }
                    if (!bnr0_.VariableReplacement.Variables) {
                        bnr0_.VariableReplacement.Variables = [];
                    }
                }

                // matter, timekeeper and comment arrays should be filled every time
                olExtension.Service._internal._populateVariableReplacements(matterArray_, bnr0_.VariableReplacement);
                olExtension.Service._internal._populateVariableReplacements(timeKeeperArray_, bnr0_.VariableReplacement);
                olExtension.Service._internal._populateVariableReplacements(commentArray_, bnr0_.VariableReplacement);

                // clear irregular personal info variables that shouldn't be there;
                olExtension.Service._internal._clearPersonalDetails(bnr0_);

                requestContent.TabMember._internal.PageFlags.LogonNeeded = requestContent.TabMember._internal.PageFlags.LogonNeededForPassword || requestContent.TabMember._internal.PageFlags.LogonNeededForUsername;
                requestContent.TabMember._internal.PageFlags.LogonCommonNeeded = requestContent.TabMember._internal.PageFlags.LogonCommonNeededForPassword || requestContent.TabMember._internal.PageFlags.LogonCommonNeededForUsername;

                //Matter needed?
                requestContent.TabMember._internal.PageFlags.MatterNeeded = bnr0_.RecordMatter;
                //Timekeeper(PersonalCode) needed?
                requestContent.TabMember._internal.PageFlags.PersonalCodeNeeded = bnr0_.RequestPersonalCode;

                if (bnr0_.RecordMatter && !requestContent.TabMember._internal.ExtensionFlags.MatterDetailFilled) {
                    olExtension.Service.CheckMatterLocalRequestSend(requestContent);
                    olExtension.Service.GetLocalPersonalCodeListRequestSend(requestContent);
                } else {
                    requestContent.TabMember._internal.ExtensionFlags.MatterDetailFilled = true;
                    requestContent.TabMember._internal.ExtensionFlags.PersonalCodeFilled = true;
                    var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                    olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent_);
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_sbnSetDataForResource', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _successBeforeNavigateLocked: false,
        SuccessBeforeNavigateRequest: function (requestResult, requestContent) {
            if (!olExtension.Service._internal._successBeforeNavigateLocked) {
                olExtension.Service._internal._successBeforeNavigateLocked = true;
                try {
                    var bnr0_ = requestResult.BeforeNavigateResponses[0];
                    var alertContent_ = new olFunctions.AlertContent('API Success Before navigate request succeeded', 'Url: ' + requestContent.TabMember._internal.GetUrl());
                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                    if (bnr0_.ClearSession) {
                        //For exact match resource only, when leaving that tab member should be deleted
                        var tabId_ = requestContent.TabMember.TabId;
                        var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                        for (var i = 0; i < tabMembers_.length; i++) {
                            olExtension._internal.TabMember.Remove(tabMembers_[i]);
                        }
                    }
                    olExtension.Service._internal._sbnSetInternalData(requestContent.TabMember, requestResult);

                    if (olFunctions.IsFilledArray(requestResult.BeforeNavigateResponses)) {
                        if (bnr0_.AppIdSpecified || bnr0_.WebControlRules) {
                            if (bnr0_.ApplicationsSessionId || bnr0_.WebControlRules) {
                                olExtension.Service._internal.HandleLogoutForExistingTabMembers(requestContent.TabMember);
                                olExtension.Service._internal._sbnSetDataFromExistingTabMembers(requestContent.TabMember);
                                if (!requestContent.TabMember._internal.PageFlags.Unauthorised) {
                                    //Authorized access
                                    if (!requestContent.TabMember._internal.ExtensionFlags.TabRemoved) {
                                        olExtension.Service._internal._sbnSetDataForResource(requestContent, requestResult);

                                        //Basic Auth
                                        olExtension.BasicAuthentication.HandleBasicAuthentication(requestContent.TabMember, bnr0_.VariableReplacement.Variables);
                                    } else {
                                        // tab removed before server responded and now we have all info
                                        // just call window closing
                                        olExtension.Service.WindowClosingRequestSend(requestContent);
                                    }
                                } else {
                                    // Unauthorised access
                                    var messageContent1_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                                    olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent1_);
                                }
                            } else {
                                if (bnr0_.ApplicationsSessionId == null) {
                                    // native mode with exact url is used so we should remove this one
                                    olExtension.BasicAuthentication._internal.RemoveFromRefreshTabIdArray(requestContent.TabMember.TabId);
                                    olExtension._internal.TabMember.Remove(requestContent.TabMember);
                                } else {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Error! Tab member should not exist here');
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            }
                        } else {
                            // AppId not specified
                            // => multiple applications, send choose application
                            if (bnr0_.ApplicationsSessionId) {
                                var messageContent2_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);

                                olExtension.Messages.ChooseApplicationDispatchMessage(messageContent2_);
                                olExtension.Service._internal.HandleLogoutForExistingTabMembers(requestContent.TabMember);
                            } else {
                                olExtension.BasicAuthentication._internal.RemoveFromRefreshTabIdArray(requestContent.TabMember.TabId);
                                olExtension._internal.TabMember.Remove(requestContent.TabMember);
                            }
                        }
                    } else {
                        //bnr being null means something strange happened and our requests broke server logic
                        //only way we know this could happen is on redirect on url that has multiple resources on it
                        //the fact this happened indicates that first tab member will not hit document ready

                        var sameIdTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, requestContent.TabMember.TabId, null, null);

                        if (sameIdTabMembers_.length > 1) {
                            var previousTabMember_ = sameIdTabMembers_[sameIdTabMembers_.length - 2];
                            previousTabMember_.PageInfo.LastUrl = requestContent.TabMember.PageInfo.LastUrl;
                            previousTabMember_.PageInfo.Url = requestContent.TabMember.PageInfo.Url;
                            previousTabMember_.TargetTab = requestContent.TabMember.TargetTab;
                            if (requestContent.TabMember._internal.ExtensionFlags.DocumentReady) {
                                olExtension.Listeners._internal.Messages._onDocumentReady(previousTabMember_.TargetTab);
                            }
                            olExtension._internal.TabMember.Remove(requestContent.TabMember);
                        } else {
                            olExtension._internal.TabMember.Remove(sameIdTabMembers_[0]);
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SuccessBeforeNavigateRequest', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }

                olExtension.Service._internal._successBeforeNavigateLocked = false;
                olWrap.storage.asyncSetOlData(olData);
            } else {
                setTimeout(function () {
                    olExtension.Service._internal.SuccessBeforeNavigateRequest(requestResult, requestContent);
                }, 200);
            }
        },
        SuccessCheckMatterGlobalRequest: function (requestResult, requestContent) {
            try {
                if (!requestResult || !requestResult.CheckMatterResponse || !requestResult.CheckMatterResponse.MatterDetails) {
                    requestResult = {};
                    requestResult.CheckMatterResponse = {};
                    requestResult.CheckMatterResponse.MatterDetails = [];
                    requestResult.CheckMatterResponse.PageCount = 0;
                }

                var alertContent_ = new olFunctions.AlertContent('API Success Check matter global request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult);
                olExtension.Messages.CheckMatterGlobalRequestDispatchResponse(messageContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessCheckMatterGlobalRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessCheckMatterLocalRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Check matter local request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult && requestResult.CheckMatterResponse && requestResult.CheckMatterResponse.MatterDetails) {
                    message_ = 'Matter details: ' + requestResult.CheckMatterResponse.MatterDetails.length;
                } else {
                    message_ = 'Check matter response: ' + requestResult.CheckMatterResponse;
                }

                if (requestResult.CheckMatterResponse) {
                    requestContent.TabMember.PageInfo.Response.CheckMatterResponse = requestResult.CheckMatterResponse;
                } else {
                    requestContent.TabMember.PageInfo.Response.CheckMatterResponse = {
                        MatterDetails: []
                    };
                }

                requestContent.TabMember._internal.ExtensionFlags.MatterDetailFilled = true;

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessCheckMatterLocalRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },


        //TODO: ISSUE WITH RESOURCE TIMEOUT: CHECK!!!!!!!!!!!!! 
        // added 06.01.2023 ON-2004
        SuccessContinueSessionRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Continue session request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                var filterMembers_ = olExtension._internal.TabMember.Filter(null, null, null, requestContent.TabMember.ApplicationsSessionId);


                for (var i = 0; i < filterMembers_.length; i++) {
                    var messageContent_ = new olExtension.DataConstructors.MessageContent(filterMembers_[i]);
                    olExtension.Messages.SuccessContinueSessionRequestReceived(messageContent_);
                }

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessContinueSessionRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        // excluded 06.01.2023 ON-2004 CHECK!!!!!!!!!!!!! 
        // SuccessContinueSessionRequest: function (requestResult, requestContent) {
        //     try {
        //         var alertContent_ = new olFunctions.AlertContent('API Success Continue session request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
        //         olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        //     } catch (e) {
        //         var alertErrorContent_ = new olFunctions.AlertContent('SuccessContinueSessionRequest', e.message + '\n' + e.stack);
        //         olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        //     }
        // },
        SuccessDeletePersonalDetailRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Delete personal detail request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestContent.Parameters.Id);
                olExtension.Messages.DeletePersonalDetailRequestDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessDeletePersonalDetailRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        AskToStorePasswordDetails: function (requestResponse) {
            var title_ = '';
            var body_ = '';

            if (requestResponse.IsNewPasswordSpecified && requestResponse.IsNewPassword) {
                // requestContent.TabMember._internal.PageFlags.IsNewPassword = true;
                // new password
                title_ = olExtension._internal.Translate('JS_StorePasswordDetailsTitle');
                body_ = olExtension._internal.Translate('JS_StorePasswordDetailsBody');
            } else {
                // requestContent.TabMember._internal.PageFlags.IsNewPassword = false;
                // update password
                title_ = olExtension._internal.Translate('JS_UpdatePasswordDetailsTitle');
                body_ = olExtension._internal.Translate('JS_UpdatePasswordDetailsBody');
            }

            var details_ = {
                Title: title_,
                Body: body_,
                IsNewPassword: requestResponse.IsNewPassword ? true : false
            };
            return details_;
        },
        SuccessFormSubmitRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Form submit request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (requestResult && requestResult.FormSubmitResponse && requestResult.FormSubmitResponse.AskToStorePasswordSpecified && requestResult.FormSubmitResponse.AskToStorePassword) {
                    var details_ = olExtension.Service._internal.AskToStorePasswordDetails(requestResult.FormSubmitResponse);
                    details_.Body = details_.Body.replace('{rep1}', requestContent.TabMember.ApplicationName);
                    var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, details_);
                    olExtension.Messages.AskToStorePassword(messageContent_);
                }
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessFormSubmitRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessFormFilled: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Form subfilled succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                requestContent.TabMember._internal.PageFlags.FormfillRequestSent = true;

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.FormfillRequestSent(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessFormSubmitRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessDocumentCompleteRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Document complete request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (requestResult && requestResult.DocumentCompleteResponse && requestResult.DocumentCompleteResponse.AskToStorePasswordSpecified && requestResult.DocumentCompleteResponse.AskToStorePassword) {
                    var details_ = olExtension.Service._internal.AskToStorePasswordDetails(requestResult.DocumentCompleteResponse);
                    details_.Body = details_.Body.replace('{rep1}', requestContent.TabMember.ApplicationName);
                    var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, details_);
                    olExtension.Messages.AskToStorePassword(messageContent_);
                }

                requestContent.TabMember._internal.ExtensionFlags.DocumentCompleteResponseReceived = true;

                //Send FormFilled request only once and only when is DocumentCompleteResponseReceived
                var tabMember_ = requestContent.TabMember;
                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);

                if (tabMember_._internal.ExtensionFlags.DocumentCompleteResponseReceived && tabMember_._internal.ExtensionFlags.FormFillRequestNeeded &&
                    !tabMember_._internal.ExtensionFlags.FormFillRequestSent) {
                    tabMember_._internal.ExtensionFlags.FormFillRequestSent = true;
                    olExtension.Service.FormFilledSend(requestContent_);

                    var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                    olExtension.Messages.FormfillRequestSent(messageContent_);
                }

                //BACK TO modInjection
                // Form filled request always on SuccessDocumentCompleteRequest
                // var requestContent1_ = new olExtension.DataConstructors.RequestContent(requestContent.TabMember);
                // olExtension.Service.FormFilledSend(requestContent1_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessDocumentCompleteRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessRequestGetSharedUsersRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Get shared users request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult.SharedUsersResponse && olFunctions.IsFilledArray(requestResult.SharedUsersResponse.SharedUsers)) {
                    requestContent.TabMember.PageInfo.Response.SharedUsersResponse = requestResult.SharedUsersResponse;
                } else {
                    requestContent.TabMember.PageInfo.Response.SharedUsersResponse = {
                        SharedUsers: []
                    };
                }

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult.SharedUsersResponse);
                olExtension.Messages.GetSharedUsersDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessRequestGetSharedUsersRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessRequestSearchSharedUsersRequestSend: function (requestResult, requestContent) {
            try {
                if (!requestResult) {
                    requestResult = {};
                }

                var alertContent_ = new olFunctions.AlertContent('API Success Request search shared users request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult.SharedUsersResponse.SharedUsers);
                olExtension.Messages.RequestSearchSharedUsersRequestDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessCheckMatterGlobalRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessGetSharedPasswordsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Get shared users passwords succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult.SharedPasswordsResponse && olFunctions.IsFilledArray(requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement.PersonalDetail)) {
                    if (!requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement) {
                        requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement = {};
                    }
                    if (!requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement.Variables) {
                        requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement.Variables = [];
                    }

                    var usernameArray_ = requestContent.TabMember.PageInfo.DefinedNames.UsernameArray;
                    var passwordArray_ = requestContent.TabMember.PageInfo.DefinedNames.PasswordArray;
                    var matterArray_ = requestContent.TabMember.PageInfo.DefinedNames.MatterArray;
                    var timeKeeperArray_ = requestContent.TabMember.PageInfo.DefinedNames.TimeKeeperArray;
                    var commentArray_ = requestContent.TabMember.PageInfo.DefinedNames.CommentArray;
                    var shareVariableRepacement_ = requestResult.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement;
                    olExtension.Service._internal._populateVariableReplacements(usernameArray_, shareVariableRepacement_);
                    olExtension.Service._internal._populateVariableReplacements(passwordArray_, shareVariableRepacement_);
                    olExtension.Service._internal._populateVariableReplacements(matterArray_, shareVariableRepacement_);
                    olExtension.Service._internal._populateVariableReplacements(timeKeeperArray_, shareVariableRepacement_);
                    olExtension.Service._internal._populateVariableReplacements(commentArray_, shareVariableRepacement_);


                    requestContent.TabMember.PageInfo.Response.SharedPasswordsResponse = requestResult.SharedPasswordsResponse;
                } else {
                    requestContent.TabMember.PageInfo.Response.SharedPasswordsResponse = {
                        SharedPasswordsUser: {
                            VariableReplacement: {
                                PersonalDetail: []
                            }
                        }
                    };
                }
                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult.SharedPasswordsResponse);
                messageContent_.TabMessageContent.Parameters = requestContent.Parameters;
                olExtension.Messages.GetSharedPasswordsDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessRequestGetSharedUsersRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessGetLocalPersonalCodeListRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Get local personal code list request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult.GetLocalPersonalCodeListResponse && olFunctions.IsFilledArray(requestResult.GetLocalPersonalCodeListResponse.LocalPersonalCodes)) {
                    requestContent.TabMember.PageInfo.Response.GetLocalPersonalCodeListResponse = requestResult.GetLocalPersonalCodeListResponse;
                } else {
                    requestContent.TabMember.PageInfo.Response.GetLocalPersonalCodeListResponse = {
                        LocalPersonalCodes: []
                    };
                }
                requestContent.TabMember._internal.ExtensionFlags.PersonalCodeFilled = true;

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessGetLocalPersonalCodeListRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessLanguageItemsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Language items request succeeded', 'Returned to extension');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                olExtension._internal.LanguageItemsResolved = true;

                olData.LanguageItems = [];
                for (var i = 0; i < requestResult.LanguageItems.length; i++) {
                    olData.LanguageItems.push(requestResult.LanguageItems[i]);
                }

                //Only after receiving request from LanguageItemsRequest proceed 
                //with pulse, cause it is possible that service is not installed 
                //if we dont get this response so no need to send pulse
                //Pulse interval
                setInterval(function () {
                    olWrap.tabs.getAll(function (tabs) {
                        for (var i = 0; i < tabs.length; i++) {
                            var id_ = tabs[i].getId();
                            olExtension.Service.PulseRequestSend(id_);
                        }
                    });
                }, 10000);

                //Clean up sessions
                if (olData.CleanUp) {
                    olExtension.Listeners._internal.Events.CleanUp();
                }

                //Initialize cleaner
                olExtension.Cleaner.Reset();

                //Page content excludes
                try {
                    olWrap.browser.pageContentExclude();
                } catch (e) {
                    var alertErrorContent_ = new olOptions.DataConstructors.AlertContent('Page content excludes, either empty or ', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }

                //storing OneLog forms
                olExtension._internal.StoreOneLogFormsFetch();
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessLanguageItemsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessExtensionOptionsRequestSend: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Options items request succeeded', 'Returned to extension');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var optionSettings_ = ol$Functions.grep(olOptions._internal.OptionsArray, function (member) {
                    return (member.Name == 'General');
                });
                optionSettings_[0].Label = 'Settings'

                if (requestResult.ExtensionOptions.OrganisationControlledOptions) {
                    var option_ = ol$Functions.grep(olOptions._internal.OptionsArray, function (member) {
                        return (member.Name == 'OrganisationControlledOptions');
                    });
                    option_[0].Value = requestResult.ExtensionOptions.OrganisationControlledOptions;

                    option_ = ol$Functions.grep(olOptions._internal.OptionsArray, function (member) {
                        return (member.Name == 'OrganisationControlledOptionsDisabledLocal');
                    });
                    option_[0].Value = requestResult.ExtensionOptions.OrganisationControlledOptionsDisabledLocal;

                    option_ = ol$Functions.grep(olOptions._internal.OptionsArray, function (member) {
                        return (member.Name == 'GeneralPageToolbarPosition');
                    });
                    option_[0].Value = String(requestResult.ExtensionOptions.GeneralPageToolbarPosition);
                    if (requestResult.ExtensionOptions.OrganisationControlledOptionsDisabledLocal) {
                        option_[0].Disabled = 'disabled';
                    }

                    option_ = ol$Functions.grep(olOptions._internal.OptionsArray, function (member) {
                        return (member.Name == 'GeneralPageToolbarMinimized');
                    });
                    option_[0].Value = requestResult.ExtensionOptions.GeneralPageToolbarMinimized;
                    if (requestResult.ExtensionOptions.OrganisationControlledOptionsDisabledLocal) {
                        option_[0].Disabled = 'disabled';
                    }

                    if (requestResult.ExtensionOptions.OrganisationControlledOptionsDisabledLocal) {
                        optionSettings_[0].Disabled = 'disabled';
                        optionSettings_[0].Label = 'Settings (Settings can not be changed. Settings are managed by your organisation)';
                    } else {
                        optionSettings_[0].Label = 'Settings (Settings can be changed for this session. Settings are managed by your organisation)';
                    }
                }

                olOptions.InitializeOptionNameValueArray();

                olWrap.storage.asyncSetItem('olOptions', olOptions._internal.OptionsArray, function () {
                    olWrap.dispatchMessage('olRefreshOptions');
                });
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessExtensionOptionsRequestSend', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessExtensionStatisticsRequestSend: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Extension Statistics request succeeded', 'Returned to extension');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessExtensionStatisticsRequestSend', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessUsernameRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Username request succeeded', 'Returned to extension');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                olExtension._internal.Username = requestResult.UsernameResponse.Username;
                olExtension._internal.UsernameResolved = true;

                olExtension._initialize();
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessUsernameRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessLogoutCompletedRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Logout completed request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                //TODO this breaks FF
                olExtension._internal.TabMember.Remove(requestContent.TabMember);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessLogoutCompletedRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessLogoutWindowRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Logout window request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                // the rest is send after logout sequence is done
                // returning back to original
                var requestContent_ = new olExtension.DataConstructors.RequestContent(requestContent.TabMember);
                olExtension.Service.LogoutCompletedRequestSend(requestContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessLogoutWindowRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessMainWindowClosingRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Main window closing request succeeded', 'Window Id: ' + requestContent.TabMember.WindowId);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessMainWindowClosingRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessNavigateCompleteRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Navigate complete request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (olFunctions.IsFilledArray(requestResult.NavigateCompleteResponses)) {
                    if (requestResult.NavigateCompleteResponses.length > 1) {
                        var navigateResponse_ = requestResult.NavigateCompleteResponses[1];

                        var filterMembers_ = olExtension._internal.TabMember.Filter(null, null, null, navigateResponse_.ApplicationsSessionId);
                        if (navigateResponse_.ApplicationsSessionId && olFunctions.IsFilledArray(filterMembers_)) {
                            var tabMember_ = filterMembers_[0];
                            tabMember_.PageInfo.ClosingResponse = navigateResponse_;
                            olExtension._internal.TabMember.HandleResourceEnd(tabMember_);
                        }
                    }

                    var ncr0_ = requestResult.NavigateCompleteResponses[0];
                    //and send pause duration
                    if (!(ncr0_.PauseDuration && ncr0_.PauseDuration > 0)) {
                        ncr0_.PauseDuration = 0;
                    }
                    requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = ncr0_.PauseDuration;
                    // send pause duration back to tab
                    var pauseDuration_ = {
                        ApplicationName: ncr0_.ApplicationName,
                        PauseDuration: ncr0_.PauseDuration
                    };
                    var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, pauseDuration_);
                    olExtension.Messages.PauseDuration(messageContent_);
                }

                olExtension.Service.DocumentCompleteRequestSend(requestContent);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessNavigateCompleteRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessNewWindowRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success New window request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olExtension._internal.OpenLogoutWindow(requestContent.TabMember.TabId);

                // This changes now...
                // Logout window request should be sent once new window is opened with new window handle
                // returning back to original
                olExtension.Service.LogoutWindowRequestSend(requestContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessNewWindowRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessPulseRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Pulse request succeeded');

                if (requestResult && requestResult.PulseResponse) {
                    var applicationSessionId_ = requestResult.PulseResponse.ApplicationSessionId;
                    var tabId_ = requestContent;

                    var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, applicationSessionId_);
                    if (olFunctions.IsFilledArray(tabMembers_)) {
                        var tabMember_ = tabMembers_[0];

                        if (requestResult.PulseResponse.PauseDuration) {
                            tabMember_.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = requestResult.PulseResponse.PauseDuration;
                        } else {
                            tabMember_.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = 0;
                        }

                        olWrap.tabs.getAll(function (tabs) {
                            var currentTargetTab_ = null;
                            for (var i = 0; i < tabs.length; i++) {
                                if (tabs[i].getId() == tabId_) {
                                    currentTargetTab_ = tabs[i];
                                }
                            }
                            if (currentTargetTab_) {
                                tabMember_.TargetTab = currentTargetTab_;
                            }

                            if (requestResult.PulseResponse.SessionInactive && requestResult.PulseResponse.SessionInactive) {
                                if (requestResult.PulseResponse.EndClientResourceSessionSpecified && requestResult.PulseResponse.EndClientResourceSession) {
                                    // sleep or hibernate occurred, just close tab
                                    currentTargetTab_.close();
                                } else {
                                    // session is inactive => resource timeout
                                    var applicationName_ = tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ApplicationName;
                                    var pauseDuration_ = 0;
                                    if (requestResult.PulseResponse.PauseDuration) {
                                        pauseDuration_ = requestResult.PulseResponse.PauseDuration;
                                    }

                                    var resourceTimeout_ = {
                                        ApplicationSessionId: applicationSessionId_,
                                        ApplicationName: applicationName_,
                                        ResourceTimeoutText: olExtension._internal.Translate('JS_ResourceTimeoutLabel'),
                                        PauseDuration: pauseDuration_,
                                        ResourceTimeoutStartTime: tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime
                                    };

                                    if (tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime) {

                                    } else {
                                        var now_ = new Date().getTime();
                                        //Rounded in seconds
                                        now_ = Math.floor(now_ / 1000);

                                        resourceTimeout_ = {
                                            ApplicationSessionId: applicationSessionId_,
                                            ApplicationName: applicationName_,
                                            ResourceTimeoutText: olExtension._internal.Translate('JS_ResourceTimeoutLabel'),
                                            PauseDuration: pauseDuration_,
                                            ResourceTimeoutStartTime: now_
                                        };

                                        tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime = now_;

                                        var tabMembers_ = olExtension._internal.TabMember.Filter(null, null, null, tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId);

                                        for (var i = 0; i < tabMembers_.length; i++) {
                                            tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime = now_;
                                        }
                                    }
                                    var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMember_, resourceTimeout_);
                                    olExtension.Messages.ResourceTimeout(messageContent_);
                                }
                            } else {
                                // send pause duration back to tab
                                if (!(requestResult.PulseResponse.PauseDuration && requestResult.PulseResponse.PauseDuration > 0)) {
                                    requestResult.PulseResponse.PauseDuration = 0;
                                }
                                var pauseDuration_ = {
                                    ApplicationName: applicationName_,
                                    PauseDuration: requestResult.PulseResponse.PauseDuration
                                };
                                var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMember_, pauseDuration_);
                                olExtension.Messages.PauseDuration(messageContent_);
                            }
                        });
                    }
                }

                if (!olOptions.DevelopmentVersion()) {
                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessPulseRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetCommentEditRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set comment edit request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult && requestResult.SetCommentEditResponse && requestResult.SetCommentEditResponse.ApplicationSessionId) {
                    olExtension._internal.TabMember.ChangeApplicationIdAndStartTime(requestContent.TabMember.ApplicationsSessionId, requestResult.SetCommentEditResponse.ApplicationSessionId, requestResult.SetCommentEditResponse.StartTime, requestResult.SetCommentEditResponse.PauseDuration);
                }
                if (requestResult && requestResult.SetCommentEditResponse) {
                    if (requestResult.SetCommentEditResponse.StartTime) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].StartTime = requestResult.SetCommentEditResponse.StartTime;
                    }
                    if (requestResult.SetCommentEditResponse.PauseDuration) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = requestResult.SetCommentEditResponse.PauseDuration;
                    }
                }

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult.SetCommentEditResponse);
                olExtension.Messages.SetCommentEditRequestDispatchResponse(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetCommentEditRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetCommentRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set comment request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                if (requestResult && requestResult.SetCommentResponse && requestResult.SetCommentResponse.ApplicationSessionId) {
                    olExtension._internal.TabMember.ChangeApplicationIdAndStartTime(requestContent.TabMember.ApplicationsSessionId, requestResult.SetCommentResponse.ApplicationSessionId, requestResult.SetCommentResponse.StartTime, requestResult.SetCommentResponse.PauseDuration);
                }
                if (requestResult && requestResult.SetCommentResponse) {
                    if (requestResult.SetCommentResponse.StartTime) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].StartTime = requestResult.SetCommentResponse.StartTime;
                    }
                    if (requestResult.SetCommentResponse.PauseDuration) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = requestResult.SetCommentResponse.PauseDuration;
                    }
                }

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, true);
                olExtension.Messages.SetCommentRequestDispatchResponse(messageContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetCommentRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetCurrentPersonalDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set current personal details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestContent.Parameters.Shared);
                messageContent_.TabMessageContent.Shared = requestContent.Parameters.Shared;
                olExtension.Messages.SetCurrentPersonalDetailsRequestDispatchResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetCurrentSharedPasswordRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set current shared password details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.SetCurrentSharedPasswordRequestDispatchResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessUnSetCurrentSharedPasswordRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Unset current shared password request succeeded', '');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.UnSetCurrentSharedPasswordRequestDispatchResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessUnSetCurrentSharedPasswordRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetTempPersonalDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set temp personal details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetTempPersonalDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessTempRecordDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Temp record details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessTempRecordDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSkipMatterDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Skip matter details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSkipMatterDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSkipPersonalDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Skip personal details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.SkipPersonalDetailsRequestDisptachResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSkipPersonalDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessStorePassword: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Store password request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.InjectReceivedData(messageContent_);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessStorePassword', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessStorePasswordShared: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Store sharedpassword request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessStorePasswordShared', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessPersonalDetailsChosenRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Personal details chosen request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember);
                olExtension.Messages.PersonalDetailsChosenRequestDisptachResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessPersonalDetailsChosenRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetPersonalDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set personal details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult);

                try {
                    var detailsId_ = requestResult.SetPersonalDetailsResponse.DetailsId;
                    var detailsName_ = requestContent.Parameters.Details.Name;
                    var detailsVariables_ = requestContent.Parameters.Details.Variables;
                    var detailsNew_ = requestContent.Parameters.New;

                    var variableReplacementVariables_ = requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.Variables;
                    if (requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail === null) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail = [];
                    }

                    var personalDetail_ = {
                        Id: detailsId_,
                        Name: detailsName_,
                        Variables: []
                    };
                    if (detailsNew_) {
                        for (var i = 0; i < detailsVariables_.length; i++) {
                            for (var j = 0; j < variableReplacementVariables_.length; j++) {
                                if (detailsVariables_[i].Name == variableReplacementVariables_[j].DefinedName) {
                                    var variable_ = {
                                        DefinedName: variableReplacementVariables_[j].DefinedName,
                                        Label: variableReplacementVariables_[j].Label,
                                        Value: detailsVariables_[i].Value
                                    };
                                    personalDetail_.Variables.push(variable_);
                                    break;
                                }
                            }
                        }
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail.push(personalDetail_);
                    } else {
                        var personalDetails_ = ol$Functions.grep(requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail, function (member) {
                            return (member.Id == detailsId_);
                        });
                        personalDetail_ = personalDetails_[0];
                    }

                    for (var i = 0; i < detailsVariables_.length; i++) {
                        for (var j = 0; j < personalDetail_.Variables.length; j++) {
                            if (detailsVariables_[i].Name == personalDetail_.Variables[j].DefinedName) {
                                personalDetail_.Variables[j].Value = detailsVariables_[i].Value;
                                break;
                            }
                        }
                    }
                } catch (e) {

                }

                olExtension.Messages.SetPersonalDetailsRequestDispatchResponse(messageContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetPersonalDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetCommonDetailsRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set common details request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult);
                olExtension.Messages.SetCommonDetailsDispatchResponse(messageContent_);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetCommonDetailsRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessValidateSelectedMatterRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Validate selected matter request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olExtension.Service._internal.SortMatterDetails(requestResult, requestContent);

                if (requestResult.ValidateMatterResponse && requestResult.ValidateMatterResponse.ApplicationSessionId) {
                    olExtension._internal.TabMember.ChangeApplicationIdAndStartTime(requestContent.TabMember.ApplicationsSessionId, requestResult.ValidateMatterResponse.ApplicationSessionId, requestResult.ValidateMatterResponse.StartTime, requestResult.ValidateMatterResponse.PauseDuration);

                    //olExtension.Listeners._internal.Messages._alreadySentValue
                }

                if (requestResult.ValidateMatterResponse) {
                    if (requestResult.ValidateMatterResponse.StartTime) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].StartTime = requestResult.ValidateMatterResponse.StartTime;
                    }
                    if (requestResult.ValidateMatterResponse.PauseDuration) {
                        requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = requestResult.ValidateMatterResponse.PauseDuration;
                    }
                }

                var messageContent_ = new olExtension.DataConstructors.MessageContent(requestContent.TabMember, requestResult.ValidateMatterResponse);
                olExtension.Messages.ValidateSelectedMatterRequestDispatchResponse(messageContent_);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessValidateSelectedMatterRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessWindowClosingRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Window closing request succeeded', 'Window Id: ' + requestContent.TabMember.WindowId);
                if (requestResult && olFunctions.IsFilledArray(requestResult.WindowClosingResponses)) {
                    requestContent.TabMember.PageInfo.ClosingResponse = requestResult.WindowClosingResponses[0];
                }

                olExtension._internal.TabMember.HandleResourceEnd(requestContent.TabMember);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessWindowClosingRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessQuittingResourceSessionRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Quitting resource session request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (requestContent.TabMember.PageInfo.Response.BeforeNavigateResponses[0].LogoutScriptExists) {
                    requestContent.TabMember.PageInfo.ClosingResponse = requestResult.QuittingResponse;
                    olExtension._internal.TabMember.HandleResourceEnd(requestContent.TabMember);
                } else {
                    olExtension._internal.TabMember.Remove(requestContent.TabMember);
                    // if there are no logout scripts and we are on resource we just need to close tab
                    if (requestContent.TabMember.CloseTab) {
                        requestContent.TabMember.TargetTab.close();
                    }
                }
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessQuittingResourceSessionRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        //Analysis service requests
        SuccessSetFeaturesRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set features request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetFeaturesRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessRequestFeatureRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Request feature request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (requestResult && olFunctions.IsFilledArray(requestResult.WindowClosingResponses)) {
                    requestContent.TabMember.PageInfo.ClosingResponse = requestResult.WindowClosingResponses[0];
                }

                olExtension._internal.TabMember.HandleResourceEnd(requestContent.TabMember);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessRequestFeatureRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessRequestFeatureItemRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Request feature item request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                if (requestResult && olFunctions.IsFilledArray(requestResult.WindowClosingResponses)) {
                    requestContent.TabMember.PageInfo.ClosingResponse = requestResult.WindowClosingResponses[0];
                }

                olExtension._internal.TabMember.HandleResourceEnd(requestContent.TabMember);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessRequestFeatureItemRequestSend', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessSetAnalysisRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Set Analysis request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessSetAnalysisRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        //WebControl
        SuccessStartMessageSeenRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Start message seen request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessStartMessageSeenRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        SuccessHideStartMessageRequest: function (requestResult, requestContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('API Success Hide start message seen request succeeded', 'Url: ' + requestContent.TabMember.PageInfo.Url);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SuccessHideStartMessageRequest', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    }
}