olExtension.Listeners._internal.Events = {
    _beforeNavigateEvent: function (event) {
        try {
            var alertContent_ = new olFunctions.AlertContent('EVT Before navigate event', 'Caught by extension Url: ' + event.target.getUrl());
            if (event.target.url == olExtension.Data.LogoutUrl) {
                olExtension._internal.HandleLogoutWindow(event);
            } else {
                //Check logout array
                if (olData.LogoutTabs.indexOf(event.target.getId()) == -1) {
                    // not a logout tab
                    var tabId_ = event.target.getId();

                    chrome.webNavigation.getAllFrames({ tabId: tabId_ }, function (result) {
                        try {

                            var framesArray_ = [];
                            for (var i = 0; i < result.length; i++) {
                                var currentFrame_ = result[i];
                                var currentFrameId_ = currentFrame_.frameId;

                                framesArray_.push(currentFrameId_)
                            }
                        } catch (e) {
                            framesArray_ = [];

                            var alertErrorContent_ = new olFunctions.AlertContent('_beforeNavigateEvent chrome.webNavigation.getAllFrames', e.message + ' ' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        } finally {
                            var tabMember_ = olExtension._internal.TabMember.Create(event.target.getId(), event.target.getUrl(), framesArray_);
                            var urlDomain_ = olFunctions.GetDomainFromUrl(event.target.getUrl());

                            if (urlDomain_ && (ol$Functions.inArray(urlDomain_, tabMember_.Domains) == -1)) {
                                tabMember_.Domains.push(urlDomain_);
                            }

                            var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);
                            olExtension.Service.BeforeNavigateRequestSend(requestContent_);
                        }
                    })
                } else {
                    // logout tab
                    return;
                }
            }
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('_beforeNavigateEvent', e.message + ' ' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    BeforeNavigate: function () {
        olWrap.browser.addEventListener(olWrap.browser.event.BeforeNavigate, function (event) {
            try {
                var waitingForSw_Init = setInterval(function () {
                    if (olExtension.Data.SW_Initialised) {
                        clearInterval(waitingForSw_Init);
                        if (event.url != null && !olWrap.urlExcluded(event.url)) {
                            olExtension.Listeners._internal.Events._beforeNavigateEvent(event);
                        }
                    }
                }, 50)
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('BeforeNavigate', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        });
    },
    CleanUp: function () {
        try {
            olExtension.Service.MainWindowClosingRequestSend(null);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CleanUp', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    TabRemoved: function () {
        olWrap.browser.addEventListener(olWrap.browser.event.TabRemoved, function (event) {
            try {
                var waitingForSw_Init = setInterval(function () {
                    if (olExtension.Data.SW_Initialised) {
                        clearInterval(waitingForSw_Init);

                        var tabId_ = event.tabId;
                        var alertContent_ = new olFunctions.AlertContent('EVT Tab removed event', 'Caught by extension ' + tabId_);
                        var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                        if (olFunctions.IsFilledArray(tabMembers_)) {
                            //resource tab closed
                            if (!tabMembers_[0].CloseTab) {
                                tabMembers_[0]._internal.ExtensionFlags.TabRemoved = true;

                                if (tabMembers_[0]._internal.ExtensionFlags.ServiceResponded) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0]);
                                    olExtension.Service.WindowClosingRequestSend(requestContent_);
                                }
                            }
                        } else {
                            var logoutTabMembers_ = olExtension._internal.TabMember.FilterLogoutInfoArray(olExtension.Data.WindowHandle, tabId_, null);
                            if (olFunctions.IsFilledArray(logoutTabMembers_)) {
                                for (var i = 0; i < logoutTabMembers_.length; i++) {
                                    olExtension._internal.TabMember.RemoveLogout(logoutTabMembers_[i]);
                                }
                            }
                        }
                        olData.CreatedTabs = ol$Functions.grep(olData.CreatedTabs, function (member) {
                            return (member != tabId_);
                        });
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    }
                }, 50)

            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('TabRemoved', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        });
    },
    TabCreated: function () {
        olWrap.browser.addEventListener(olWrap.browser.event.TabCreated, function (event) {
            try {
                var waitingForSw_Init = setInterval(function () {
                    if (olExtension.Data.SW_Initialised) {
                        clearInterval(waitingForSw_Init);
                        var alertContent_ = new olFunctions.AlertContent('EVT Tab created event', 'Caught by extension ' + event.tabId);
                        olData.CreatedTabs.push(event.tabId);
                        // Handle cookies array if this is first tab to open
                        var currentTabId_ = event.target.getId();
                        olWrap.tabs.getAll(function (tabs) {
                            if (tabs.length == 1 && tabs[0].getId() == currentTabId_) {
                                // this tab is the first one
                                olExtension.Functions.HandleCookiesArray();
                            }
                        });
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    }
                }, 50)
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('TabCreated', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        });
    },
    ReloadPage() {
        window.location.reload();
    },
    TabReplaced: function () {
        if (chrome.webNavigation.onTabReplaced) {

            chrome.webNavigation.onTabReplaced.addListener(function (event) {
                try {

                    var waitingForSw_Init = setInterval(function () {
                        if (olExtension.Data.SW_Initialised) {
                            clearInterval(waitingForSw_Init);

                            var alertContent_ = new olFunctions.AlertContent('EVT Tab replaced event', 'Caught by extension ' + event.tabId);

                            var tabId_ = event.tabId;
                            var replacedTabId_ = event.replacedTabId;
                            //insert into created tabs
                            olData.CreatedTabs.push(tabId_);

                            //invoke document ready for replaced tab
                            olWrap.tabs.getAll(function (tabs) {
                                for (var i = 0; i < tabs.length; i++) {
                                    if (tabId_ == tabs[i].getId()) {
                                        //change tabId in tab member
                                        var foundTab = tabs[i];
                                        var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, replacedTabId_, null, null);
                                        if (olFunctions.IsFilledArray(tabMembers_)) {
                                            for (var j = 0; j < tabMembers_.length; j++) {
                                                tabMembers_[j].TabId = tabId_;
                                                tabMembers_[j].TargetTab = foundTab;
                                            }
                                        }
                                        var tabMembersLogout_ = olExtension._internal.TabMember.FilterLogoutInfoArray(olExtension.Data.WindowHandle, replacedTabId_);
                                        if (olFunctions.IsFilledArray(tabMembersLogout_)) {
                                            for (var k = 0; k < tabMembersLogout_.length; k++) {
                                                tabMembersLogout_[k].TabId = tabId_;
                                                tabMembersLogout_[k].TargetTab = foundTab;
                                            }
                                        }

                                        // Westlaw - google problem
                                        if ((foundTab.getUrl().indexOf('chrome-instant') == -1) && (foundTab.getUrl().indexOf('://www.google.') == -1)) {

                                            chrome.scripting.executeScript({
                                                target: { tabId: tabId_ },
                                                func: ReloadPage

                                            });
                                        };
                                        break;
                                    }
                                }
                            });
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        }
                    }, 50)
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('TabReplaced', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            });
        }
    },
    WindowChanged: function () {
        var alertContent_ = new olFunctions.AlertContent('EVT Window changed event', 'Caught by extension');
        chrome.windows.onFocusChanged.addListener(function (windowId) {
            try {
                var waitingForSw_Init = setInterval(function () {
                    if (olExtension.Data.SW_Initialised) {
                        clearInterval(waitingForSw_Init);
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                    }
                }, 50)
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('WindowChanged', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        });
    },
    BrowserWindowClosing: function () {
        var alertContent_ = new olFunctions.AlertContent('EVT Browser window closing', 'Caught by extension');
        chrome.windows.onRemoved.addListener(function (windowId) {
            try {
                var waitingForSw_Init = setInterval(function () {
                    if (olExtension.Data.SW_Initialised) {
                        clearInterval(waitingForSw_Init);

                        if (!olFunctions.IsFilledArray(olData.TabInfoArray.TabMembers)) {
                            //Clear all domain cookies on empty tabmembersarray,  when browser window is closed
                            //Fixes problems that browser will end session and delete cookies with out extension
                            olExtension.Functions.HandleCookiesArray();
                        }
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    }
                }, 50)
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('BrowserWindowClosing', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        });
    }
}

olExtension.Listeners.InitializeEventListeners = function () {
    try {
        olExtension.Listeners._internal.Events.BeforeNavigate();
        olExtension.Listeners._internal.Events.TabRemoved();
        olExtension.Listeners._internal.Events.TabReplaced();
        olExtension.Listeners._internal.Events.TabCreated();
        olExtension.Listeners._internal.Events.WindowChanged();
        olExtension.Listeners._internal.Events.BrowserWindowClosing();
    } catch (e) {
        var alertErrorContent_ = new olFunctions.AlertContent('IntialiseEventListeners', e.message + '\n' + e.stack);
        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
    }
}

olExtension.Listeners.InitializeEventListeners();