//Listen to messages sent from page
olExtension.Listeners = {
    _internal: {
        Messages: {
            Flags: {
                MatterDone: function () {
                    olWrap.addMessageListener('olMatterDone', function (event) {
                        try {
                            var alertContent_ = new olFunctions.AlertContent('MSG Matter done message', 'Received by extension');

                            var waitingForSw_Init = setInterval(function () {
                                if (olExtension.Data.SW_Initialised) {
                                    clearInterval(waitingForSw_Init);
                                    var tabId_ = event.target.getId();
                                    var tabMember_;
                                    var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                    if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                        tabMember_ = filterTabMembers_[0];
                                        tabMember_._internal.PageFlags.MatterDone = event.data;

                                        var filterTabMembersAllWithSameApplicationsSessionId_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, null, null, tabMember_.ApplicationsSessionId);
                                        if (olFunctions.IsFilledArray(filterTabMembersAllWithSameApplicationsSessionId_)) {
                                            for (var i = 0; i < filterTabMembersAllWithSameApplicationsSessionId_.length; i++) {
                                                var currentTabmember_ = filterTabMembersAllWithSameApplicationsSessionId_[i];
                                                currentTabmember_._internal.PageFlags.MatterDone = event.data;
                                            }
                                        }
                                    }
                                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                }
                            }, 50)
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('MatterDone', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    });
                },
                LogonDone: function () {
                    olWrap.addMessageListener('olLogonDone', function (event) {
                        try {
                            var alertContent_ = new olFunctions.AlertContent('MSG Logon done message', 'Received by extension');
                            var waitingForSw_Init = setInterval(function () {
                                if (olExtension.Data.SW_Initialised) {
                                    clearInterval(waitingForSw_Init);
                                    var tabId_ = event.target.getId();
                                    var tabMember_;
                                    var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                    if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                        tabMember_ = filterTabMembers_[0];
                                        tabMember_._internal.PageFlags.LogonDone = event.data;
                                    }
                                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                }
                            }, 50)
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('LogonDone', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    });
                }
            },
            _GetOptionsFromExtension: function () {
                olWrap.addMessageListener('_GetOptionsFromExtension', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Get options from extension message', 'Received by extension');
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                var eventTabId_ = event.target.getId();
                                olExtension.Messages._GetOptionsFromExtensionResponse(eventTabId_);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CloseTab', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _ResponseTo_GetStatisticsFromPage: function () {
                olWrap.addMessageListener('_olResponseTo_GetStatisticsFromPage', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Response to Get statistics from extension message', 'Received by extension');

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var eventTabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, eventTabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];
                                }

                                for (var i = 0; i < event.data.Statistics.Summary.length; i++) {
                                    var eventData_ = event.data.Statistics.Summary[i];
                                    olData._DebugStatistics.Summary.push(
                                        {
                                            Message: eventData_.Message,
                                            Count: eventData_.Count,
                                            Source: 'Page:' + tabMember_.PageInfo.LastUrl + (tabMember_.ApplicationName ? '(' + tabMember_.ApplicationName + ')' : '')
                                        }
                                    )
                                }

                                for (var i = 0; i < event.data.Statistics.Summary.length; i++) {
                                    var eventData_ = event.data.Statistics.Transactions[i];
                                    olData._DebugStatistics.Transactions.push(
                                        {
                                            Message: eventData_.Message,
                                            Time: eventData_.Time,
                                            Source: 'Page:' + tabMember_.PageInfo.LastUrl + (tabMember_.ApplicationName ? ' (' + tabMember_.ApplicationName + ')' : '')
                                        }
                                    )
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CloseTab', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetAnalysisRequest: function () {
                olWrap.addMessageListener('olSetAnalysisRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set analysis request message', 'Received by extension');

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();

                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);
                                    olExtension.Service.SetAnalysisRequest(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('messages.SetAnalysisRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ApplicationRequest: function () {
                olWrap.addMessageListener('olApplicationRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Application request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);
                                var tabId_ = event.target.getId();
                                var applicationsSessionId_ = event.data.ApplicationsSessionId;

                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, applicationsSessionId_);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];
                                    tabMember_.ApplicationName = event.data.ApplicationName;

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);

                                    olExtension.Service.ApplicationRequestSend(requestContent_);
                                }

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ApplicationRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            CheckMatterGlobalRequest: function () {
                olWrap.addMessageListener('olCheckMatterGlobalRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Check matter global request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();

                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);
                                    olExtension.Service.CheckMatterGlobalRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _alreadySentValue: null,
            GrabMatterValue: function () {
                olWrap.addMessageListener('olGrabMatterValue', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Grab matter value from page message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);

                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    // if (tabMember_._internal.PageFlags.MatterNumber != event.data) {
                                    if (!olExtension.Listeners._internal.Messages._alreadySentValue || olExtension.Listeners._internal.Messages._alreadySentValue != event.data) {
                                        //New value send it to page
                                        tabMember_._internal.PageFlags.MatterNumber = event.data;

                                        if (!olExtension.Listeners._internal.Messages._alreadySentValue || olExtension.Listeners._internal.Messages._alreadySentValue != event.data)
                                            var sendGrabedMatterValueToPage_ = {
                                                MatterNumber: event.data
                                            };

                                        var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMember_, sendGrabedMatterValueToPage_);
                                        olExtension.Messages.SendGrabedMatterValueToPage(messageContent_);
                                    }
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('GrabMatterValue', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RequestSearchSharedUsersRequest: function () {
                olWrap.addMessageListener('olRequestSearchSharedUsersRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Search shared users request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();

                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);
                                    olExtension.Service.RequestSearchSharedUsersRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ContinueSessionRequest: function () {
                olWrap.addMessageListener('olContinueSessionRequest', function (event) {
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var alertContent_ = new olFunctions.AlertContent('MSG Continue session request message', 'Received by extension Url: ' + event.target.getUrl());

                                var tabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);
                                    olExtension.Service.ContinueSessionRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ContinueSessionRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            CloseTab: function () {
                olWrap.addMessageListener('olCloseTab', function (event) {
                    var alertContent_ = new olFunctions.AlertContent('MSG Close tab message', 'Received by extension Url: ' + event.target.getUrl());
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);
                                olExtension.Functions.CloseTabFunction(event.target, event.data);
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CloseTab', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            DeletePersonalDetailRequest: function () {
                olWrap.addMessageListener('olDeletePersonalDetailRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Delete personal detail request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();

                                var tabMember_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);

                                    olExtension.Service.DeletePersonalDetailRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('DeletePersonalDetailRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            FormSubmit: function () {
                olWrap.addMessageListener('olFormSubmit', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Form submit message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var filterTabMembers_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var tabMember_ = filterTabMembers_[0];
                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);

                                olExtension.Service.FormSubmitRequestSend(requestContent_);
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('FormSubmit', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            FormFilled: function () {
                olWrap.addMessageListener('olFormFilled', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Form filled message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var filterTabMembers_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var tabMember_ = filterTabMembers_[0];
                                tabMember_._internal.ExtensionFlags.FormFillRequestNeeded = true;

                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);

                                //Send FormFilled request only once and only when is DocumentCompleteResponseReceived
                                if (tabMember_._internal.ExtensionFlags.DocumentCompleteResponseReceived && tabMember_._internal.ExtensionFlags.FormFillRequestNeeded &&
                                    !tabMember_._internal.ExtensionFlags.FormFillRequestSent) {
                                    tabMember_._internal.ExtensionFlags.FormFillRequestSent = true;
                                    olExtension.Service.FormFilledSend(requestContent_);
                                }

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('FormFilled', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RequestGetSharedUsersRequest: function () {
                olWrap.addMessageListener('olRequestGetSharedUsersRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Get shared user request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var filterTabMembers_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var tabMember_ = filterTabMembers_[0];

                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);
                                olExtension.Service.RequestGetSharedUsersRequestSend(requestContent_);
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('RequestGetSharedUsersRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ToolbarButtonClicked: function () {
                olWrap.addMessageListener('olToolbarButtonClicked', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Toolbar Button Clicked message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var filterTabMembers_;
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                var tabMember_ = filterTabMembers_[0];

                                var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMember_, event.data);
                                olExtension.Messages.ToolbarButtonClickedResponse(messageContent_);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ToolbarButtonClicked', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            GetSharedPasswordsRequest: function () {
                olWrap.addMessageListener('olGetSharedPasswordsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Get shared password message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var tabMember_ = filterTabMembers_[0];

                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);
                                olExtension.Service.GetSharedPasswordsRequestSend(requestContent_);
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('GetSharedPasswordsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _onDocumentReady: function (targetTab, documentTitle, tabUrl) {
                if (typeof (documentTitle) === 'undefined')
                    documentTitle = targetTab.getTitle();
                if (typeof (tabUrl) === 'undefined')
                    tabUrl = targetTab.getUrl();

                var tabUrl_ = tabUrl;
                var tabId_ = targetTab.getId();

                if (tabUrl_ == olExtension.Data.LogoutUrl) {
                    olExtension._internal.HandleLogoutWindow({ target: targetTab });
                } else {
                    olWrap.tabs.getAll(function (tabs) {
                        for (var i = 0; i < tabs.length; i++) {
                            var currentTabId_ = tabs[i].getId();
                            if (ol$Functions.inArray(currentTabId_, olData.CreatedTabs) == -1) {
                                olData.CreatedTabs.push(currentTabId_);
                            }
                        }

                        var createdTab_ = true;
                        if (ol$Functions.inArray(tabId_, olData.CreatedTabs) == -1) {
                            createdTab_ = false;
                        }

                        if (createdTab_) {
                            chrome.webNavigation.getAllFrames({ tabId: tabId_ }, function (result) {
                                //Check logout array
                                if (olData.LogoutTabs.indexOf(tabId_) == -1) {
                                    // Not a logout tab
                                    // fix target tab for all tab members with that id no matter what
                                    var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);

                                    for (var f = 0; f < filterTabMembers_.length; f++) {
                                        filterTabMembers_[f].TargetTab = targetTab;
                                    }
                                    if (tabUrl_ != null) {
                                        var tabMember_;

                                        filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                        if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                            tabMember_ = filterTabMembers_[0];
                                        } else {
                                            try {
                                                var framesArray_ = [];
                                                for (var i = 0; i < result.length; i++) {
                                                    var currentFrame_ = result[i];
                                                    var currentFrameId_ = currentFrame_.frameId;
                                                    framesArray_.push(currentFrameId_)
                                                }
                                                tabMember_ = olExtension._internal.TabMember.Create(tabId_, tabUrl_, framesArray_);
                                                tabMember_.TargetTab = targetTab;
                                            } catch (e) {
                                                var alertErrorContent_ = new olFunctions.AlertContent('_onDocumentReady chrome.webNavigation.getAllFrames', e);
                                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                            }
                                        }

                                        var urlDomain_ = olFunctions.GetDomainFromUrl(tabUrl_);
                                        if (urlDomain_ && (ol$Functions.inArray(urlDomain_, tabMember_.Domains) == -1)) {
                                            tabMember_.Domains.push(urlDomain_);
                                        }

                                        if (!tabMember_._internal.ExtensionFlags.BeforeNavigateRequestSent) {
                                            var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);
                                            olExtension.Service.BeforeNavigateRequestSend(requestContent_);
                                        }

                                        tabMember_._internal.ExtensionFlags.DocumentReady = true;
                                        tabMember_.DocumentTitle = documentTitle;

                                        var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMember_);

                                        if (tabMember_._internal.ExtensionFlags.Error) {
                                            olExtension.Messages.Error(messageContent_);
                                            return;
                                        }

                                        if (tabMember_._internal.ExtensionFlags.ErrorState) {
                                            olExtension._internal.TabMember.RemoveOnErrorState(tabMember_);
                                            return;
                                        }

                                        if (olFunctions.IsFilledArray(tabMember_.PageInfo.Response.BeforeNavigateResponses) && !tabMember_.PageInfo.Response.BeforeNavigateResponses[0].AppIdSpecified && tabMember_.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId) {
                                            olExtension.Messages.ChooseApplicationDispatchMessage(messageContent_);
                                        } else {
                                            olExtension.Messages.BeforeNavigateRequestDispatchResponse(messageContent_);
                                        }
                                    }
                                } else {
                                    // ne moze da se salje logoutTabMember_, ff puca iz nepoznatog razloga
                                    // pokusacu da posaljem samo closing response

                                    var logoutTabMember_ = olExtension._internal.TabMember.GetLogoutTM(true, olExtension.Data.WindowHandle, tabId_);
                                    if (logoutTabMember_) {
                                        var closingResponses_ = logoutTabMember_.PageInfo.ClosingResponse;
                                        if (closingResponses_) {
                                            var LogoutClosingResponseSentInterval_ = ol$Functions.grep(olData.LogoutClosingResponseSentIntervals, function (interval) {
                                                return (interval.tabId == tabId_);
                                            });
                                            if (olFunctions.IsFilledArray(LogoutClosingResponseSentInterval_)) {
                                                return;
                                            } else {
                                                var interval_ = setInterval(function () {
                                                    targetTab.dispatchMessage('olLogoutMember', closingResponses_);
                                                }, 100);
                                                olData.LogoutClosingResponseSentIntervals.push({
                                                    tabId: tabId_,
                                                    interval: interval_
                                                });
                                            }

                                            if (olOptions.DebugApiMess()) {
                                                //auto close tab after 30000 ms if in debugging/development
                                                olExtension.Functions.CloseTabFunction(targetTab, 30000);
                                            } else {
                                                //auto close tab after 10000 ms in release
                                                olExtension.Functions.CloseTabFunction(targetTab, 10000);
                                            }
                                        }
                                    } else {
                                        logoutTabMember_ = olExtension._internal.TabMember.GetLogoutTM(false, null, tabId_);
                                        var alertErrorContent_ = new olFunctions.AlertContent('ERROR: Resource did not perform lougout! tabid = ' + tabId_ + '  tabUrl = ' + tabUrl_ + ' documentTitle = ' + documentTitle + ' logoutTabMember : ' + logoutTabMember_, '');
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                    return;
                                }
                            })
                        } else {
                        }
                    });
                }
            },
            DocumentReady: function () {
                olWrap.addMessageListener('olDocumentReady', function (event) {

                    var waitingForSw_Init = setInterval(function () {
                        if (olExtension.Data.SW_Initialised) {
                            clearInterval(waitingForSw_Init);

                            if (event.target.url == olExtension.Data.LogoutUrl) {
                                olExtension._internal.HandleLogoutWindow(event);
                            } else {
                                try {
                                    var alertContent_ = new olFunctions.AlertContent('MSG Document ready message', 'Received by extension Url: ' + event.target.getUrl());

                                    olExtension.Listeners._internal.Messages._onDocumentReady(event.target, event.data);

                                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('olExtension.Listeners.Messages.DocumentReady', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            }
                        }
                    }, 50)
                });
            },
            _processedTabsFrames: {},
            previousInjectionParameters: '',
            count: 0,
            InsertIntoSubframes: function () {
                olWrap.addMessageListener('olInsertIntoSubframes', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Insert Into Subframes message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var url_ = event.target.getUrl();

                                olExtension.Listeners._internal.Messages._onLoadFunction(tabId_, url_, event);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('olExtension.Listeners.Messages.InsertIntoSubframes', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            WindowHashChange: function () {
                olWrap.addMessageListener('olWindowHashChange', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Window hash change message', 'Received by extension Url: ' + event.data.Url);

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                chrome.webNavigation.getAllFrames({ tabId: tabId_ }, function (result) {
                                    var tabMember_;
                                    var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, event.data.Url, null);
                                    if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                        tabMember_ = filterTabMembers_[0];
                                    } else {
                                        try {
                                            var framesArray_ = [];
                                            for (var i = 0; i < result.length; i++) {
                                                var currentFrame_ = result[i];
                                                var currentFrameId_ = currentFrame_.frameId;
                                                framesArray_.push(currentFrameId_)
                                            }
                                            tabMember_ = olExtension._internal.TabMember.Create(tabId_, event.data.Url, framesArray_);
                                            tabMember_.TargetTab = targetTab;
                                        } catch (e) {
                                            var alertErrorContent_ = new olFunctions.AlertContent('WindowHashChange chrome.webNavigation.getAllFrames', e);
                                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                        }
                                    }

                                    tabMember_.TargetTab = event.target;
                                    olExtension.Listeners._internal.Messages._onDocumentReady(tabMember_.TargetTab, event.data.Title, event.data.Url);

                                })

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('olExtension.Listeners.Messages.WindowHashChange', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ProcessPageCompleted: function () {
                olWrap.addMessageListener('olProcessPageCompleted', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Process page completed message', 'Received by extension Url: ' + event.target.getUrl());
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ProcessPageCompleted', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            PersonalDetailsChosenRequest: function () {
                olWrap.addMessageListener('olPersonalDetailsChosenRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Personal details chosen request completed message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                olExtension.Service.PersonalDetailsChosenRequestSend(requestContent_);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('PersonalDetailsChosenRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            PulseRequest: function () {
                //this is obsolete since pulse interval moved to extension page
                olWrap.addMessageListener('olPulseRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Pulse', 'Received by extension');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var tabId_ = event.target.getId();

                        olExtension.Service.PulseRequestSend(tabId_);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('PulseRequest message', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            LogoutSequenceCompleted: function () {
                olWrap.addMessageListener('olLogoutSequenceCompleted', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Logout Sequence Completed', 'Received by extension');

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);


                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var applicationSessionId_ = event.data;

                                var tabMembers_ = olExtension._internal.TabMember.FilterLogoutInfoArray(null, null, applicationSessionId_);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    for (var i = 0; i < tabMembers_.length; i++) {
                                        olExtension._internal.TabMember.RemoveLogout(tabMembers_[i]);
                                    }
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('LogoutSequenceCompleted, Extension', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCommentRequest: function () {
                olWrap.addMessageListener('olSetCommentRequest', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Set comment request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SetCommentRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommentRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCommentEditRequest: function () {
                olWrap.addMessageListener('olSetCommentEditRequest', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Set comment edit request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SetCommentEditRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommentEditRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCurrentPersonalDetailsRequest: function () {
                olWrap.addMessageListener('olSetCurrentPersonalDetailsRequest', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Set current personal details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                //var tabUrl_ = event.url;
                                var tabUrl_ = event.target.getUrl()
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                olExtension.Service.SetCurrentPersonalDetailsRequestSend(requestContent_);
                                olExtension.BasicAuthentication.HandleBasicAuthentication(tabMembers_[0], event.data.Details.Variables);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCurrentSharedPasswordRequest: function () {
                olWrap.addMessageListener('olSetCurrentSharedPasswordRequest', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Set current shared password request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                olExtension.Service.SetCurrentSharedPasswordRequestSend(requestContent_);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            UnSetCurrentSharedPasswordRequest: function () {
                olWrap.addMessageListener('olUnSetCurrentSharedPasswordRequest', function (event) {
                    try {
                        // olExtension.Functions._parseEventDataExtension(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Unset current shared password message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                olExtension.Service.UnSetCurrentSharedPasswordRequestSend(requestContent_);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('UnSetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetPersonalDetailsRequest: function () {
                olWrap.addMessageListener('olSetPersonalDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set personal details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SetPersonalDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCommonDetailsRequest: function () {
                olWrap.addMessageListener('olSetCommonDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set common details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SetCommonDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommonDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetTempPersonalDetailsRequest: function () {
                olWrap.addMessageListener('olSetTempPersonalDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set temp personal details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SetTempPersonalDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetTempPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            TempRecordDetailsRequest: function () {
                olWrap.addMessageListener('olTempRecordDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Temp record details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.TempRecordDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('TempRecordDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            StorePasswordRequest: function () {
                olWrap.addMessageListener('olStorePasswordRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Store password request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.StorePasswordRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('StorePasswordRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            StorePasswordSharedRequest: function () {
                olWrap.addMessageListener('olStorePasswordSharedRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Store shared password request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.StorePasswordSharedRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('StorePasswordSharedRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SkipMatterDetailsRequest: function () {
                olWrap.addMessageListener('olSkipMatterDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Skip matter details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SkipMatterDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SkipMatterDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SkipPersonalDetailsRequest: function () {
                olWrap.addMessageListener('olSkipPersonalDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Skip personal details request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);
                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.SkipPersonalDetailsRequestSend(requestContent_);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RefreshOptions: function () {
                olWrap.addMessageListener('olRefreshOptions', function () {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Refresh options message', 'Received by extension');
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olOptions._internal.Get();

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('RefreshOptions', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            JsonMv3BuilderTestingMode: function () {
                olWrap.addMessageListener('olJsonMv3BuilderTestingMode', function (event) {
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olExtension.Data.JsonMv3TestingScript = event.data;

                                var alertContent_ = new olFunctions.AlertContent('MSG Json Mv3 Builder Testing Mode, Script: ' + event.data, 'Received by extension');
                                olFunctions.Alert(true, alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('JsonMv3BuilderTestingMode', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            UpdateResponse: function () {
                olWrap.addMessageListener('olUpdateResponse', function (event) {
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);
                                var tabPrevious_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, event.target.getId(), null, null)[0];

                                try {
                                    var responsePrevious_ = JSON.stringify(tabPrevious_.PageInfo.Response);
                                    var pageFlagsPrevious_ = JSON.stringify(tabPrevious_._internal.PageFlags);
                                    var selectedUserPrevious_ = JSON.stringify(tabPrevious_._internal.SelectedUser);
                                    var documentTitlePrevious_ = JSON.stringify(tabPrevious_.DocumentTitle);
                                } catch (error) {
                                    var responsePrevious_ = JSON.stringify(olFunctions.RemoveComments(tabPrevious_.PageInfo.Response))
                                    var pageFlagsPrevious_ = JSON.stringify(olFunctions.RemoveComments(tabPrevious_._internal.PageFlags));
                                    var selectedUserPrevious_ = JSON.stringify(olFunctions.RemoveComments(tabPrevious_._internal.SelectedUser));
                                    var documentTitlePrevious_ = JSON.stringify(olFunctions.RemoveComments(tabPrevious_.DocumentTitle));
                                }

                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, null, null, event.data.Response.BeforeNavigateResponses[0].ApplicationsSessionId);

                                if (!olFunctions.IsFilledArray(tabMembers_)) {
                                    tabMembers_ = olExtension._internal.TabMember.FilterLogoutInfoArray(olExtension.Data.WindowHandle, null, event.data.Response.BeforeNavigateResponses[0].ApplicationsSessionId);
                                }

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    for (var i = 0; i < tabMembers_.length; i++) {
                                        // we will copy variable replacements, start time and pause duration and page flags
                                        if (event.data.Response.BeforeNavigateResponses && event.data.Response.BeforeNavigateResponses[0]) {
                                            // FIX **************
                                            var currentTabMemberBnr_ = tabMembers_[i].PageInfo.Response.BeforeNavigateResponses[0];
                                            var pageBnr_ = event.data.Response.BeforeNavigateResponses[0];
                                            var matterArray_ = tabMembers_[i].PageInfo.DefinedNames.MatterArray;
                                            var timeKeeperArray_ = tabMembers_[i].PageInfo.DefinedNames.TimeKeeperArray;
                                            var commentArray_ = tabMembers_[i].PageInfo.DefinedNames.CommentArray;

                                            try {
                                                if (pageBnr_ && pageBnr_.VariableReplacement && olFunctions.IsFilledArray(pageBnr_.VariableReplacement.Variables)) {

                                                    for (var p = 0; p < pageBnr_.VariableReplacement.Variables.length; p++) {
                                                        var currentVariable_ = pageBnr_.VariableReplacement.Variables[p];

                                                        if (ol$Functions.inArray(currentVariable_.DefinedName, matterArray_) != -1) {
                                                            if (!currentVariable_.Value) {
                                                                // we NEVER set matter number to empty value so we are using previous version
                                                                // bug was with 2 tabs open and first one not setting matter and other one sets value to real value
                                                                // and then first tab (sometimes) owerwrites matter value in 1st 15 seconds were injection is working
                                                                // https://www.ndrin.com/
                                                                // https://henchman.atlassian.net/browse/ON-2572
                                                                currentVariable_.Value = currentTabMemberBnr_.VariableReplacement.Variables[p].Value;

                                                                if (currentVariable_.Value) {
                                                                    //If there is a value set, then set MatterDone flag as well
                                                                    event.data.PageFlags.MatterDone = true;
                                                                }
                                                            }
                                                        }

                                                        if (ol$Functions.inArray(currentVariable_.DefinedName, timeKeeperArray_) != -1) {
                                                            if (!pageBnr_.VariableReplacement.Variables[p].Value) {
                                                                //Similar for timekeeper
                                                                pageBnr_.VariableReplacement.Variables[p].Value = currentTabMemberBnr_.VariableReplacement.Variables[p].Value;
                                                            }
                                                        }

                                                        if (ol$Functions.inArray(currentVariable_.DefinedName, commentArray_) != -1) {
                                                            if (!pageBnr_.VariableReplacement.Variables[p].Value) {
                                                                //Similar for comment
                                                                pageBnr_.VariableReplacement.Variables[p].Value = currentTabMemberBnr_.VariableReplacement.Variables[p].Value;
                                                            }
                                                        }
                                                    }

                                                    if (!pageBnr_.MatterDetails) {
                                                        pageBnr_.MatterDetails = currentTabMemberBnr_.MatterDetails;
                                                    }
                                                }
                                            } catch (error) {

                                            }
                                            // END FIX **********

                                            if (event.data.Response.BeforeNavigateResponses[0].VariableReplacement) {
                                                currentTabMemberBnr_.VariableReplacement = pageBnr_.VariableReplacement;
                                            }

                                            currentTabMemberBnr_.StartTime = pageBnr_.StartTime;
                                            currentTabMemberBnr_.PauseDuration = pageBnr_.PauseDuration;
                                            currentTabMemberBnr_.ShowStartMessage = pageBnr_.ShowStartMessage ? pageBnr_.ShowStartMessage : false;
                                        }

                                        tabMembers_[i]._internal.PageFlags = event.data.PageFlags;
                                        tabMembers_[i]._internal.SelectedUser = event.data.SelectedUser;
                                        tabMembers_[i].DocumentTitle = event.data.Title;
                                        tabMembers_[i].InjectionParameters = event.data.InjectionParameters;

                                        var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMembers_[i]);
                                        olExtension.Messages.UpdateSubFrames(messageContent_);
                                    }
                                } else {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Update before navigate response message received', 'Error: no tab member(AppSesId:' + event.data.Response.BeforeNavigateResponses[0].ApplicationsSessionId + ')');
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                                var tabCurrent_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, event.target.getId(), null, null)[0];

                                try {
                                    var responseCurrent_ = JSON.stringify(tabCurrent_.PageInfo.Response);
                                    var pageFlagsCurrent_ = JSON.stringify(tabCurrent_._internal.PageFlags);
                                    var selectedUserCurrent_ = JSON.stringify(tabCurrent_._internal.SelectedUser);
                                    var documentTitleCurrent_ = JSON.stringify(tabCurrent_.DocumentTitle);
                                } catch (error) {
                                    var responseCurrent_ = JSON.stringify(olFunctions.RemoveComments(tabCurrent_.PageInfo.Response));
                                    var pageFlagsCurrent_ = JSON.stringify(olFunctions.RemoveComments(tabCurrent_._internal.PageFlags));
                                    var selectedUserCurrent_ = JSON.stringify(olFunctions.RemoveComments(tabCurrent_._internal.SelectedUser));
                                    var documentTitleCurrent_ = JSON.stringify(olFunctions.RemoveComments(tabCurrent_.DocumentTitle));
                                }

                                //This is for update of storage data, optimization is working in this case, we are not saving 
                                if (
                                    (responsePrevious_ !== responseCurrent_) ||
                                    (pageFlagsPrevious_ !== pageFlagsCurrent_) ||
                                    (selectedUserPrevious_ !== selectedUserCurrent_) ||
                                    (documentTitlePrevious_ !== documentTitleCurrent_)
                                ) {
                                    olWrap.storage.asyncSetOlData(olData);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('UpdateResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ValidateSelectedMatterRequest: function () {
                olWrap.addMessageListener('olValidateSelectedMatterRequest', function (event) {
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request message', 'Received by extension Url: ' + event.target.getUrl());

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    olExtension.Service.ValidateSelectedMatterRequestSend(requestContent_);
                                } else {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Validate selected matter request message received', 'Error: no tab member');
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ValidateSelectedMatterRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ValidateSelectedMatterRequestWithoutResponse: function () {
                olWrap.addMessageListener('olValidateSelectedMatterRequestWithoutResponse', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request without response message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabUrl_ = event.url;
                                var tabId_ = event.target.getId();
                                var tabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, tabUrl_, null);

                                if (olFunctions.IsFilledArray(tabMembers_)) {
                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMembers_[0], event.data);
                                    requestContent_.withoutResponse = true;
                                    olExtension.Service.ValidateSelectedMatterRequestSend(requestContent_);
                                } else {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Validate selected matter request message received', 'Error: no tab member');
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('olExtension.ValidateSelectedMatterRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            QuittingResourceSessionRequest: function () {
                olWrap.addMessageListener('olQuittingResourceSessionRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Quitting resource session request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, null, null, event.data.ApplicationSessionId);

                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    for (var i = 0; i < filterTabMembers_.length; i++) {
                                        if (filterTabMembers_[i].TabId == tabId_) {
                                            tabMember_ = filterTabMembers_[i];
                                        } else {
                                            //IE closes tabs here so we will too
                                            filterTabMembers_[i].TargetTab.close();
                                        }
                                    }

                                    if (tabMember_) {
                                        if (event.data.CloseTab) {
                                            //tabMember_.TargetTab = event.target;
                                            tabMember_.CloseTab = true;
                                        }

                                        var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_);
                                        olExtension.Service.QuittingResourceSessionRequestSend(requestContent_);
                                    }
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('QuittingResourceSessionRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            //Analysis
            SetFeaturesRequest: function () {
                olWrap.addMessageListener('olSetFeaturesRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set features request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, event.data.ApplicationSessionId);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);

                                    olExtension.Service.SetFeaturesRequestSend(requestContent_);
                                }

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetFeaturesRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            LogoutMemberReceived: function () {
                olWrap.addMessageListener('olLogoutMemberReceived', function (event) {
                    try {
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var LogooutClosingResponseSentInterval_ = ol$Functions.grep(olData.LogoutClosingResponseSentIntervals, function (interval) {
                                    return (interval.tabId == tabId_);
                                });
                                if (olFunctions.IsFilledArray(LogooutClosingResponseSentInterval_)) {
                                    clearInterval(LogooutClosingResponseSentInterval_[0].interval);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('LogoutMemberReceived', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            //WebControl
            StartMessageSeenRequest: function () {
                olWrap.addMessageListener('olStartMessageSeenRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Start message seen request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);

                                    olExtension.Service.StartMessageSeenRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('StartMessageSeenRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            HideStartMessageRequest: function () {
                olWrap.addMessageListener('olHideStartMessageRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Hide start message request message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var tabMember_;

                                var filterTabMembers_ = olExtension._internal.TabMember.Filter(olExtension.Data.WindowHandle, tabId_, null, null);
                                if (olFunctions.IsFilledArray(filterTabMembers_)) {
                                    tabMember_ = filterTabMembers_[0];

                                    var requestContent_ = new olExtension.DataConstructors.RequestContent(tabMember_, event.data);

                                    olExtension.Service.HideStartMessageRequestSend(requestContent_);
                                }
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('HideStartMessageRequest', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            DomContentLoaded: function () {
                olWrap.addMessageListener('olDomContentLoaded', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Dom content message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                var tabId_ = event.target.getId();
                                olWrap.api.tabsFramesScripts[tabId_] = {};
                                olWrap.api.tabsFramesScripts[tabId_][0] = { scriptsNamesArray: [] };
                                if (!olWrap.urlExcluded(event.target.getUrl())) {
                                    olWrap.api.onDomContentLoaded(event);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('DomContentLoaded', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            WebControlMessageDomContentLoaded: function () {
                olWrap.addMessageListener('olWebControlMessageDomContentLoaded', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Web Control Message Dom content message', 'Received by extension Url: ' + event.target.getUrl());
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olWrap.api._LoadContentCss(event.target.id);

                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('WebControlMessageDomContentLoaded', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _onLoadFunction: function (tabId, url, event) {
                try {
                    var framesArray = [];
                    if (!olWrap.urlExcluded(url)) {
                        var frames_ = [];
                        var oneMessageIsEnough = false;
                        chrome.webNavigation.getAllFrames({ tabId: tabId }, function (result) {
                            var filterMembers_ = olExtension._internal.TabMember.Filter(null, tabId, null, null);
                            if (filterMembers_.length) {
                                //Reset SubframesOnPageToProcess array, because on F5 on page frameIds are changed so we need to get new correct ones
                                filterMembers_[0].SubframesOnPageToProcess = [0];
                            }

                            for (var i = 0; i < result.length; i++) {
                                var processThisSubframe_ = false;
                                var currentFrame_ = result[i];
                                var currentSubframeDomain_ = olFunctions.GetDomainFromUrl(currentFrame_.url);
                                if (ol$Functions.inArray(currentFrame_.frameId, frames_) == -1 && currentFrame_.frameId != 0) {
                                    try {
                                        //TODO: ON-2005 MV3 - Error in service worker console for some untracked pages 
                                        if (filterMembers_[0]) {
                                            for (var j = 0; j < filterMembers_[0]._internal.ExtensionFlags.ProcessSubframesDomains.length; j++) {
                                                var currentDomain_ = olFunctions.GetDomainFromUrl(filterMembers_[0]._internal.ExtensionFlags.ProcessSubframesDomains[j]);
                                                if (currentSubframeDomain_ && currentSubframeDomain_.indexOf(currentDomain_) != -1) {
                                                    processThisSubframe_ = true;
                                                }
                                            }
                                        }
                                        if (processThisSubframe_) {
                                            if (ol$Functions.inArray(currentFrame_.frameId, filterMembers_[0].SubframesOnPageToProcess) == -1) {
                                                filterMembers_[0].SubframesOnPageToProcess.push(currentFrame_.frameId);
                                                if (event && event.data) {
                                                    filterMembers_[0].InjectionParameters = event.data;
                                                } else {
                                                    filterMembers_[0].InjectionParameters = {};
                                                }
                                            }
                                            if (olWrap.api.tabsFramesScripts[tabId][currentFrame_.frameId] && !oneMessageIsEnough) {
                                                oneMessageIsEnough = true;
                                                var newData_ = {
                                                    InjectionParameters: event.data,
                                                }
                                                var messageContent_ = new olExtension.DataConstructors.MessageContent(filterMembers_[0], newData_);
                                                olExtension.Messages.InjectReceivedData(messageContent_);
                                            } else {
                                                frames_.push(currentFrame_.frameId);
                                            }
                                        }
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('_onLoadFunction processing url and frameId', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                }
                            }
                            framesArray = frames_;

                            if (framesArray.length > 0) {
                                olWrap.api.onLoad(tabId, framesArray);
                            }
                        })
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('_onLoadFunction', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            Load: function () {
                olWrap.addMessageListener('olLoad', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Load message', 'Received by extension Url: ' + event.target.getUrl());

                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                var tabId_ = event.target.getId();
                                var url_ = event.target.getUrl();
                                olExtension.Listeners._internal.Messages._onLoadFunction(tabId_, url_);
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ExecMV3Script: function () {
                olWrap.addMessageListener('olExecMV3Script', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Execute script MV3 message', 'Received by extension Url: ' + event.target.getUrl());
                        var waitingForSw_Init = setInterval(function () {
                            if (olExtension.Data.SW_Initialised) {
                                clearInterval(waitingForSw_Init);

                                var tabId_ = event.target.getId();
                                var filterMembers_ = olExtension._internal.TabMember.Filter(null, tabId_, null, null);

                                var params_ = event.data;
                                var now_ = Date.now();

                                //If the MV3 Inject was processed less then 10ms ago then do not print it
                                //DO NOT PUT olWrap.api.onExecScript in this IF
                                if (filterMembers_[0].LastTimeProcessed + 10 < now_) {
                                    filterMembers_[0].LastTimeProcessed = now_;
                                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                }

                                //DO NOT PUT this for in previous IF
                                for (var i = 0; i < filterMembers_[0].SubframesOnPageToProcess.length; i++) {
                                    olWrap.api.onExecScript(params_, tabId_, filterMembers_[0].SubframesOnPageToProcess[i]);
                                }
                            }
                        }, 50)
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ExecMV3Script', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_);
                    }
                });
            },
            AsyncSetItem: function () {
                olWrap.addMessageListener('olAsyncSetItem', function (event) {
                    olWrap.storage.asyncSetItem(event.data.name, event.data.value, function () {
                        event.target.dispatchMessage(event.data.messageName);
                    });
                });
            },
            AsyncGetItem: function () {
                olWrap.addMessageListener('olAsyncGetItem', function (event) {
                    olWrap.storage.asyncGetItem(event.data.name, function (data) {
                        try {
                            if (data) {
                                event.target.dispatchMessage(event.data.messageName, data);
                            } else {
                                event.target.dispatchMessage(event.data.messageName, "");
                            }
                        } catch (e) {
                            olWrap.Console.Log('AsyncGetItem error')
                            olWrap.Console.Log(e.message)
                        }
                    });
                });
            }
        }
    },
    InitializeMessageListeners: function () {
        try {
            olExtension.Listeners._internal.Messages._GetOptionsFromExtension();
            olExtension.Listeners._internal.Messages._ResponseTo_GetStatisticsFromPage();
            olExtension.Listeners._internal.Messages.Flags.MatterDone();
            olExtension.Listeners._internal.Messages.Flags.LogonDone();
            olExtension.Listeners._internal.Messages.ApplicationRequest();
            olExtension.Listeners._internal.Messages.CheckMatterGlobalRequest();
            olExtension.Listeners._internal.Messages.GrabMatterValue();
            olExtension.Listeners._internal.Messages.RequestSearchSharedUsersRequest();
            olExtension.Listeners._internal.Messages.ContinueSessionRequest();
            olExtension.Listeners._internal.Messages.CloseTab();
            olExtension.Listeners._internal.Messages.DeletePersonalDetailRequest();
            olExtension.Listeners._internal.Messages.FormSubmit();
            olExtension.Listeners._internal.Messages.FormFilled();
            olExtension.Listeners._internal.Messages.RequestGetSharedUsersRequest();
            olExtension.Listeners._internal.Messages.ToolbarButtonClicked();
            olExtension.Listeners._internal.Messages.GetSharedPasswordsRequest();
            olExtension.Listeners._internal.Messages.DocumentReady();
            olExtension.Listeners._internal.Messages.InsertIntoSubframes();
            olExtension.Listeners._internal.Messages.PulseRequest();
            olExtension.Listeners._internal.Messages.LogoutSequenceCompleted();
            olExtension.Listeners._internal.Messages.ProcessPageCompleted();
            olExtension.Listeners._internal.Messages.PersonalDetailsChosenRequest();
            olExtension.Listeners._internal.Messages.RefreshOptions();
            olExtension.Listeners._internal.Messages.JsonMv3BuilderTestingMode();
            olExtension.Listeners._internal.Messages.SetCurrentPersonalDetailsRequest();
            olExtension.Listeners._internal.Messages.SetCurrentSharedPasswordRequest();
            olExtension.Listeners._internal.Messages.SetCommentRequest();
            olExtension.Listeners._internal.Messages.SetCommentEditRequest();
            olExtension.Listeners._internal.Messages.SetPersonalDetailsRequest();
            olExtension.Listeners._internal.Messages.SetCommonDetailsRequest();
            olExtension.Listeners._internal.Messages.SetTempPersonalDetailsRequest();
            olExtension.Listeners._internal.Messages.TempRecordDetailsRequest();
            olExtension.Listeners._internal.Messages.StorePasswordRequest();
            olExtension.Listeners._internal.Messages.StorePasswordSharedRequest();
            olExtension.Listeners._internal.Messages.SkipPersonalDetailsRequest();
            olExtension.Listeners._internal.Messages.SkipMatterDetailsRequest();
            olExtension.Listeners._internal.Messages.ValidateSelectedMatterRequest();
            olExtension.Listeners._internal.Messages.ValidateSelectedMatterRequestWithoutResponse();
            olExtension.Listeners._internal.Messages.UpdateResponse();
            olExtension.Listeners._internal.Messages.UnSetCurrentSharedPasswordRequest();
            olExtension.Listeners._internal.Messages.QuittingResourceSessionRequest();
            olExtension.Listeners._internal.Messages.SetFeaturesRequest();
            olExtension.Listeners._internal.Messages.LogoutMemberReceived();
            olExtension.Listeners._internal.Messages.StartMessageSeenRequest();
            olExtension.Listeners._internal.Messages.HideStartMessageRequest();
            olExtension.Listeners._internal.Messages.WindowHashChange();
            olExtension.Listeners._internal.Messages.SetAnalysisRequest();
            olExtension.Listeners._internal.Messages.DomContentLoaded();
            olExtension.Listeners._internal.Messages.WebControlMessageDomContentLoaded();
            olExtension.Listeners._internal.Messages.Load();
            // olExtension.Listeners._internal.Messages.ExecScript();
            olExtension.Listeners._internal.Messages.ExecMV3Script();
            olExtension.Listeners._internal.Messages.AsyncSetItem();
            olExtension.Listeners._internal.Messages.AsyncGetItem();
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('IntialiseMessageListeners', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    }
}

//Send message from extension to page
olExtension.Messages = {
    _GetOptionsFromExtensionResponse: function (tabId) {
        try {
            var tabMembers_ = olExtension._internal.TabMember.Filter(null, tabId, null, null);
            var alertContent_ = new olFunctions.AlertContent('MSG Get statistics from page message', 'Sent by extension');
            var messageContent_ = new olExtension.DataConstructors.MessageContent(tabMembers_[0], olOptions);

            olExtension.Messages._internal.DispatchMessageToTab('ResponseTo_olGetOptionsFromExtension', messageContent_);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetSharedUsersDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _GetStatisticsFromPage: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get statistics from page message', 'Sent by extension');

            olExtension.Messages._internal.DispatchMessageToTab('ol_GetStatisticsFromPage', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetSharedUsersDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    AskToStorePassword: function (messageContent) {
        try {
            if (messageContent.TabMember.TargetTab && messageContent.TabMember._internal.ExtensionFlags.ServiceResponded && messageContent.TabMember._internal.ExtensionFlags.DocumentReady) {
                var alertContent_ = new olFunctions.AlertContent('MSG Ask to store password message', 'Sent by extension');
                olExtension.Messages._internal.DispatchMessageToTab('olAskToStorePassword', messageContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } else {
                setTimeout(function () {
                    olExtension.Messages.AskToStorePassword(messageContent);
                }, 200);
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    FormfillRequestSent: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Form Fill Request sent message', 'Sent by extension');
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

            olExtension.Messages._internal.DispatchMessageToTab('olFormfillRequestSent', messageContent);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SuccessContinueSessionRequestReceived: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Success Continue Session Request Received sent message', 'Sent by extension');
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            olExtension.Messages._internal.DispatchMessageToTab('olSuccessContinueSessionRequestReceived', messageContent);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SuccessContinueSessionRequestReceived', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    BeforeNavigateRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Before navigate request response message', 'Sent by extension');

            if (olExtension.Data.JsonMv3TestingScript) {
                messageContent.TabMember.PageInfo.TestingJsonScripts = true;
            }

            if (!messageContent.TabMember._internal.PageFlags.Unauthorised) {
                if (messageContent.TabMember.TargetTab && messageContent.TabMember._internal.ExtensionFlags.ServiceResponded && messageContent.TabMember._internal.ExtensionFlags.DocumentReady && messageContent.TabMember._internal.ExtensionFlags.MatterDetailFilled && messageContent.TabMember._internal.ExtensionFlags.PersonalCodeFilled) {
                    olExtension.Messages._internal.DispatchMessageToTab('olResponseToBeforeNavigateRequest', messageContent);
                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                    //sending NavigateCompleteRequest
                    var requestContent_ = new olExtension.DataConstructors.RequestContent(messageContent.TabMember);
                    olExtension.Service.NavigateCompleteRequestSend(requestContent_);

                }
            } else if (messageContent.TabMember.TargetTab && messageContent.TabMember._internal.ExtensionFlags.ServiceResponded && messageContent.TabMember._internal.ExtensionFlags.DocumentReady) {
                olExtension.Messages._internal.DispatchMessageToTab('olResponseToBeforeNavigateRequest', messageContent);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                //sending NavigateCompleteRequest
                var requestContent1_ = new olExtension.DataConstructors.RequestContent(messageContent.TabMember);
                olExtension.Service.NavigateCompleteRequestSend(requestContent1_);
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('BeforeNavigateRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    CheckMatterGlobalRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Check matter global request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToCheckMatterGlobalRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GrabedMatterValueSendToPage: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Check matter global request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olGrabedMatterValueSendToPage', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestSearchSharedUsersRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Search Shared Users request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToRequestSearchSharedUsersRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('RequestSearchSharedUsersRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GetSharedUsersDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get shared users request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToRequestGetSharedUsersRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetSharedUsersDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GetSharedPasswordsDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get shared passwords request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToGetSharedPasswordsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('GetSharedPasswordsDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ChooseApplicationDispatchMessage: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG ChooseApplicationDispatchMessage', 'Sent by extension');
            if (messageContent.TabMember._internal.ExtensionFlags.DocumentReady && messageContent.TabMember._internal.ExtensionFlags.ServiceResponded) {
                var alertContent_ = new olFunctions.AlertContent('MSG Choose application message', 'Sent by extension');
                olExtension.Messages._internal.DispatchMessageToTab('olChooseApplication', messageContent);
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ChooseApplicationDispatchMessage', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DeletePersonalDetailRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Delete personal detail request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToDeletePersonalDetailRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('DeletePersonalDetailRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PersonalDetailsChosenRequestDisptachResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Personal details chosen request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToPersonalDetailsChosenRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('PersonalDetailsChosenRequestDisptachResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ResourceTimeout: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Resource timeout message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResourceTimeout', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ResourceTimeout extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SendGrabedMatterValueToPage: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Send grabed matter value to page message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olSendGrabedMatterValueToPage', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SendGrabedMatterValueToPage extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    InjectReceivedData: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Inject received data message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olInjectReceivedData', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('InjectReceivedData extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ToolbarButtonClickedResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Toolbar button clicked response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olToolbarButtonClickedResponse', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ToolbarButtonClickedResponse extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _errorState: false,
    Error: function (messageContent) {
        try {
            if (messageContent.TabMember._internal.ExtensionFlags.DocumentReady) {
                if (!olExtension.Messages._errorState) {
                    olExtension.Messages._errorState = true;
                    var alertContent_ = new olFunctions.AlertContent('MSG Error message', 'Sent by extension');
                    olExtension.Messages._internal.DispatchMessageToTab('olError', messageContent);

                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                }
                olExtension._internal.TabMember.Remove(messageContent.TabMember);
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('Error extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    WebControlMessage: function (messageContent) {
        try {
            if (messageContent.TabMember._internal.ExtensionFlags.DocumentReady) {
                var alertContent_ = new olFunctions.AlertContent('MSG WebControlMessage message', 'Sent by extension');
                olExtension.Messages._internal.DispatchMessageToTab('olWebControlMessage', messageContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('WebControlMessage extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PauseDuration: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Pause duration message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olPauseDuration', messageContent);

            if (!olOptions.DevelopmentVersion()) {
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('PauseDuration extension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentPersonalDetailsRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set current personal details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetCurrentPersonalDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentSharedPasswordRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set current personal details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetCurrentSharedPasswordRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UnSetCurrentSharedPasswordRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Unset current personal details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToUnSetCurrentSharedPasswordRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('UnSetCurrentPersonalDetailsRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentEditRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set comment edit request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetCommentEditRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCommentEditRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipPersonalDetailsRequestDisptachResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Skip personal details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSkipPersonalDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequestDisptachResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set comment request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetCommentRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCommentRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetPersonalDetailsRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set personal details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetPersonalDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetPersonalDetailsRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommonDetailsDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set common details request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToSetCommonDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('SetCommonDetailsDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ValidateSelectedMatterRequestDispatchResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request response message', 'Sent by extension');
            olExtension.Messages._internal.DispatchMessageToTab('olResponseToValidateSelectedMatterRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ValidateSelectedMatterRequestDispatchResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UpdateSubFrames: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Update subframes message', 'Sent by extension');

            olExtension.Messages._internal.DispatchMessageToTab('olUpdateSubFrames', messageContent);

            // olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('UpdateSubFrames', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _internal: {
        DispatchMessageToTab: function (message, messageContent) {
            try {
                messageContent.TabMember.TargetTab.dispatchMessage(message, messageContent.TabMessageContent);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('DispatchMessageToTab', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    }
}

//message listeners
olExtension.Listeners.InitializeMessageListeners();