//Analysis module
var Analysis = {
    dispatchMessage: function (name, data) {
        var messageContent_ = {
            name: name,
            data: data,
            origin: 'tab'
        };
        //chrome.runtime.sendMessage(messageContent_);
        chrome.runtime.sendMessage(messageContent_, function (response) {
            if (!chrome.runtime.lastError) {
                // if you have any response (to avoid unnecessary error in the console)
            }
        });
    },
    _processPageAnalysisNeeded: false,
    FeaturesArray: [],
    // do not change name of this object or names of method in it
    // they are used from server scripts
    OneLogClientResponse: {
        OLSendData: function (messageContent) {
            Analysis.dispatchMessage('olSetAnalysisRequest', messageContent);
        }
    },
    Process: function (obj) {
        "olInternalJS";
        try {
            window.OnelogClientResponse = Analysis.OneLogClientResponse;
            var url = location.href.toLowerCase();
            switch (true) {
                case (obj.matchURLs !== undefined):
                    //var url = location.href.toLowerCase();
                    for (var i = 0; i < obj.matchURLs.length; i++) {
                        if (url.indexOf(obj.matchURLs[i]) > -1) {
                            Analysis.OLPrepareData(obj);
                        }
                    }
                    break;
                case (obj.nonMatchURLs !== undefined):
                    //var url = location.href.toLowerCase();
                    var counter = 0;
                    for (var i = 0; i < obj.nonMatchURLs.length; i++) {
                        if (url.indexOf(obj.nonMatchURLs[i]) == -1) {
                            counter = counter + 1;
                        }
                    }
                    if (counter == obj.nonMatchURLs.length) {
                        Analysis.OLPrepareData(obj);
                    }
                    break;
                default:
                    Analysis.OLPrepareData(obj);
                    break;
            }
        } catch (e) {
            // console.log("AnalysisCode ERROR!!!!!!!!!!!!!!!!!", e); console.log(e);
        }
    },
    CheckSetFeaturesRequestSend: function (featuresArray) {
        var sendRequest_ = false;
        if (featuresArray.length == Analysis.FeaturesArray.length) {
            for (var i = 0; i < featuresArray.length; i++) {
                var containsFeature_ = false;
                for (var j = 0; j < Analysis.FeaturesArray.length; j++) {
                    if (Analysis.FeaturesArray[j].UID == featuresArray[i].UID) {
                        containsFeature_ = true;
                        if (Analysis.FeaturesArray[j].Item.length == featuresArray[i].Item.length) {
                            for (var k = 0; k < featuresArray[i].Item.length; k++) {
                                var tempItemsArray_ = $.grep(Analysis.FeaturesArray[j].Item, function (member) {
                                    return ((String(member.Label) == String(featuresArray[i].Item[k].Label)) && ((String(member.Value) == String(featuresArray[i].Item[k].Value))));
                                });
                                if (!olFunctions.IsFilledArray(tempItemsArray_)) {
                                    sendRequest_ = true;
                                    break;
                                }
                            }
                        } else {
                            sendRequest_ = true;
                            break;
                        }
                    }
                    if (containsFeature_) {
                        break;
                    }
                }
                if (!containsFeature_) {
                    sendRequest_ = true;
                }
                if (sendRequest_) {
                    break;
                }
            }
        } else {
            sendRequest_ = true;
        }

        return sendRequest_;
    },
    pageContent: null,
    ProcessAnalysis: function (applicationType, jscodeArray) {
        try {
            switch (applicationType) {
                case 'FP':
                    window.OnelogClientResponse = Analysis.OneLogClientResponse;
                    var currentJsCode_ = '';
                    for (var i = 0; i < jscodeArray.length; i++) {
                        currentJsCode_ = currentJsCode_ + atob(jscodeArray[i].jsCode);
                    }

                    var atobCode_ = '"olInternalJS";window.OnelogClientResponse = Analysis.OneLogClientResponse;try{' + currentJsCode_ + '}catch(e){console.log("AnalysisCode ERROR!!!!!!!!!!!!!!!!!");console.log(e)};';

                    olfWrap.browser.execScript(atobCode_)
                    break;
                default:
                    if (Analysis.pageContent.Data.PageInfo !== null && olFunctions.IsFilledArray(Analysis.pageContent.Data.PageInfo.Response.BeforeNavigateResponses)) {
                        olInjection.ElementValue.SetDocuments();
                        for (var i = 0; i < Analysis.pageContent.Data.PageInfo.Response.BeforeNavigateResponses.length; i++) {
                            var currentBnr_ = Analysis.pageContent.Data.PageInfo.Response.BeforeNavigateResponses[i];

                            if (olFunctions.IsFilledArray(currentBnr_.Features)) {
                                // Regular Analysis ---------------------------------------------------------------------------------------
                                var FeaturesArray_ = new Array();

                                for (var j = 0; j < currentBnr_.Features.length; j++) {
                                    var urls_ = currentBnr_.Features[j].URLS;
                                    var nonMatchUrls_ = currentBnr_.Features[j].NonMatchURLs;
                                    // Checking if document needs to be processed
                                    var processAnalysis_ = olFunctions.CheckUrls(urls_, nonMatchUrls_);
                                    if (processAnalysis_ && olFunctions.IsFilledArray(currentBnr_.Features[j].GrabTextItems)) {
                                        if (olFunctions.IsFilledArray(currentBnr_.Features[j].AttachEvents)) {
                                            // attach to events
                                            Analysis.pageContent.Content.AttachEvents(currentBnr_.Features[j], true, currentBnr_.Features[j]);
                                        } else {
                                            // process on document complete
                                            var featuresElement_ = {
                                                UID: currentBnr_.Features[j].UID,
                                                Label: currentBnr_.Features[j].Title,
                                                Item: []
                                            };
                                            // fill feature elements item array
                                            for (var k = 0; k < currentBnr_.Features[j].GrabTextItems.length; k++) {
                                                olFunctions.PPA_PushItem(currentBnr_.Features[j].GrabTextItems[k], featuresElement_, FeaturesArray_);
                                            }
                                            if (olFunctions.IsFilledArray(featuresElement_.Item)) {
                                                FeaturesArray_.push(featuresElement_);
                                            }
                                        }
                                    }
                                }

                                if (olFunctions.IsFilledArray(FeaturesArray_)) {
                                    var sendRequest_ = Analysis.CheckSetFeaturesRequestSend(FeaturesArray_);
                                    if (sendRequest_) {
                                        Analysis.FeaturesArray = FeaturesArray_;
                                        var Features_ = {
                                            Features: FeaturesArray_
                                        };
                                        Analysis.pageContent.Messages.SetFeaturesRequest(Features_);
                                    }
                                }
                            }

                            //FOR FIREFOX??? check it
                            if (currentBnr_.AnalysisCode && currentBnr_.AnalysisCode !== null) {
                                // New Analysis --------------------------------------------------------------------------------------------
                                var atobCode_ = currentBnr_.AnalysisCode;
                                olInjection.JSExec('olJSInjectAfter', atobCode_);
                            }
                        }
                    }
                    Analysis.FinishedAnalysis();
                    break;
            }

        } catch (e) {
            console.log('ProcessAnalysis ERROR', e)
        }
    },
    OLPrepareData: function (obj) {
        var objectNode = 'findElement';
        var objectNodeAfterEvent = 'afterEvent.findElement';
        var objectNodeFindElement = 'findElement.findElement';
        var isInFrame = false;
        if (olResourceSpecFunctions.checkIfPropertyExist(obj, objectNodeFindElement + '.isInIFrame')) {
            isInFrame = true;
        }

        switch (true) {
            case (obj.afterEvent !== undefined):
                try {

                    var trackAllNodesPath_ = olWrap.Functions.findPath(obj, 'trackAll', 'true')
                    switch (true) {
                        case (trackAllNodesPath_ !== ''):
                            elementMain = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNodeAfterEvent, document);
                            if (elementMain) {
                                if (isInFrame) {
                                    elementMain = elementMain.contentDocument;
                                }
                                elementEvents = olResourceSpecFunctions.jsonMV3GetAllElements(obj, trackAllNodesPath_, elementMain)
                            }
                            if (elementEvents) {
                                var event_ = obj.afterEvent.eventName;
                                for (var indx_ = 0; indx_ < elementEvents.length; indx_++) {
                                    elementEvents[indx_].addEventListener(event_, function (event) {
                                        element = olResourceSpecFunctions.OLGrabElement(event.target, obj, trackAllNodesPath_);
                                        Analysis.OLSendDataWrap(element, obj.analysisId);
                                    }, false);
                                }
                            }
                            break;
                        default:
                            elementEvent = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNodeAfterEvent, document)
                            var event_ = obj.afterEvent.eventName;
                            elementEvent.addEventListener(event_, function () {
                                element = olResourceSpecFunctions.OLGrabElement(olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document), obj, objectNode);
                                Analysis.OLSendDataWrap(element, obj.analysisId);
                            }, false);
                            break;
                    }
                } catch (e) {
                }
                break;
            case ((obj.findElement !== undefined) && (obj.findElement.findElement !== undefined)):
                if (obj.findElement.findElement.getParent !== undefined) {
                    //check if getParent
                    var objTemp_ = olFunctions.GetPropertyValue(obj, objectNode);
                    var objTempStr_ = JSON.stringify(objTemp_)
                    var count_ = 0
                    if (objTempStr_) {
                        count_ = (objTempStr_.match(/getParent/g) || []).length;
                        if (count_ > 0) {
                            for (var g = 0; g < count_; g++) {
                                objectNodeFindElement = objectNodeFindElement + '.findElement'
                            }
                        }
                    }
                    elementFinal = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document)
                } else {
                    elementMain = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document);
                    if (isInFrame) {
                        elementMain = elementMain.contentDocument;
                    }
                    elementFinal = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNodeFindElement, elementMain)
                }
                if (elementFinal !== undefined) {
                    element = olResourceSpecFunctions.OLGrabElement(elementFinal, obj, objectNodeFindElement);
                    Analysis.OLSendDataWrap(element, obj.analysisId);
                }
                break;
            case (obj.findTextInPage !== undefined):
                var attributeVal = "onelogGrabbed" + "_" + obj.analysisId;
                element = olResourceSpecFunctions.searchForTextInPage(window, obj.findTextInPage.start, obj.findTextInPage.end, attributeVal);//"onelogGrabbed"+ "_" + obj.findTextInPage.start + "_" +  obj.findTextInPage.end);
                Analysis.OLSendDataWrap(element, obj.analysisId);
                break;
            case (obj.stringFunc !== undefined):
                switch (true) {
                    case (obj.getURL !== undefined):
                        var url_ = window.location.href;
                        element = document.body;
                        var attributeVal = "onelogGrabbed" + "_" + obj.analysisId;
                        if (!element.hasAttribute(attributeVal)) {
                            element.setAttribute(attributeVal, "yes");
                            var resultStr = olResourceSpecFunctions.searchForTextInString(url_, obj.stringFunc.textBetween.start, obj.stringFunc.textBetween.end);
                        }
                        if (resultStr) {
                            Analysis.OLSendDataWrap(resultStr, obj.analysisId);
                        }
                        break;
                    default:
                        element = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document);
                        var attributeVal = "onelogGrabbed" + "_" + obj.analysisId;
                        if (!element.hasAttribute(attributeVal)) {
                            element.setAttribute(attributeVal, "yes");
                            var stringToParse = element.innerHTML;
                            var resultStr = olResourceSpecFunctions.searchForTextInString(stringToParse, obj.stringFunc.textBetween.start, obj.stringFunc.textBetween.end);
                        }
                        if (resultStr) {
                            Analysis.OLSendDataWrap(resultStr, obj.analysisId);
                        }
                        break;
                }
                // element = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document);
                // var attributeVal = "onelogGrabbed" + "_" + obj.analysisId;
                // if (!element.hasAttribute(attributeVal)) {
                //     element.setAttribute(attributeVal, "yes");
                //     var stringToParse = element.innerHTML;
                //     var resultStr = olResourceSpecFunctions.searchForTextInString(stringToParse, obj.stringFunc.textBetween.start, obj.stringFunc.textBetween.end);
                // }
                // if (resultStr) {
                //     Analysis.OLSendDataWrap(resultStr, obj.analysisId);
                // }
                break;
            default:
                element = olResourceSpecFunctions.OLGrabElement(olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, document), obj, objectNode);
                Analysis.OLSendDataWrap(element, obj.analysisId);
        }
    },
    OLSendDataWrap: function (element, analysisId) {
        if (element != "") {
            element = element.trim();
            if (element != "") {
                dataObj = {};
                dataObj.id = analysisId;
                dataObj.value = element;
                if (typeof window.OnelogClientResponse !== undefined) {
                    if (window.OnelogClientResponse != null) {
                        window.OnelogClientResponse.OLSendData(JSON.stringify(dataObj));
                    }
                }
            }
        }
    },
    ActivateAnalysis: function (data) {
        Analysis.pageContent = data;
        if ($.inArray('Analysis', Analysis.pageContent.Content.Modules._internal.NeededModulesArray) > -1) {
            Analysis._processPageAnalysisNeeded = true;
            var alertContent_ = new olFunctions.AlertContent('ActivateAnalysis', 'Page function');
            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
        }
    },
    FinishedAnalysis: function () {
        Analysis.pageContent.Content.Modules._internal._processOngoing = false;
        Analysis._processPageAnalysisNeeded = false;
        Analysis.pageContent.Content.Modules.ProcessModules();
    },
}