/**
 *  OneLog injection object
 */

var olInjection = {
    Parameters: {
        ElementsWithFiredEvents: [],
        Flags: {
            ExtensionEnvironment: true,
            MobileEnvironment: '',
            BrowserName: '',
            Comment: '',
            CommentChanged: false,
            CommentRequest: false,
            InOfflineMode: false,
            MatterNeeded: false,
            MatterDone: false,
            MatterSkipped: false,
            MatterChanged: false,
            MatterFormat: '',
            FinalMatterValue: '',
            MatterFreeInput: false,
            UseMatterInScript: false,
            PersonalCodeNeeded: false,
            PersonalCodeDone: false,
            TimekeeperNumber: '',
            TimekeeperChanged: false,
            LogonNeeded: false,
            LogonNeededForUsername: false,
            LogonNeededForPassword: false,
            LogonCommonNeeded: false,
            LogonCommonNeededForUsername: false,
            LogonCommonNeededForPassword: false,
            LogonDetailsFreeInput: false,
            LogonDone: false,
            LogonSkipped: false,
            ToolbarMinimized: null,
            Unauthorised: false,
            LicenceLimitReachedNeeded: false,
            LicenceLimitReachedDone: false,
            PooledDetailsLimitReachedNeeded: false,
            PooledDetailsLimitReachedDone: false,
            TabId: '',
            PmtUser: true,
            PmtAdmin: false,
            PmtAutomatic: false,
            PassDetailsToSite: true,
            LoginType: 'User',
            UsingSharedPasswords: false,
            ForcedInjected: false,
        },
        CurrentPrompt: '',
        JScript: [],
        Forms: [],
        VariableReplacement: {},
        LogonDataArray: [],
        DefinedNames: {
            UsernameArray: ['username'],
            PasswordArray: ['password'],
            MatterArray: ['matter'],
            CustomArray: [],
            TimeKeeperArray: ['time keeper', 'timekeeper'],
            CommentArray: ['comment']
        },
        InjectFieldColor: '#FFFF80',
        DebugFunctions: true,
        DebugErrors: true,
        DebugPageEventsSubmit: false,
        SubframeEnviroment: false
    },
    //ToolbarMinimized Changed to null so preference on option page can override this on first setting of the toolbar
    //TODO change DebugErrors to false for production
    PageEvents: {
        Matter_onClick: function () {
            try {
                if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                    // simulate click on matter
                    olPage.Messages.ToolbarButtonClicked('ToolbarMenuMatter');
                    $('#olToolbarMenuMatter').click();
                    // lose focus
                    $(this).blur();
                } else {
                    var alertContent_ = new olFunctions.AlertContent('Mobile', 'Matter_onClick not supported in mobile mode');
                    olFunctions.Alert(true, alertContent_);
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('Matter_onClick', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
            }
        },
        Logon_onClick: function () {
            try {
                if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                    // simulate click on logon
                    if (!olInjection.Parameters.Flags.UsingSharedPasswords) {
                        olPage.Messages.ToolbarButtonClicked('ToolbarMenuLogon');
                        $('#olToolbarMenuLogon').click();
                        // lose focus
                        $(this).blur();
                    }
                } else {
                    var alertContent_ = new olFunctions.AlertContent('Mobile', 'Logon_onClick not supported in mobile mode');
                    olFunctions.Alert(true, alertContent_);
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('Logon_onClick', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
            }
        },
        Element_onKeyUp: function (elDefinedName, value) {
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                try {
                    for (var i = 0; i < olInjection.Parameters.VariableReplacement.Variables.length; i++) {
                        var definedNameVariables_ = String(olInjection.Parameters.VariableReplacement.Variables[i].DefinedName);
                        for (var j = 0; j < olPage.Data.FoundElements.length; j++) {
                            var currentFoundElement = olPage.Data.FoundElements[j];
                            if (currentFoundElement.definedName == definedNameVariables_ && currentFoundElement.element) {
                                if (olInjection.Parameters.VariableReplacement.Variables[i].IsPersonal || olInjection.Parameters.Flags.PmtAutomatic) {
                                    olInjection.Parameters.VariableReplacement.Variables[i].AutomaticValue = currentFoundElement.element.value;
                                    break;
                                }
                            }
                        }
                    }

                    // share changes with all tabs
                    olPage.Messages.UpdateResponse();
                    if (olInjection.Parameters.Flags.PmtAutomatic) {
                        // automatic password management, send temp personal detail request
                        olPage.Messages.SetTempPersonalDetailsRequest();
                    }
                    //always send request temp record details
                    olPage.Messages.TempRecordDetailsRequest();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('Element_onKeyUp', e.message + '\n' + e.stack);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
                }
            }
        },
        Element_onChange: function (freeInput, bOnKeyUp, elDefinedName, elValue) {
            if (!freeInput) {
                olInjection.ElementValue._internal.ElementValueSet = false;
            }
            if (bOnKeyUp) {
                olInjection.PageEvents.Element_onKeyUp(elDefinedName, elValue);
            }
        },
        SubmitElement_onClick: function () {
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                try {
                    var alertContent_ = new olFunctions.AlertContent('Submit event', 'Caught by page');
                    olPage.Messages.FormSubmit();
                    olFunctions.Alert(olInjection.Parameters.DebugPageEventsSubmit, alertContent_);
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SubmitElement_onClick', e.message + '\n' + e.stack);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
                }
            }
        },
        Submit: function () {
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                $(document).off('submit');
                $(document).on('submit', 'form', function () {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('Submit event', 'Caught by page');
                        olPage.Messages.FormSubmit();
                        olFunctions.Alert(olInjection.Parameters.DebugPageEventsSubmit, alertContent_);
                    } catch (e) {
                        var alertContent1_ = new olFunctions.AlertContent('olInject.PageEvents.Submit', e.message + '\n' + e.stack);
                        olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent1_);
                    }
                });
            }
        },
        PPA_Event: function (feature) {
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                olInjection.ElementValue.SetDocuments();
                var FeaturesArray_ = [];

                var featuresElement_ = {
                    UID: feature.UID,
                    Label: feature.Title,
                    Item: []
                };

                // fill feature elements item array
                for (var k = 0; k < feature.GrabTextItems.length; k++) {
                    olFunctions.PPA_PushItem(feature.GrabTextItems[k], featuresElement_, FeaturesArray_);
                }
                FeaturesArray_.push(featuresElement_);
                if (olFunctions.IsFilledArray(FeaturesArray_)) {
                    var Features_ = {
                        Features: FeaturesArray_
                    };

                    olPage.Messages.SetFeaturesRequest(Features_);
                }
            }
        }
    },
    ElementValue: {
        _internal: {
            ElementValueSet: false,
            SetTimeoutForInjectElements: false,
            Documents: new Array(),
            _setInjectElement: function (element, value) {
                if (element) {
                    element.value = value;
                    element.autocomplete = "off";
                    element.style.setProperty('background-color', olInjection.Parameters.InjectFieldColor, 'important');
                    element.style.setProperty('background-image', 'none', 'important');
                    element.style.setProperty('color', 'black', 'important');
                    element.style.setProperty('-webkit-box-shadow', '0 0 0px 1000px ' + olInjection.Parameters.InjectFieldColor + ' inset', 'important');
                    element.style.setProperty('-box-shadow', '0 0 0px 1000px ' + olInjection.Parameters.InjectFieldColor + ' inset', 'important');
                }
            },
            // private: get element by id in document and frames if they exist
            GetElementByID: function (elID) {
                var element_ = null;
                for (var i = 0; i < olInjection.ElementValue._internal.Documents.length; i++) {
                    element_ = olInjection.ElementValue._internal.Documents[i].getElementById(elID.toString());
                    if (element_) {
                        break;
                    }
                }
                return element_;
            },
            // private: get elements by name in document and frames if they exist
            GetElementsByName: function (elName) {
                var elements_ = null;
                for (var i = 0; i < olInjection.ElementValue._internal.Documents.length; i++) {
                    var currentDocument = olInjection.ElementValue._internal.Documents[i];
                    elements_ = currentDocument.getElementsByName(elName.toString());
                    if (elements_ && elements_.length && elements_.length > 0) {
                        break;
                    }
                }
                return elements_;
            },
            // private: get the tag type as defined in Onelog, with possible return values: Select, Input, RadioCheck
            GetElementTagType: function (elementToCheck) {
                if (elementToCheck) {
                    if (elementToCheck.tagName.toLowerCase() == 'select') {
                        return 'Select';
                    } else if (elementToCheck.tagName.toLowerCase() == 'input') {
                        if (elementToCheck.type.toLowerCase() == 'radio') {
                            return 'RadioCheck';
                        } else if (elementToCheck.type.toLowerCase() == 'email' || elementToCheck.type.toLowerCase() == 'text' || elementToCheck.type.toLowerCase() == 'password') {
                            return 'Input';
                        } else {
                            var alertContent_ = new olFunctions.AlertContent('GetElementTagType', 'Unrecognized tag type: ' + elementToCheck.type.toLowerCase());
                            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                            return 'Input';
                        }
                    }
                }
                return '';
            },
            _getElementsByAttributeValue: function (attribute, value, container) {
                if (typeof (container) === 'undefined')
                    container = document;
                var result_ = new Array();
                var allElements_ = container.getElementsByTagName('*');
                if (attribute == null) {
                    result_ = allElements_;
                } else {
                    for (var i = 0; i < allElements_.length; i++) {
                        if (allElements_[i].getAttribute(attribute) == value) {
                            result_.push(allElements_[i]);
                        }
                    }
                }
                return result_;
            },
            // private: check if element type prompt needs to be opened
            _openElementTypePromptIfNeeded: function (elementType, elements) {
                var elementsVisible = true;
                if ((typeof elements != 'undefined') && (elements.length)) {
                    elementsVisible = false;
                    for (let index = 0; index < elements.length; index++) {
                        const element = elements[index];
                        if (element.offsetParent !== null) {
                            elementsVisible = true;
                            break;
                        }
                    }
                }
                switch (elementType) {
                    case 'matter':
                        if (olInjection.Parameters.Flags.ExtensionEnvironment && olPage.Data.PageFlags.MatterNeeded && !olPage.Data.PageFlags.MatterDone && olPage.Data.PageFlags.UseMatterInScript && elementsVisible) {
                            olPage.Content._internal.ProcessMatter();
                        }
                        break;
                }
            },
            // private: get the form with provided parameters  in document and frames if they exist
            GetForm: function (accessParam, accessType) {
                var loginFormArray_ = new Array();
                var currentLoginFormByID_ = null;
                var formsArrayByName_ = null;
                var currentLoginFormByIndex_ = null;

                if (accessType == 'noUseForm') {
                    //adding fake form for scripts that have useForm set to false
                    loginFormArray_.push(null);
                } else {
                    for (var i = 0; i < olInjection.ElementValue._internal.Documents.length; i++) {
                        var currentDocument_ = olInjection.ElementValue._internal.Documents[i];
                        switch (accessType) {
                            case 'byID':
                                var tmpLoginFormArray_ = olInjection.ElementValue._internal._getElementsByAttributeValue('id', accessParam.toString(), currentDocument_);
                                for (var j = 0; j < tmpLoginFormArray_.length; j++) {
                                    if (tmpLoginFormArray_[j].tagName.toLowerCase() == 'form') {
                                        loginFormArray_.push(tmpLoginFormArray_[j]);
                                    }
                                }
                                if (loginFormArray_.length == 0) {
                                    currentLoginFormByID_ = currentDocument_.getElementById(accessParam.toString());
                                    if (currentLoginFormByID_) {
                                        if (currentLoginFormByID_.tagName.toLowerCase() == 'form') {
                                            loginFormArray_.push(currentLoginFormByID_);
                                        }
                                    }
                                }
                                break;
                            case 'byName':
                                formsArrayByName_ = currentDocument_.getElementsByName(accessParam);
                                if (olFunctions.IsFilledArray(formsArrayByName_)) {
                                    for (var j = 0; j < formsArrayByName_.length; j++) {
                                        if (formsArrayByName_[j].tagName.toLowerCase() == 'form') {
                                            loginFormArray_.push(formsArrayByName_[j]);
                                        }
                                    }
                                }
                                break;
                            case 'byIndex':
                                currentLoginFormByIndex_ = currentDocument_.forms[accessParam];
                                if (currentLoginFormByIndex_) {
                                    if (currentLoginFormByIndex_.tagName.toLowerCase() == 'form') {
                                        loginFormArray_.push(currentLoginFormByIndex_);
                                    }
                                }
                                break;
                        }
                    }
                    //Attach submit events
                    olInjection.PageEvents.Submit();
                }
                return loginFormArray_;
            },
            // private: get the element by name
            SetValueByElementName: function (value, elementName, instance, containerForm, htmlTagType, attributes, onClick, onKeyUp, onChange, freeInput, elementType, inputReplacementTypeBool, loginType) {
                var elementFound_ = null;
                try {
                    var elements_ = null;
                    if (containerForm) {
                        // This will return an array of matching elements if more than one element is found,
                        // but if only one element is found this statement will return that element, not an array.
                        elements_ = containerForm.elements[elementName];
                    } else {
                        // This will return an array of matching elements.
                        elements_ = olInjection.ElementValue._internal.GetElementsByName(elementName);
                    }
                    //?
                    if (!instance || instance.length < 1) {
                        instance = 1;
                    }
                    if (elements_ && typeof elements_ != 'undefined') {
                        if (typeof elements_.length != 'undefined' && elements_.length > 0) {
                            olInjection.ElementValue._internal._openElementTypePromptIfNeeded(elementType, elements_);

                            // change value
                            for (var i = 0; i < elements_.length; i++) {
                                if (htmlTagType == 'Select') {
                                    elements_[i].selectedIndex = instance - 1;
                                } else if (htmlTagType == 'RadioCheck') {
                                    if (i == instance - 1) {
                                        elements_[i].checked = true;
                                    }
                                } else {
                                    if ((i == (instance - 1)) && (elements_[i])) {
                                        if (value && (elementType == 'matter' || inputReplacementTypeBool)) {

                                            //If Unauthorised then ignore all data that you might receive
                                            if (!olInjection.Parameters.Flags.Unauthorised) {
                                                olInjection.ElementValue._internal._setInjectElement(elements_[i], value);
                                            }


                                            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                                                //Send message to sevrice whenever we change element value
                                                olPage.Messages.FormFilled();
                                            }
                                        }
                                        elementFound_ = elements_[i];

                                        if (onClick) {
                                            olFunctions.olAddEventListener(elements_[i], 'click', onClick);
                                        }
                                        if (onKeyUp) {
                                            olFunctions.olAddEventListener(elements_[i], 'keyup', onKeyUp);
                                        }
                                        if (onChange) {
                                            olFunctions.olAddEventListener(elements_[i], 'input', onChange);
                                        }
                                        if (!freeInput) {
                                            elements_[i].readOnly = true;
                                        }
                                        // LG: NEW - html element attributes processing
                                        olInjection.ElementValue._internal.PerformAttributesChanges(elements_[i], attributes);

                                        break;
                                    }
                                }
                            }
                        } else if (typeof elements_.length == 'undefined') {
                            olInjection.ElementValue._internal._openElementTypePromptIfNeeded(elementType, [elements_]);

                            // change value
                            if (htmlTagType == 'RadioCheck') {
                                // element is not radioCheck
                                // do nothing
                            } else {
                                if (value && (elementType == 'matter' || inputReplacementTypeBool)) {

                                    //If Unauthorised then ignore all data that you might receive
                                    if (!olInjection.Parameters.Flags.Unauthorised) {
                                        olInjection.ElementValue._internal._setInjectElement(elements_, value);
                                    }

                                    if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                                        //Send message to sevrice whenever we change element value
                                        olPage.Messages.FormFilled();
                                    }

                                }

                                elementFound_ = elements_;

                                // LG: NEW - html element attributes processing
                                olInjection.ElementValue._internal.PerformAttributesChanges(elements_, attributes);

                                if (onClick) {
                                    olFunctions.olAddEventListener(elements_, 'click', onClick);
                                }
                                if (onKeyUp) {
                                    olFunctions.olAddEventListener(elements_, 'keyup', onKeyUp);
                                }
                                if (onChange) {
                                    olFunctions.olAddEventListener(elements_, 'input', onChange);
                                }
                                if (!freeInput) {
                                    elements_.readOnly = true;
                                }
                            }
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error SetValueByElementName', 'ElByName: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            AttachEventByElementName: function (elementName, instance, containerForm, htmlTagType, events, bAnalysis, feature) {
                try {
                    var elementFound_ = false;
                    var elements_ = null;

                    if (containerForm) {
                        elements_ = containerForm.elements[elementName];
                    } else {
                        elements_ = olInjection.ElementValue._internal.GetElementsByName(elementName);
                    }

                    if (!instance || instance.length < 1) {
                        instance = 1;
                    }

                    if (elements_ && typeof elements_ != 'undefined') {
                        if (typeof elements_.length != 'undefined' && elements_.length > 0) {
                            for (var i = 0; i < elements_.length; i++) {

                                if ((i == (instance - 1)) && (elements_[i])) {
                                    if (olFunctions.IsFilledArray(events)) {
                                        for (var m = 0; m < events.length; m++) {
                                            if (bAnalysis) {
                                                olInjection.BindElementsForAnalysis(elements_[i], events[m], feature);
                                            } else {
                                                olInjection.BindElementsWithTimeout(elements_[i], events[m]);
                                            }
                                        }
                                    } else {
                                        olInjection.BindElementsWithTimeout(elements_[i], 'click');
                                    }

                                    elementFound_ = true;
                                    break;
                                }

                            }
                        } else if (typeof elements_.length == 'undefined') {
                            if (olFunctions.IsFilledArray(events)) {
                                for (var m = 0; m < events.length; m++) {
                                    if (bAnalysis) {
                                        olInjection.BindElementsForAnalysis(elements_, events[m], feature);
                                    } else {
                                        olInjection.BindElementsWithTimeout(elements_, events[m]);
                                    }
                                }
                            } else {
                                olInjection.BindElementsWithTimeout(elements_, 'click');
                            }
                            elementFound_ = true;
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error ClickByElementName', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            ClickByElementName: function (elementName, instance, containerForm, htmlTagType) {
                try {
                    var elementFound_ = false;
                    var elements_ = null;

                    if (containerForm) {
                        elements_ = containerForm.elements[elementName];
                    } else {
                        elements_ = olInjection.ElementValue._internal.GetElementsByName(elementName);
                    }

                    if (!instance || instance.length < 1) {
                        instance = 1;
                    }

                    if (elements_ && typeof elements_ != 'undefined') {
                        if (typeof elements_.length != 'undefined' && elements_.length > 0) {
                            for (var i = 0; i < elements_.length; i++) {
                                if (htmlTagType == 'Select') {
                                    elements_[i].selectedIndex = instance - 1;
                                } else {
                                    if ((i == (instance - 1)) && (elements_[i])) {
                                        elements_[i].click();
                                        elementFound_ = true;
                                        break;
                                    }
                                }
                            }
                        } else if (typeof elements_.length == 'undefined') {
                            elements_.click();
                            elementFound_ = true;
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error ClickByElementName', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            // private: get the element by index
            SetValueByElementIndex: function (value, elementIndex, instance, containerForm, htmlTagType, customTagName, attributes, onClick, onKeyUp, onChange, freeInput, elementType, inputReplacementTypeBool, loginType) {
                var elementFound_ = null;
                try {
                    var elements_ = null;
                    var tagName_ = 'input';

                    if (customTagName) {
                        tagName_ = customTagName;
                    }

                    if (htmlTagType == 'Select') {
                        tagName_ = 'select';
                    }

                    if (containerForm) {
                        elements_ = containerForm.getElementsByTagName(tagName_);
                    } else {
                        elements_ = document.getElementsByTagName(tagName_);
                    }

                    if (elements_.length > 0) {
                        olInjection.ElementValue._internal._openElementTypePromptIfNeeded(elementType, elements_);

                        // change value
                        for (var i = 0; i < elements_.length; i++) {
                            if ((i == elementIndex) && (elements_[i])) {
                                if (htmlTagType == 'Select') {
                                    elements_[i].selectedIndex = instance - 1;
                                } else if (htmlTagType == 'RadioCheck') {
                                    if (i == instance - 1) {
                                        elements_[i].checked = true;
                                    }
                                } else {
                                    if (value && (elementType == 'matter' || inputReplacementTypeBool)) {

                                        //If Unauthorised then ignore all data that you might receive
                                        if (!olInjection.Parameters.Flags.Unauthorised) {
                                            olInjection.ElementValue._internal._setInjectElement(elements_[i], value);
                                        }

                                        if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                                            //Send message to service whenever we change element value
                                            olPage.Messages.FormFilled();
                                        }
                                    }
                                    if (onClick) {
                                        olFunctions.olAddEventListener(elements_[i], 'click', onClick);
                                    }
                                    if (onKeyUp) {
                                        olFunctions.olAddEventListener(elements_[i], 'keyup', onKeyUp);
                                    }
                                    if (onChange) {
                                        olFunctions.olAddEventListener(elements_[i], 'input', onChange);
                                    }
                                    if (!freeInput) {
                                        elements_[i].readOnly = true;
                                    }
                                    // LG: NEW - html element attributes processing
                                    olInjection.ElementValue._internal.PerformAttributesChanges(elements_[i], attributes);
                                }

                                elementFound_ = elements_[i];
                                break;
                            }
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error SetValueByElementIndex', 'ElByIndex: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            AttachEventByElementIndex: function (elementIndex, instance, containerForm, htmlTagType, customTagName, events, bAnalysis, feature) {
                try {
                    var elementFound_ = false;

                    var elements_ = null;
                    var tagName_ = 'input';

                    if (customTagName) {
                        tagName_ = customTagName;
                    }

                    if (htmlTagType == 'Select') {
                        tagName_ = 'select';
                    }

                    if (containerForm) {
                        elements_ = containerForm.getElementsByTagName(tagName_);
                    } else {
                        elements_ = document.getElementsByTagName(tagName_);
                    }

                    if (elements_.length > 0) {
                        for (var i = 0; i < elements_.length; i++) {
                            if ((i == elementIndex) && (elements_[i])) {

                                if (olFunctions.IsFilledArray(events)) {
                                    for (var m = 0; m < events.length; m++) {
                                        if (bAnalysis) {
                                            olInjection.BindElementsForAnalysis(elements_[i], events[m], feature);
                                        } else {
                                            olInjection.BindElementsWithTimeout(elements_[i], events[m]);
                                        }
                                    }
                                } else {
                                    olInjection.BindElementsWithTimeout(elements_[i], 'click');
                                }

                                elementFound_ = true;
                                break;
                            }
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error ClickByElementIndex', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            ClickByElementIndex: function (elementIndex, instance, containerForm, htmlTagType, customTagName) {
                try {
                    var elementFound_ = false;

                    var elements_ = null;
                    var tagName_ = 'input';

                    if (customTagName) {
                        tagName_ = customTagName;
                    }

                    if (htmlTagType == 'Select') {
                        tagName_ = 'select';
                    }

                    if (containerForm) {
                        elements_ = containerForm.getElementsByTagName(tagName_);
                    } else {
                        elements_ = document.getElementsByTagName(tagName_);
                    }

                    if (elements_.length > 0) {
                        for (var i = 0; i < elements_.length; i++) {
                            if ((i == elementIndex) && (elements_[i])) {
                                if (htmlTagType == 'Select') {
                                    elements_[i].selectedIndex = instance - 1;
                                } else {
                                    elements_[i].click();
                                }
                                elementFound_ = true;
                                break;
                            }
                        }
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error ClickByElementIndex', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },

            // private: get the element by id
            SetValueByElementId: function (value, elementId, instance, containerForm, htmlTagType, attributes, onClick, onKeyUp, onChange, freeInput, elementType, inputReplacementTypeBool, loginType) {
                var elementFound_ = null;
                try {
                    var element_ = null;
                    if (containerForm) {
                        var allElements_ = containerForm.getElementsByTagName('*');
                        for (var i = 0; i < allElements_.length; i++) {
                            var id = (allElements_[i].id == elementId);
                            if (id) {
                                var tagType = (htmlTagType == 'Submit' || htmlTagType == olInjection.ElementValue._internal.GetElementTagType(allElements_[i]));
                                if (tagType) {
                                    element_ = allElements_[i];
                                    break;
                                }
                            }
                        }
                    } else {
                        element_ = olInjection.ElementValue._internal.GetElementByID(elementId);
                    }

                    if (element_ && typeof element_ != 'undefined') {
                        olInjection.ElementValue._internal._openElementTypePromptIfNeeded(elementType, [element_]);

                        // change value
                        if (htmlTagType == 'Select') {
                            element_.selectedIndex = instance - 1;
                        } else if (htmlTagType == 'RadioCheck') {
                            if (i == instance - 1) {
                                element_.checked = true;
                            }
                        } else {
                            if (value && (elementType == 'matter' || inputReplacementTypeBool)) {

                                //If Unauthorised then ignore all data that you might receive
                                if (!olInjection.Parameters.Flags.Unauthorised) {
                                    olInjection.ElementValue._internal._setInjectElement(element_, value);
                                }

                                if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                                    //Send message to sevrice whenever we change element value
                                    olPage.Messages.FormFilled();
                                }


                            }
                            if (onClick) {
                                olFunctions.olAddEventListener(element_, 'click', onClick);
                            }
                            if (onKeyUp) {
                                olFunctions.olAddEventListener(element_, 'keyup', onKeyUp);
                            }
                            if (onChange) {
                                olFunctions.olAddEventListener(element_, 'input', onChange);
                            }
                            if (!freeInput) {
                                element_.readOnly = true;
                            }
                        }

                        // LG: NEW - html element attributes processing
                        olInjection.ElementValue._internal.PerformAttributesChanges(element_, attributes);
                        elementFound_ = element_;
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error SetValueByElementId', 'ElByID: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            AttachEventByElementId: function (elementId, instance, containerForm, htmlTagType, events, bAnalysis, feature) {
                var elementFound_ = false;
                try {
                    var element_ = null;
                    if (containerForm) {
                        for (var i = 0; i < containerForm.elements.length; i++) {
                            var id = (containerForm.elements[i].id == elementId);
                            if (id) {
                                element_ = containerForm.elements[i];
                            }
                        }
                    } else {
                        element_ = olInjection.ElementValue._internal.GetElementByID(elementId);
                    }
                    if (element_ && typeof element_ != 'undefined') {
                        if (olFunctions.IsFilledArray(events)) {
                            for (var m = 0; m < events.length; m++) {
                                if (bAnalysis) {
                                    olInjection.BindElementsForAnalysis(element_, events[m], feature);
                                } else {
                                    olInjection.BindElementsWithTimeout(element_, events[m]);
                                }
                            }
                        } else {
                            olInjection.BindElementsWithTimeout(element_, 'click');
                        }
                        elementFound_ = true;
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error AttachEventByElementId', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            ClickByElementId: function (elementId, instance, containerForm, htmlTagType) {
                var elementFound_ = false;
                try {
                    var element_ = null;
                    if (containerForm) {
                        for (var i = 0; i < containerForm.elements.length; i++) {
                            var id = (containerForm.elements[i].id == elementId);
                            if (id) {
                                element_ = containerForm.elements[i];
                            }
                        }
                    } else {
                        element_ = olInjection.ElementValue._internal.GetElementByID(elementId);
                    }

                    if (element_ && typeof element_ != 'undefined') {
                        if (htmlTagType == 'Select') {
                            element_.selectedIndex = instance - 1;
                        } else {
                            element_.click();
                        }

                        elementFound_ = true;
                    }
                } catch (e) {
                    var alertContent_ = new olFunctions.AlertContent('Error ClickByElementId', 'Error: ' + e);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertContent_);
                } finally {
                    return elementFound_;
                }
            },
            //private: perform the necessary chages on style or on other attributes of an html element
            PerformAttributesChanges: function (elementToStyle, elAttributes) {
                try {
                    elementToStyle.setAttribute("autocomplete", "off");
                    try {
                        $(elementToStyle)[0].form.setAttribute("autocomplete", "off");
                    } catch (e) {
                    }

                    if (olFunctions.IsFilledArray(elAttributes)) {
                        for (var i = 0; i < elAttributes.length; i++) {
                            var attName = elAttributes[i].Name;
                            var attValue = elAttributes[i].Value;
                            if (elAttributes[i].IsStyle) {
                                if (elAttributes[i].IsRemoveSpecified) {
                                    elementToStyle.style.removeProperty(attName);
                                } else {
                                    elementToStyle.style[attName] = attValue;
                                }
                            } else {
                                if (elAttributes[i].IsRemoveSpecified) {
                                    elementToStyle.removeAttribute(attName);
                                } else {
                                    elementToStyle[attName] = attValue;
                                }
                            }
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('PerformAttributesChanges: ', e.message + '\n' + e.stack);
                    olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
                }
            }
        },
        AttachEvent: function (elAccessParam, elAccessType, elInstance, elHtmlTagType, elCustomTagName, formAccessParam, formAccessType, events, bAnalysis, feature) {
            var loginForm_ = null;
            var succeeded_ = false;
            var loginFormArray_ = [null];

            if (bAnalysis) {
                formAccessType = 'noUseForm';
            }

            loginFormArray_ = olInjection.ElementValue._internal.GetForm(formAccessParam, formAccessType);
            //Problem cause loginFormArray_ sometimes gets empty after getForm
            if (!olFunctions.IsFilledArray(loginFormArray_)) {
                loginFormArray_.push(null);
            }

            for (var i = 0; i < loginFormArray_.length; i++) {
                loginForm_ = loginFormArray_[i];
                switch (elAccessType) {
                    case 'byID':
                        succeeded_ = olInjection.ElementValue._internal.AttachEventByElementId(elAccessParam, elInstance, loginForm_, elHtmlTagType, events, bAnalysis, feature);
                        break;
                    case 'byName':
                        succeeded_ = olInjection.ElementValue._internal.AttachEventByElementName(elAccessParam, elInstance, loginForm_, elHtmlTagType, events, bAnalysis, feature);
                        break;
                    case 'byIndex':
                        succeeded_ = olInjection.ElementValue._internal.AttachEventByElementIndex(elAccessParam, elInstance, loginForm_, elHtmlTagType, elCustomTagName, events, bAnalysis, feature);
                        break;
                }
            }
            return succeeded_;
        },
        Set: function (elVariable, elAccessParam, elAccessType, elInstance, elHtmlTagType, elCustomTagName, elAttributes, elDefinedName, formAccessParam, formAccessType, inputReplacementType, loginType) {
            try {
                var loginForm_ = null;
                var element_ = null;
                var onClick_ = null;
                var onKeyUp_ = null;
                var bOnKeyUp_ = false;
                var onChange_ = null;
                var loginFormArray_ = [null];
                var freeInput_ = true;

                var irtInput_ = (inputReplacementType == 'Input');
                var irtTrack_ = (inputReplacementType == 'TrackOnly');
                var irtReplace_ = (inputReplacementType == 'ReplaceOnly');

                var track_ = !irtReplace_ && !elVariable.elOrg && (irtInput_ || irtTrack_) && (loginType == 'Collect' || (loginType == 'Automatic' && !irtReplace_))
                // || olInjection.Parameters.Flags.Unauthorised;

                var replace_ = elVariable.elOrg || (olInjection.Parameters.Flags.PassDetailsToSite && ((irtInput_ || irtReplace_) && loginType != 'Collect'));
                loginFormArray_ = olInjection.ElementValue._internal.GetForm(formAccessParam, formAccessType);

                var elDefinedName_ = String(elDefinedName);

                // preventing attaching events on fields that are not defined       
                if (elDefinedName_ == 'comment' && !(olPage.Data.PageFlags.CommentRequest || olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].RequireComment)) {
                    return;
                }

                var logonDetailsFreeInput_ = olInjection.Parameters.Flags.LogonDetailsFreeInput;
                var logonSkipped_ = olInjection.Parameters.Flags.LogonSkipped;
                var logonData_ = olInjection.Parameters.LogonDataArray;

                var adminFreeInput_ = (loginType == 'Admin' && !(olFunctions.IsFilledArray(logonData_)));

                var collectReplaceOnlyFreeInput_ = (loginType == 'Collect' && irtReplace_);
                logonDetailsFreeInput_ = (logonDetailsFreeInput_ || irtReplace_ || adminFreeInput_ || logonSkipped_ || track_ || collectReplaceOnlyFreeInput_);

                var matterDetailsFreeInput_ = olInjection.Parameters.Flags.MatterFreeInput;
                var matterDetailsUseInScript_ = olInjection.Parameters.Flags.UseMatterInScript;
                var elementType_ = '';

                if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                    if (elHtmlTagType == 'Submit') {
                        onClick_ = olInjection.PageEvents.SubmitElement_onClick;
                    } else {
                        if (olInjection.Parameters.DefinedNames.UsernameArray.indexOf(elDefinedName_) > -1) {
                            //username
                            elementType_ = 'username';
                            freeInput_ = logonDetailsFreeInput_;

                            if ((olInjection.Parameters.Flags.LogonNeededForUsername || olInjection.Parameters.Flags.LogonCommonNeededForUsername)) {
                                if (!freeInput_) {
                                    onClick_ = olInjection.PageEvents.Logon_onClick;
                                } else {
                                    if (track_) {
                                        onKeyUp_ = function (event) {
                                            olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                        };
                                        bOnKeyUp_ = true;
                                    }
                                }
                                onChange_ = function (event) {
                                    olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                };
                            } else {
                                if (freeInput_ && track_) {
                                    onKeyUp_ = function (event) {
                                        olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                    };
                                    bOnKeyUp_ = true;
                                    onChange_ = function (event) {
                                        olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                    };
                                }
                            }
                        } else {
                            if (olInjection.Parameters.DefinedNames.PasswordArray.indexOf(elDefinedName_) > -1) {
                                //password
                                elementType_ = 'password';
                                freeInput_ = logonDetailsFreeInput_;
                                if ((olInjection.Parameters.Flags.LogonNeededForPassword || olInjection.Parameters.Flags.LogonCommonNeededForPassword)) {
                                    if (!freeInput_) {
                                        onClick_ = olInjection.PageEvents.Logon_onClick;
                                    } else {
                                        if (track_) {
                                            onKeyUp_ = function (event) {
                                                olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                            };
                                            bOnKeyUp_ = true;
                                        }
                                    }
                                    onChange_ = function (event) {
                                        olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                    };
                                } else {
                                    if (freeInput_ && track_) {
                                        onKeyUp_ = function (event) {
                                            olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                        };
                                        bOnKeyUp_ = true;
                                        onChange_ = function (event) {
                                            olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                        };
                                    }
                                }
                            } else {
                                if (olInjection.Parameters.DefinedNames.MatterArray.indexOf(elDefinedName_) > -1) {
                                    //matter
                                    elementType_ = 'matter';
                                    freeInput_ = matterDetailsFreeInput_;
                                    if (olInjection.Parameters.Flags.MatterNeeded) {
                                        if (!freeInput_) {
                                            onClick_ = olInjection.PageEvents.Matter_onClick;
                                        } else {
                                            if (track_) {
                                                onKeyUp_ = function (event) {
                                                    olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                                };
                                                bOnKeyUp_ = true;
                                            }
                                        }
                                        onChange_ = function (event) {
                                            olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                        };
                                    } else {
                                        if (freeInput_ && track_) {
                                            onKeyUp_ = function (event) {
                                                olInjection.PageEvents.Element_onKeyUp(elDefinedName_, $(event.target).val());
                                            };
                                            bOnKeyUp_ = true;
                                            onChange_ = function (event) {
                                                olInjection.PageEvents.Element_onChange(freeInput_, bOnKeyUp_, elDefinedName_, $(event.target).val());
                                            };
                                        }
                                    }
                                } else {
                                    //time keeper and comment should be same logic
                                    if ((olInjection.Parameters.DefinedNames.TimeKeeperArray.indexOf(elDefinedName_) > -1) || (olInjection.Parameters.DefinedNames.CommentArray.indexOf(elDefinedName_) > -1)) {
                                        elementType_ = 'matter';
                                        onClick_ = olInjection.PageEvents.Matter_onClick;
                                    }
                                }
                            }
                        }
                    }
                } else {
                    //olFunctions.Alert(true, olFunctions.AlertContent('Mobile', 'Set events not supported in mobile mode'));
                }

                for (var i = 0; i < loginFormArray_.length; i++) {
                    loginForm_ = loginFormArray_[i];

                    if (loginForm_) {
                        loginForm_.setAttribute("autocomplete", "off");
                    }

                    switch (elAccessType) {
                        case 'byID':
                            element_ = olInjection.ElementValue._internal.SetValueByElementId(elVariable.elValue, elAccessParam, elInstance, loginForm_, elHtmlTagType, elAttributes, onClick_, onKeyUp_, onChange_, freeInput_, elementType_, replace_, loginType);
                            break;
                        case 'byName':
                            element_ = olInjection.ElementValue._internal.SetValueByElementName(elVariable.elValue, elAccessParam, elInstance, loginForm_, elHtmlTagType, elAttributes, onClick_, onKeyUp_, onChange_, freeInput_, elementType_, replace_, loginType);
                            break;
                        case 'byIndex':
                            element_ = olInjection.ElementValue._internal.SetValueByElementIndex(elVariable.elValue, elAccessParam, elInstance, loginForm_, elHtmlTagType, elCustomTagName, elAttributes, onClick_, onKeyUp_, onChange_, freeInput_, elementType_, replace_, loginType);
                            break;
                    }
                }
                if (!olInjection.ElementValue._internal.ElementValueSet && element_) {
                    olInjection.ElementValue._internal.ElementValueSet = true;
                }
                return element_;
            } catch (e) {
                var alertCatch_ = new olFunctions.AlertContent('SET', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertCatch_);
            }

        },
        Click: function (elAccessParam, elAccessType, elInstance, elHtmlTagType, elCustomTagName, formAccessParam, formAccessType) {
            var loginForm_ = null;
            var succeeded_ = false;
            var loginFormArray_ = [null];

            //if (formAccessParam && formAccessParam.toString().length > 0 && formAccessType && formAccessType.toString().length > 0) {
            loginFormArray_ = olInjection.ElementValue._internal.GetForm(formAccessParam, formAccessType);
            //}

            for (var i = 0; i < loginFormArray_.length; i++) {
                loginForm_ = loginFormArray_[i];
                switch (elAccessType) {
                    case 'byID':
                        succeeded_ = olInjection.ElementValue._internal.ClickByElementId(elAccessParam, elInstance, loginForm_, elHtmlTagType);
                        break;
                    case 'byName':
                        succeeded_ = olInjection.ElementValue._internal.ClickByElementName(elAccessParam, elInstance, loginForm_, elHtmlTagType);
                        break;
                    case 'byIndex':
                        succeeded_ = olInjection.ElementValue._internal.ClickByElementIndex(elAccessParam, elInstance, loginForm_, elHtmlTagType, elCustomTagName);
                        break;
                }
            }

            return succeeded_;
        },
        GetElementVariableReplacement: function (elDefinedName, variableReplacement) {
            var elValue_ = null;
            var elOrg_ = false;

            if (olFunctions.IsFilledArray(variableReplacement.Variables)) {
                //matter
                if (olInjection.Parameters.DefinedNames.MatterArray.indexOf(String(elDefinedName)) > -1) {
                    elValue_ = olInjection.Parameters.Flags.FinalMatterValue;
                } else {
                    //time keeper
                    if (olInjection.Parameters.DefinedNames.TimeKeeperArray.indexOf(String(elDefinedName)) > -1) {
                        elValue_ = olInjection.Parameters.Flags.TimekeeperNumber;
                    } else {
                        //comment
                        if (olInjection.Parameters.DefinedNames.CommentArray.indexOf(String(elDefinedName)) > -1) {
                            elValue_ = olInjection.Parameters.Flags.Comment;
                        } else {
                            //default
                            for (var i = 0; i < variableReplacement.Variables.length; i++) {
                                var currentVariable = variableReplacement.Variables[i];

                                if (currentVariable.DefinedName == elDefinedName) {
                                    elValue_ = $.trim(currentVariable.Value);
                                    elOrg_ = !((currentVariable.IsPersonalSpecified && currentVariable.IsPersonal) || (currentVariable.IsCommonSpecified && currentVariable.IsCommon));
                                }
                                if (elValue_) {
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            var elVariable_ = {
                elValue: elValue_,
                elOrg: elOrg_
            };
            return elVariable_;
        },
        SetDocuments: function (inDocument) {
            try {
                //clear Documents
                olInjection.ElementValue._internal.Documents = new Array();

                var newDocuments_ = new Array();
                if (inDocument && typeof inDocument == 'object') {
                    //start iterations with given document
                    newDocuments_.push(inDocument);
                } else {
                    //start iterations with main document
                    newDocuments_.push(document);
                }

                var checkAgain_ = true;

                while (checkAgain_) {
                    checkAgain_ = false;
                    var iterationDocuments_ = new Array();
                    for (var i = 0; i < newDocuments_.length; i++) {
                        try {
                            var iFrames_ = newDocuments_[i].getElementsByTagName('iframe');
                            for (var iframe in iFrames_) {
                                var frame_ = null;
                                try {
                                    frame_ = iFrames_[iframe];
                                    var frameDocument_ = frame_.contentDocument ? frame_.contentDocument : frame_.contentWindow.document;
                                    if (typeof frameDocument_ == 'object') {
                                        iterationDocuments_.push(frameDocument_);
                                        checkAgain_ = true;
                                    }
                                } catch (e) {
                                    //this try catch is here to prevent cross domain errors...
                                }
                            }
                            var frames_ = newDocuments_[i].getElementsByTagName('frame');
                            for (var frame in frames_) {
                                try {
                                    var frame_ = frames_[frame];
                                    var frameDocument_ = frame_.contentDocument ? frame_.contentDocument : frame_.contentWindow.document;

                                    if (typeof frameDocument_ == 'object') {
                                        iterationDocuments_.push(frameDocument_);
                                        checkAgain_ = true;
                                    }
                                } catch (e) {
                                    //this try catch is here to prevent cross domain errors...
                                }
                            }
                            //newDocuments_[i] is valid document
                            olInjection.ElementValue._internal.Documents.push(newDocuments_[i]);
                        } catch (ex) {
                        }
                    }
                    newDocuments_ = iterationDocuments_;
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SetDocuments: ', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
            } finally {
                var clearedDocuments_ = new Array();
                for (var doc in olInjection.ElementValue._internal.Documents) {
                    var currentDocument = olInjection.ElementValue._internal.Documents[doc];
                    if (currentDocument != null && (typeof currentDocument == 'object')) {
                        clearedDocuments_.push(currentDocument);
                    }
                }
                olInjection.ElementValue._internal.Documents = clearedDocuments_;
            }
        },
        SetMatterValues: function () {
            try {
                if (!olInjection.Parameters.Flags.MatterSkipped) {
                    var matterNumber_ = '';
                    var timekeeperNumber_ = '';
                    var comment_ = '';

                    if (olInjection.Parameters.Flags.MatterNumber) {
                        matterNumber_ = olInjection.Parameters.Flags.MatterNumber;
                    }
                    if (olInjection.Parameters.Flags.TimekeeperNumber != null) {
                        if (olInjection.Parameters.Flags.TimekeeperNumberForSite) {
                            timekeeperNumber_ = olInjection.Parameters.Flags.TimekeeperNumberForSite;
                        } else {
                            timekeeperNumber_ = olInjection.Parameters.Flags.TimekeeperNumber;
                        }
                    }
                    if (olInjection.Parameters.Flags.Comment) {
                        comment_ = olInjection.Parameters.Flags.Comment;
                    }

                    var matterFormat_ = olInjection.Parameters.Flags.MatterFormat;
                    if (matterFormat_ && matterFormat_ != '') {
                        matterFormat_ = matterFormat_.replace('MatterId', matterNumber_);
                        matterFormat_ = matterFormat_.replace('PersonalId', timekeeperNumber_);
                        olInjection.Parameters.Flags.FinalMatterValue = matterFormat_.replace('Comment', comment_);
                    } else {
                        olInjection.Parameters.Flags.FinalMatterValue = matterNumber_;
                    }

                    olPage.Messages.UpdateResponse();
                } else {
                    olInjection.Parameters.Flags.FinalMatterValue = '';
                }

            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('SetMatterValues: ', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
            }
        }
    },
    InjectElementsWithTimeout: function () {
        setTimeout(function () {
            olInjection.InjectElements();
        }, 200);
        setTimeout(function () {
            olInjection.InjectElements();
        }, 900);
    },
    _CheckAllForInjection: function () {
        if (typeof olPage != 'undefined') {
            return olPage.Content._internal.CheckAllForInjection();
        } else {
            return true;
        }
    },
    _previousInjectionParameter: '',
    _lastTimeInjectionDone: 0,
    _injectElements: function (inDocument) {
        try {
            var now_ = Date.now();
            if (olInjection._lastTimeInjectionDone + 250 < now_) {
                olInjection._lastTimeInjectionDone = now_;
                if (olInjection._CheckAllForInjection()) {
                    var alertErrorContent_ = new olFunctions.AlertContent('Injection attempt');
                    olFunctions.Alert(olInjection.Parameters.DebugFunctions, alertErrorContent_);

                    //at least one injection will happen
                    olInjection.InjectionHappened = true;
                    olInjection.ElementValue.SetDocuments(inDocument);

                    var loginType_ = olInjection.Parameters.Flags.LoginType;
                    if (olFunctions.IsFilledArray(olInjection.Parameters.Forms)) {
                        olInjection.ElementValue.SetMatterValues();
                        for (var i = 0; i < olInjection.Parameters.Forms.length; i++) {
                            var currentForm_ = olInjection.Parameters.Forms[i];
                            if (olFunctions.CheckUrls(currentForm_.URL, currentForm_.IgnoreURL)) {
                                if (currentForm_.UseForm) {
                                    var formAccessType_ = null;
                                    var formAccessParam_ = null;
                                    formAccessType_ = olDictionaries.Dictionaries.FormAccessType(currentForm_.Id, currentForm_.Name, currentForm_.IndexSpecified);
                                    switch (formAccessType_) {
                                        case 'byIndex':
                                            formAccessParam_ = currentForm_.Index;
                                            break;
                                        case 'byID':
                                            formAccessParam_ = currentForm_.Id;
                                            break;
                                        case 'byName':
                                            formAccessParam_ = currentForm_.Name;
                                            break;
                                    }
                                } else {
                                    formAccessType_ = 'noUseForm';
                                }

                                if (olFunctions.IsFilledArray(currentForm_.Elements)) {
                                    //process elements
                                    for (var k = 0; k < currentForm_.Elements.length; k++) {
                                        var currentElement_ = currentForm_.Elements[k];
                                        var inputReplacementType_ = olDictionaries.Dictionaries.InputReplacementType(currentElement_);
                                        var elDefinedName_ = currentElement_.DefinedName;
                                        var elVariable_ = olInjection.ElementValue.GetElementVariableReplacement(elDefinedName_, olInjection.Parameters.VariableReplacement);
                                        var elElementType_ = olDictionaries.Dictionaries.ElElementType(currentElement_.ElementTypeSpecified, currentElement_.ElementType);
                                        var elAccessType_ = olDictionaries.Dictionaries.ElAccessType(currentElement_.Id, currentElement_.Name, currentElement_.IndexSpecified);
                                        var elAttributes_ = currentElement_.Attributes;
                                        var elCustomTagName_ = currentElement_.TagName;

                                        var elAccessParam_ = null;
                                        switch (elAccessType_) {
                                            case 'byIndex':
                                                elAccessParam_ = currentElement_.Index;
                                                break;
                                            case 'byID':
                                                elAccessParam_ = currentElement_.Id;
                                                break;
                                            case 'byName':
                                                elAccessParam_ = currentElement_.Name;
                                                break;
                                        }

                                        var element_ = olInjection.ElementValue.Set(elVariable_, elAccessParam_, elAccessType_, currentElement_.Instance, elElementType_, elCustomTagName_, elAttributes_, elDefinedName_, formAccessParam_, formAccessType_, inputReplacementType_, loginType_);

                                        var params_ = {
                                            JScript: currentForm_.JScript,
                                            elAccessParam: elAccessParam_,
                                            elAccessType: elAccessType_,
                                            elAttributes: elAttributes_,
                                            elCustomTagName: elCustomTagName_,
                                            elDefinedName: elDefinedName_,
                                            elElementType: elElementType_,
                                            elInstance: currentElement_.Instance,
                                            elVariable: elVariable_,
                                            inputReplacementType: inputReplacementType_,
                                            loginType: loginType_,
                                            formAccessType: formAccessType_,
                                            formAccessParam: formAccessParam_,
                                        }

                                        if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                                            olWrap.browser.execMV3Script(params_);
                                            olPage.Messages.UpdateResponse();
                                        } else {
                                            // MOBILE JSON MV3 part              
                                            olWrap.Mobile.onExecScriptMobile(params_);
                                        }

                                        try {
                                            if (olInjection.Parameters.Flags.ExtensionEnvironment && ((olInjection.Parameters.DefinedNames.UsernameArray.indexOf(elDefinedName_) > -1) || (olInjection.Parameters.DefinedNames.PasswordArray.indexOf(elDefinedName_) > -1))) {
                                                olPage.Functions.AddDefinedElement({
                                                    definedName: elDefinedName_,
                                                    element: element_
                                                });
                                            }
                                        } catch (e) {
                                            var alertErrorContent_ = new olFunctions.AlertContent('_injectElements: ', e.message + '\n' + e.stack);
                                            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    olInjection.JScriptInjectionBA('olJSInjectAfter');

                    if (!olPage.Data.LocalPageFlags.SubframeEnviroment && !olInjection.ElementValue._internal.ElementValueSet && !olInjection.ElementValue._internal.SetTimeoutForInjectElements) {
                        olInjection.ElementValue._internal.SetTimeoutForInjectElements = true;
                        setTimeout(function () {
                            olInjection.InjectElements();
                        }, 1000);
                        setTimeout(function () {
                            olInjection.InjectElements();
                        }, 2000);
                        setTimeout(function () {
                            olInjection.InjectElements();
                        }, 3000);
                        setTimeout(function () {
                            olInjection.InjectElements();
                        }, 5000);
                    }
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('_injectElements', e.message + '\n' + e.stack);
            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
        }
    },
    InjectElementsForced: function (inDocument) {
        setTimeout(function () {
            olInjection._injectElements(inDocument);
        }, 500);
    },
    InjectElements: function (inDocument) {
        try {
            olInjection._injectElements(inDocument);
            if (olInjection.InjectionHappened) {
                setTimeout(function () {
                    olInjection._injectElements(inDocument);
                }, 1000);
                setTimeout(function () {
                    olInjection._injectElements(inDocument);
                }, 2000);
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('InjectElements', e.message + '\n' + e.stack);
            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
        }
    },
    BindElementsWithTimeout: function (element, event) {
        var alertContent_ = new olFunctions.AlertContent('BindElementsWithTimeout', 'mod Injection');
        // olFunctions.Alert(true, alertContent_);

        if (olInjection.Parameters.Flags.ExtensionEnvironment) {
            var element_ = $(element);
            element_.off(event, olInjection.InjectElementsWithTimeout);
            element_.on(event, olInjection.InjectElementsWithTimeout);
        } else {
            var alertContent_ = new olFunctions.AlertContent('Mobile', 'BindElementsWithTimeout not supported in mobile mode');
            olFunctions.Alert(true, alertContent_);
        }
    },
    BindElementsForAnalysis: function (element, event, feature) {
        if (olInjection.Parameters.Flags.ExtensionEnvironment) {
            var element_ = $(element);
            element_.on(event, function () {
                olInjection.PageEvents.PPA_Event(feature);
            });
        } else {
            var alertContent_ = new olFunctions.AlertContent('Mobile', 'BindElementsForAnalysis not supported in mobile mode');
            olFunctions.Alert(true, alertContent_);
        }
    },
    JScriptInjectionBA: function (type) {
        try {
            var runSchedule_ = null;
            switch (type) {
                case 'olJSInjectBefore':
                    runSchedule_ = 0;
                    break;
                case 'olJSInjectAfter':
                    runSchedule_ = 1;
                    break;
            }
            if (olFunctions.IsFilledArray(olInjection.Parameters.JScript)) {
                for (var s = 0; s < olInjection.Parameters.JScript.length; s++) {
                    if (olInjection.Parameters.JScript[s].RunScheduleSpecified) {
                        if (olInjection.Parameters.JScript[s].RunSchedule == runSchedule_) {
                            var atobCode_ = olFunctions.jsAtob(olInjection.Parameters.JScript[s].Code);
                            olInjection.JSExec(type, atobCode_, 'RS' + runSchedule_ + s);
                        }
                    }
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('JScriptInjectionBA', e.message + '\n' + e.stack);
            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
        }
    },
    JSExec: function (type, atobCode, index) {
        try {

            if (!olInjection.Parameters.Flags.ExtensionEnvironment && !index) {
                //Mobile
                index = 'MobileBAIndex';
            }

            if (type == 'olJSInjectAfter' && !olInjection.InjectionHappened) {
                setTimeout(function () {
                    olInjection.JSExec('olJSInjectAfter', atobCode);
                }, 200);
                return;
            }

            var params_ = {
                JScript: [{ CodeString: atobCode }]
            }
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                olWrap.browser.execMV3Script(params_);
                olPage.Messages.UpdateResponse();
            } else {
                // MOBILE JSON MV3 part  
                olWrap.Mobile.onExecScriptMobile(params_);
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('JSExec', e.message + '\n' + e.stack);
            olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
        }
    },
    JScriptInjection: function (JScriptArray, formIndex) {
        if (typeof (formIndex) === 'undefined') {
            formIndex = '';
        }
        for (var s = 0; s < JScriptArray.length; s++) {
            try {
                var atobCode_ = olFunctions.jsAtob(JScriptArray[s].Code);
                olInjection.JSExec('olJSInject', atobCode_, formIndex.toString() + s.toString());
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('JScriptInjection', e.message + '\n' + e.stack);
                olFunctions.Alert(olInjection.Parameters.DebugErrors, alertErrorContent_);
            }
        }
    }
};