/**
 *  Onelog resource functions
 */

var olResourceSpecFunctions = {
    split: function (inputValue, splitOn, index) {
        var splitIndex = inputValue.indexOf(splitOn, index);
        var result_
        if (splitIndex != -1) {
            var splitresult = inputValue.split(splitOn);
            //inputField.value = splitresult[index];
            result_ = splitresult[index];
        } else {
            //inputField.value = inputValue;
            result_ = inputValue;
        }
        return result_;
    },
    stringToReplace: function (inputValue, stringToReplace, stringReplaceWidth) {
        var result_ = inputValue
        result_ = inputValue.replace(stringToReplace, stringReplaceWidth);
        return result_;
    },
    reInject: function () {
        if (typeof (OnelogClientInject) != 'undefined') {
            OnelogClientInject.Inject();
        } else {
            olPage.Content.Inject();
        }
    },
    callEventByType: function (element_, eventType) {
        //Only if element is found try to call event
        if (element_) {
            switch (eventType) {
                case 'submit':
                    element_.submit();
                    break;
                case 'onelogInject':
                    olResourceSpecFunctions.reInject();
                    break;
                case 'focus':
                    element_.focus();
                    break;
                //Add "click" event to "callEvent" ON-2438
                case 'click':
                    element_.click();
                    break;
            }
        }
    },
    checkIfPropertyExist: function (obj, nestedProperty) {
        nestedProperty = nestedProperty.split('.')
        var returnValue_ = false;
        while (obj && nestedProperty.length) obj = obj[nestedProperty.shift()];
        obj ? returnValue_ = true : returnValue_ = false;
        return returnValue_
    },
    getPWManagementType: function () {
        if (typeof (olPage) == 'undefined') return 0;
        var bnResponse = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
        if (bnResponse) {
            if (bnResponse.PasswordManagementType) {
                return bnResponse.PasswordManagementType;
            }
        } else {
            return 0;
        }
    },
    GetVariableReplacement: function () {
        try {
            var vr;
            if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                if (typeof (olPage) == 'undefined') return null;
                if (typeof (olPage.Data.PageInfo.Response) == 'undefined') return null;

                var bnResponse = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                if (bnResponse) {
                    vr = bnResponse.VariableReplacement;
                }
            } else {
                vr = olInjection.Parameters.VariableReplacement;
            }

            if (vr) {
                return vr;
            }
            return null;
        } catch (error) {
            return null
        }
    },
    GetVariables: function () {
        var vr = olResourceSpecFunctions.GetVariableReplacement();
        if (vr != null) {
            var variables = vr.Variables;
            if (variables) {
                return variables;
            }
        }
        return null;
    },
    GetVariableValue: function (definedName) {
        var variables = olResourceSpecFunctions.GetVariables();
        if (variables != null) {
            for (var i = 0; i < variables.length; i++) {
                if (variables[i]) {
                    if (variables[i].DefinedName) {
                        if (variables[i].DefinedName.toLowerCase() == definedName.toLowerCase()) {
                            if (variables[i].Value) {
                                return variables[i].Value;
                            }
                        }
                    }
                }
            }
        }
        return null;
    },
    GetVariableDefinedName: function (definedName) {
        var variables = olResourceSpecFunctions.GetVariables();
        if (variables != null) {
            for (var i = 0; i < variables.length; i++) {
                if (variables[i]) {
                    if (variables[i].DefinedName) {
                        if (variables[i].DefinedName.toLowerCase() == definedName.toLowerCase()) {
                            return variables[i].DefinedName;
                        }
                    }
                }
            }
        }
        return null;
    },
    CreateVariable: function (obj, name_) {
        var internalVariable = {
            value: null,
            definedName: null
        }
        try {
            var _createVariable = obj.createVariable.filter(function (el) {
                return el.name == name_
            }
            );
            if (olFunctions.IsFilledArray(_createVariable)) {
                switch (true) {
                    case (olResourceSpecFunctions.checkIfPropertyExist(_createVariable[0], 'variableBuilder.stringFunc.replace.replaceWith.onelogVariableName')):
                        internalVariable.value = olResourceSpecFunctions.GetVariableValue(_createVariable[0].variableBuilder.stringFunc.replace.replaceWith.onelogVariableName);
                        internalVariable.definedName = olResourceSpecFunctions.GetVariableDefinedName(_createVariable[0].variableBuilder.stringFunc.replace.replaceWith.onelogVariableName);
                        break;
                    default:
                        internalVariable.value = olResourceSpecFunctions.GetVariableValue(_createVariable[0].variableBuilder.onelogVariableName);
                        internalVariable.definedName = olResourceSpecFunctions.GetVariableDefinedName(_createVariable[0].variableBuilder.onelogVariableName);
                        break;
                }
                if (internalVariable.value) {
                    switch (true) {
                        case (olResourceSpecFunctions.checkIfPropertyExist(_createVariable[0], 'variableBuilder')):
                            switch (true) {
                                case (olResourceSpecFunctions.checkIfPropertyExist(_createVariable[0], 'variableBuilder.stringFunc.split')):
                                    internalVariable.value = olResourceSpecFunctions.split(internalVariable.value, _createVariable[0].variableBuilder.stringFunc.split.splitOn, _createVariable[0].variableBuilder.stringFunc.split.index)
                                    break;

                                case (olResourceSpecFunctions.checkIfPropertyExist(_createVariable[0], 'variableBuilder.stringFunc.replace.stringToReplace')):
                                    internalVariable.value = olResourceSpecFunctions.stringToReplace(_createVariable[0].variableBuilder.value, _createVariable[0].variableBuilder.stringFunc.replace.stringToReplace, internalVariable.value)
                                    break;
                            }
                            break;
                    }
                }
            }
            return internalVariable
        } catch (error) {
            console.log('CreateVariable ERROR', error)
            return null;
        }
    },
    grabMatterValue: function (obj, elementIndex_, element_) {
        /*STARTMV3JSON
        {
                  "grabMatterValue": [{
                                      "findElement": {
                                                "searchType": "querySelector",
                                                "path": "#clientidnavigationmenu > span:nth-child(2)"
                                      },
                                      "matterValueType": "textContent",
                                      "matterEmptyList": ["-None-"]
                            }]
                  
        }
        ENDMV3JSON*/

        var matterValue_;
        switch (obj.grabMatterValue[elementIndex_].matterValueType) {
            case 'textContent':
                matterValue_ = element_.textContent;
                break;
            case 'value':
                matterValue_ = element_.value;
                break;
        }

        var matterEmptyList_ = obj.grabMatterValue[elementIndex_].matterEmptyList
        var sendMessage_ = true;
        if (matterValue_ != null) {
            for (var i = 0; i < matterEmptyList_.length; i++) {
                var currentElem = matterEmptyList_[i];
                if (currentElem == matterValue_) {
                    sendMessage_ = false;
                    break;
                }
            }
        }

        if (sendMessage_) {
            var messageContent_ = {
                name: 'olGrabMatterValue',
                data: matterValue_,
                origin: 'tab'
            };
            chrome.runtime.sendMessage(messageContent_, function (response) {
                if (!chrome.runtime.lastError) {
                    // if you have any response (to avoid unnecessary error in the console)
                }
            });
        }
    },
    reactTriggerChange: function (node) {
        var supportedInputTypes = {
            color: true,
            date: true,
            datetime: true,
            'datetime-local': true,
            email: true,
            month: true,
            number: true,
            password: true,
            range: true,
            search: true,
            tel: true,
            text: true,
            time: true,
            url: true,
            week: true
        };
        var nodeName = node.nodeName.toLowerCase();
        var type = node.type;
        var event;
        var descriptor;
        var initialValue;
        var initialChecked;
        var initialCheckedRadio;

        // Do not try to delete non-configurable properties.
        // Value and checked properties on DOM elements are non-configurable in PhantomJS.
        function deletePropertySafe(elem, prop) {
            var desc = Object.getOwnPropertyDescriptor(elem, prop);
            if (desc && desc.configurable) {
                delete elem[prop];
            }
        }

        // In IE10 propertychange is not dispatched on range input if invalid
        // value is set.
        function changeRangeValue(range) {
            var initMin = range.min;
            var initMax = range.max;
            var initStep = range.step;
            var initVal = Number(range.value);

            range.min = initVal;
            range.max = initVal + 1;
            range.step = 1;
            range.value = initVal + 1;
            deletePropertySafe(range, 'value');
            range.min = initMin;
            range.max = initMax;
            range.step = initStep;
            range.value = initVal;
        }

        function getCheckedRadio(radio) {
            var name = radio.name;
            var radios;
            var i;
            if (name) {
                radios = document.querySelectorAll('input[type="radio"][name="' + name + '"]');
                for (i = 0; i < radios.length; i += 1) {
                    if (radios[i].checked) {
                        return radios[i] !== radio ? radios[i] : null;
                    }
                }
            }
            return null;
        }

        function preventChecking(e) {
            e.preventDefault();
            if (!initialChecked) {
                e.target.checked = false;
            }
            if (initialCheckedRadio) {
                initialCheckedRadio.checked = true;
            }
        }

        if (nodeName === 'select' ||
            (nodeName === 'input' && type === 'file')) {
            // IE9-IE11, non-IE
            // Dispatch change.
            event = document.createEvent('HTMLEvents');
            event.initEvent('change', true, false);
            node.dispatchEvent(event);
        } else if ((nodeName === 'input' && supportedInputTypes[type]) ||
            nodeName === 'textarea') {
            // React 16
            // Cache artificial value property descriptor.
            // Property doesn't exist in React <16, descriptor is undefined.
            descriptor = Object.getOwnPropertyDescriptor(node, 'value');

            // React 0.14: IE9
            // React 15: IE9-IE11
            // React 16: IE9
            // Dispatch focus.
            event = document.createEvent('UIEvents');
            event.initEvent('focus', false, false);
            //node.dispatchEvent(event);

            // React 0.14: IE9
            // React 15: IE9-IE11
            // React 16
            // In IE9-10 imperative change of node value triggers propertychange event.
            // Update inputValueTracking cached value.
            // Remove artificial value property.
            // Restore initial value to trigger event with it.
            if (type === 'range') {
                changeRangeValue(node);
            } else {
                initialValue = node.value;
                node.value = initialValue + '#';
                deletePropertySafe(node, 'value');
                node.value = initialValue;
            }

            // React 15: IE11
            // For unknown reason React 15 added listener for propertychange with addEventListener.
            // This doesn't work, propertychange events are deprecated in IE11,
            // but allows us to dispatch fake propertychange which is handled by IE11.
            event = document.createEvent('HTMLEvents');
            event.initEvent('propertychange', false, false);
            event.propertyName = 'value';
            node.dispatchEvent(event);

            // React 0.14: IE10-IE11, non-IE
            // React 15: non-IE
            // React 16: IE10-IE11, non-IE
            event = document.createEvent('HTMLEvents');
            event.initEvent('input', true, false);
            node.dispatchEvent(event);

            // React 16
            // Restore artificial value property descriptor.
            if (descriptor) {
                Object.defineProperty(node, 'value', descriptor);
            }
        } else if (nodeName === 'input' && type === 'checkbox') {
            // Invert inputValueTracking cached value.
            node.checked = !node.checked;

            // Dispatch click.
            // Click event inverts checked value.
            event = document.createEvent('MouseEvents');
            event.initEvent('click', true, true);
            node.dispatchEvent(event);
        } else if (nodeName === 'input' && type === 'radio') {
            // Cache initial checked value.
            initialChecked = node.checked;

            // Find and cache initially checked radio in the group.
            initialCheckedRadio = getCheckedRadio(node);

            // React 16
            // Cache property descriptor.
            // Invert inputValueTracking cached value.
            // Remove artificial checked property.
            // Restore initial value, otherwise preventDefault will eventually revert the value.
            descriptor = Object.getOwnPropertyDescriptor(node, 'checked');
            node.checked = !initialChecked;
            deletePropertySafe(node, 'checked');
            node.checked = initialChecked;

            // Prevent toggling during event capturing phase.
            // Set checked value to false if initialChecked is false,
            // otherwise next listeners will see true.
            // Restore initially checked radio in the group.
            node.addEventListener('click', preventChecking, true);

            // Dispatch click.
            // Click event inverts checked value.
            event = document.createEvent('MouseEvents');
            event.initEvent('click', true, true);
            node.dispatchEvent(event);

            // Remove listener to stop further change prevention.
            node.removeEventListener('click', preventChecking, true);

            // React 16
            // Restore artificial checked property descriptor.
            if (descriptor) {
                Object.defineProperty(node, 'checked', descriptor);
            }
        }
    },
    createOnelogEvt: function (elem, functionType, eventName, setTimeoutBetweenEvents) {
        try {
            var multiplier_;
            //We are separating inital timeout value by 100ms between events
            setTimeoutBetweenEvents > 0 ? multiplier_ = 1 : multiplier_ = 0;
            var currentSetTimeoutBetweenEvents_ = setTimeoutBetweenEvents + multiplier_ * (olInjection.Parameters.ElementsWithFiredEvents.length * 100);
            switch (functionType) {
                case 'callReact':
                    if (currentSetTimeoutBetweenEvents_) {
                        setTimeout(function () {
                            olResourceSpecFunctions.reactTriggerChange(elem);
                        }, currentSetTimeoutBetweenEvents_)
                    } else {
                        olResourceSpecFunctions.reactTriggerChange(elem);
                    }
                    break;
                case 'fireEvent':
                    if ("createEvent" in document) {
                        var evt = new Event(eventName, {
                            'bubbles': true,
                            'cancelable': false
                        });

                        if (currentSetTimeoutBetweenEvents_) {
                            setTimeout(function () {
                                elem.dispatchEvent(evt);
                            }, currentSetTimeoutBetweenEvents_);
                        } else {
                            elem.dispatchEvent(evt);
                        }
                    }
                    else {
                        try {
                            //Old IE 8 and lower support
                            elem.fireEvent("on".concat(eventName));
                        } catch (error) {

                        }
                    }
                    break;
            }
            olInjection.Parameters.ElementsWithFiredEvents.push({
                htmlElement: elem,
                functionType: functionType,
                eventName: eventName,
            })
        }
        catch (e) {
            console.log('createOnelogEvt', e)
        }
    },
    isChanged: function (element_, changeType_) {
        var result = false;
        switch (changeType_) {
            case 'hide':
                result = (element_.offsetParent === null)
                break;
            case 'show':
                // result = element_.style.display == "block"
                result = (element_.offsetParent !== null)
                break;
        }
        return result;
    },
    addAttributeToElement: function (obj, index_, element_) {
        try {
            if (element_) {   
             switch (true) {
                    // isStyle
                    case (obj.addElementAttribute[index_].newAttribute.isStyle !== undefined):
                        if (element_) {
                            element_.style.setProperty(obj.addElementAttribute[index_].newAttribute.name, obj.addElementAttribute[index_].newAttribute.value, 'important');
                        }
                        break;
                    // onelogVariableName                        
                    case (obj.addElementAttribute[index_].newAttribute.onelogVariableName !== undefined):
                        var value_ = olResourceSpecFunctions.GetVariableValue(obj.addElementAttribute[index_].newAttribute.onelogVariableName);
                        var definedName = olResourceSpecFunctions.GetVariableDefinedName(obj.addElementAttribute[index_].newAttribute.onelogVariableName);

                        if (obj.addElementAttribute[index_].newAttribute.addAutoPasswordSupport !== undefined) {
                            if (obj.addElementAttribute[index_].newAttribute.addAutoPasswordSupport == 'true') {
                                if (element_) {
                                    if (olResourceSpecFunctions.getPWManagementType() == 2) {
                                        olPage.Functions.AddDefinedElement({
                                            definedName: definedName,
                                            element: element_
                                        });
                                        olFunctions.olAddEventListener(element_, 'keyup', function () {
                                            olInjection.PageEvents.Element_onKeyUp(definedName, element_.value);
                                        });
                                    }
                                }
                            }
                        }
                        if (value_) {
                            olInjection.ElementValue._internal._setInjectElement(element_, value_);
                        }
                        break;

                    //internalVariableName
                    case (obj.addElementAttribute[index_].newAttribute.internalVariableName !== undefined):
                        var newAttribute_ = olResourceSpecFunctions.CreateVariable(obj, obj.addElementAttribute[index_].newAttribute.internalVariableName);

                        //todo: check this!!!
                        if (obj.addElementAttribute[index_].newAttribute.addAutoPasswordSupport !== undefined) {
                            if (obj.addElementAttribute[index_].newAttribute.addAutoPasswordSupport == 'true') {
                                if (element_) {
                                    if (olResourceSpecFunctions.getPWManagementType() == 2) {
                                        olPage.Functions.AddDefinedElement({
                                            definedName: newAttribute_.definedName,
                                            element: element_
                                        });
                                        olFunctions.olAddEventListener(element_, 'keyup', function () {
                                            olInjection.PageEvents.Element_onKeyUp(definedName, element_.value);
                                        });
                                    }
                                }
                            }
                        }

                        if (newAttribute_.value) {            
                            element_.value = newAttribute_.value;
                        }
                        break;
                    case (obj.addElementAttribute[index_].newAttribute !== undefined):
                        var attrName = obj.addElementAttribute[index_].newAttribute.name;
                        var attrValue = obj.addElementAttribute[index_].newAttribute.value;
                        element_.setAttribute(attrName, attrValue);
                        break;
                }
                if (obj.addElementAttribute[index_].newAttribute.callFunction !== undefined) {
                    if (obj.addElementAttribute[index_].newAttribute.callFunction.eventName == undefined) {
                        obj.addElementAttribute[index_].newAttribute.callFunction.eventName = 'Input';
                    }

                    olResourceSpecFunctions.createOnelogEvt(element_, obj.addElementAttribute[index_].newAttribute.callFunction.functionType, obj.addElementAttribute[index_].newAttribute.callFunction.eventName);
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('addAttributeToElement', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    setPropertyToElement: function (obj, index_, element_) {
        try {
            if (element_) {
                switch (true) {
                    case (element_.length !== undefined):
                        var optionIndex_ = obj.setProperty[index_].property.optionIndex;
                        if (element_.options[optionIndex_]) {
                            element_.options[optionIndex_].selected = obj.setProperty[index_].property.value;
                        }
                        break;

                    default:
                        var property_ = obj.setProperty[index_].property.name;
                        var value_ = obj.setProperty[index_].property.value;
                        var valueProp_ = value_;

                        if (value_ == 'true') {
                            valueProp_ = true;
                        }
                        if (value_ == 'false') {
                            valueProp_ = false;
                        }

                        element_[property_] = valueProp_;
                        break;
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('setPropertyToElement', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    setTextToElement: function (obj, index_, element_) {
        try {
            if (element_) {
                var text_ = obj.addElementText[index_].textContent;
                element_.textContent = text_;
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('setTextToElement', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _waitForAttribute: [],
    _waitForAttributeCounter: [],
    removeElementAttribute: function (obj, index_, element_) {
        if (!olResourceSpecFunctions._waitForAttributeCounter[index_]) {
            olResourceSpecFunctions._waitForAttributeCounter[index_] = 0;
        }

        if (element_) {
            var attrName_ = obj.removeElementAttribute[index_].removeAttribute.name;
            var counter_ = olResourceSpecFunctions._waitForAttributeCounter[index_];

            if (!olResourceSpecFunctions._waitForAttribute[index_]) {
                olResourceSpecFunctions._waitForAttribute[index_] = setInterval(function () {
                    counter_++;
                    if ((element_.hasAttribute(attrName_))) {
                        clearInterval(olResourceSpecFunctions._waitForAttribute[index_])
                        element_.removeAttribute(attrName_)
                    }

                    if (counter_ >= 20) {
                        clearInterval(olResourceSpecFunctions._waitForAttribute[index_])
                    }
                }, 100)
            }
        }
    },
    createOnelogMessage: function (obj) {
        if (obj.createOnelogMessage.messageHTML !== undefined) {
            try {
                WebControl._showMessage(obj.createOnelogMessage.messageHTML);
            } catch (error) {
            }
        }
    },
    jsonMV3GetAllElements: function (obj, objectNode, inDocument) {
        var elements_;
        if (olFunctions.GetPropertyValue(obj, objectNode)) {
            switch (true) {
                case (olFunctions.GetPropertyValue(obj, objectNode).name !== undefined):
                    elements_ = inDocument.getElementsByName(olFunctions.GetPropertyValue(obj, objectNode).name);
                    break;
                case (olFunctions.GetPropertyValue(obj, objectNode).tagName !== undefined):
                    elements_ = inDocument.getElementsByTagName(olFunctions.GetPropertyValue(obj, objectNode).tagName);
                    break;
                case (olFunctions.GetPropertyValue(obj, objectNode).attribute !== undefined):
                    switch (olFunctions.GetPropertyValue(obj, objectNode).attribute.name) {
                        case 'class':
                            var value_ = olFunctions.GetPropertyValue(obj, objectNode).attribute.value;
                            elements_ = inDocument.getElementsByClassName(value_)
                            break;
                        default:
                            var value_ = olFunctions.GetPropertyValue(obj, objectNode).attribute.value;
                            elements_ = inDocument.querySelectorAll('[' + olFunctions.GetPropertyValue(obj, objectNode).attribute.name + '="' + value_ + '"]');
                            break;
                    }
                break;
                case (olFunctions.GetPropertyValue(obj, objectNode).searchType !== undefined):                                        
                        switch (olFunctions.GetPropertyValue(obj, objectNode).searchType) {
                            case 'querySelector':                            
                                var value_ = olFunctions.GetPropertyValue(obj, objectNode).path;                                     
                                elements_ = inDocument.querySelectorAll(value_)                                
                        break;
                        }    
                break;
            }
        }
        return elements_
    },
    jsonMV3ConfigGetElement: function (obj, objectNode, inDocument) {
        var element_;
        var objTemp_ = olFunctions.GetPropertyValue(obj, objectNode);
        if (objTemp_) {
            var index_ = objTemp_.index ? objTemp_.index : 0;
            switch (true) {
                case (objTemp_.id !== undefined):
                    element_ = inDocument.getElementById(objTemp_.id);
                    break;
                case (objTemp_.name !== undefined):
                    element_ = inDocument.getElementsByName(objTemp_.name)[index_];
                    break;
                case (objTemp_.tagName !== undefined):
                    if (objTemp_.text !== undefined) {
                        var elements_ = inDocument.getElementsByTagName(objTemp_.tagName)
                        if (elements_) {
                            for (i = 0; i < elements_.length; i++) {
                                if (elements_[i].textContent.indexOf(objTemp_.text) > -1) {
                                    element_ = elements_[i];
                                    break;
                                }
                            }
                        }
                    } else {
                        element_ = inDocument.getElementsByTagName(objTemp_.tagName)[index_];
                    }
                    break;
                case (objTemp_.attribute !== undefined):
                    switch (objTemp_.attribute.name) {
                        case 'class':
                            var value_ = objTemp_.attribute.value;
                            element_ = inDocument.getElementsByClassName(value_)[index_];
                            break;
                        case 'olelement':
                            var value_ = objTemp_.attribute.value;
                            element_ = inDocument.querySelectorAll('[olelement="' + value_ + '"]')[index_];
                            break;
                        default:
                            //Onelog MV3 - Allow find element by any attribute (ON-2455)
                            var value_ = objTemp_.attribute.value;
                            element_ = inDocument.querySelectorAll('[' + objTemp_.attribute.name + '="' + value_ + '"]')[index_];
                            break;
                    }
                    break;
                case (objTemp_.searchType !== undefined):
                    var path_ = objTemp_.path;
                    if (objTemp_.searchType == 'querySelector' || objTemp_.searchType == 'querySelectorAll') {
                        element_ = inDocument.querySelectorAll(path_)[index_];
                    }
                    break;
            }
        }

        //check if getParent
        var objTempStr_ = JSON.stringify(objTemp_)
        var count_ = 0
        var parentElement_ = element_
        if (objTempStr_) {
            count_ = (objTempStr_.match(/getParent/g) || []).length;
            if (count_ > 0) {
                for (var g = 0; g < count_; g++) {
                    parentElement_ = parentElement_.parentNode
                    objectNode = objectNode + '.findElement'
                }
                objectNode = objectNode + '.findElement'
                element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, objectNode, parentElement_)
            }
        }
        return element_
    },
    getElementInFrame: function (obj, path_, elementIndex_) {
        try {
            var elementMain_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
            if (elementMain_) {
                if (obj.addElementAttribute[elementIndex_].findElement.findElement.isInIFrame == 'true') {
                    var elementInFramePath_ = 'addElementAttribute.'.concat(elementIndex_).concat('.findElement.findElement');
                    var elementInFrame_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementInFramePath_, elementMain_.contentDocument);
                    if (elementInFrame_) {
                        // check: isShadowRoot lvl1
                        if (olResourceSpecFunctions.checkIfPropertyExist(obj, 'addElementAttribute.' + elementIndex_ + '.findElement.findElement.isShadowRoot')) {
                            if (obj.addElementAttribute[elementIndex_].findElement.findElement.findElement.isShadowRoot == 'true') {
                                var shadowElement = elementInFrame_.shadowRoot;
                                var elementPath_ = 'addElementAttribute.'.concat(elementIndex_).concat('.findElement.findElement.findElement');
                                var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, shadowElement);
                            }
                            //nested ShadowRoot lvl2
                            if (olResourceSpecFunctions.checkIfPropertyExist(obj, 'addElementAttribute.' + elementIndex_ + '.findElement.findElement.findElement.isShadowRoot')) {
                                if (element_) {
                                    var shadowElementNested_ = element_.shadowRoot;
                                    var elementPathNested_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement');
                                    element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested_, shadowElementNested_);
                                }


                                //nested ShadowRoot lvl3
                                if (olResourceSpecFunctions.checkIfPropertyExist(obj, 'addElementAttribute.' + elementIndex_ + '.findElement.findElement.findElement.findElement.isShadowRoot')) {
                                    if (element_) {
                                        var shadowElementNested2_ = element_.shadowRoot;
                                        var elementPathNested2_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement.findElement');
                                        element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested2_, shadowElementNested2_);
                                    }
                                }
                            }
                        }
                        if (element_) {
                            return element_
                        } else {
                            return elementInFrame_
                        }
                    }
                }
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('getElementInFrame', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_);
        }
    },
    getElement: function (params) {
        var elementFound_ = [];
        switch (params.elAccessType) {
            case 'byID':
                //added [] because GetElementByID returns only one value, to make it as an array
                if (olInjection.ElementValue._internal.GetElementByID(params.elAccessParam)) {
                    elementFound_ = [olInjection.ElementValue._internal.GetElementByID(params.elAccessParam)];
                }
                break;
            case 'byName':
                if (olFunctions.IsFilledArray(olInjection.ElementValue._internal.GetElementsByName(params.elAccessParam))) {
                    elementFound_ = olInjection.ElementValue._internal.GetElementsByName(params.elAccessParam);
                    var elementInstance_ = params.elInstance ? params.elInstance - 1 : 0;
                    var htmlTagType_ = params.elElementType;

                    var elements_ = [];
                    var tagName_ = 'input';

                    if (htmlTagType_ == 'Select') {
                        tagName_ = 'select';
                    }

                    for (var i = 0; i < elementFound_.length; i++) {
                        if ((elementFound_[i].tagName).toLowerCase() == tagName_) {
                            elements_.push(elementFound_[i]);
                        }
                    }

                    elementFound_ = elements_;

                    for (var i = 0; i < elementFound_.length; i++) {
                        if (i == elementInstance_) {
                            elementFound_ = [elementFound_[i]];
                            break;
                        }
                    }
                }
                break;
            case 'byIndex':
                // must check forms in this case (not needed for byID, byName!!!)
                var searchContainer_ = olInjection.ElementValue._internal.GetForm(params.formAccessParam, params.formAccessType);
                if (searchContainer_[0] == null) {
                    searchContainer_ = [document];
                }
                var elementIndex = params.elAccessParam;
                var htmlTagType_ = params.elElementType;

                var elements_ = [];
                var tagName_ = 'input';

                if (htmlTagType_ == 'Select') {
                    tagName_ = 'select';
                }
                elements_ = searchContainer_[0].getElementsByTagName(tagName_);

                if (elements_.length > 0) {
                    for (var g = 0; g < elements_.length; g++) {
                        if (((g == elementIndex) && (elements_[g]))) {
                            //added [] because GetElementByID returns only one value, to make it as an array
                            elementFound_.push(elements_[g]);
                            //break;
                        }
                    }
                }
                break;
        }
        return elementFound_;
    },
    removePageElementAction: function (obj) {
        if (olFunctions.IsFilledArray(obj.removePageElement)) {
            for (var i = 0; i < obj.removePageElement.length; i++) {
                var path_ = 'removePageElement.'.concat(i.toString()).concat('.findElement');
                var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                if (element_) {
                    element_.remove();
                }
            }
        }
    },
    addPageElementAction: function (obj) {
        for (var i = 0; i < obj.addPageElement.length; i++) {
            if (olResourceSpecFunctions._checkMatchNonMatchUrl(obj.addPageElement[i])) {
                switch (true) {
                    case (obj.addPageElement[i].newElement.insertBefore !== undefined):
                        var path_ = 'addPageElement.'.concat(i.toString()).concat('.newElement.insertBefore.findElement');
                        var mainElement_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                        if (mainElement_) {
                            var pathNewElement_ = 'addPageElement.'.concat(i.toString()).concat('.newElement');
                            newElement_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathNewElement_, document);
                            if (!newElement_) {
                                if (obj.addPageElement[i].newElement.tagName !== undefined) {
                                    newElement_ = document.createElement(obj.addPageElement[i].newElement.tagName);
                                    if (obj.addPageElement[i].newElement.id !== undefined) {
                                        newElement_.id = obj.addPageElement[i].newElement.id
                                    }
                                    if (obj.addPageElement[i].newElement.type !== undefined) {
                                        newElement_.type = obj.addPageElement[i].newElement.type
                                    }

                                    if (obj.addPageElement[i].newElement.size !== undefined) {
                                        newElement_.size = obj.addPageElement[i].newElement.size
                                    }
                                }

                                if (obj.addPageElement[i].newElement.newAttribute !== undefined) {
                                    switch (true) {
                                        case (obj.addPageElement[i].newElement.newAttribute.internalVariableName !== undefined):

                                            var newAttr_ = olResourceSpecFunctions.CreateVariable(obj, obj.addPageElement[i].newElement.newAttribute.internalVariableName);
                                            var attrName_ = obj.addPageElement[i].newElement.newAttribute.name

                                            newElement_.setAttribute(attrName_, newAttr_.value);
                                            break;
                                        default:
                                            regid = obj.addPageElement[i].newElement.id;
                                            var attrName_ = obj.addPageElement[i].newElement.newAttribute.name;
                                            var attrValue_ = obj.addPageElement[i].newElement.newAttribute.value//.concat(regid);
                                            newElement_.setAttribute(attrName_, attrValue_);
                                            break;
                                    }
                                }

                                if (obj.addPageElement[i].newElement.text !== undefined) {
                                    newElement_.appendChild(document.createTextNode(obj.addPageElement[i].newElement.text));
                                    if (obj.addPageElement[i].newElement.id !== undefined) {
                                        newElement_.id = obj.addPageElement[i].newElement.id;
                                    }
                                }
                                mainElement_.parentNode.insertBefore(newElement_, mainElement_);
                            }
                        }
                        break;
                    default:
                        for (var i = 0; i < obj.addPageElement.length; i++) {
                            (function (i) {
                                //array created with . instead of [] according to the jsonMV3ConfigGetElement (GetPropertyValue) logic
                                var path_ = 'addPageElement.'.concat(i.toString()).concat('.newElement.appendTo.findElement');
                                var mainElemen_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                                var el = document.createElement(obj.addPageElement[i].newElement.tagName);


                                if (mainElemen_) {
                                    switch (true) {
                                        case (obj.addPageElement[i].newElement.text !== undefined):
                                            var content = document.createTextNode(obj.addPageElement[i].newElement.text);
                                            if (obj.addPageElement[i].newElement.newAttribute !== undefined) {
                                                var attrName = obj.addPageElement[i].newElement.newAttribute.name;
                                                var attrValue = obj.addPageElement[i].newElement.newAttribute.value;
                                                el.appendChild(content)
                                                el.setAttribute(attrName, attrValue);
                                            }
                                            el.appendChild(content)
                                            mainElemen_.appendChild(el);
                                            break;
                                        case (obj.addPageElement[i].newElement.id !== undefined):
                                            el.id = obj.addPageElement[i].newElement.id;
                                            document.body.appendChild(el);
                                            break;
                                    }
                                }
                            })(i);
                        }
                        break;
                }
            }
        }
    },
    prepareGetAll: function (obj, node) {
        var getAllNodesPath_ = olWrap.Functions.findPath(olFunctions.GetPropertyValue(obj, node), 'getAll', 'true')
        if (olFunctions.IsFilledArray(getAllNodesPath_)) {
            //TODO  CHECK: getAllNodesPath_  is an array!!!! 
            var getAllPath_ = node.concat(getAllNodesPath_);
       
            getAllPath_ = getAllPath_.replace('[', '.').replace(']', '').replace('.findElement', '')
            var getAllObject = olFunctions.GetPropertyValue(obj, getAllPath_); //'addElementAttribute.9'); 

            if (getAllObject) {
                var elements_ = olResourceSpecFunctions.jsonMV3GetAllElements(getAllObject, 'findElement', document)
                delete getAllObject.findElement['getAll'];
                for (var e = 0; e < elements_.length; e++) {
                    var attrValue_ = 'element_' + e.toString();
                    elements_[e].setAttribute('olelement', attrValue_)
                    var newAttr_ = (
                        {
                            name: "olelement",
                            value: attrValue_
                        }
                    )
                    // important: must have JSON.parse(JSON.stringify(getAllObject))!!!!
                    var tempObj_ = JSON.parse(JSON.stringify(getAllObject));
                    tempObj_.findElement.attribute = newAttr_;
                    //TODO: add parameter here
                    switch (node) {
                        case 'addElementAttribute':
                            obj.addElementAttribute.push(tempObj_);
                            break;
                        case 'removeElementAttribute':
                            obj.removeElementAttribute.push(tempObj_);
                            break;
                    }
                }
            }
        }

    },
    prepareElementAction: function (obj, node) {
        try {
            var nodeString_ = node.concat('.')
            var objNodeArray_ = [];
            olResourceSpecFunctions.prepareGetAll(obj, node);
            objNodeArray_ = olFunctions.GetPropertyValue(obj, node);
            for (var i = 0; i < objNodeArray_.length; i++) {
                (function (i) {

                    var waitForElementEvent_ = setInterval(function () {
                        var path_ = nodeString_.concat(i.toString()).concat('.findElement');
                        var pathElementEvent_ = nodeString_.concat(i.toString()).concat('.afterEvent.findElement');
                        var elementindex_ = i.toString();
                        try {
                            switch (true) {
                                // afterEvent                                
                                case (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.afterEvent')):
                                    var elementEvent_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathElementEvent_, document);

                                    var event_ = objNodeArray_[elementindex_].afterEvent.eventName;
                                    var isInFrame = false;
                                    if (elementEvent_) {
                                        clearInterval(waitForElementEvent_)
                                        elementEvent_.setAttribute('path_'.concat(elementindex_), path_);
                                        if (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.findElement.findElement.isInIFrame')) {
                                            isInFrame = true;
                                        }
                                        elementEvent_.addEventListener(event_, function (event) {
                                            var monitoredElement_ = event.target;
                                            var counterWhile = 0
                                            while (!(monitoredElement_.getAttribute('path_0')) && (counterWhile < 100)) {
                                                monitoredElement_ = monitoredElement_.parentElement;
                                                counterWhile++
                                            }
                                            var pathArray_ = []
                                            for (var p = 0, attributes_ = elementEvent_.attributes, n = attributes_.length; p < n; p++) {
                                                if (attributes_[p].nodeName.includes('path_')) {
                                                    pathArray_.push(attributes_[p].value)
                                                }
                                            }
                                            for (var j = 0; j < pathArray_.length; j++) {
                                                (function (j) {
                                                    var waitForElement_ = setInterval(function () {

                                                        var elementPath_ = monitoredElement_.getAttribute('path_'.concat(j.toString()))
                                                        var elementIndex_ = j.toString();
                                                        if (isInFrame == true) {
                                                            element_ = olResourceSpecFunctions.getElementInFrame(obj, elementPath_, elementIndex_)
                                                        } else {
                                                            element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, document);

                                                        }
                                                        if (element_) {
                                                            clearInterval(waitForElement_)

                                                            olResourceSpecFunctions.setElementAction(obj, elementIndex_, node, element_)
                                                        }
                                                    }, 100)
                                                })(j);
                                            }
                                        })
                                    }
                                    break;
                                // isShadowRoot lvl1
                                case (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.findElement.findElement.isShadowRoot')):
                                    if (objNodeArray_[i].findElement.findElement.isShadowRoot == 'true') {
                                        var elementMain_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                                        var shadowElement = elementMain_.shadowRoot;
                                        var elementPath_ = nodeString_.concat(i.toString()).concat('.findElement.findElement');
                                        var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, shadowElement);
                                        //nested ShadowRoot lvl2
                                        if (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.findElement.findElement.findElement.isShadowRoot')) {
                                            if (element_) {
                                                var shadowElementNested_ = element_.shadowRoot;
                                                var elementPathNested_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement');
                                                element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested_, shadowElementNested_);
                                            }

                                            //nested ShadowRoot lvl3
                                            if (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.findElement.findElement.findElement.findElement.isShadowRoot')) {
                                                if (element_) {
                                                    var shadowElementNested2_ = element_.shadowRoot;
                                                    var elementPathNested2_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement.findElement');
                                                    element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested2_, shadowElementNested2_);
                                                }
                                            }
                                        }
                                    }
                                    if (element_) {
                                        clearInterval(waitForElementEvent_)
                                        olResourceSpecFunctions.setElementAction(obj, i, node, element_)
                                    }
                                    break;
                                // isInIFrame
                                case (olResourceSpecFunctions.checkIfPropertyExist(obj, nodeString_ + elementindex_ + '.findElement.findElement.isInIFrame')):
                                    var element_ = olResourceSpecFunctions.getElementInFrame(path_, elementindex_)
                                    var elementMain_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);

                                    if (elementMain_) {
                                        if (objNodeArray_[i].findElement.findElement.isInIFrame == 'true') {
                                            var elementInFramePath_ = nodeString_.concat(i.toString()).concat('.findElement.findElement');
                                            var elementInFrame_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementInFramePath_, elementMain_.contentDocument);
                                            if (elementInFrame_) {
                                                if (objNodeArray_[i].findElement.findElement.findElement.isShadowRoot == 'true') {
                                                    var shadowElement = elementInFrame_.shadowRoot;
                                                    var elementPath_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement');
                                                    var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, shadowElement);
                                                    //nested ShadowRoot lvl2
                                                    try {
                                                        if (element_) {
                                                            if (objNodeArray_[i].findElement.findElement.findElement.findElement.isShadowRoot == 'true') {
                                                                var shadowElementNested_ = element_.shadowRoot;
                                                                var elementPathNested_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement.findElement');
                                                                element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested_, shadowElementNested_);

                                                                //nested ShadowRoot lvl3
                                                                if (objNodeArray_[i].findElement.findElement.findElement.findElement.findElement.isShadowRoot == 'true') {
                                                                    if (element_) {
                                                                        var shadowElementNested2_ = element_.shadowRoot;
                                                                        var elementPathNested2_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement.findElement');
                                                                        element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested2_, shadowElementNested2_);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    } catch (error) {

                                                    }

                                                    if (element_) {
                                                        clearInterval(waitForElementEvent_)
                                                        olResourceSpecFunctions.setElementAction(obj, i, node, element_)
                                                    }
                                                } else {
                                                    clearInterval(waitForElementEvent_)
                                                    olResourceSpecFunctions.setElementAction(obj, i, node, element_)
                                                }
                                            }
                                        }
                                    }
                                    break;
                                default:
                                    var tempPath_ = '.findElement';
                                    //checking depth of findElement
                                    while (olResourceSpecFunctions.checkIfPropertyExist(obj, path_ + tempPath_)) {
                                        path_ = path_ + tempPath_;
                                    }
                                    var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                                    if (element_) {
                                        clearInterval(waitForElementEvent_)
                                        olResourceSpecFunctions.setElementAction(obj, i, node, element_)
                                    }
                                    break;
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('execFunc', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_);
                        }
                    }, 100)
                })(i);
            }
        } catch (error) {
            console.log('ERROR prepareElementAction', error)
        }
    },
    _checkMatchNonMatchUrl: function (obj) {
        var returnValue_ = false;
        var url = location.href.toLowerCase();
        switch (true) {
            case (obj.matchURLs !== undefined):
                for (var i = 0; i < obj.matchURLs.length; i++) {
                    if (url.indexOf(obj.matchURLs[i]) > -1) {
                        returnValue_ = true;
                    }
                }
                break;
            case (obj.nonMatchURLs !== undefined):
                var counter = 0;
                for (var i = 0; i < obj.nonMatchURLs.length; i++) {
                    if (url.indexOf(obj.nonMatchURLs[i]) == -1) {
                        counter = counter + 1;
                    }
                }
                if (counter == obj.addElementAttribute[elementIndex_].nonMatchURLs.length) {
                    returnValue_ = true;
                }
                break;
            default:
                returnValue_ = true;
                break;
        }
        return returnValue_;
    },
    setElementAction: function (obj, elementIndex_, node, element_) {
        switch (node) {
            case 'addElementAttribute':
                if (olResourceSpecFunctions._checkMatchNonMatchUrl(obj[node][elementIndex_])) {
                    olResourceSpecFunctions.addAttributeToElement(obj, elementIndex_, element_)
                }
                break;
            case 'grabMatterValue':
                olResourceSpecFunctions.grabMatterValue(obj, elementIndex_, element_)
                break;
            case 'setProperty':
                olResourceSpecFunctions.setPropertyToElement(obj, elementIndex_, element_)
                break;
            case 'addElementText':
                olResourceSpecFunctions.setTextToElement(obj, elementIndex_, element_)
                break;
            case 'removeElementAttribute':
                if (olResourceSpecFunctions._checkMatchNonMatchUrl(obj[node][elementIndex_])) {
                    olResourceSpecFunctions.removeElementAttribute(obj, elementIndex_, element_)
                }
                break;
            default:
                break;
        }
    },
    addElementAttributeAction: function (obj) {
        olResourceSpecFunctions.prepareElementAction(obj, 'addElementAttribute');
    },
    grabMatterValueAction: function (obj) {
        olResourceSpecFunctions.prepareElementAction(obj, 'grabMatterValue');
    },

    setPropertyAction: function (obj) {
        olResourceSpecFunctions.prepareElementAction(obj, 'setProperty');
    },

    addElementTextAction: function (obj) {
        olResourceSpecFunctions.prepareElementAction(obj, 'addElementText');
    },

    runInPageCheckElement: function (obj) {
        try {
            var result = false;
            switch (true) {
                case (obj.runInPage.pageFunction !== undefined):
                    switch (true) {
                        case (obj.runInPage.pageFunction.runAfterNotFindingElement !== undefined):
                            //If property "runInPage.pageFunction.runAfterNotFindingElement" is defined then try to find element
                            var path_ = 'runInPage.findElement'
                            var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);

                            // This is XOR between runAfterNotFindingElement and !element_ 
                            // which is written as (obj.runInPage.pageFunction.runAfterNotFindingElement ^ !element_)
                            // for easier understanding left as bellow
                            if (obj.runInPage.pageFunction.runAfterNotFindingElement == 'true') {
                                // If runAfterNotFindingElement is true then you need to check 
                                // if the element is missing in the page and then return true 
                                if (!element_) {
                                    result = true;
                                }
                            } else {
                                // If runAfterNotFindingElement is false then you need to check 
                                // if the element is in the page and then return true 
                                if (element_) {
                                    result = true;
                                }
                            }
                            break;
                        case (obj.runInPage.pageFunction.runAfterPropertySet !== undefined):
                            olResourceSpecFunctions.setPropertyAction(obj.runInPage);
                            result = true;
                            break;
                    }
                    break;
            }
            return result;
        } catch (error) {
        } finally {
            return result;
        }
    },
    createOnelogMessageAction: function (obj) {
        var url = location.href.toLowerCase();
        var path_ = 'createOnelogMessage.findElement'
        var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
        if (element_) {
            switch (true) {
                case (obj.createOnelogMessage.matchURLs !== undefined):
                    for (var i = 0; i < obj.createOnelogMessage.matchURLs.length; i++) {
                        if (url.indexOf(obj.createOnelogMessage.matchURLs[i]) > -1) {
                            olResourceSpecFunctions.createOnelogMessage(obj);
                        }
                    }
                    break;
                case (obj.createOnelogMessage.nonMatchURLs !== undefined):
                    var counter = 0;
                    for (var i = 0; i < obj.createOnelogMessage.nonMatchURLs.length; i++) {
                        if (url.indexOf(obj.createOnelogMessage.nonMatchURLs[i]) == -1) {
                            counter = counter + 1;
                        }
                    }
                    if (counter == obj.createOnelogMessage.nonMatchURLs.length) {
                        olResourceSpecFunctions.createOnelogMessage(obj);
                    }
                    break;
                default:
                    olResourceSpecFunctions.createOnelogMessage(obj);
                    break;
            }
        }
    },
    removeElementAttributeAction: function (obj) {
        olResourceSpecFunctions.prepareElementAction(obj, 'removeElementAttribute');
    },
    _respondToVisibility: function (objElement, callback) {
        try {
            var targetElementToObservePath_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(objElement.obj, objElement.targetElementToObservePath, document);
            var options = {
                root: document
            }

            var observer_ = new IntersectionObserver(
                (entries, observer) => {
                    entries.forEach(entry => {
                        var visibility_ = (entry.intersectionRatio > 0 ? 'show' : 'hide');
                        var previousVisibilityState_ = entry.target.getAttribute('olvisibilitystate') != null ? entry.target.getAttribute('olvisibilitystate') : 'initial';
                        entry.target.setAttribute('olpreviousvisibilitystate', previousVisibilityState_);
                        entry.target.setAttribute('olvisibilitystate', visibility_);
                        callback(visibility_, objElement, entry.target);
                    });
                },
                options);

            if (targetElementToObservePath_) {
                observer_.observe(targetElementToObservePath_);
            } else {
                setTimeout(
                    function () {
                        olResourceSpecFunctions._respondToVisibility(objElement, callback)
                    }, 100)
            }
        } catch (error) {
            console.log('_respondToVisibility error', error, objElement)
        }
    },
    _callBackForIntersectionObserverFunc: function (visible, objElement, target) {
        try {
            var obj_ = objElement.obj;
            var eventElement_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj_, objElement.eventElementPath, document);

            var targetElementPreviousVisibilitystate_ = target.getAttribute('olpreviousvisibilitystate');
            if (eventElement_) {
                switch (objElement.eventName) {
                    case 'click':
                        if (visible == objElement.targetElementFireEventOnVisibilityState && targetElementPreviousVisibilitystate_ != 'initial') {
                            // Visibility of element is same as asked in JSON and also 
                            // it is not initial event which is fired automaticly when
                            // page is loaded 
                            eventElement_.click();
                        }
                        break;
                }
            }
        } catch (error) {
            console.log('_callBackForIntersectionObserverFunc error', error, objElement)
        }
    },
    onElementChangeVisibilityObserver: function (obj) {
        try {
            for (var i = 0; i < obj.onElementChangeVisibilityObserver.length; i++) {
                (function (i) {
                    switch (true) {
                        case (obj.onElementChangeVisibilityObserver[i].sendEvent !== undefined):
                            var targetElementToObservePath_ = 'onElementChangeVisibilityObserver.'.concat(i).concat('.findElement');
                            var eventElementPath_ = 'onElementChangeVisibilityObserver.'.concat(i).concat('.sendEvent.findElement');
                            var eventName_ = obj.onElementChangeVisibilityObserver[i].sendEvent.eventName;
                            var objElement_ = JSON.parse(JSON.stringify({
                                obj: obj,
                                targetElementToObservePath: targetElementToObservePath_,
                                targetElementFireEventOnVisibilityState: obj.onElementChangeVisibilityObserver[i].change,
                                eventElementPath: eventElementPath_,
                                eventName: eventName_
                            }));

                            olResourceSpecFunctions._respondToVisibility(objElement_, (olResourceSpecFunctions._callBackForIntersectionObserverFunc))
                            break;
                    }
                })(i);
            }
        } catch (error) {
            console.log('onElementChangeVisibilityObserver error', error)
        }
    },
    conditionForElementChange: function (elementChange, changeType) {
        var condition_ = false;


        switch (changeType) {
            case 'hide':
                if (elementChange && !olResourceSpecFunctions.isChanged(elementChange, changeType)) {
                    condition_ = true;
                }
                break;
            case 'show':
                if (elementChange) {
                    condition_ = true;
                }
                break;
        }
        return condition_;
    },
    onElementChangeSendEvent: function (obj, i) {
        var changeType_ = obj.onElementChange[i].change;
        var path_ = 'onElementChange.'.concat(i).concat('.sendEvent.findElement');
        var pathChange_ = 'onElementChange.'.concat(i).concat('.findElement');

        var eventName_ = obj.onElementChange[i].sendEvent.eventName;
        var elementChange_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathChange_, document);

        var elementChangeInterval = setInterval(function () {
            elementChange_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathChange_, document);

            if (olResourceSpecFunctions.conditionForElementChange(elementChange_, changeType_)) {
                clearInterval(elementChangeInterval);
                var elementInterval = setInterval(function () {
                    var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                    if (element_) {
                        clearInterval(elementInterval);
                        var sendEventInterval = setInterval(function () {
                            if (olResourceSpecFunctions.isChanged(elementChange_, changeType_)) {
                                clearInterval(sendEventInterval);
                                switch (true) {
                                    case (eventName_ == 'click'):
                                        element_.click();
                                        i++;
                                        olResourceSpecFunctions.onElementChangeAction(obj, i)
                                        break;
                                }
                            }
                        }, 50);
                    }
                }, 50);
            }
        }, 50);
    },
    onElementChangeAttribute: function (obj, index) {
        var currentElementChange_ = obj.onElementChange[index];
        var onElementChangeType;
        switch (true) {
            case currentElementChange_.addElementAttribute !== undefined:
                onElementChangeType = 'addElementAttribute';
                break;
            case currentElementChange_.removeElementAttribute !== undefined:
                onElementChangeType = 'removeElementAttribute';
                break;

        }
        var changeType_ = obj.onElementChange[index].change;
        for (var k = 0; k < obj.onElementChange[index][onElementChangeType].length; k++) {
            (function (k) {
                var path_ = 'onElementChange.'.concat(index).concat('.'.concat(onElementChangeType).concat('.').concat(k).concat('.findElement'));
                var pathChange_ = 'onElementChange.'.concat(index).concat('.findElement');
                var elementChangeInterval = setInterval(function () {
                    elementChange_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathChange_, document);

                    if (olResourceSpecFunctions.conditionForElementChange(elementChange_, changeType_)) {
                        clearInterval(elementChangeInterval);
                        var elementInterval = setInterval(function () {
                            var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                            if (element_) {
                                clearInterval(elementInterval);
                                var attributeInterval = setInterval(function () {
                                    if (olResourceSpecFunctions.isChanged(elementChange_, changeType_)) {
                                        clearInterval(attributeInterval);



                                        olResourceSpecFunctions.prepareElementAction(obj.onElementChange[index], onElementChangeType);
                                        index = index + 1;
                                        olResourceSpecFunctions.onElementChangeAction(obj, index)
                                    }
                                }, 10);
                            }
                        }, 10);
                    }
                }, 10);
            })(k);
        }
    },
    onElementChangeAction: function (obj, index) {
        try {
            if (index < obj.onElementChange.length) {
                switch (true) {
                    case (obj.onElementChange[index].sendEvent !== undefined):
                        olResourceSpecFunctions.onElementChangeSendEvent(obj, index);
                        break;
                    case ((obj.onElementChange[index].addElementAttribute !== undefined) || (obj.onElementChange[index].removeElementAttribute !== undefined)):
                        olResourceSpecFunctions.onElementChangeAttribute(obj, index);
                        break;
                }
            } else {
                olResourceSpecFunctions.onElementChangeAction(obj, 0)
            }
        } catch (error) {
            console.log('ERROR onElementChangeAction', error)
        }
    },
    callEventAction: function (obj) {
        for (var i = 0; i < obj.callEvent.length; i++) {
            (function (i) {
                var path_ = 'callEvent.'.concat(i.toString()).concat('.findElement');
                var pathElementEvent_ = 'callEvent.'.concat(i.toString()).concat('.afterEvent.findElement');
                var elementindex_ = i.toString();

                switch (true) {
                    // afterEvent
                    case (olResourceSpecFunctions.checkIfPropertyExist(obj, 'callEvent.' + elementindex_ + '.afterEvent')):
                        var elementEvent_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathElementEvent_, document);
                        var event_ = obj.callEvent[elementindex_].afterEvent.eventName;
                        var isInFrame = false;
                        var waitForElementEvent_ = setInterval(function () {
                            elementEvent_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, pathElementEvent_, document);
                            if (elementEvent_) {
                                clearInterval(waitForElementEvent_)
                                if (olResourceSpecFunctions.checkIfPropertyExist(obj, 'callEvent.' + elementindex_ + '.findElement.findElement.isInIFrame')) {
                                    isInFrame = true;
                                }
                                elementEvent_.addEventListener(event_, function (event) {
                                    var elementPath_ = path_;
                                    var elementIndex_ = elementindex_;
                                    var waitForElement_ = setInterval(function () {
                                        if (isInFrame == true) {
                                            element_ = olResourceSpecFunctions.getElementInFrame(obj, elementPath_, elementIndex_);
                                        } else {
                                            element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, document);
                                        }
                                        if (element_) {
                                            clearInterval(waitForElement_);
                                            olResourceSpecFunctions.callEventByType(element_, obj.callEvent[elementIndex_].eventName)
                                        }
                                    }, 100)
                                })
                            }

                        }, 100)
                        break;
                    // isShadowRoot
                    case (olResourceSpecFunctions.checkIfPropertyExist(obj, 'callEvent.' + elementindex_ + '.findElement.findElement.isShadowRoot')):
                        if (obj.callEvent[i].findElement.findElement.isShadowRoot == 'true') {
                            var elementMain_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                            var shadowElement = elementMain_.shadowRoot;
                            var elementPath_ = 'callEvent.'.concat(i.toString()).concat('.findElement.findElement');
                            var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, shadowElement);

                            if (
                                olResourceSpecFunctions.checkIfPropertyExist(obj, 'callEvent.' + elementindex_ + '.findElement.findElement.findElement.isShadowRoot')
                            ) {
                                if (element_) {
                                    var shadowElementNested_ = element_.shadowRoot;
                                    var elementPathNested_ = nodeString_.concat(i.toString()).concat('.findElement.findElement.findElement');
                                    element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPathNested_, shadowElementNested_);
                                }
                            }

                        }
                        if (element_) {
                            olResourceSpecFunctions.callEventByType(element_, obj.callEvent[i].eventName)
                        }
                        break;
                    // isInIFrame
                    case (olResourceSpecFunctions.checkIfPropertyExist(obj, 'callEvent.' + elementindex_ + '.findElement.findElement.isInIFrame')):
                        var element_ = olResourceSpecFunctions.getElementInFrame(path_, elementindex_)
                        var elementMain_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                        if (elementMain_) {
                            if (obj.callEvent[i].findElement.findElement.isInIFrame == 'true') {
                                var elementInFramePath_ = 'callEvent.'.concat(i.toString()).concat('.findElement.findElement');
                                var elementInFrame_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementInFramePath_, elementMain_.contentDocument);
                                if (elementInFrame_) {
                                    if (obj.callEvent[i].findElement.findElement.findElement.isShadowRoot == 'true') {
                                        var shadowElement = elementInFrame_.shadowRoot;
                                        var elementPath_ = 'callEvent.'.concat(i.toString()).concat('.findElement.findElement.findElement');
                                        var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, elementPath_, shadowElement);
                                        if (element_) {
                                            olResourceSpecFunctions.callEventByType(element_, obj.callEvent[i].eventName)
                                        }
                                    }
                                }
                            }
                        }
                        break;
                    default:
                        var element_ = olResourceSpecFunctions.jsonMV3ConfigGetElement(obj, path_, document);
                        if (element_) {
                            olResourceSpecFunctions.callEventByType(element_, obj.callEvent[elementindex_].eventName)
                        } else {
                            olResourceSpecFunctions.reInject();
                        }
                        break;
                }
            })(i);
        }
    },
    execFunc: function (functionType, eventName, params, obj, action) {
        try {
            switch (action) {
                case 'createOnelogEvt':
                    var setTimeout_ = obj.callFunction.delay ? obj.callFunction.delay : 0;
                    var elementFound_ = olResourceSpecFunctions.getElement(params);

                    for (var i = 0; i < elementFound_.length; i++) {
                        (function (i) {
                            if (olFunctions.IsFilledArray(elementFound_)) {
                                olResourceSpecFunctions.createOnelogEvt(elementFound_[i], functionType, eventName, setTimeout_);
                            }
                        })(i);
                    }
                    if (olInjection.Parameters.Flags.ExtensionEnvironment) {
                        olPage.Functions._forcedInject(setTimeout_);
                    }
                    break;
                case 'grabMatterValue':
                    // var setTimeout_ = obj.callFunction.delay ? obj.callFunction.delay : 0;

                    if (obj.grabMatterValue) {
                        olResourceSpecFunctions.grabMatterValueAction(obj);
                    }

                    break;
                case 'addPageElement':
                    olResourceSpecFunctions.addPageElementAction(obj);
                    break;
                case 'removePageElement':
                    olResourceSpecFunctions.removePageElementAction(obj);
                    break;
                case 'addElementAttribute':
                    if (obj.addElementAttribute) {
                        olResourceSpecFunctions.addElementAttributeAction(obj);
                    }
                    break;
                case 'removeElementAttribute':
                    if (obj.removeElementAttribute) {
                        olResourceSpecFunctions.removeElementAttributeAction(obj)
                    }
                    break;
                case 'onElementChange':
                    if (obj.onElementChange) {
                        olResourceSpecFunctions.onElementChangeAction(obj, 0)
                    }
                    break;
                case 'onElementChangeVisibilityObserver':
                    if (obj.onElementChangeVisibilityObserver) {
                        olResourceSpecFunctions.onElementChangeVisibilityObserver(obj, 0)
                    }
                    break;
                case 'callEvent':
                    if (obj.callEvent) {
                        olResourceSpecFunctions.callEventAction(obj);
                    }
                    break;
                case 'setProperty':
                    if (obj.setProperty) {
                        olResourceSpecFunctions.setPropertyAction(obj);
                    }
                    break;
                case 'addElementText':
                    if (obj.addElementText) {
                        olResourceSpecFunctions.addElementTextAction(obj);
                    }
                    break;
                case 'runInPage':
                    if (obj.runInPage) {
                        try {
                            //timeout is needed here, callback isn't prossible without too many changes in existing (already tested) code
                            var delay_ = obj.runInPage.pageFunction.delay ? obj.runInPage.pageFunction.delay : 250;

                            setTimeout(() => {
                                window[obj.runInPage.pageFunction.function]();
                            }, delay_);  // DELAY!!!
                        } catch (error) {
                        }
                    }
                    break;
                case 'createOnelogMessage':
                    if (obj.createOnelogMessage) {
                        olResourceSpecFunctions.createOnelogMessageAction(obj);
                    }
                    break;

            }
        }
        catch (error) {
            // ON-2306 https://henchman.atlassian.net/browse/ON-2306
            // console.log('execFunc! error', error)
        }
    },
    OLGrabElement: function (element_, obj, objectNode) {
        if (element_) {
            if (!element_.hasAttribute("onelogGrabbed")) {
                var returnText_ = olFunctions.GetPropertyValue(obj, objectNode).returnText;
                if (returnText_ !== undefined) {
                    switch (true) {
                        case (olFunctions.GetPropertyValue(obj, objectNode).returnText.textContent !== undefined):
                            result = element_.textContent;
                            if ((olFunctions.GetPropertyValue(obj, objectNode).waitForReturnText == 'true')) {
                                if (result !== "") {
                                    element_.setAttribute("onelogGrabbed", "yes");
                                }
                            } else {
                                element_.setAttribute("onelogGrabbed", "yes");
                            }

                            break;
                        case (olFunctions.GetPropertyValue(obj, objectNode).returnText.attribute !== undefined):
                            var atrr_ = olFunctions.GetPropertyValue(obj, objectNode).returnText.attribute;
                            result = element_.getAttribute(atrr_);
                            element_.setAttribute("onelogGrabbed", "yes");
                            break;
                        case (olFunctions.GetPropertyValue(obj, objectNode).returnText.getValue == 'true'):
                            result = element_.value;
                            if (result !== "") {
                                element_.setAttribute("onelogGrabbed", "yes");
                            }
                            break;
                    }
                    return result;
                }
            }
        }
        return "";
    },
    searchForTextInString: function (strToParse, start, end) {
        try {
            var result_ = '';
            var startPos = strToParse.indexOf(start);
            if (startPos > -1) {
                startPos = startPos + start.length;
                startText = strToParse.substring(startPos);
                if (startText) {
                    if (startText.length > 0) {
                        endPos = startText.indexOf(end);
                        if (endPos > 0) {
                            txt = startText.substring(0, endPos);
                            if (txt != "") {
                                if (txt.trim() != "") {
                                    result_ = txt.trim();
                                }
                            }
                        }
                    }
                }
            }
            return result_
        } catch (e) {
            console.log('searchForTextInString error', error)
        }
    },
    searchForTextInPage: function (wdw, start, end, attr) {
        if (wdw) {
            if (wdw.document) {
                startPos = wdw.document.body.textContent.indexOf(start);
                if (startPos > -1) {
                    if (!wdw.document.body.hasAttribute(attr)) {
                        wdw.document.body.setAttribute(attr, "yes");
                        startPos = startPos + start.length;
                        startText = wdw.document.body.textContent.substring(startPos);
                        if (startText) {
                            if (startText.length > 0) {
                                endPos = startText.indexOf(end);
                                if (endPos > 0) {
                                    txt = startText.substring(0, endPos);
                                    if (txt != "") {
                                        if (txt.trim() != "") {
                                            return txt.trim();
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else {
                    for (var i = 0; i < wdw.frames.length; i++) {
                        txt = searchForTextInPage(wdw.frames[i], start, end, attr);
                        if (txt != "") {
                            if (txt.trim() != "") {
                                return txt.trim();
                            }
                        }
                    }
                }
            } else {
                if (wdw.frames) {
                    for (var i = 0; i < wdw.frames.length; i++) {
                        txt = searchForTextInPage(wdw.frames[i], start, end, attr);
                        if (txt != "") {
                            if (txt.trim() != "") {
                                return txt.trim();
                            }
                        }
                    }
                }
            }
        }
        return "";
    },
}