var WebControl = {
    olPageFunctions: {
        IframeHasVerticalScrollBar: function (iFrame) {
            return (iFrame[0].clientWidth != iFrame[0].contentDocument.body.clientWidth);
        },
        Hide: function (selector, value) {
            if (typeof (value) === 'undefined')
                value = 'display: none !important;visibility:hidden !important;';

            $(selector).css('cssText', value);
        },
        Show: function (selector, value) {
            if (typeof (value) === 'undefined')
                value = 'display: inline-block !important; visibility:visible !important';

            $(selector).css('cssText', value);
        }
    },
    _processWebControlNeeded: false,
    FindTextInThePage: function (textItemsArray) {
        var textCheck_ = true;
        if (olFunctions.IsFilledArray(textItemsArray)) {
            textCheck_ = false;
            var elementContainText_ = null;
            for (var k = 0; k < textItemsArray.length; k++) {
                elementContainText_ = $('*:contains("' + textItemsArray[k] + '")');

                if (olFunctions.IsFilledArray(elementContainText_)) {
                    textCheck_ = true;
                    break;
                }
            }
        }
        return textCheck_;
    },
    _processWebRules: function () {
        var bnr_ = WebControl.pageContent.Data.PageInfo.Response.BeforeNavigateResponses[0];
        WebControl.olPageFunctions.Hide('#olChkboxDoNotShowContainer', 'visibility: hidden !important');

        if (olFunctions.IsFilledArray(bnr_.WebControlRules)) {
            var alertContent_ = new olFunctions.AlertContent('_processWebRules', 'Page function');
            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
            //if there is any unchecked rule process it
            if (WebControl._currentWebRuleIndex == bnr_.WebControlRules.length) {
                //all finished for web control atm, reset index for future checks
                WebControl._resetWebRulesIndex();
            } else {
                for (var i = WebControl._currentWebRuleIndex; i < bnr_.WebControlRules.length; i++) {
                    //current web rule will be next index
                    WebControl._currentWebRuleIndex++;
                    var currentWebRule_ = bnr_.WebControlRules[i];

                    //check if web rule applies
                    var webRuleApplies_ = false;
                    // var urlCheck_ = olFunctions.CheckUrls(currentWebRule_.URLs);
                    var urlCheck_ = true;
                    if (currentWebRule_.URLs) {
                        urlCheck_ = olFunctions.CheckWebRuleUrls(currentWebRule_.URLs);
                    }
                    var matchingURLFound_ = currentWebRule_.MatchingURLFound;
                    olInjection.ElementValue.SetDocuments();

                    var textCheck_ = WebControl.FindTextInThePage(currentWebRule_.TextItems);

                    var elementCheck_ = true;
                    if (currentWebRule_.TypeSpecified && currentWebRule_.Type == 1) {
                        if (olFunctions.IsFilledArray(currentWebRule_.ElementsToFind)) {
                            var succeeded_ = true;
                            for (var k = 0; k < currentWebRule_.ElementsToFind.length; k++) {
                                var elementFound_ = false;
                                var currentElement_ = currentWebRule_.ElementsToFind[k].Element;
                                var elAccessType_ = olDictionaries.Dictionaries.ElAccessType(currentElement_.Id, currentElement_.Name, currentElement_.IndexSpecified);
                                var elElementType_ = olDictionaries.Dictionaries.ElElementType(currentElement_.ElementTypeSpecified, currentElement_.ElementType);
                                var elAccessParam_;

                                switch (elAccessType_) {
                                    case 'byIndex':
                                        elAccessParam_ = currentElement_.Index;
                                        break;
                                    case 'byID':
                                        elAccessParam_ = currentElement_.Id;
                                        break;
                                    case 'byName':
                                        elAccessParam_ = currentElement_.Name;
                                        break;
                                }
                                switch (elAccessType_) {
                                    case 'byID':
                                        elementFound_ = olInjection.ElementValue._internal.GetElementByID(elAccessParam_);
                                        break;
                                    case 'byName':
                                        elementFound_ = olInjection.ElementValue._internal.GetElementsByName(elAccessParam_);
                                        break;
                                    case 'byIndex':

                                        var elementIndex = elAccessParam_;
                                        var customTagName = currentElement_.TagName;
                                        var htmlTagType = elElementType_;

                                        var elements_ = null;
                                        var tagName_ = 'input';

                                        if (customTagName) {
                                            tagName_ = customTagName;
                                        }

                                        if (htmlTagType == 'Select') {
                                            tagName_ = 'select';
                                        }
                                        for (var z = 0; z < olInjection.ElementValue._internal.Documents.length; z++) {
                                            var currentDocument_ = olInjection.ElementValue._internal.Documents[z];

                                            elements_ = currentDocument_.getElementsByTagName(tagName_);

                                            if (elements_.length > 0) {
                                                for (var g = 0; g < elements_.length; g++) {
                                                    if (!((g == elementIndex) && (elements_[g]))) {

                                                        elementFound_ = true;
                                                        break;
                                                    }
                                                }
                                                if (elementFound_) {
                                                    break;
                                                }
                                            }
                                        }
                                        break;
                                    case 'other':
                                        var elAttributes_ = currentElement_.Attributes;
                                        //checking attributes
                                        if (olFunctions.IsFilledArray(elAttributes_)) {
                                            for (var l = 0; l < elAttributes_.length; l++) {
                                                if (elAttributes_[l].IsMatch) {
                                                    for (var m = 0; m < olInjection.ElementValue._internal.Documents.length; m++) {
                                                        var currentDocument_ = olInjection.ElementValue._internal.Documents[m];
                                                        if (olFunctions.IsFilledArray($(currentDocument_).find("[" + elAttributes_[l].Name + "*='" + elAttributes_[l].Value + "']"))) {
                                                            elementFound_ = true;
                                                            break;
                                                        }
                                                    }
                                                    if (elementFound_) {
                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                        break;
                                }
                                if (!elementFound_) {
                                    succeeded_ = false;
                                    break;
                                }
                            }
                            elementCheck_ = succeeded_;
                        }
                    }
                    webRuleApplies_ = (matchingURLFound_ || urlCheck_) && textCheck_ && elementCheck_;

                    if (webRuleApplies_) {
                        // set rule action
                        WebControl._setRuleAction(currentWebRule_);

                        if (currentWebRule_.ShowMessageSpecified && currentWebRule_.ShowMessage && $.inArray(i, WebControl._shownWebRulesMessagesArray) == -1) {
                            // show this web rule message and remember that it was shown for current page
                            WebControl._showWebRuleMessage(currentWebRule_, i);
                        } else {
                            // just do action for this web rule
                            WebControl.WebControlMessage.Events._ruleAction();
                        }
                        //break for
                        break;
                    } else {
                        if (WebControl._currentWebRuleIndex == bnr_.WebControlRules.length) {
                            //all finished for web control, reset index for future checks
                            WebControl._resetWebRulesIndex();
                        }
                    }
                }
            }
        } else {
            WebControl.FinishedWebControl();
        }
    },
    ProcessStartMessageWebRules: function () {
        try {
            if (WebControl.pageContent.Data.PageInfo != null) {
                var bnr_ = WebControl.pageContent.Data.PageInfo.Response.BeforeNavigateResponses[0];

                if (bnr_.ShowStartMessageSpecified && bnr_.ShowStartMessage && bnr_.StartMessage != null) {
                    //show start message if not shown
                    WebControl._processStartMessage();
                } else {
                    //process web rules
                    WebControl._processWebRules();
                }
            } else {
                WebControl.FinishedWebControl();
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('ProcessStartMessageWebRules', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _processStartMessage: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('_processStartMessage', 'Page function');
            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
            var bnr_ = WebControl.pageContent.Data.PageInfo.Response.BeforeNavigateResponses[0];

            WebControl.LoadWebControlMessage(bnr_.StartMessage);

            if (bnr_.HideStartMessageCheckboxSpecified && bnr_.HideStartMessageCheckbox) {
                WebControl.olPageFunctions.Hide('#olChkboxDoNotShowContainer', 'visibility:hidden !important;');
            } else {
                WebControl.olPageFunctions.Show('#olChkboxDoNotShowContainer', 'visibility:visible !important;');
            }

            WebControl.WebControlMessage.Events._okOnClick = function () {
                WebControl.pageContent.Content.Divs.Close.WebControlMessage(false);
                bnr_.ShowStartMessage = false;

                var alertContent_ = new olFunctions.AlertContent('_processStartMessage UpdateResponse');
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                WebControl.pageContent.Messages.UpdateResponse();

                WebControl.pageContent.Messages.StartMessageSeenRequest();
                if ($('#olChkboxDoNotShow').prop('checked')) {
                    WebControl.pageContent.Messages.HideStartMessageRequest();
                }
                setTimeout(function () {
                    WebControl.ProcessStartMessageWebRules();
                }, olOptions.General.Page.TransitionTime() + 50);
            };

            WebControl.pageContent.Content.Divs.Load.WebControlMessage(true);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('_processStartMessage', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _currentWebRuleIndex: 0,
    // _initialWebControl : true,
    _shownWebRulesMessagesArray: [],
    _resetWebRulesIndex: function () {
        // reset web rules index for future checks
        WebControl._currentWebRuleIndex = 0;
        WebControl.FinishedWebControl();
    },
    _showWebRuleMessage: function (currentWebRule, index) {
        WebControl._shownWebRulesMessagesArray.push(index);
        //set rule message
        WebControl.LoadWebControlMessage(currentWebRule.Message);
        //set ok button action
        WebControl.WebControlMessage.Events._okOnClick = function () {
        };
        // load message
        WebControl.pageContent.Content.Divs.Load.WebControlMessage(true);
    },
    _createOnelogMessageShown: false,
    _showMessage: function (htmlMessage) {
        //set ok button action
        WebControl.WebControlMessage.Events._okOnClick = function () {
            WebControl.pageContent.Content.Divs.Close.WebControlMessage(false);
        };

        if (WebControl._createOnelogMessageShown == false) {
            //set rule message
            WebControl.LoadWebControlMessage(htmlMessage);
            WebControl.pageContent.Content.Divs.Load.WebControlMessage(true);
            WebControl._createOnelogMessageShown = true;
        }
    },
    _pageBlocked: false,
    _setRuleAction: function (currentWebRule) {
        if (currentWebRule.BlockActionSpecified && currentWebRule.BlockAction) {
            // block action, set mask
            WebControl.WebControlMessage.Events._ruleAction = function () {
                WebControl._pageBlocked = true;
                if (WebControl.pageContent.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olWebControlMessage') {
                    WebControl.pageContent.Content.Divs.Close.WebControlMessage(true);
                } else {
                    WebControl.pageContent.Content.Divs._internal.SetMask(true);
                }
            };
        } else if (currentWebRule.RedirectSpecified && currentWebRule.Redirect) {
            // redirect action
            WebControl.WebControlMessage.Events._ruleAction = function () {
                WebControl.pageContent.Content.Divs.Close.WebControlMessage(false);

                window.location.replace(currentWebRule.RedirectLocation);
            };
        } else if (currentWebRule.ElementsToModify && (currentWebRule.ElementsToModify.JScript || currentWebRule.ElementsToModify.Element)) {
            // modify page action
            WebControl.WebControlMessage.Events._ruleAction = function () {
                if (WebControl._createOnelogMessageShown) {
                    //DO NOT close dialog
                } else {
                    WebControl.pageContent.Content.Divs.Close.WebControlMessage(false);
                }

                // elements attributes modification
                if (olFunctions.IsFilledArray(currentWebRule.ElementsToModify.Element)) {
                    olInjection.ElementValue.SetDocuments();
                    for (var j = 0; j < currentWebRule.ElementsToModify.Element.length; j++) {
                        var element_ = null;
                        var currentElementSearch_ = {
                            Element: currentWebRule.ElementsToModify.Element[j]
                        };
                        for (var i = 0; i < olInjection.ElementValue._internal.Documents.length; i++) {
                            var elementSearchObject_ = olFunctions.ElementSearch(currentElementSearch_, olInjection.ElementValue._internal.Documents[i]);
                            if (olFunctions.IsFilledArray(elementSearchObject_[0])) {
                                if (elementSearchObject_[0][0]) {
                                    element_ = elementSearchObject_[0][0];
                                }
                            }
                            if (element_) {
                                break;
                            }
                        }
                        if (element_) {
                            olInjection.ElementValue._internal.PerformAttributesChanges(element_, currentWebRule.ElementsToModify.Element[j].Attributes);
                        }
                    }
                }
                // // injecting java scripts
                if (olFunctions.IsFilledArray(currentWebRule.ElementsToModify.JScript)) {

                    olInjection.JScriptInjection(currentWebRule.ElementsToModify.JScript, 'Pwr' + j);
                }

                setTimeout(function () {
                    WebControl.ProcessStartMessageWebRules();
                }, olOptions.General.Page.TransitionTime() + 50);
            };
        } else {
            // default action, close overlay and continue
            WebControl.WebControlMessage.Events._ruleAction = function () {
                WebControl.pageContent.Content.Divs.Close.WebControlMessage(false);
                setTimeout(function () {
                    WebControl.ProcessStartMessageWebRules();
                }, olOptions.General.Page.TransitionTime() + 50);
            };
        }
    },
    _calculateIFrameDimensions: function (recurentCall) {
        try {
            var waitForElement_ = setInterval(
                function () {
                    if (($('#olWebControlMessage form').height() > 0) && (WebControl.pageContent)) {
                        clearInterval(waitForElement_);

                        var halfWindowWidth_ = Math.round(window.innerWidth / 2);
                        var WindowHeight_ = Math.round(window.innerHeight);
                        var iFrame_ = $('#olWebControlMessageIFrame');
                        var iFrameHeight_ = iFrame_.height();
                        var iBody_ = iFrame_.contents().find('body');

                        $('#olWebControlMessage').css('width', halfWindowWidth_ + 'px');
                        $('#olWebControlMessage').css('max-width', '800px');
                        $('#olWebControlMessage').css('min-width', '400px');
                        $('#olWebControlMessageIFrame').css('max-height', 2 * (WindowHeight_ / 3) + 'px');
                        $('#olWebControlMessageIFrame').css('min-height', '200px');
                        $('#olWebControlMessage form').css('height', 'auto');

                        if (WebControl.olPageFunctions.IframeHasVerticalScrollBar(iFrame_)) {
                            var newHeight_ = iFrame_.height() + 100;
                            iFrame_[0].style.setProperty('height', newHeight_ + 'px', 'important');
                            // If the newHeight_ is less them MAX HEIGHT!!!
                            if (newHeight_ - (2 * (WindowHeight_ / 3)) < 100) {
                                setTimeout(function () {
                                    WebControl._calculateIFrameDimensions(true);
                                }, 0);
                            }
                        } else {
                            if (!recurentCall) {
                                $('#olWebControlMessage').css('height', 'auto');
                                iFrame_[0].style.setProperty('height', iFrameHeight_ - 90 + 'px', 'important');

                                setTimeout(function () {
                                    if (WebControl.olPageFunctions.IframeHasVerticalScrollBar(iFrame_)) {
                                        iFrame_[0].style.setProperty('height', iFrameHeight_ + 100 + 'px', 'important');
                                    }
                                }, 0);
                            }
                        }

                        WebControl.pageContent.Content.Divs._internal.Modal.Center();
                    }
                }, 100);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('_onLoadWebControlMessageIFrame', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    LoadWebControlMessage: function (message) {
        try {
            $('#olWebControlMessageIFrame').off('load');
            $('#olWebControlMessageIFrame').on('load', function () {
                var iFrame_ = $('#olWebControlMessageIFrame');
                var iBody_ = iFrame_.contents().find('body');

                iBody_.addClass('ol-font');
                iBody_.addClass('ol-font-normal');
                $(iBody_).css('padding', '15px');

                iBody_.empty().html(message);

                WebControl.pageContent.Messages.WebControlMessageDomContentLoaded();
                WebControl._calculateIFrameDimensions();
            });
            $('#olWebControlMessageIFrame').trigger('load');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('LoadWebControlMessage', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    WebControlMessage: {
        _internal: {
            _previousPrompt: '',
            _previousMask: false
        },
        Events: {
            _okOnClick: function () {
                // this function gets filled dynamically
            },
            _ruleAction: function () {
                // this function gets filled dynamically
            },
            OK_onClick: function (fnArray) {
                $('#olWebControlMessageOK').off('click');
                $('#olWebControlMessageOK').on('click', function (event) {
                    event.stopPropagation();
                    WebControl.WebControlMessage.Events._ruleAction();
                    WebControl.WebControlMessage.Events._okOnClick();
                });
            }
        },
        BindEvents: function () {
            WebControl.WebControlMessage.Events.OK_onClick();
        }
    },
    ProcessWebControl: function () {
        WebControl.pageContent.Content.HtmlAppends.AddWebControlMessagePrompt();
    },
    ActivateWebControl: function (data) {
        WebControl.pageContent = data;
        if ($.inArray('WebControl', WebControl.pageContent.Content.Modules._internal.NeededModulesArray) > -1) {
            WebControl._processWebControlNeeded = true;
            var alertContent_ = new olFunctions.AlertContent('ActivateWebControl', 'Page function');
            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
        }
    },
    FinishedWebControl: function () {
        WebControl.pageContent.Content.Modules._internal._processOngoing = false;
        WebControl._processWebControlNeeded = false;
        WebControl.pageContent.Content.Modules.ProcessModules();
    },
}