/* global chrome*/
// ==UserScript==
// @name OneLog wrapper
// @namespace itsOneLog
// @exclude ol.ol.ol.ol

/**
 *  OneLog wrapper
 */
var olWrap = {
    Mobile: {
        onExecScriptMobile: function (params) {
            try {
                if (params.JScript) {
                    for (var q = 0; q < params.JScript.length; q++) {
                        try {
                            var currentScript_ = '';
                            if (params.JScript[q].CodeString) {
                                //ROOT script handling
                                currentScript_ = params.JScript[q].CodeString;
                            } else {
                                currentScript_ = olFunctions.Mobile.decodeUTF8(params.JScript[q].Code)
                            }
                        } catch (e) {

                        }
                        var obj = olWrap.Functions.jsonMV3(currentScript_, false);

                        if (obj) {

                            //TODO Analysis for mobile!!!!
                            // for (var i = 0; i < obj.length; i++) {
                            //     if (obj[i] && obj[i].hasOwnProperty('analysisId')) {
                            //         //Analysis is only performed on top frame frameId==0 !!!!!
                            //         if (frameId == 0) {
                            //             chrome.scripting.executeScript({
                            //                 target: { tabId: tabId, frameIds: [frameId] },
                            //                 func: Analysis.Process,
                            //                 args: [obj[i]],
                            //             });
                            //         }
                            //     }
                            // }

                            var action;
                            if (obj.callFunction) {
                                action = 'createOnelogEvt';
                                if (obj.callFunction.eventName == undefined) {
                                    obj.callFunction.eventName = 'Input';
                                }
                                olResourceSpecFunctions.execFunc(obj.callFunction.functionType, obj.callFunction.eventName, params, obj, action);
                            }

                            if (obj.addPageElement) {
                                action = 'addPageElement';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.removePageElement) {
                                action = 'removePageElement';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.addElementAttribute) {
                                action = 'addElementAttribute';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.setProperty) {
                                action = 'setProperty';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.addElementText) {
                                action = 'addElementText';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.removeElementAttribute) {
                                action = 'removeElementAttribute';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }

                            if (obj.onElementChange) {
                                action = 'onElementChange';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }
                            if (obj.onElementChangeVisibilityObserver) {
                                action = 'onElementChangeVisibilityObserver';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }
                            if (obj.callEvent) {
                                action = 'callEvent';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }
                            if (obj.runInPage) {
                                var executeFunc = olResourceSpecFunctions.runInPageCheckElement(obj);
                                if (executeFunc == true) {
                                    action = 'runInPage';
                                    olResourceSpecFunctions.execFunc('', '', params, obj, action);
                                }
                            }
                            if (obj.createOnelogMessage) {
                                action = 'createOnelogMessage';
                                olResourceSpecFunctions.execFunc('', '', params, obj, action);
                            }
                        }
                    }
                }
            } catch (e) {
            }
        }
    },
    Flags: {
        JsonMessages: false
    },
    contentScriptOrderArray: [
        'jQuery.js',
        "olFramework.js",
        'idleTimer.js',
        'modFunctions.js',
        "modResourceSpecFunctions.js",
        'modWrap.js',
        'modData.js',
        'modOptions.js',
        'modDictionaries.js',
        'modInjection.js',
        'page.js',
        'pageMessaging.js',
        'pageEvents.js',
        "modAnalysis.js",
        "modWebControl.js",
    ],
    Functions: {
        JsonParse: function (data) {
            if (olWrap.Flags.JsonMessages) {
                return JSON.parse(String(data));
            } else {
                return data;
            }
        },
        JsonStringify: function (data) {
            if (olWrap.Flags.JsonMessages) {
                return JSON.stringify(data);
            } else {
                return data;
            }
        },
        Guid: function () {
            var guid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = Math.random() * 16 | 0,
                    v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            });
            return guid;
        },
        findPath: function (ob, key, value) {
            var path = [];
            var keyExists = (obj) => {
                if (!obj || (typeof obj !== "object" && !Array.isArray(obj))) {
                    return false;
                }
                else if (obj.hasOwnProperty(key) && obj[key] === value) {
                    return true;
                }
                else if (Array.isArray(obj)) {
                    let parentKey = path.length ? path.pop() : "";

                    for (let i = 0; i < obj.length; i++) {
                        path.push(`${parentKey}[${i}]`);
                        var result = keyExists(obj[i], key);
                        if (result) {
                            return result;
                        }
                        path.pop();
                    }
                }
                else {
                    for (var k in obj) {
                        path.push(k);
                        var result = keyExists(obj[k], key);
                        if (result) {
                            return result;
                        }
                        path.pop();
                    }
                }

                return false;
            };
            keyExists(ob);
            return path.join(".");
        },
        jsonMV3: function (script, extensionEnvironment) {
            try {
                if (typeof (extensionEnvironment) === 'undefined') {
                    extensionEnvironment = false;
                }

                var startMV3 = "STARTMV3JSON";
                var endMV3 = "ENDMV3JSON";
                if (script.lastIndexOf(startMV3) >= 0) {
                    var resultScript = script.substring(
                        script.lastIndexOf(startMV3) + startMV3.length,
                        script.lastIndexOf(endMV3)
                    );
                    var objMV3 = JSON.parse(resultScript);
                }

                if (!extensionEnvironment) {
                    //DEVICE PLATFORM SUPPORT MOBILE MV3
                    //MOBILE specific scripts 
                    //IF THEY EXIST override regular scripts
                    var startMobileMV3 = "EMPTY_START_STRING_NEEDED_TO_USE_DEFAULT";
                    var endMobileMV3 = "";
                    // If device is defined then process only script specific 
                    // for that device plaltform
                    switch (Device.Platform) {
                        case 'iOS':
                            switch (Device.Name) {
                                case 'iPad':
                                    startMobileMV3 = "START_IPAD_MV3JSON";
                                    endMobileMV3 = "END_IPAD_MV3JSON";
                                    break;
                                case 'iPhone':
                                    startMobileMV3 = "START_IPHONE_MV3JSON";
                                    endMobileMV3 = "END_IPHONE_MV3JSON";
                                    break;
                            }
                            break;
                        case 'macOS':
                            startMobileMV3 = "START_MAC_MV3JSON";
                            endMobileMV3 = "END_MAC_MV3JSON";
                            break;
                        case 'Android':
                            startMobileMV3 = "START_ANDROID_MV3JSON";
                            endMobileMV3 = "END_ANDROID_MV3JSON";
                            break;
                        case 'UWP':
                            startMobileMV3 = "START_UWP_MV3JSON";
                            endMobileMV3 = "END_UWP_MV3JSON";
                            break;
                    }

                    if (script.lastIndexOf(startMobileMV3) >= 0) {
                        var resultScriptMobile = script.substring(
                            script.lastIndexOf(startMobileMV3) + startMobileMV3.length,
                            script.lastIndexOf(endMobileMV3)
                        );
                        var objMobileMV3 = JSON.parse(resultScriptMobile);
                        objMV3 = objMobileMV3;
                    } else {
                        startMobileMV3 = "START_MOBILE_MV3JSON";
                        endMobileMV3 = "END_MOBILE_MV3JSON";

                        if (script.lastIndexOf(startMobileMV3) >= 0) {
                            var resultScriptMobile = script.substring(
                                script.lastIndexOf(startMobileMV3) + startMobileMV3.length,
                                script.lastIndexOf(endMobileMV3)
                            );
                            var objMobileMV3 = JSON.parse(resultScriptMobile);
                            objMV3 = objMobileMV3;
                        }
                    }
                }

                return objMV3
            }
            catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('jsonMV3', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                console.log('jsonMV3', resultScript)
            }
        }
    },
    DataConstructor: {
        olTab: function (tab) {
            tab.getId = function () {
                return tab.id;
            };
            tab.getUrl = function () {
                return tab.url;
            };
            tab.getTitle = function () {
                return tab.title;
            };
            tab.navigate = function (url) {
                chrome.tabs.update(tab.id, {
                    url: url
                });
            };
            tab.dispatchMessage = function (name, data) {
                var messageContent_ = olWrap.Functions.JsonStringify({
                    name: name,
                    data: data
                });
                chrome.tabs.sendMessage(tab.id, messageContent_, function () {
                    if (!chrome.runtime.lastError) {
                        // if you have any response (to avoid unnecessary error in the console)
                    }
                });
            };
            tab.close = function () {
                chrome.tabs.get(tab.id, function (tab) {
                    if (!chrome.runtime.lastError) {
                        chrome.tabs.remove(tab.id);
                    }
                });
            };
            return tab;
        },
        olWin: function (win) {
            // create olTabs
            win.olTabs = [];
            if (win.tabs) {
                for (var i in win.tabs) {
                    // var currentTabId_ = win.tabs[i].id;
                    // chrome.tabs.get(currentTabId_, function (tab) {
                    // win.olTabs.push(olWrap.DataConstructor.olTab(tab));
                    // });
                    win.olTabs.push(olWrap.DataConstructor.olTab(win.tabs[i]));
                }
            }

            win.getId = function () {
                return win.id.toString();
            };
            win.getTabs = function (callback) {
                callback(win.olTabs);
            };
            win.getCurrentTab = function (callback) {
                for (var i in win.tabs) {
                    if (win.tabs[i].active) {
                        // chrome.tabs.get(win.tabs[i].id, function (tab) {
                        //     callback(olWrap.DataConstructor.olTab(tab));
                        // });
                        callback(olWrap.DataConstructor.olTab(win.tabs[i]));
                    }
                }
            };
            win.isActive = function () {
                return win.focused;
            };
            return win;
        }
    },
    api: {
        onReady: function (callback) {
            callback();
        },
        tabsFramesScripts: {},
        _LoadContentScripts: function (tabId, frameId) {
            try {
                //If no frameId is sent, use top frame with id 0
                frameId = frameId ? frameId : 0;
                var callback = null;

                function createCallback(tabId, frameId, scriptFile, callback) {
                    return function () {
                        if (chrome.runtime.lastError) {
                            var errorMsg = chrome.runtime.lastError.message
                            var alertErrorContent_ = new olFunctions.AlertContent('_LoadContentScripts chrome.runtime.lastError error:', errorMsg);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        } else {
                            try {
                                chrome.tabs.get(tabId, function (tab) {
                                    if (!chrome.runtime.lastError && tab && tab.url.indexOf('chrome://') == -1 && tab.url.indexOf('chrome-extension://') == -1 && tab.url.indexOf('about:debugging#') == -1 && tab.url.indexOf('about:') == -1) {
                                        try {
                                            chrome.scripting.executeScript({
                                                target: { tabId: tabId, frameIds: [frameId] },
                                                files: [scriptFile],
                                            }, callback);
                                        } catch (e) {
                                            var alertErrorContent_ = new olFunctions.AlertContent('chrome.scripting.executeScript error', e.message + '\n' + e.stack);
                                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                        }
                                    }
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Content script loading error:', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    };
                };
                for (var i = olWrap.contentScriptOrderArray.length - 1; i >= 0; --i) {
                    var scriptName_ = olWrap.contentScriptOrderArray[i];
                    try {
                        if (olWrap.api.tabsFramesScripts[tabId]) {
                            if (olWrap.api.tabsFramesScripts[tabId][frameId]) {
                                if (ol$Functions.inArray(scriptName_, olWrap.api.tabsFramesScripts[tabId][frameId].scriptsNamesArray) == -1) {
                                    olWrap.api.tabsFramesScripts[tabId][frameId].scriptsNamesArray.push(scriptName_);
                                    callback = createCallback(tabId, frameId, scriptName_, callback);
                                }
                            } else {
                                olWrap.api.tabsFramesScripts[tabId][frameId] = { scriptsNamesArray: [] };
                                olWrap.api.tabsFramesScripts[tabId][frameId].scriptsNamesArray.push(scriptName_);
                                callback = createCallback(tabId, frameId, scriptName_, callback);
                            }
                        } else {
                            olWrap.api.tabsFramesScripts[tabId] = {};
                            olWrap.api.tabsFramesScripts[tabId][frameId] = { scriptsNamesArray: [] };
                            olWrap.api.tabsFramesScripts[tabId][frameId].scriptsNamesArray.push(scriptName_);
                            callback = createCallback(tabId, frameId, scriptName_, callback);
                        }
                    } catch (e1) {
                        olWrap.Console.Log('_LoadContentScripts createCallback e1', e1)
                    }
                }

                if (callback !== null)
                    callback();
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('_LoadContentScripts error:', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        _LoadContentCss: function (tabId) {
            chrome.scripting.insertCSS({
                target: { tabId: tabId, allFrames: true },
                files: ['onelogStyles.css']
            });
        },
        onDomContentLoaded: function (event) {
            olWrap.api._LoadContentScripts(event.target.id);
            olWrap.api._LoadContentCss(event.target.id);
        },
        onLoad: function (tabId, framesArray) {
            for (var i = 0; i < framesArray.length; i++) {
                var currentFrameId = framesArray[i];
                olWrap.api._LoadContentScripts(tabId, currentFrameId);
            }
        },
        onExecScript: function (params, tabId, frameId) {
            try {
                if (chrome.runtime.lastError) {
                    var errorMsg = chrome.runtime.lastError.message
                    var alertErrorContent_ = new olFunctions.AlertContent('onExecScript chrome.runtime.lastError error:', errorMsg + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                } else {
                    if (params.JScript || olExtension.Data.JsonMv3TestingScript) {
                        if (olExtension.Data.JsonMv3TestingScript) {
                            params.JScript = [{}]
                        }
                        for (var q = 0; q < params.JScript.length; q++) {
                            var currentScript_ = params.JScript[q].CodeString;
                            if (olExtension.Data.JsonMv3TestingScript) {
                                var obj = olWrap.Functions.jsonMV3(olExtension.Data.JsonMv3TestingScript, true);
                            } else {
                                var obj = olWrap.Functions.jsonMV3(currentScript_, true);
                            }

                            if (obj) {
                                for (var i = 0; i < obj.length; i++) {
                                    if (obj[i] && obj[i].hasOwnProperty('analysisId')) {
                                        //Analysis is only performed on top frame frameId==0 !!!!!
                                        if (frameId == 0) {
                                            chrome.scripting.executeScript({
                                                target: { tabId: tabId, frameIds: [frameId] },
                                                func: Analysis.Process,
                                                args: [obj[i]],
                                            });
                                        }
                                    }
                                }

                                var action;
                                if (obj.callFunction) {
                                    action = 'createOnelogEvt';
                                    if (obj.callFunction.eventName == undefined) {
                                        obj.callFunction.eventName = 'Input';
                                    }
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: [obj.callFunction.functionType, obj.callFunction.eventName, params, obj, action],
                                    });

                                }
                                if (obj.addPageElement) {
                                    action = 'addPageElement';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.removePageElement) {
                                    action = 'removePageElement';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.addElementAttribute) {
                                    action = 'addElementAttribute';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.grabMatterValue) {
                                    action = 'grabMatterValue';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.setProperty) {
                                    action = 'setProperty';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.addElementText) {
                                    action = 'addElementText';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.removeElementAttribute) {
                                    action = 'removeElementAttribute';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }

                                if (obj.onElementChange) {
                                    action = 'onElementChange';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }
                                if (obj.onElementChangeVisibilityObserver) {
                                    action = 'onElementChangeVisibilityObserver';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }
                                if (obj.callEvent) {
                                    action = 'callEvent';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }
                                if (obj.runInPage) {
                                    var exesuteFunc = false;
                                    chrome.scripting.executeScript(
                                        {
                                            target: { tabId: tabId, frameIds: [frameId] },
                                            func: olResourceSpecFunctions.runInPageCheckElement,
                                            args: [obj]
                                        },
                                        (res) => {
                                            exesuteFunc = res[0].result;
                                            if (exesuteFunc == true) {
                                                action = 'runInPage';
                                                chrome.scripting.executeScript({
                                                    target: { tabId: tabId, frameIds: [frameId] },
                                                    world: 'MAIN',
                                                    func: olResourceSpecFunctions.execFunc,
                                                    args: ['', '', params, obj, action],
                                                });
                                            }
                                        })
                                }
                                if (obj.createOnelogMessage) {
                                    action = 'createOnelogMessage';
                                    chrome.scripting.executeScript({
                                        target: { tabId: tabId, frameIds: [frameId] },
                                        func: olResourceSpecFunctions.execFunc,
                                        args: ['', '', params, obj, action],
                                    });
                                }
                            }
                        }
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('onExecScript error:', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    },
    Console: {
        Log: function (message, type) {
            try {
                type ? type : type = 'default';
                var today = new Date();
                var date = today.getFullYear() + '.' + ('0' + String(today.getMonth() + 1)).slice(-2) + '.' + ('0' + String(today.getDate())).slice(-2);

                var time = ('0' + String(today.getHours())).slice(-2) + ":" + ('0' + String(today.getMinutes())).slice(-2) + ":" + String('0' + today.getSeconds()).slice(-2) + '.' + String('00' + today.getMilliseconds()).slice(-3)

                var style;
                var style1;
                var style2;
                style = 'line-height: 300%; font-weight: bold; font-size: 14px;';

                switch (type) {
                    case 'error':
                        style1 = style + 'color:#E8523F';
                        break;
                    case 'apimessevent':
                        style1 = style + 'color:#30852c';
                        break;
                    case 'default':
                        style1 = style + 'color:#39A9DC';
                        break;
                }

                style2 = style + 'color:#F5F5F';
                var dt = 'Onelog:' + date + ' - ' + time + ': ';
                if (olOptions.DebugStatistics()) {

                    olData._DebugStatistics.Transactions.push(
                        {
                            Message: message,
                            Time: time,
                            Source: 'Extension'
                        }
                    )
                    var element_ = ol$Functions.grep(olData._DebugStatistics.Summary, function (member) {
                        return (message == member.Message);
                    });

                    if (olFunctions.IsFilledArray(element_)) {
                        element_[0].Count++;
                    } else {
                        olData._DebugStatistics.Summary.push(
                            {
                                Message: message,
                                Count: 1,
                                Source: 'Extension'
                            }
                        )
                    }
                } else {
                    if (!olOptions.DebugNone()) {
                        console.log("%c" + dt + "%c" + message, style1, style2);
                    }
                }
            } catch (e) {
            }
        },
        Warn: function (message) {
            console.warn(message);
        },
        Error: function (message) {
            var today = new Date();
            var date = today.getFullYear() + '.' + ('0' + String(today.getMonth() + 1)).slice(-2) + '.' + ('0' + String(today.getDate())).slice(-2);

            var time = ('0' + String(today.getHours())).slice(-2) + ":" + ('0' + String(today.getMinutes())).slice(-2) + ":" + String('0' + today.getSeconds()).slice(-2);
            var style = 'line-height: 300%; font-weight: bold; font-size: 14px;';
            var style1 = style + 'color:red';
            var style2 = style + 'color:#F5F5F';
            var dt = 'Onelog:' + date + ' - ' + time + ': ';

            console.error("%c" + dt + "%c" + message, style1, style2);
        },
        Statistics: function (statisticsObject) {
            console.clear();

            var timeInMin_ = olOptions.DebugStatisticsPeriod();
            var ExtensionInfo_ = olWrap.getExtensionInfo();
            var style = 'line-height: 300%; font-weight: bold; font-size: 24px;';
            var style1 = style + 'color:#39A9DC';
            var style2 = style + 'color:#F5F5F';

            console.log("%c" + olData.BrowserName + ' version:' + "%c" + ExtensionInfo_.version, style1, style2);
            console.log("%c" + 'Time of observation period:' + "%c" + timeInMin_ + ' min', style1, style2);

            console.log("%c" + 'Summary report (sorted per number of calls)', style1);
            console.table((statisticsObject.Summary).sort((a, b) => (a.Count < b.Count) ? 1 : -1));

            console.log("%c" + 'Timeline', style1);
            console.table((statisticsObject.Transactions).sort((a, b) => (a.Time > b.Time) ? 1 : -1));
        },
    },
    extension: {
        getURL: function (resourceURL) {
            return chrome.runtime.getURL(resourceURL);
        }
    },
    storage: {
        asyncSetItem: function (name, value, callback) {
            if (typeof (callback) === 'undefined')
                callback = function () {
                };
            if (chrome.storage) {
                var storageItem_ = {};
                storageItem_[name] = value;
                chrome.storage.local.set(storageItem_, callback);
            } else {
                var messageName_ = olWrap.Functions.Guid();
                olWrap.addMessageListener(messageName_, function () {
                    callback();
                });

                var data_ = {
                    name: name,
                    value: value,
                    messageName: messageName_
                };

                olWrap.dispatchMessage('olAsyncSetItem', data_);
            }
        },
        asyncGetItem: function (name, callback) {
            if (chrome.storage) {
                chrome.storage.local.get(name, function (data) {
                    try {
                        callback(data[name]);
                    } catch (error) {
                    }
                });
            } else {
                var messageName_ = olWrap.Functions.Guid();

                olWrap.addMessageListener(messageName_, function (messageContent) {
                    try {
                        callback(messageContent.data);
                    } catch (error) {
                    }
                });

                var data_ = {
                    name: name,
                    messageName: messageName_
                };

                olWrap.dispatchMessage('olAsyncGetItem', data_);
            }
        },
        asyncSetOlData: function (value) {
            try {
                switch (olWrap.browser.getName()) {
                    case olWrap.browser.name.firefox:
                        value = JSON.stringify(value);
                        break;
                    default:
                        break;
                }

                if (olData.useStorage == true && chrome.storage) {
                    chrome.storage.local.set({ 'olDataKey': value }, function () {
                    });
                }
            }
            catch (e) {
                var alertContent_ = new olFunctions.AlertContent('asyncSetOlData! ERROR', e);
                olFunctions.Alert(true, alertContent_);
            }
        },
        asyncGetOlData: function (callback) {
            try {
                if (chrome.storage) {
                    chrome.storage.local.get('olDataKey', function (data) {

                        //  todo: check this!!!
                        if (data.olDataKey !== undefined) {
                            switch (olWrap.browser.getName()) {
                                case olWrap.browser.name.firefox:
                                    olData = JSON.parse(data.olDataKey);
                                    break;
                                default:
                                    olData = data.olDataKey;
                                    break;
                            }
                        }

                        switch (olExtension.Version) {
                            case 'TerminalServer':
                                //PROBLEM WITH TERMINAL SERVER
                                if (olData.Initialized) {
                                } else {
                                    olData.Initialize();
                                }
                                break;
                            default:
                                break;
                        }

                        for (var k = 0; k < olData.TabInfoArray.TabMembers.length; k++) {
                            var currentTabmember_ = olData.TabInfoArray.TabMembers[k];
                            currentTabmember_._internal.GetUrl = function () {
                                return currentTabmember_.PageInfo.Url;
                            }
                            currentTabmember_._internal.GetLastUrl = function () {
                                return currentTabmember_.PageInfo.LastUrl;
                            }
                        }

                        if (callback) {
                            callback();
                        }
                    });
                }
            }
            catch (e) {
                var alertContent_ = new olFunctions.AlertContent('asyncGetOlData! ERROR', e);
                olFunctions.Alert(true, alertContent_);
            }
        },
        asyncRemoveOlData: function () {
            try {
                chrome.storage.local.remove(['olDataKey'], function () {
                    var error = chrome.runtime.lastError;
                    if (error) {
                        console.error(error);
                    }
                })
            }
            catch (e) {
                var alertContent_ = new olFunctions.AlertContent('asyncRemoveOlData! ERROR', e);
                olFunctions.Alert(true, alertContent_);
            }
        }
    },
    tabs: {
        getAll: function (callback) {
            chrome.tabs.query({}, function (tabs) {
                if (!chrome.runtime.lastError) {
                    var olTabs_ = [];
                    for (var i in tabs) {
                        if (tabs[i]) {
                            olTabs_.push(olWrap.DataConstructor.olTab(tabs[i]));
                        }
                    }
                    callback(olTabs_);
                }
            });
        },
        getCurrent: function (callback) {
            chrome.tabs.getCurrent(function (tab) {
                if (!chrome.runtime.lastError && tab) {
                    callback(olWrap.DataConstructor.olTab(tab));
                }
            });
        }
    },
    windows: {
        _storedWindowParams: null,
        storeWindowSize: function () {
            chrome.windows.getAll({
                populate: true
            }, function (windows) {
                if (windows && windows.length > 0) {
                    var window = windows[0];
                    var params = {
                        top: 0, //window.top,
                        left: 0, //window.left,
                        height: window.height,
                        width: window.width,
                        url: 'https://devtest.onelog.com/mobview/olResources/logout.html'
                    }
                    olWrap.windows._storedWindowParams = params;
                }
            });
        },
        getCurrent: function (callback) {
            try {
                chrome.windows.getCurrent({
                    populate: true
                }, function (win) {
                    try {
                        callback(olWrap.DataConstructor.olWin(win));
                    } catch (error) {

                    }
                });
            } catch (error) {

            }
        },
        getAll: function (callback) {
            try {
                chrome.windows.getAll({
                    populate: true
                }, function (wins) {
                    try {
                        var olWins_ = [];
                        for (var i in wins) {
                            olWins_.push(olWrap.DataConstructor.olWin(wins[i]));
                        }
                        callback(olWins_);
                    } catch (error) {

                    }
                });
            } catch (error) {

            }
        },
        create: function (logoutUrl, callback) {
            var winCreateCallback;

            switch (olWrap.browser.getName()) {
                case olWrap.browser.name.chrome:
                case olWrap.browser.name.edg:
                    winCreateCallback = function (win) {
                        try {
                            chrome.windows.update(
                                win.id,
                                {
                                    focused: false,
                                    state: 'minimized'
                                },
                                function (win) {
                                    try {
                                        if (callback) callback(olWrap.DataConstructor.olWin(win));
                                    } catch (error) {

                                    }
                                }
                            );
                        } catch (error) {

                        }
                    };
                    chrome.system.display.getInfo(
                        function (displayInfo) {
                            try {
                                var heightScreen = 0;
                                var widthScreen = 0;
                                heightScreen = displayInfo[0].bounds.height;
                                for (var i = 0; i < displayInfo.length; i++) {
                                    widthScreen = widthScreen + displayInfo[i].bounds.width;
                                }
                                chrome.windows.create(
                                    {
                                        url: logoutUrl,
                                        type: 'popup',
                                        top: heightScreen - 150,
                                        left: widthScreen - 200,
                                        height: 150,
                                        width: 200
                                    },
                                    winCreateCallback
                                );
                            } catch (error) {

                            }
                        });
                    break;
                case olWrap.browser.name.firefox:
                    winCreateCallback = function (win) {
                        try {
                            chrome.windows.update(
                                win.id,
                                {
                                    state: 'minimized'
                                },
                                function (win) {
                                    try {
                                        if (callback) callback(olWrap.DataConstructor.olWin(win));
                                    } catch (error) {

                                    }
                                }
                            );
                        } catch (error) {

                        }
                    };
                    chrome.windows.create(
                        {
                            url: logoutUrl,
                            type: 'popup',
                            height: 150,
                            width: 200
                        },
                        winCreateCallback
                    );
                    break;
            }
        },
    },
    browser: {
        name: {
            chrome: 'chrome',
            firefox: 'firefox',
            edge: 'edge',
            edg: '_edge'
        },
        event: {
            BeforeNavigate: 'BeforeNavigate',
            TabRemoved: 'TabRemoved',
            TabCreated: 'TabCreated'
        },
        addEventListener: function (name, callback) {
            switch (name) {
                case 'BeforeNavigate':
                    var listener_ = function (event) {
                        if (event.frameId === 0) {
                            chrome.tabs.get(event.tabId, function (tab) {
                                if (!chrome.runtime.lastError) {
                                    event.target = olWrap.DataConstructor.olTab(tab);
                                    callback(event);
                                }
                            });
                        }
                    }
                    chrome.webNavigation.onBeforeNavigate.addListener(function (event) {
                        if (event.frameId === 0) {
                            // 0 indicates the navigation happens in the tab content window
                            listener_(event);
                        }
                    });
                    break;
                case 'TabRemoved':
                    chrome.tabs.onRemoved.addListener(function (tabId, event) {
                        event.tabId = tabId;
                        callback(event);
                    });
                    break;
                case 'TabCreated':
                    chrome.tabs.onCreated.addListener(function (tab) {
                        var event = {};
                        event.target = olWrap.DataConstructor.olTab(tab);
                        event.tabId = event.target.id;
                        callback(event);
                    });
                    break;
            }
        },
        _shortBrowserName: '',
        _longBrowserName: '',
        _getBrowserName: function () {
            var ua = navigator.userAgent,
                tem,
                M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];

            var isOperaOrEdgeMatch = ua.match(/\b(OPR|Edge|Edg)\/(\d+)/);

            if ((M[1] === 'Chrome') && (isOperaOrEdgeMatch != null)) {
                olWrap.browser._longBrowserName = isOperaOrEdgeMatch.slice(1).join(' ').replace('OPR', 'Opera');

                olWrap.browser._longBrowserName = isOperaOrEdgeMatch.slice(1).join(' ')

                if (ua.match(/\b(Edg)\/(\d+)/) && !ua.match(/\b(Edge)\/(\d+)/)) {
                    olWrap.browser._longBrowserName = olWrap.browser._longBrowserName.replace('Edg', '_Edge');
                }
            } else {
                M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
                olWrap.browser._longBrowserName = M.join(' ');
            }

            var spaceIndex_ = olWrap.browser._longBrowserName.indexOf(' ');

            if (spaceIndex_ != -1) {
                olWrap.browser._shortBrowserName = olWrap.browser._longBrowserName.slice(0, spaceIndex_).toLowerCase();
            } else {
                olWrap.browser._shortBrowserName = olWrap.browser._longBrowserName.toLowerCase();
            }

            return olWrap.browser._shortBrowserName;
        },
        getName: function () {
            if (olWrap.browser._shortBrowserName) {
                return olWrap.browser._shortBrowserName;
            } else {
                return olWrap.browser._getBrowserName();
            }
        },
        getResourceExclusionListFetch: async function (onLoad) {
            try {
                var ExtensionInfo_ = olWrap.getExtensionInfo();
                var resourceExclusionList_ = await fetch(olExtension.Data.RuntimeDataUrl + '?version=' + ExtensionInfo_.version);
                if (resourceExclusionList_.status === 200) {
                    var response_ = await resourceExclusionList_.text();
                    onLoad(response_);
                    return response_;
                }
            } catch (e) {
                var alertContent_ = new olFunctions.AlertContent('getResourceExclusionListFetch catch', response_);
                olFunctions.Alert(true, alertContent_);
            }
        },
        _getScriptTextFetch: async function (script) {
            try {
                var request_ = await fetch(script);
                if (request_.status === 200) {
                    try {
                        var response_ = await request_.text();
                        onLoad(response_);
                        return response_;
                    } catch (n) {
                        return null;
                    }
                }
            } catch (e) {
                var alertContent_ = new olFunctions.AlertContent('getResourceExclusionListFetch catch', response_);
                olFunctions.Alert(true, alertContent_);
            }
        },
        _prepareFullContentScript: function () {
            olWrap.contentScripts = [];
            olWrap.fullContentScript = '';

            for (var key in olWrap.contentScriptOrderArray) {
                var contentScriptName_ = olWrap.contentScriptOrderArray[key];
                var contentScriptText_ = olWrap.browser._getScriptTextFetch(contentScriptName_);

                olWrap.contentScripts.push({
                    name: contentScriptName_,
                    text: contentScriptText_
                });
                olWrap.fullContentScript = olWrap.fullContentScript + contentScriptText_ + '\n\n';
            }
        },
        pageContentExclude: function () {
            olWrap.browser.getResourceExclusionListFetch(function (response_) {
                if (response_) {
                    var olRuntimeData_ = JSON.parse(response_);
                    olWrap.olRuntimeData = olRuntimeData_;
                }
                olWrap.olRuntimeData.exclude.push('chrome://');
                olWrap.olRuntimeData.exclude.push('chrome-extension://');
                olWrap.olRuntimeData.exclude.push('about:debugging#//');
                olWrap.olRuntimeData.exclude.push('about://');

                olWrap.browser._prepareFullContentScript();
            });
        },
        execMV3Script: function (params) {
            try {
                olWrap.dispatchMessage('olExecMV3Script', params);
            }
            catch (e) {
                var alertContent_ = new olFunctions.AlertContent('execMV3Script! ERROR', e);
                olFunctions.Alert(true, alertContent_);
            }
        }
    },
    getExtensionInfo: function () {
        return chrome.runtime.getManifest();
    },
    _messageListenerArray: [],
    _messageListenerAdded: false,
    addMessageListener: function (name, callback) {
        //add particular name and callback to message listener array
        olWrap._messageListenerArray.push({
            name: name,
            callback: callback
        });

        //if global message listener wasn't added...
        if (!olWrap._messageListenerAdded) {
            // add global message listener
            chrome.runtime.onMessage.addListener(function (message, sender, sendResponse) {
                // this is global message listener
                var localMessage_ = olWrap.Functions.JsonParse(message);
                var messageCallbackFound_ = false;
                var messageCallback_ = null;

                // check if there is callback for message name
                for (var i = 0; i < olWrap._messageListenerArray.length; i++) {
                    if (olWrap._messageListenerArray[i].name == localMessage_.name) {
                        messageCallbackFound_ = true;
                        messageCallback_ = olWrap._messageListenerArray[i].callback;
                        break;
                    }
                }

                if (messageCallbackFound_) {
                    // prepare event object
                    var event_ = {};
                    if (sender && sender.tab) {
                        event_.target = olWrap.DataConstructor.olTab(sender.tab);
                    }
                    event_.data = localMessage_.data;
                    // call message callback
                    messageCallback_(event_);
                }
                sendResponse();
            });
            olWrap._messageListenerAdded = true;
        }
    },
    dispatchMessage: function (name, data) {
        try {
            var messageContent_ = olWrap.Functions.JsonStringify({
                name: name,
                data: data,
                origin: 'tab'
            });
            //chrome.runtime.sendMessage(messageContent_);
            chrome.runtime.sendMessage(messageContent_, function (response) {
                if (!chrome.runtime.lastError) {
                    // if you have any response (to avoid unnecessary error in the console)
                }
            });
        } catch (error) {
            olWrap.Console.Log('dispatchMessage error', error)
        }
    },
    _escapeRegExp: function (e) {
        return e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
    },
    _checkExcludeUrls: function (excludeUrls, url) {
        if ("undefined" != typeof excludeUrls) {
            excludeUrls instanceof Array || (excludeUrls = new Array(excludeUrls));
            for (var t = 0; t < excludeUrls.length; t++) {
                var s = olWrap._escapeRegExp(excludeUrls[t]).replace(/\\\*/g, ".*"),
                    i = new RegExp(s);
                if (i.test(url))
                    return true;
            }
        }
        return false;
    },
    urlExcluded: function (url) {
        if (olWrap.olRuntimeData && olWrap.olRuntimeData.exclude) {
            return olWrap._checkExcludeUrls(olWrap.olRuntimeData.exclude, url);
        } else {
            return false;
        }
    },
    Initialize: function () {
    }
};

olWrap.Initialize();