/**
 *  OneLog Functions - replacement for jquery
 */

var ol$Functions = {
    // grep: function (params, callback) {
    //     {
    //         try {
    //             var filtered = [];
    //             filtered = params.filter(callback)
    //             return filtered;
    //         } catch (e) {
    //             var alertErrorContent_ = new olFunctions.AlertContent('grep', e.message + '\n' + e.stack);
    //             olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
    //         }
    //     };
    // },

    grep: function (params, callback) {
        {
            try {
                var filtered = [],
                    len = params.length,
                    i = 0;
                for (i; i < len; i++) {
                    var item = params[i];
                    var cond = callback(item);
                    if (cond) {
                        filtered.push(item);
                    }
                }
                return filtered;
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('grep', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        };
    },

    inArray: function (value, arr) {
        try {
            var status = -1;
            for (var i = 0; i < arr.length; i++) {
                var name = arr[i];
                if (name == value) {
                    status = i;
                    break;
                }
            }
            return status;
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('inArray', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },

    trim: function (value) {
        try {
            return value.trim();
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('trim', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    merge: function (array1, array2) {
        try {
            return array1.concat(array2);;
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('merge', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    }
}