var OptionsPage = {
    Options: {
        _internal: {

        }
    },
    JSONBuilder: {
        _templates: {

        },
        _internal: {

        }
    },
    Initialize: function () {
        OptionsPage._events.OnReady();
        OptionsPage._events.OnClickSave();
        OptionsPage._events.OnClickMinMax();
        OptionsPage._events.OnClickExportJSON();
        OptionsPage._events.OnClickResetJSON();
        OptionsPage._events.OnClearTextAreaJSON();
        OptionsPage._events.OnSaveToExtension();
        OptionsPage._events.OnCopyToClipboard();
        OptionsPage._events.OnClickDefault();
        OptionsPage._events.OnClickAdministrativeSectionOK();
        OptionsPage._events.OnClickAdministrativeSectionClose();
        OptionsPage._events.onEnterClickOnAdministrativeSection();
    },
    _methods: {
        VisibilityJsonBuilder: function () {
            switch (olWrap.browser.getName()) {
                case olWrap.browser.name.chrome:
                    var array_ = OptionsPage._methods._activeArray('options');
                    var element_ = OptionsPage._methods._findElementInArray('olVisibilityJsonBuilder', array_);

                    if (OptionsPage._methods.GetElementValue(element_)) {
                        $('#olJsonBuilderContainer').show(200);
                    } else {
                        $('#olJsonBuilderContainer').hide(200);
                    }

                    OptionsPage._methods.MinMaxOptions();
                    break;
                default:
                    $('#olJsonBuilderContainer').hide(200);
                    break;
            }
        },
        StatusMsg: function (msg, type) {
            var target_;
            switch (type) {
                case 'options':
                    target_ = $('#divOnelogStatus');
                    break;
                case 'json':
                    target_ = $('#divJSONBuilderStatus');
                    break;
                case 'export':
                    target_ = $('#divJSONBuilderExportAreaStatus');
                    break;
            }
            target_.html(msg);
            setTimeout(function () {
                target_.html('');
            }, 3000);
        },
        GetElementValue: function (element) {
            switch (element.Type) {
                case 'checkbox':
                case 'collapsibleObj':
                case 'collapsibleArr':
                case 'template':
                case 'radio':
                    return $('#' + element.ObjectId).is(':checked');
                case 'text':
                case 'label':
                case 'select':
                    return $('#' + element.ObjectId).val();
                case 'radioContainer':
                    return true;
                case 'label':
                    return $('#' + element.ObjectId).attr('version');
                case 'internal':
                    element.Value
                    break;
                default:
                    console.log('Element of type ' + element.Type + ' not supported!');
                    break;
            };
        },
        SetElementValue: function (element, defaultParam) {
            var elementValue = defaultParam ? element.DefaultValue : element.Value;
            switch (element.Type) {
                case 'text':
                case 'label':
                    $('#' + element.ObjectId).val(elementValue);
                    break;
                case 'checkbox':
                    $("#" + element.ObjectId).prop('checked', elementValue);
                    break;
                case 'collapsibleObj':
                case 'collapsibleArr':
                case 'template':
                    $("#" + element.ObjectId).prop('checked', elementValue);
                    OptionsPage._methods._setCollapsibleIcon(element);
                    break;
                case 'select':
                    $('#' + element.ObjectId).val(elementValue);
                    break;
                case 'radioContainer':
                    true;
                    break;
                case 'radio':
                    $('#' + element.ObjectId).prop('checked', elementValue);
                    break;
                case 'label':
                    return $('#' + element.ObjectId).attr('version', elementValue);
                case 'internal':
                    element.Value = elementValue;
                    break;
                default:
                    console.log('Element of type ' + element.Type + ' not supported!');
                    break;
            };
        },
        _attachEventToHtmlObj: function (elementData) {
            var elemId_ = elementData.ObjectId;
            setTimeout(function () {
                //Events init
                switch (elementData.Type) {
                    case 'checkbox':
                        $('#' + elemId_).click(function (event) {
                            OptionsPage._events.OnClickCheckbox(event.currentTarget)
                        });
                        break;
                    case 'radio':
                        $('#' + elemId_).click(function (event) {
                            OptionsPage._events.OnClickRadio(event.currentTarget)
                        });
                        break;
                    case 'template':
                        $('#expandElement' + elemId_).click(function (event) {
                            event.stopImmediatePropagation();
                            event.preventDefault();
                            event.stopPropagation();
                            OptionsPage._events.OnClickTemplate(event.currentTarget)
                        });
                        break;
                    case 'collapsibleObj':
                    case 'collapsibleArr':
                        if (elemId_ == 'olAdministratorSettings') {
                            $('#expandElementolAdministratorSettings').click(function (event) {
                                event.stopImmediatePropagation();
                                event.preventDefault();
                                event.stopPropagation();
                                OptionsPage._events.OnClickAdministrativeSection(event.currentTarget);
                            });
                        } else {
                            $('#expandElement' + elemId_).click(function (event) {
                                event.stopImmediatePropagation();
                                event.preventDefault();
                                event.stopPropagation();
                                OptionsPage._events.OnClickCollapsible(event.currentTarget)
                            });
                        }
                        break;

                    default:
                        break;
                }
            }, 50);
        },
        CreateHtmlElement: function (elementData, type) {
            var container_ = '';
            var elemId_ = elementData.ObjectId;
            var containerId_ = 'container' + elemId_;
            var contentId_ = 'containerContent' + elemId_;
            var label_ = '<label for="' + elemId_ + '"> ' + elementData.Label + '</label>';

            switch (elementData.Type) {
                case 'text':
                    container_ += '<div class="element-container" id="' + containerId_ + '">';
                    container_ += label_ + '<input type="' + elementData.Type + '" id="' + elemId_ + '" autocomplete="off"/>' + '<div id="' + contentId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'label':
                    container_ += '<div class="element-container" id="' + containerId_ + '">';
                    container_ += label_ + '<input type="' + elementData.Type + '" id="' + elemId_ + '" disabled autocomplete="off"/>' + '</div><div id="' + contentId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'checkbox':
                    container_ += '<div class="element-container" id="' + containerId_ + '">';
                    container_ += '<input type="' + elementData.Type + '" id="' + elemId_ + '" checked"" objtype="' + type + '"/>' + ' ' + label_ + '</div><div id="' + contentId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'select':
                    container_ += '<div class="element-container" id="' + containerId_ + '">';
                    container_ += label_ + '<select id="' + elemId_ + '">';
                    var options = '';
                    for (var j = 0; j < elementData.ElementOptions.length; j++) {
                        options = options + '<option value="' + elementData.ElementOptions[j].Value + '">' + elementData.ElementOptions[j].Text + '</option><br/>';
                    }
                    container_ += options + '</select></div>';
                    break;
                case 'radio':
                    container_ += '<div class="element-container" id="' + containerId_ + '">';
                    container_ += '<input type="radio" id="' + elemId_ + '" name="' + elementData.ParentId + '" value=' + elementData.Value + '" objtype="' + type + '"/><label for="' + elemId_ + '">' + elementData.Label + '</label><br/>' + '</div><div id="' + contentId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'collapsibleObj':
                case 'collapsibleArr':
                    container_ = '<div class="collapsible-container" id="' + containerId_ + '">';
                    container_ += '<div id="expandElement' + elemId_ + '" objtype="' + type + '"> <i class="collapsible-button ol-fa ol-fa-caret-down"></i>';
                    container_ += '<i class="collapsible-button ol-fa ol-fa-caret-right"></i>';
                    container_ += '<input type="checkbox" id="' + elemId_ + '" checked="" style="display:none"/>';
                    container_ += label_ + '</div><div id="' + contentId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'template':
                    container_ = '<div class="collapsible-container" id="' + containerId_ + '">';
                    container_ += '<div id="expandElement' + elemId_ + '" objtype="' + type + '"> <i class="collapsible-button ol-fa ol-fa-plus"></i>';
                    container_ += '<i class="collapsible-button ol-fa ol-fa-minus"></i>';
                    container_ += '<input type="checkbox" id="' + elemId_ + '" checked="" style="display:none"/>';
                    container_ += label_ + '</div><div id="containerContent' + elemId_ + '" class="collapsible-content"></div></div></div>';
                    break;
                case 'radioContainer':
                    container_ = '<div class="collapsible-container" id="' + containerId_ + '">';
                    container_ += label_ + '<form id="' + contentId_ + '" class="collapsible-content"></form></div>';
                    break;
                case 'internal':
                    break;
                default:
                    console.log('Element of type ' + elementData.Type + ' not supported!');
                    break;
            }

            if (elemId_ == 'olVisibilityJsonBuilder' && olWrap.browser.getName() != olWrap.browser.name.chrome) {
                //DO NOT SHOW JSON Builder checkbox in any other browser then chrome
                container_ = '';
            }

            //Attach element to appropriate section of HTML
            switch (type) {
                case 'options':
                    if (elementData.Type != 'internal') {
                        if (elementData.ParentId == null) {
                            $('#divOnelogOptions').append(container_);
                        } else {
                            $('#containerContent' + elementData.ParentId).append(container_);
                        }
                    }
                    break;
                case 'json':
                    if (elementData.ParentId == null) {
                        $('#divJSONBuilder').append(container_);
                    } else {
                        $('#containerContent' + elementData.ParentId).append(container_);
                    }
                    break;
            }

            if (elementData.Visible === false) {
                $('#' + containerId_).hide();
                $('#' + contentId_).hide();
            }

            OptionsPage._methods._attachEventToHtmlObj(elementData);
        },
        _activeArray: function (type) {
            var array_;
            switch (type) {
                case 'options':
                    array_ = OptionsPage.Options._internal.OptionsArray;
                    break;
                case 'json':
                    array_ = OptionsPage.JSONBuilder._internal.JSONBuilderArray;
                    break;
            }
            return array_
        },
        _findElementInArray: function (elementId, array) {
            var result_ = $.grep(array, function (member, index) {
                if (elementId == member.ObjectId) {
                    member.index = index
                    return member;
                }
            });

            return result_[0];
        },
        CreateHtmlElements: function (type) {
            var array_ = OptionsPage._methods._activeArray(type);
            for (var i = 0; i < array_.length; i++) {
                OptionsPage._methods.CreateHtmlElement(array_[i], type);
            };

            for (var i = 0; i < array_.length; i++) {
                OptionsPage._methods.SetElementValue(array_[i]);
            }

            OptionsPage._methods.SetElementsVisibility(type);
            $('#olPleaseWait').remove();
        },
        _setCollapsibleIcon: function (element) {
            var openIcon_;
            var closedIcon_;

            switch (element.Type) {
                case 'template':
                    openIcon_ = 'minus';
                    closedIcon_ = 'plus';
                    break;
                case 'collapsibleObj':
                case 'collapsibleArr':
                    openIcon_ = 'caret-down';
                    closedIcon_ = 'caret-right';
                    break;
            }

            if (OptionsPage._methods.GetElementValue(element)) {
                $('#expandElement' + element.ObjectId + ' > .collapsible-button.ol-fa.ol-fa-' + openIcon_).show();
                $('#expandElement' + element.ObjectId + ' > .collapsible-button.ol-fa.ol-fa-' + closedIcon_).hide();
                $("#containerContent" + element.ObjectId).show(200);

            } else {
                $('#expandElement' + element.ObjectId + ' > .collapsible-button.ol-fa.ol-fa-' + openIcon_).hide();
                $('#expandElement' + element.ObjectId + ' > .collapsible-button.ol-fa.ol-fa-' + closedIcon_).show();
                $("#containerContent" + element.ObjectId).hide(200);
            }

        },
        _setElementSubtreeVisibility: function (type, elementId) {
            var array_ = OptionsPage._methods._activeArray(type);
            var element_ = OptionsPage._methods._findElementInArray(elementId, array_);

            switch (element_.Type) {
                case 'template':
                case 'collapsibleObj':
                case 'collapsibleArr':
                    OptionsPage._methods._setCollapsibleIcon(element_);
                case 'radioContainer':
                case 'radio':
                    if (OptionsPage._methods.GetElementValue(element_)) {
                        $('#containerContent' + element_.ObjectId).show(200);

                        var childElements_ = $.grep(array_, function (member) {
                            return (element_.ObjectId == member.ParentId && member.Visible);
                        });

                        for (var j = 0; j < childElements_.length; j++) {
                            if (OptionsPage._methods.GetElementValue(childElements_[j])) {
                                $('#containerContent' + childElements_[j].ObjectId).show(200);
                            } else {
                                $('#containerContent' + childElements_[j].ObjectId).hide(200);
                            }
                        }
                    } else {
                        $('#containerContent' + element_.ObjectId).hide(200);
                    }
                    break;
                case 'internal':
                    break;
                default:

                    break;
            }
        },
        SetElementsVisibility: function (type) {
            setTimeout(
                function () {
                    try {
                        var array_ = OptionsPage._methods._activeArray(type);

                        for (var i = 0; i < array_.length; i++) {
                            var currentElementId_ = array_[i].ObjectId;
                            OptionsPage._methods._setElementSubtreeVisibility(type, currentElementId_);
                        }
                    } catch (error) {
                    }
                }, 200)
        },
        LoadOptions: function (defaultParam) {
            var array_ = OptionsPage.Options._internal.OptionsArray;
            for (var i = 0; i < array_.length; i++) {
                OptionsPage._methods.SetElementValue(array_[i], defaultParam);
            }
        },
        LoadJsonBuilder: function (callback) {
            olJSONBuilder._getLocalJsonMV3scriptFetch(callback);
        },
        MinMaxOptions: function () {
            var array_ = OptionsPage._methods._activeArray('options');
            var element_ = OptionsPage._methods._findElementInArray('olVisibilityJsonBuilder', array_);

            if (OptionsPage._methods.GetElementValue(element_)) {
                $('#olMinMaxOptions').show();
                var status_ = $('#olMinMaxOptions').attr('status');
                if (status_ == 'opened') {
                    $('#olMinMaxOptions').attr('status', 'closed');
                    $('#olMinMaxOptions > .minmax-button.ol-fa.ol-fa-caret-up').hide();
                    $('#olMinMaxOptions > .minmax-button.ol-fa.ol-fa-caret-down').show();
                    $('#olOptionsContent').show(200);
                } else {
                    $('#olMinMaxOptions').attr('status', 'opened');
                    $('#olMinMaxOptions > .minmax-button.ol-fa.ol-fa-caret-up').show();
                    $('#olMinMaxOptions > .minmax-button.ol-fa.ol-fa-caret-down').hide();

                    $('#olOptionsContent').hide(200);
                }
            } else {
                $('#olMinMaxOptions').hide();
            }

        },
        SaveOptions: function () {
            $('#olAdministratorSettings').prop('checked', false);
            var type_ = 'options';
            var array_ = OptionsPage._methods._activeArray(type_);

            for (var i = 0; i < array_.length; i++) {
                //DO NOT PROCESS INTERNAL VALUES!!!!!
                if (array_[i].Type != 'internal') {
                    array_[i].Value = OptionsPage._methods.GetElementValue(array_[i]);
                }
            }

            olWrap.storage.asyncSetItem('olOptions', array_, function () {
                olWrap.dispatchMessage('olRefreshOptions');
                OptionsPage._methods.StatusMsg('Options saved', 'options');
            });

            OptionsPage._methods.SetElementsVisibility(type_);
            OptionsPage._methods.VisibilityJsonBuilder();
        },
        ExportJSON: function () {
            var type_ = 'json';
            var array_ = OptionsPage._methods._activeArray(type_);

            for (var i = 0; i < array_.length; i++) {
                //DO NOT PROCESS INTERNAL VALUES!!!!!
                if (array_[i].Type != 'internal') {
                    array_[i].Value = OptionsPage._methods.GetElementValue(array_[i]);
                }
            }

            var objForExtension_;
            var obj_ = olJSONBuilder._parser.setJsonFromConfigObject(array_);
            var formfill_ = OptionsPage._methods._findElementInArray('ol_formfill', array_);
            var root_ = OptionsPage._methods._findElementInArray('ol_root', array_);
            var analysis_ = OptionsPage._methods._findElementInArray('ol_analysis', array_);
            var webcontrol_ = OptionsPage._methods._findElementInArray('ol_webcontrol', array_);
            var other_ = OptionsPage._methods._findElementInArray('ol_other', array_);
            var test_ = OptionsPage._methods._findElementInArray('ol_test', array_);

            if (formfill_ && OptionsPage._methods.GetElementValue(formfill_)) {
                objForExtension_ = obj_['formfill'];
            }
            if (root_ && OptionsPage._methods.GetElementValue(root_)) {
                objForExtension_ = obj_['root'];
            }
            if (analysis_ && OptionsPage._methods.GetElementValue(analysis_)) {
                objForExtension_ = obj_['analysis'];
            }
            if (webcontrol_ && OptionsPage._methods.GetElementValue(webcontrol_)) {
                objForExtension_ = obj_['webcontrol'];
            }
            if (other_ && OptionsPage._methods.GetElementValue(other_)) {
                objForExtension_ = obj_['other'];
            }
            if (test_ && OptionsPage._methods.GetElementValue(test_)) {
                objForExtension_ = obj_['test'];
            }

            if (objForExtension_ && Object.keys(objForExtension_).length) {
                var startMV3_ = '/*STARTMV3JSON\n';
                var endMV3_ = '\nENDMV3JSON*/';

                $('#textareaJSONBuilderExportArea').val(startMV3_ + JSON.stringify(objForExtension_, '', 10) + endMV3_)

                OptionsPage._methods.StatusMsg('JSON exported', 'json');
            } else {
                OptionsPage._methods.ClearTextAreaJSON('json');
                OptionsPage._methods.StatusMsg('Nothing to export', 'json');
            }
        },
        ClearTextAreaJSON: function () {
            $('#textareaJSONBuilderExportArea').val('');
        },
        SaveToExtension: function () {
            olWrap.dispatchMessage('olJsonMv3BuilderTestingMode', $('#textareaJSONBuilderExportArea').val());

            OptionsPage._methods.StatusMsg('Script sent to extension for testing, go to resource and test it', 'export');
        },
        ResetJSON: function () {
            OptionsPage._methods.InitializeJSONBuilder();
            $('#divJSONBuilder').text('');
            OptionsPage._methods.StatusMsg('Script reset done', 'json');
        },
        CopyToClipboard: function () {
            var copyText = document.getElementById('textareaJSONBuilderExportArea');
            // Select the text field
            copyText.select();

            // Copy the text inside the text field
            navigator.clipboard.writeText(copyText.value);

            OptionsPage._methods.StatusMsg('Script copied to clipboard', 'export');
        },
        DefaultOptions: function () {
            var type_ = 'options';
            OptionsPage._methods.LoadOptions(true);
            OptionsPage._methods.SaveOptions();
            OptionsPage._methods.SetElementsVisibility(type_);
            OptionsPage._methods.StatusMsg('Reverted to default options', type_);
        },
        InitializeOptions: function () {
            try {
                olWrap.storage.asyncGetItem('olOptions', function (data) {
                    var type_ = 'options';
                    OptionsPage.Options._internal.OptionsArray = data;
                    OptionsPage._methods.CreateHtmlElements(type_);
                    OptionsPage._methods.LoadOptions(false);
                    // OptionsPage._methods.SetElementsVisibility(type_);
                    var olPromptAdmin_ = $('#olPromptAdministrativeSection');
                    olPage.Content.Divs._internal.Modal._appendToModal(olPromptAdmin_);
                });
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('InitializeOptions error', e.message + '\n' + e.stack);
                olFunctions.Alert(true, alertErrorContent_, 'error');
            }
        },
        InitializeJSONBuilder: function () {
            try {
                olJSONBuilder._internal.JSONBuilderArray = [];
                OptionsPage.JSONBuilder = olJSONBuilder;
                OptionsPage._methods.LoadJsonBuilder(OptionsPage._methods.VisibilityJsonBuilder);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('InitializeJSONBuilder error', e.message + '\n' + e.stack);
                olFunctions.Alert(true, alertErrorContent_, 'error');
            }
        }
    },
    _events: {
        OnReady: function () {
            try {
                olWrap.api.onReady(
                    function () {
                        OptionsPage._methods.InitializeOptions();
                        OptionsPage._methods.InitializeJSONBuilder();
                    }
                );
            } catch (e) {
                alert(e);
            }
        },
        OnClickSave: function () {
            $('#olSaveOptions').click(
                function () {
                    OptionsPage._methods.SaveOptions('options');
                });
        },
        OnClickMinMax: function () {
            $('#olMinMaxOptions').click(
                function () {
                    OptionsPage._methods.MinMaxOptions();
                });
        },
        OnClickExportJSON: function () {
            $('#olExportJSON').click(
                function () {
                    OptionsPage._methods.ExportJSON('json');
                });
        },
        OnClickResetJSON: function () {
            $('#olResetJSON').click(
                function () {
                    OptionsPage._methods.ResetJSON('json');
                    OptionsPage._methods.ClearTextAreaJSON('json');
                });
        },
        OnClearTextAreaJSON: function () {
            $('#olClearTextAreaJSON').click(
                function () {
                    OptionsPage._methods.ClearTextAreaJSON('json');
                });
        },
        OnSaveToExtension: function () {
            $('#olSaveToExtension').click(
                function () {
                    OptionsPage._methods.SaveToExtension();
                });
        },
        OnCopyToClipboard: function () {
            $('#olCopyToClipboard').click(
                function () {
                    OptionsPage._methods.CopyToClipboard('json');
                });
        },
        OnClickDefault: function () {
            $('#olDefaultOptions').click(
                function () {
                    OptionsPage._methods.DefaultOptions();
                });
        },
        OnClickCheckbox: function (currentTarget) {
            var inputId_ = (currentTarget.id);
            var currentObjType_ = $(currentTarget).attr('objtype');
            OptionsPage._methods._setElementSubtreeVisibility(currentObjType_, inputId_);
        },
        OnClickRadio: function (currentTarget) {
            var currentObjType_ = $(currentTarget).attr('objtype');
            //for radio identifier is "name", that ties all of them into 1 object
            //that is why visibility is fired on that top element by name
            OptionsPage._methods._setElementSubtreeVisibility(currentObjType_, currentTarget.name);
        },
        OnClickCollapsible: function (currentTarget, doNotSetInput) {
            var inputId_ = (currentTarget.id).substring('expandElement'.length);
            var currentObjType_ = $(currentTarget).attr('objtype');

            var collapsibleInput_ = $('#' + inputId_);
            var currentCollapisbleState_ = collapsibleInput_.prop('checked');
            if (!doNotSetInput) {
                collapsibleInput_.prop('checked', !currentCollapisbleState_);
            }
            var array_ = OptionsPage._methods._activeArray(currentObjType_);
            var element_ = OptionsPage._methods._findElementInArray(inputId_, array_);
            element_.Value = !currentCollapisbleState_;
            OptionsPage._methods._setElementSubtreeVisibility(currentObjType_, inputId_);
        },
        OnClickTemplate: function (currentTarget) {
            var inputId_ = (currentTarget.id).substring('expandElement'.length);
            var currentObjType_ = $(currentTarget).attr('objtype');
            var collapsibleInput_ = $('#' + inputId_);
            var currentCollapisbleState_ = collapsibleInput_.prop('checked');
            var mainArray_ = OptionsPage._methods._activeArray(currentObjType_)
            var element_ = OptionsPage._methods._findElementInArray(inputId_, mainArray_);
            var elementInsertAt_ = element_.index;
            var parent_ = OptionsPage._methods._findElementInArray(element_.ParentId, mainArray_);

            collapsibleInput_.prop('checked', !currentCollapisbleState_);
            element_.Value = !currentCollapisbleState_;

            if (currentCollapisbleState_) {
                //SREDITI NIZ NIJE DOBAR!!!!!!!!!!!!!!!!!!!!!
                switch (parent_.Type) {
                    case 'collapsibleObj':
                    case 'template':
                        $('#containerContent' + inputId_).hide(200, function () {
                            OptionsPage._methods.SetElementValue(element_);
                            olJSONBuilder._internal.JSONBuilderArray = $.grep(olJSONBuilder._internal.JSONBuilderArray, function (member) {
                                if (inputId_ == member.ParentId) {
                                    $('#container' + member.ObjectId).remove();
                                }
                                return ((inputId_ != member.ParentId));
                            });
                        })
                        break;
                    case 'radio':
                        if (!parent_.isArray) {
                            break;
                        }
                    case 'collapsibleArr':
                        $('#container' + inputId_).hide(200, function () {
                            olJSONBuilder._internal.JSONBuilderArray = $.grep(olJSONBuilder._internal.JSONBuilderArray, function (member) {
                                return ((inputId_ != member.ParentId) && (inputId_ != member.ObjectId));
                            });
                            $('#container' + inputId_).remove();

                        })
                        break;

                    default:
                        break;
                }
            } else {
                $('#container' + inputId_).hide();
                var templateArray_ = JSON.parse(JSON.stringify(OptionsPage.JSONBuilder._templates[element_.Label]));

                for (var i = 0; i < templateArray_.length; i++) {
                    var currentTemplateElem_ = templateArray_[i];
                    var appendToParentId_ = currentTemplateElem_.ParentId.substring(('ol_' + element_.Label).length);
                    appendToParentId_ = appendToParentId_ ? appendToParentId_ : '';
                    var appendToObjectId_ = currentTemplateElem_.ObjectId.substring(('ol_' + element_.Label).length);
                    appendToObjectId_ = appendToObjectId_ ? appendToObjectId_ : '';
                    var appendToObjPath_ = (currentTemplateElem_.ObjPath).substring(element_.Label.length);

                    currentTemplateElem_.ObjectId = element_.ObjectId + appendToObjectId_;
                    currentTemplateElem_.ParentId = element_.ObjectId + appendToParentId_;

                    currentTemplateElem_.ObjPath = element_.ObjPath + appendToObjPath_;

                    OptionsPage._methods.CreateHtmlElement(currentTemplateElem_, currentObjType_);
                    OptionsPage._methods.SetElementValue(currentTemplateElem_);

                    //Insert just after the element main node
                    mainArray_.splice(elementInsertAt_ + 1, 0, currentTemplateElem_);
                    elementInsertAt_ = elementInsertAt_ + 1;
                };

                if (parent_.Type == 'collapsibleArr' || (parent_.Type == 'radio' && parent_.isArray)) {
                    element_.InArray = true;
                    var suffix_ = element_.ObjectId.substring(parent_.ObjectId.length + 2 + element_.Label.length);

                    if (suffix_) {
                        suffix_ = Number(suffix_) + 1;
                    } else {
                        suffix_ = 1;
                    }

                    var newArrMember_ = JSON.parse(JSON.stringify(element_));
                    newArrMember_.ObjectId = parent_.ObjectId + '_' + element_.Label + '_' + suffix_;
                    newArrMember_.Value = false;

                    var result_ = '';
                    var pathArr_ = (newArrMember_.ObjPath.split('.')).reverse();

                    var lastIndex_;

                    for (var k = 0; k < pathArr_.length; k++) {
                        var currentPathMember_ = pathArr_[k];

                        if (!isNaN(currentPathMember_) && !lastIndex_) {
                            //If it is number it will enter here
                            currentPathMember_ = Number(currentPathMember_) + 1;
                            lastIndex_ = true;
                        }

                        if (k == pathArr_.length - 1) {
                            result_ = currentPathMember_ + result_;
                        } else {
                            result_ = '.' + currentPathMember_ + result_;
                        }
                    }

                    newArrMember_.ObjPath = result_;

                    OptionsPage._methods.CreateHtmlElement(newArrMember_, currentObjType_);

                    mainArray_.push(newArrMember_);

                    OptionsPage._methods.SetElementValue(newArrMember_);
                    OptionsPage._methods._setElementSubtreeVisibility(currentObjType_, newArrMember_.ObjectId);

                }

                OptionsPage._methods._setElementSubtreeVisibility(currentObjType_, element_.ObjectId);
                $('#container' + inputId_).show(200);
            }
        },
        OnClickAdministrativeSection: function (currentTarget) {
            if ($('#olAdministratorSettings').prop('checked')) {
                //It was open, close it
                OptionsPage._events.OnClickCollapsible(currentTarget)
                $('#olAdministratorSettings').prop('checked', false);
            }
            else {
                $('#olAdministrativePasswordInput').val(null);
                olPage.Content.Divs._internal.Modal.Open('olPromptAdministrativeSection', true);
                $('#olAdministrativePasswordInput').focus();
            }
        },
        OnClickAdministrativeSectionClose: function () {
            $('#olAdministratorSettingsClose').click(function (event) {
                event.stopPropagation();
                olPage.Content.Divs.Close._internal.CloseOverlay('olPromptAdministrativeSection');
                $('#olAdministratorSettings').prop('checked', false);
                OptionsPage._events.OnClickCollapsible($('#expandElementolAdministratorSettings')[0], true)

            });
        },
        OnClickAdministrativeSectionOK: function () {
            $('#olPromptAdministrativeSectionOK').click(function (event) {
                var pass_;
                if (olOptions.DevelopmentVersion()) {
                    pass_ = '';
                } else {
                    pass_ = '0n3l0g';
                }

                if ($('#olAdministrativePasswordInput').val() == pass_) {
                    OptionsPage._methods.StatusMsg('Access granted', 'options');
                    olPage.Content.Divs.Close._internal.CloseOverlay('olPromptAdministrativeSection');
                    OptionsPage._events.OnClickCollapsible($('#expandElementolAdministratorSettings')[0])
                } else {
                    olPage.Content.Divs.Close._internal.CloseOverlay('olPromptAdministrativeSection');
                    OptionsPage._methods.StatusMsg('Wrong password', 'options');
                    // $('#olAdministratorSettings').prop('checked', false);
                    $('#olAdministratorSettings').prop('checked', false);
                    OptionsPage._events.OnClickCollapsible($('#expandElementolAdministratorSettings')[0], true)
                }
            });
        },
        onEnterClickOnAdministrativeSection: function () {
            $('#olPromptAdministrativeSection').on('keypress', function (e) {
                if (e.which == 13) {
                    e.preventDefault();
                    $("#olPromptAdministrativeSectionOK").click();
                }
            });
        }
    },
};

olWrap.api.onReady(function () {
    var ExtensionInfo_ = olWrap.getExtensionInfo();
    $('#olOptionsText').text($('#olOptionsHeader').text() + ' ( ' + ExtensionInfo_.version + ' )');

    //////////____Input Focus___//////////////////
    $('.ol-input-control').focusout(function () {
        $('.ol-input-element').removeClass('focus');
    });
    $('.ol-input-control').focus(function () {
        $(this).closest('.ol-input-element').addClass('focus');
    });

    /// Input Kepress Filled  Focus
    $('.ol-input-control').on('keyup', function () {
        if ($(this).val().length > 0) {
            $(this).closest('.ol-input-element').addClass('filled');
        } else {
            $(this).closest('.ol-input-element').removeClass('filled');
        }
    });

    /// Input Check Filled Focus
    var $formControl = $('.ol-input-control');
    // var values = {};
    $formControl.each(function () {
        if ($(this).val().length > 0) {
            $(this).closest('.ol-input-element').addClass('filled');
        }
        else {
            $(this).closest('.ol-input-element').removeClass('filled');
        }
    });
    OptionsPage.Initialize();
});