olPage.Listeners = {
    _internal: {
        Events: {
            _processingKey: false,
            _currentTabIndex: 0,
            BodySubtreeChangedMutationObserver: function () {
                var observer = new MutationObserver(function (mutations) {
                    mutations.forEach(function (mutation) {
                        if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                            //TOP FRAME only processing                         
                            try {
                                var alertContent_ = new olFunctions.AlertContent('EVT Body Subtree Changed event', 'Caught by page');
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                Analysis.ActivateAnalysis(olPage);
                                WebControl.ActivateWebControl(olPage);
                                olPage.Content.Modules.ProcessModules();
                                //TODO !!!!!!!!!!!!!!!!!! Is this needed here?? https://www.thedailybeast.com/ login after 15 sec injection
                                olPage.Messages.InsertIntoSubframes(olInjection.Parameters);


                                //FORCE Injection attempt, usually will fill in details in sites that generate login form on main frame without changing url!!!
                                olInjection.InjectElementsForced(document);
                            } catch (error) {
                                // This is only for start of the page content
                                // after multiple tries on inject this will work
                                // Analysis or WebControl sometimes are not defined
                            }
                        }

                    });
                });
                var config = { attributes: true, childList: true, characterData: false };
                observer.observe(document.querySelector('body'), config);
            },
            TitleSubtreeChangedMutationObserver: function () {
                //If title exists add obsever
                if (document.querySelector('title')) {
                    var observer = new MutationObserver(function (mutations) {
                        mutations.forEach(function (mutation) {
                            var alertContent_ = new olFunctions.AlertContent('EVT Title Changed event', 'Caught by page');
                            try {
                                olPage.Messages.UpdateResponse();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('TitleSubtreeChanged', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        });
                    });
                    var config = { attributes: true, childList: true, characterData: true };

                    observer.observe(document.querySelector('title'), config);
                }
            },
            WindowHashChange: function () {
                //Because there where situations where 'hashchange' event 
                //wasnt working properly, we made interval that is checking if 
                //window.location.href is changed, comparing to local variable!!!!
                //DO NOT CHANGE INTERVAL!!!
                setInterval(function () {
                    if (olPage.currentLocation === undefined || olPage.currentLocation !== window.location.href) {
                        olPage.currentLocation = window.location.href;

                        olPage.Messages.UpdateResponse();
                        olPage.PageReset();
                        olPage.Messages.WindowHashChange();

                        var alertContent_ = new olFunctions.AlertContent('EVT Window Hash Change event', 'Caught by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    }
                }, 150);
            },
            WindowBeforeUnload: function () {
                olFunctions.olAddEventListener(window, 'beforeunload', function () {
                    var alertContent_ = new olFunctions.AlertContent('EVT Window Before unload event', 'Caught by page');
                    try {
                        olPage.Data.LocalPageFlags.WindowUnloading = true;
                        var parameters_ = {
                            Statistics: olData._DebugStatistics
                        };

                        olPage.Messages._ResponseTo_GetStatisticsFromPage(parameters_);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('olPage.Listeners._internal.Events.WindowBeforeUnload', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                });
            },
            _windowOnResizeModal: function () {
                var alertContent_ = new olFunctions.AlertContent('EVT Window on resize modal event', 'Caught by page');
                try {
                    WebControl._calculateIFrameDimensions();
                    olPage.Content.Divs._internal.Modal.Center();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('olPage.Listeners._internal.Events.WindowOnResizeModal', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            },
            WindowOnResizeModal: function () {
                $(window).on('resize.modal', olPage.Listeners._internal.Events._windowOnResizeModal);
            },
            WindowOnScroll: function () {
                olFunctions.olAddEventListener(window, 'scroll', function (event) {
                    // var alertContent_ = new olFunctions.AlertContent('Window on scroll event', 'Caught by page');
                    // olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    try {
                        event.stopPropagation();
                        olPage.Content.Divs._internal.Modal.Center;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('olPage.Listeners._internal.Events.WindowOnScroll', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            FramesLoad: function () {
                try {
                    $('frame, iframe').on('load', function () {
                        // var alertContent_ = new olFunctions.AlertContent('EVT Frames Load event', 'Caught by page');
                        // olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                            //TOP FRAME only processing                         
                            try {
                                Analysis.ActivateAnalysis(olPage);
                                WebControl.ActivateWebControl(olPage);
                                olPage.Content.Modules.ProcessModules();
                            } catch (error) {
                                // This is only for start of the page content
                                // after multiple tries on inject this will work
                                // Analysis or WebControl sometimes are not defined
                            }
                        }
                    });
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('FramesLoad', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            _onDocumentReadyFunction: function () {
                try {
                    var alertContent_ = new olFunctions.AlertContent('EVT Document ready event', 'Caught by page');

                    //initiate page events
                    olPage.Listeners._internal.Events.FramesLoad();
                    //IE: check if frameset exists
                    olPage.Functions.SetHasFrameset();
                    olPage.Messages.DocumentReady(document.title);

                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('olPage.Listeners._internal.Events.DocumentReady', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }

                try {
                    var olFix_video = function () {
                        $('iframe').each(function () {
                            var url = $(this).attr("src");
                            if ((url) && (url.indexOf("pdf") == -1) && (url.indexOf("?") > 0)) {
                                $(this).attr(
                                    //Fix for
                                    //https://henchman.atlassian.net/browse/ON-1018
                                    //https://app.volarian.com/QueryCentre/index.html#ticketView?queryCentreId=30c0bb4b-aa76-466f-87b3-a3db00b865f9&ticketId=0c4149c3-00c7-43ba-9f7e-a5940124a87d
                                    // {
                                    // "src" : url + "&wmode=transparent",
                                    // "wmode" : "Opaque"
                                    // }
                                    {
                                        "wmode": "transparent"
                                    });
                            }
                        });
                    };

                    olFix_video();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('Video fix error:', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            DocumentReady: function () {
                $(document).ready(function () {
                    try {
                        olPage.Listeners._internal.Events._onDocumentReadyFunction();
                    } catch (error) {

                    }
                });
            },
            ElementFocus: function (element) {
                olPage.Listeners._internal.Events._currentTabIndex = $(element).attr('tabindex');
                if ($(element).text && $(element).text() !== '') {
                    $(element).select();
                }
            },
            KeyEvents: function () {
                $(document).on('keyup', function (e) {
                    //Tab
                    if (e.keyCode == 9) {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt !== '') {
                            e.stopImmediatePropagation();
                            e.preventDefault();
                            e.stopPropagation();

                            var $focused_ = $(':focus');
                            if ($('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).has($focused_).length === 0) {
                                var nextTabIndex_ = parseInt(olPage.Listeners._internal.Events._currentTabIndex) + 1;
                                var nextForFocus_ = $('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).find('[tabindex=' + nextTabIndex_ + ']');
                                if (nextForFocus_.length === 0) {
                                    var zeroElement_ = $('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).find('[tabindex=1]');
                                    zeroElement_.focus();
                                } else {
                                    nextForFocus_[0].focus();
                                }
                            }
                        }
                    }
                });

                $(document).on('keypress', function (e) {
                    //Enter
                    if (!olPage.Listeners._internal.Events._processingKey && e.keyCode == 13) {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt !== '') {
                            e.stopImmediatePropagation();
                            e.preventDefault();
                            e.stopPropagation();
                            olPage.Listeners._internal.Events._processingKey = true;

                            var $focused_ = $(':focus');
                            //Is focused item child of current prompt, if not, focus on tabindex = 1 on current form
                            if ($('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).has($focused_).length === 0) {
                                $('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).find('[tabindex=1]').select().focus();
                            }

                            switch (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt) {
                                case ('olPromptLogonDetails'):
                                    if (olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData()) {
                                        $("#olPromptLogonDetailsOK").click();
                                    } else {
                                        olPage.Listeners._internal.Events._processingKey = false;
                                    }
                                    break;
                                case ('olPromptMatter'):
                                    if (olPage.Content.Divs._internal.PromptMatter._internal.CheckData()) {
                                        $("#olMatterOK").click();
                                    } else {
                                        olPage.Listeners._internal.Events._processingKey = false;
                                    }
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                });
            },
            _securityPolicyViolationFired: 0,
            SecurityPolicyViolationEvents: function () {
                $(document).on('securitypolicyviolation', function (e) {
                    if (olPage.Listeners._internal.Events._securityPolicyViolationFired == 0) {
                        olPage.Listeners._internal.Events._securityPolicyViolationFired++;

                        var alertContent_ = new olFunctions.AlertContent('EVT Security Policy Violation event');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    }
                    olPage.Listeners._internal.Events._securityPolicyViolationFired++;
                });
            },
            _previousToolbarClosed: false,
            OnBeforePrint: function () {
                window.onbeforeprint = function () {
                    olPage.Listeners._internal.Events._previousToolbarClosed = olPage.Content.Divs.Load._toolbarClosed;
                    $('#olToolbarClose').trigger('click');
                }
            },
            OnAfterPrint: function () {
                window.onafterprint = function () {
                    if (!olPage.Listeners._internal.Events._previousToolbarClosed) {
                        olPage.Content.Divs.Load._toolbarClosed = false;
                        olPage.Functions.ShowToolbar();
                        olPage.Content.Divs.Load.Toolbar(false);
                        var alertContent_ = new olFunctions.AlertContent('EVT After Print event');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Messages.UpdateResponse();
                    }
                }
            }
        }
    }
}

olPage.Listeners.InitiateContentEventListeners = function () {
    try {
        olPage.Listeners._internal.Events.WindowBeforeUnload();
        olPage.Listeners._internal.Events.WindowOnScroll();
        olPage.Listeners._internal.Events.WindowOnResizeModal();
        olPage.Listeners._internal.Events.KeyEvents();
        olPage.Listeners._internal.Events.DocumentReady();
        olPage.Listeners._internal.Events.SecurityPolicyViolationEvents();
        olPage.Listeners._internal.Events.BodySubtreeChangedMutationObserver();
        olPage.Listeners._internal.Events.TitleSubtreeChangedMutationObserver();
        olPage.Listeners._internal.Events.WindowHashChange();
        olPage.Listeners._internal.Events.OnBeforePrint();
        olPage.Listeners._internal.Events.OnAfterPrint();
    } catch (e) {
        var alertErrorContent_ = new olFunctions.AlertContent('InitiateContentEventListeners', e.message + '\n' + e.stack);
        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
    }
}

//Events
olPage.Listeners.InitiateContentEventListeners();