//Listen to messages sent from extension
olPage.Listeners = {
    _internal: {
        Messages: {
            _GetOptionsFromExtensionResponse: function () {
                olWrap.addMessageListener('ResponseTo_olGetOptionsFromExtension', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Get options from extension response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olOptions._internal.OptionsArray = eventLocal_.data.ResponseContent._internal.OptionsArray;
                        olOptions._internal.OptionsNameValueArray = eventLocal_.data.ResponseContent._internal.OptionsArray;

                        olPage._optionsInitialized = true;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _GetStatisticsFromPage: function () {
                olWrap.addMessageListener('ol_GetStatisticsFromPage', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Get statistics from page asked from extension message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var parameters_ = {
                            Statistics: olData._DebugStatistics
                        };
                        olPage.Messages._ResponseTo_GetStatisticsFromPage(parameters_);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AskToStorePassword: function () {
                olWrap.addMessageListener('olAskToStorePassword', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var bnr_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];

                        //Default delay for displaying password saving dialog
                        var timeoutValue_ = 1500;
                        if (bnr_.StorePasswordDialogDisplayTimeSpecified) {
                            timeoutValue_ = bnr_.StorePasswordDialogDisplayTime;
                        }
                        setTimeout(function () {
                            try {
                                var alertContent_ = new olFunctions.AlertContent('MSG Ask to store password message', 'Received by page');
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                                olPage.Content.Modules._internal.PasswordManagement._parameters = eventLocal_.data;

                                olPage.Data.PageFlags.IsNewPassword = olPage.Content.Modules._internal.PasswordManagement._parameters.ResponseContent.IsNewPassword;

                                olPage.Content.Modules.ActivatePasswordManagement();
                                olPage.Content.Modules.ProcessModules();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword page', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }, timeoutValue_);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }

                });
            },
            FormfillRequestSent: function () {
                olWrap.addMessageListener('olFormfillRequestSent', function () {
                    try {
                        olPage.Data.PageFlags.FormfillRequestSent = true;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            GrabedMatterValueReceived: function () {
                olWrap.addMessageListener('olSendGrabedMatterValueToPage', function (event) {
                    try {
                        if (olPage.Data.PageFlags.MatterNumber != event.data.ResponseContent.MatterNumber) {
                            $('#olNewMatter').val(event.data.ResponseContent.MatterNumber)

                            if (olPage.Content.Divs._internal.PromptMatter._internal.CheckData(event.data.ResponseContent.MatterNumber, null, null)) {
                                $('#olMatterOK').click();
                            }

                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AskToStorePassword', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SuccessContinueSessionRequestReceived: function () {
                olWrap.addMessageListener('olSuccessContinueSessionRequestReceived', function () {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Success Continue Session Request Received response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        olPage.Content.Divs.Close.ResourceTimeout(false);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SuccessContinueSessionRequestReceived', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            BeforeNavigateRequestResponse: function () {
                olWrap.addMessageListener('olResponseToBeforeNavigateRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Before navigate request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var receivedPageInfo_ = eventLocal_.data.PageInfo;
                        if (olFunctions.CompareTabUrl(receivedPageInfo_.Url)) {
                            olPage.Data.ApplicationName = eventLocal_.data.ApplicationName;
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser = eventLocal_.data.SelectedUser;
                            if (olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser.Title) {
                                olInjection.Parameters.Flags.UsingSharedPasswords = true;
                                olPage.Data.LocalPageFlags.UsingSharedPasswords = true;
                            }
                            olPage.Data.PageFlags = eventLocal_.data.PageFlags;
                            olPage.Data.PageInfo = receivedPageInfo_;

                            if (olPage.Data.PageInfo.Response.BeforeNavigateResponses.length > 0) {
                                olInjection.Parameters.JScript = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].JScript;
                                olInjection.JScriptInjectionBA('olJSInjectBefore');

                                olPage.Content.ProcessPage();
                            }
                        } else {
                            if (olPage.Data.LocalPageFlags.SubframeEnviroment) {
                                olPage.Data.ApplicationName = eventLocal_.data.ApplicationName;
                                olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser = eventLocal_.data.SelectedUser;
                                if (olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser.Title) {
                                    olInjection.Parameters.Flags.UsingSharedPasswords = true;
                                    olPage.Data.LocalPageFlags.UsingSharedPasswords = true;
                                }
                                olPage.Data.PageFlags = eventLocal_.data.PageFlags;
                                olPage.Data.PageInfo = receivedPageInfo_;

                                if (olPage.Data.PageInfo.Response.BeforeNavigateResponses.length > 0) {
                                    olInjection.Parameters.JScript = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].JScript;
                                }
                            }
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('BeforeNavigateRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            CheckMatterGlobalRequestResponse: function () {
                olWrap.addMessageListener('olResponseToCheckMatterGlobalRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Check global matter request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var receivedMessageContent_ = eventLocal_.data;

                        olPage.Content.Divs._internal.PromptMatterSearch._internal.CreateSearchTable(receivedMessageContent_.ResponseContent.CheckMatterResponse);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CheckMatterGlobalRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RequestSearchSharedUsersRequestResponse: function () {
                olWrap.addMessageListener('olResponseToRequestSearchSharedUsersRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('Request search shared users request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.pageIndex = 0;
                        olPage.Content.Divs._common.filteredSharedUsers = eventLocal_.data.ResponseContent;

                        var sharedUsersDataArr = olPage.Content.Divs._common.ProcessSharedUsersData();
                        olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.PopulateSharedUsers(sharedUsersDataArr);

                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('RequestSearchSharedUsersRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RequestGetSharedUsersRequestResponse: function () {
                olWrap.addMessageListener('olResponseToRequestGetSharedUsersRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        var receivedSharedUsersResponse_ = eventLocal_.data.ResponseContent;
                        var alertContent_ = new olFunctions.AlertContent('MSG Choose shared users request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Data.PageInfo.Response.SharedUsersResponse = receivedSharedUsersResponse_;

                        if (receivedSharedUsersResponse_.SharedUsers.length == 0) {
                            // olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.pageIndex == 0;
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.stopScrolling = true;
                        } else {
                            olPage.Content.Divs._common.filteredSharedUsers = [...olPage.Content.Divs._common.filteredSharedUsers, ...receivedSharedUsersResponse_.SharedUsers];
                        }

                        var sharedUsersDataArr = olPage.Content.Divs._common.ProcessSharedUsersData();
                        if (sharedUsersDataArr.length <= 5) {
                            $("#olPromptChooseSharedUserToUsePasswordsFrom .ol-search-container").hide();
                            olPage.Functions.Hide("body #olPromptChooseSharedUserToUsePasswordsFrom .ol-search-container");
                        } else {
                            $("#olPromptChooseSharedUserToUsePasswordsFrom .ol-search-container input").val('');
                        }

                        olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.PopulateSharedUsers(sharedUsersDataArr);

                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('RequestGetSharedUsersRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            RequestGetSharedPasswordsRequestResponse: function () {
                olWrap.addMessageListener('olResponseToGetSharedPasswordsRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        var receivedSharedPasswordsResponse_ = eventLocal_.data.ResponseContent;
                        var alertContent_ = new olFunctions.AlertContent('MSG Shared passwords request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Data.PageInfo.Response.SharedPasswordsResponse = receivedSharedPasswordsResponse_;
                        olPage.Content.Divs.Load.PromptLogon(true, true, eventLocal_.data.Parameters);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('RequestGetSharedPasswordsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ChooseApplicationMessage: function () {
                olWrap.addMessageListener('olChooseApplication', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('Choose application message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        //In offline mode
                        if (eventLocal_.data.PageInfo.Response.BeforeNavigateResponses[0].InOfflineModeSpecified) {
                            olPage.Data.PageFlags = eventLocal_.data.PageFlags;
                            olPage.Data.PageFlags.InOfflineMode = eventLocal_.data.PageInfo.Response.BeforeNavigateResponses[0].InOfflineMode;
                        }

                        //Resource choose application prompt
                        olPage.Content.HtmlAppends.AddChooseApplicationPrompt(eventLocal_.data.PageInfo);
                        // olPage.Content.HtmlAppends._iconTypeSelection();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ChooseApplicationMessage', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            DeletePersonalDetailRequestResponse: function () {
                olWrap.addMessageListener('olResponseToDeletePersonalDetailRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Delete personal detail request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        var receivedMessageContent_ = eventLocal_.data;

                        olPage.Content.Divs._common.UpdateLogonData(receivedMessageContent_.ResponseContent, 'delete');
                        olPage.Content.Divs.Load.PromptLogon(true);

                        olPage.Messages.UpdateResponse();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('DeletePersonalDetailRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            _logoutTabMemberReceived: false,
            LogoutTabMember: function () {
                olWrap.addMessageListener('olLogoutMember', function (event) {
                    try {
                        if (!olPage.Listeners._internal.Messages._logoutTabMemberReceived) {
                            setTimeout(function () {
                                olPage.Messages.LogoutMemberReceived();
                            }, 500);
                            olPage.Listeners._internal.Messages._logoutTabMemberReceived = true;
                            var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                            var alertContent_ = new olFunctions.AlertContent('MSG Logout tab member', 'Received by page');
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                            olPage.Content.Logout.ProcessLogoutSequence(eventLocal_.data);
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('LogoutTabMember', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            PersonalDetailsChosenRequestResponse: function () {
                olWrap.addMessageListener('olResponseToPersonalDetailsChosenRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Personal details chosen request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Data.PageFlags.LogonDone = true;
                        olPage.Messages.Flags.LogonDone(true);
                        olPage.Content.Divs.Close.PromptLogon(false);

                        olPage.Content.Inject();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('PersonalDetailsChosenRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ResourceTimeout: function () {
                olWrap.addMessageListener('olResourceTimeout', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Resource timeout message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        if (olPage.Data.PageInfo && olPage.Data.PageInfo.Response && olPage.Data.PageInfo.Response.BeforeNavigateResponses && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0]) {
                            // update page pause duration info
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = eventLocal_.data.ResponseContent.PauseDuration;
                            // update of resource timeout start time
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime = eventLocal_.data.ResponseContent.ResourceTimeoutStartTime;
                        } else {
                            olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime = eventLocal_.data.ResponseContent.ResourceTimeoutStartTime;
                        }

                        //Resource timeout prompt
                        olPage.Content.HtmlAppends.AddTimeoutPrompt(eventLocal_.data);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ResourceTimeout page', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            Error: function () {
                olWrap.addMessageListener('olError', function (event) {
                    setTimeout(function () {
                        try {
                            var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                            var alertContent_ = new olFunctions.AlertContent('MSG Error message', 'Received by page');
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                            //Error prompt
                            olPage.Content.HtmlAppends.AddErrorPrompt(eventLocal_.data);
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Error message function:', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }, olOptions.General.Page.TransitionTime() + 50);
                });
            },
            PauseDuration: function () {
                olWrap.addMessageListener('olPauseDuration', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Pause duration message', 'Received by page, \nApp: ' + eventLocal_.data.ApplicationName + ',\nPause duration: ' + eventLocal_.data.ResponseContent.PauseDuration);

                        if (!olOptions.DevelopmentVersion()) {
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                        }

                        // update page pause duration info
                        if (olPage.Data.PageInfo && olPage.Data.PageInfo.Response && olPage.Data.PageInfo.Response.BeforeNavigateResponses && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0]) {
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = eventLocal_.data.ResponseContent.PauseDuration;

                            if (eventLocal_.data.ResponseContent.InOfflineMode && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].InOfflineMode != eventLocal_.data.ResponseContent.InOfflineMode) {
                                olPage.Content.Divs._internal.ChangeImageSources();
                                olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].InOfflineMode = eventLocal_.data.ResponseContent.InOfflineMode;
                            }
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('PauseDuration', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            InjectReceivedData: function () {
                olWrap.addMessageListener('olInjectReceivedData', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        if (olPage.Data.LocalPageFlags.SubframeEnviroment && eventLocal_.data.ResponseContent) {
                            var alertContent_ = new olFunctions.AlertContent('MSG Inject received data message', 'Received by page');
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                            olInjection.Parameters = eventLocal_.data.ResponseContent.InjectionParameters;
                            olInjection.Parameters.SubframeEnviroment = true;
                            olInjection._injectElements(document);
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('InjectReceivedData', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ToolbarButtonClickedResponse: function () {
                olWrap.addMessageListener('olToolbarButtonClickedResponse', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Toolbar button clicked response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                            switch (eventLocal_.data.ResponseContent) {
                                case 'ToolbarMenuLogon':
                                    $('#olToolbarMenuLogon').click();
                                    // lose focus
                                    $(this).blur();
                                    break;
                                case 'ToolbarMenuMatter':
                                    $('#olToolbarMenuMatter').click();
                                    // lose focus
                                    $(this).blur();
                                    break;
                                default:
                                    break;
                            }
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('InjectReceivedData', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCurrentPersonalDetailsRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetCurrentPersonalDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set current personal details request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        olInjection.Parameters.Flags.UsingSharedPasswords = eventLocal_.data.Shared;
                        olPage.Data.LocalPageFlags.UsingSharedPasswords = eventLocal_.data.Shared;

                        if (olPage.Data.nextSelectedLogonParams && !olPage.Data.nextSelectedLogonParams.Shared) {
                            olPage.Data.nextSelectedLogonParams = null;
                        }

                        olPage.Messages.PersonalDetailsChosenRequest();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCurrentSharedPasswordRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetCurrentSharedPasswordRequest', function (event) {
                    try {
                        olInjection.Parameters.Flags.UsingSharedPasswords = true;
                        olPage.Data.LocalPageFlags.UsingSharedPasswords = true;
                        olPage.Data.nextSelectedLogonParams = null;

                        var alertContent_ = new olFunctions.AlertContent('MSG Set current shared password request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            UnSetCurrentSharedPasswordRequestResponse: function () {
                olWrap.addMessageListener('olResponseToUnSetCurrentSharedPasswordRequest', function (event) {
                    try {
                        //Reset this flag so it automatically choose password from MY details if there is only one
                        olInjection.Parameters.Flags.UsingSharedPasswords = false;
                        olPage.Data.LocalPageFlags.UsingSharedPasswords = false;

                        $('#olPromptLogonDetails').data('InitialPrompt', true);
                        if (olPage.Data.nextSelectedLogonParams) {
                            olPage.Messages.SetCurrentPersonalDetailsRequest(olPage.Data.nextSelectedLogonParams);
                        }
                        else {
                            olPage.Content.Divs.Load.PromptLogon(true);
                        }

                        var alertContent_ = new olFunctions.AlertContent('MSG Response to unset current shared password request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCurrentPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCommentEditRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetCommentEditRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set comment edit request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);

                        var receivedMessageContent_ = eventLocal_.data;
                        olPage.Data.PageInfo.Response.SetCommentEditResponse = receivedMessageContent_.ResponseContent;

                        if (olPage.Data.PageInfo.Response.SetCommentEditResponse && olPage.Data.PageInfo.Response.SetCommentEditResponse.StartTime) {
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].StartTime = olPage.Data.PageInfo.Response.SetCommentEditResponse.StartTime;
                            olPage.Data.StartTime = new Date(olPage.Data.PageInfo.Response.SetCommentEditResponse.StartTime);
                        }
                        if (olPage.Data.PageInfo.Response.SetCommentEditResponse && olPage.Data.PageInfo.Response.SetCommentEditResponse.PauseDuration) {
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = olPage.Data.PageInfo.Response.SetCommentEditResponse.PauseDuration;
                        } else {
                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = 0;
                        }

                        if (olPage.Data.PageInfo.Response.SetCommentEditResponse && olPage.Data.PageInfo.Response.SetCommentEditResponse.PersonalCodeForSite) {
                            olPage.Data.PageFlags.TimekeeperNumberForSite = olPage.Data.PageInfo.Response.SetCommentEditResponse.PersonalCodeForSite
                        }

                        olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId = receivedMessageContent_.ApplicationsSessionId;
                        olPage.Content.Divs._internal.PromptMatter._internal.UpdateVariables();
                        olPage.Messages.Flags.MatterDone(true, false);
                        olPage.Content.Divs.Close.PromptMatter(true);
                        olPage.Content.Divs._internal.PromptMatter._internal.FillMatterValues();
                        olPage.Content.Inject();
                        olPage.Content.Divs._internal.PromptMatter.Initialize();
                        olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommentEditRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetCommentRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetCommentRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set comment request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Content.Divs._internal.PromptMatter._internal.UpdateVariables();
                        olPage.Messages.Flags.MatterDone(true, false);
                        olPage.Content.Divs.Close.PromptMatter(true);
                        olPage.Content.Divs._internal.PromptMatter._internal.FillMatterValues();
                        olPage.Content.Inject();
                        olPage.Content.Divs._internal.PromptMatter.Initialize();
                        olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommentRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SetPersonalDetailsRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetPersonalDetailsRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        if (!olPage.Data.LocalPageFlags.WindowUnloading) {
                            var alertContent_ = new olFunctions.AlertContent('MSG Set personal details response message', 'Received by page');
                            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                            var receivedMessageContent_ = eventLocal_.data;
                            var receivedId_ = receivedMessageContent_.ResponseContent.SetPersonalDetailsResponse.DetailsId;

                            olPage.Content.Divs.Close.PromptLogonDetails(true);
                            olPage.Content.Divs._common.UpdateLogonData(receivedId_, 'add-update');
                            $('#olPromptLogonDetails').data('InitialPrompt', true);
                            olPage.Content.Divs.Load.PromptLogon(true);
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                    olPage.Listeners._internal.Events._processingKey = false;
                });
            },
            SetCommonDetailsRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSetCommonDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Set common details response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Content.Divs.Close.PromptLogonDetails(true);
                        olPage.Content.Divs._common.UpdateLogonData('olCommonId', 'add-update');
                        $('#olPromptLogonDetails').data('InitialPrompt', true);
                        olPage.Content.Divs.Load.PromptLogon(true);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetCommonDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            SkipPersonalDetailsRequestResponse: function () {
                olWrap.addMessageListener('olResponseToSkipPersonalDetailsRequest', function (event) {
                    try {
                        var alertContent_ = new olFunctions.AlertContent('MSG Skip personal details response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Data.PageFlags.LogonSkipped = true;
                        olPage.Data.PageFlags.LogonDone = true;
                        olPage.Messages.Flags.LogonDone(true);
                        olPage.Content.Divs.Close.PromptLogon(true);

                        olPage.Content.Inject();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            UpdateSubFrames: function () {
                olWrap.addMessageListener('olUpdateSubFrames', function (event) {
                    try {
                        if (olPage.Data.LocalPageFlags.SubframeEnviroment) {
                            var alertContent_ = new olFunctions.AlertContent('MSG Update subframes message', 'Received by page');
                            // olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                            var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                            var receivedPageInfo_ = eventLocal_.data.PageInfo;

                            olPage.Data.PageFlags = eventLocal_.data.PageFlags;
                            olPage.Data.PageInfo = receivedPageInfo_;
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SkipPersonalDetailsRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            ValidateSelectedMatterRequestResponse: function () {
                olWrap.addMessageListener('olResponseToValidateSelectedMatterRequest', function (event) {
                    try {
                        var eventLocal_ = olPage.Functions._parseEventDataPage(event);
                        var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request response message', 'Received by page');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        var receivedMessageContent_ = eventLocal_.data;
                        olPage.Data.PageFlags.CommentRequest = false;
                        olPage.Data.PageInfo.Response.ValidateMatterResponse = receivedMessageContent_.ResponseContent;

                        if (olPage.Data.PageInfo.Response.ValidateMatterResponse.PersonalCodeForSite) {
                            olPage.Data.PageFlags.TimekeeperNumberForSite = olPage.Data.PageInfo.Response.ValidateMatterResponse.PersonalCodeForSite
                        }

                        olPage.Content.Divs._internal.PromptMatter._internal.PopulateMatterDropDownList();
                        olPage.Content.Divs._internal.PromptMatter._internal.UnselectMatterDropDownList();

                        if (olPage.Data.PageInfo.Response.ValidateMatterResponse.ValidatedSpecified) {
                            if (typeof (olPage.Data.PageInfo.Response.ValidateMatterResponse.Validated) === 'undefined') {
                                if (typeof (olPage.Data.PageInfo.Response.ValidateMatterResponse.ValidPersonalID) !== 'undefined') {
                                    if (!olPage.Data.PageInfo.Response.ValidateMatterResponse.ValidPersonalID) {
                                        olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                                        olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_TimekeeperWrong'), 'a');
                                    } else {
                                        olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                                        olPage.Content.Divs.SetInfoMsg('Unknown error', 'a');
                                    }
                                }
                            } else {
                                if (olPage.Data.PageInfo.Response.ValidateMatterResponse.Validated) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.FillMatterValues();
                                    olPage.Data.StartTime = new Date();
                                    if (olPage.Data.PageInfo.Response.ValidateMatterResponse.RequiresCommentSpecified && olPage.Data.PageInfo.Response.ValidateMatterResponse.RequiresComment) {
                                        olPage.Data.PageFlags.CommentRequest = true;
                                        olPage.Content.Divs._internal.PromptMatter._internal.EnableComment();
                                        olPage.Content.Divs._internal.PromptMatter._internal.ShowComment();
                                        olPage.Content.Divs._internal.PromptMatter._internal.CheckData();
                                    } else {
                                        if (olPage.Content.Divs._internal.PromptMatter._internal.RequestNewSession()) {
                                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId = receivedMessageContent_.ApplicationsSessionId;
                                        }

                                        if (olPage.Data.PageInfo.Response.ValidateMatterResponse && olPage.Data.PageInfo.Response.ValidateMatterResponse.StartTime) {
                                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].StartTime = olPage.Data.PageInfo.Response.ValidateMatterResponse.StartTime;
                                            olPage.Data.StartTime = new Date(olPage.Data.PageInfo.Response.ValidateMatterResponse.StartTime);
                                            if (isNaN(olPage.Data.StartTime)) {
                                                olPage.Data.StartTime = new Date(olPage.Functions.DateFromISO8601(olPage.Data.PageInfo.Response.ValidateMatterResponse.StartTime));
                                            }
                                        }

                                        if (olPage.Data.PageInfo.Response.ValidateMatterResponse && olPage.Data.PageInfo.Response.ValidateMatterResponse.PauseDuration) {
                                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = olPage.Data.PageInfo.Response.ValidateMatterResponse.PauseDuration;
                                        } else {
                                            olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PauseDuration = 0;
                                        }

                                        olPage.Content.Divs._internal.PromptMatter._internal.UpdateVariables();
                                        olPage.Messages.Flags.MatterDone(true, false);
                                        olPage.Content.Divs.Close.PromptMatter(true);
                                        //fixed issue with saving comment in the first matter change
                                        //olPage.Content.Divs._internal.PromptMatter._internal.FillMatterValues();
                                        olPage.Content.Inject();
                                        olPage.Content.Divs._internal.PromptMatter.Initialize();
                                    }
                                } else {
                                    olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                                    olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_MatterNumberWrong'), 'a');
                                }
                            }
                            if (!olPage.Data.PageFlags.CommentRequest) {
                                olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                            }
                        } else {
                            olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                            if (olPage.Data.PageInfo.Response.ValidateMatterResponse.ValidPersonalIDSpecified && !olPage.Data.PageInfo.Response.ValidateMatterResponse.ValidPersonalID) {
                                olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_TimekeeperWrong'), 'a');
                            } else {
                                olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_MatterNumberWrong'), 'a');
                            }
                            olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ValidateSelectedMatterRequestResponse', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            }
        }
    },
    InitiateContentMessageListeners: function () {
        try {
            olPage.Listeners._internal.Messages._GetOptionsFromExtensionResponse();
            olPage.Listeners._internal.Messages._GetStatisticsFromPage();
            olPage.Listeners._internal.Messages.AskToStorePassword();
            olPage.Listeners._internal.Messages.FormfillRequestSent();
            olPage.Listeners._internal.Messages.GrabedMatterValueReceived();
            olPage.Listeners._internal.Messages.SuccessContinueSessionRequestReceived();
            olPage.Listeners._internal.Messages.BeforeNavigateRequestResponse();
            olPage.Listeners._internal.Messages.CheckMatterGlobalRequestResponse();
            olPage.Listeners._internal.Messages.RequestSearchSharedUsersRequestResponse();
            olPage.Listeners._internal.Messages.ChooseApplicationMessage();
            olPage.Listeners._internal.Messages.RequestGetSharedUsersRequestResponse();
            olPage.Listeners._internal.Messages.RequestGetSharedPasswordsRequestResponse();
            olPage.Listeners._internal.Messages.DeletePersonalDetailRequestResponse();
            olPage.Listeners._internal.Messages.PersonalDetailsChosenRequestResponse();
            olPage.Listeners._internal.Messages.ResourceTimeout();
            olPage.Listeners._internal.Messages.Error();
            olPage.Listeners._internal.Messages.LogoutTabMember();
            olPage.Listeners._internal.Messages.SetCommentEditRequestResponse();
            olPage.Listeners._internal.Messages.SetCurrentPersonalDetailsRequestResponse();
            olPage.Listeners._internal.Messages.SetCurrentSharedPasswordRequestResponse();
            olPage.Listeners._internal.Messages.UnSetCurrentSharedPasswordRequestResponse();
            olPage.Listeners._internal.Messages.SetCommentRequestResponse();
            olPage.Listeners._internal.Messages.SetPersonalDetailsRequestResponse();
            olPage.Listeners._internal.Messages.SetCommonDetailsRequestResponse();
            olPage.Listeners._internal.Messages.SkipPersonalDetailsRequestResponse();
            olPage.Listeners._internal.Messages.ValidateSelectedMatterRequestResponse();
            olPage.Listeners._internal.Messages.PauseDuration();
            olPage.Listeners._internal.Messages.InjectReceivedData();
            olPage.Listeners._internal.Messages.ToolbarButtonClickedResponse();
            olPage.Listeners._internal.Messages.UpdateSubFrames();
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('InitiateContentMessageListeners', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    }
}

//Send message from page to extension
olPage.Messages = {
    _internal: {
        DispatchMessage: function (message, messageContent) {
            try {
                olWrap.dispatchMessage(message, messageContent);
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('DispatchMessage', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    },
    Flags: {
        MatterDone: function (matterDone, matterSkipped) {
            olPage.Data.PageFlags.MatterDone = matterDone;
            olPage.Data.PageFlags.MatterSkipped = matterSkipped;
            try {
                var alertContent_ = new olFunctions.AlertContent('MSG Matter done message', 'Sent by page');
                olPage.Messages._internal.DispatchMessage('olMatterDone', matterDone);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('MatterDone', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        LogonDone: function (messageContent) {
            try {
                var alertContent_ = new olFunctions.AlertContent('MSG Logon done message', 'Sent by page');
                olPage.Messages._internal.DispatchMessage('olLogonDone', messageContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('LogonDone', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    },
    _GetOptionsFromExtension: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get options from extension message', 'Sent by page');
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

            olPage.Messages._internal.DispatchMessage('_GetOptionsFromExtension', messageContent);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages._GetOptionsFromExtension', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _ResponseTo_GetStatisticsFromPage: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Response to get statistics from page message', 'Sent by page');
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

            olPage.Messages._internal.DispatchMessage('_olResponseTo_GetStatisticsFromPage', messageContent);
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ApplicationRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ApplicationRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Application request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olApplicationRequest', messageContent);
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            //REMOVED becuase of this JIRA issue https://henchman.atlassian.net/browse/ON-2572
            // //TODO HARD CORE westlaw reload
            // if (olFunctions.CompareUrls(location.href, 'signon.thomsonreuters.com/?productid=CBT')) {
            //     setTimeout(function () {
            //         location.reload();
            //     }, 1000);
            // }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ApplicationRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ContinueSessionRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Continue session request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olContinueSessionRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ContinueSessionRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    CheckMatterGlobalRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Check matter global request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olCheckMatterGlobalRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.CheckMatterGlobalRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestSearchSharedUsersRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Search shared users request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olRequestSearchSharedUsersRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.RequestSearchSharedUsersRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _closeTabMessageSent: false,
    CloseTab: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Close tab message', 'Sent by page');

            if (!olPage.Messages._closeTabMessageSent) {
                olPage.Messages._closeTabMessageSent = true;
                olPage.Messages._internal.DispatchMessage('olCloseTab', messageContent);
            }
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.CloseTab', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    RequestGetSharedUsersRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get shared users request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olRequestGetSharedUsersRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.RequestGetSharedUsersRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    GetSharedPasswordsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Get shared password request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olGetSharedPasswordsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.GetSharedPasswordsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    Notification: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Notification', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olNotification', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.Notification', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DeletePersonalDetailRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Delete personal detail message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olDeletePersonalDetailRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.DeletePersonalDetailRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    FormSubmit: function (messageContent) {
        try {
            //With introducing the password recording stuff, there is need that
            //we send first TempRecordDetailsRequest and then after that FormSubmit
            //Even because its inlogical that on formsubit message we send other 
            //request, we kept it like that cause those formsubmit messages are 
            //sent on form submit events and that would be even more confusing to 
            //change all that

            //always send request temp record details
            olPage.Messages.TempRecordDetailsRequest();

            setTimeout(function () {
                var alertContent_ = new olFunctions.AlertContent('MSG Form submit message', 'Sent by page');
                olPage.Messages._internal.DispatchMessage('olFormSubmit', messageContent);
                if (olPage.Data.PageFlags.PmtAutomatic) {
                    // automatic password management, send temp personal detail request
                    olPage.Messages.SetTempPersonalDetailsRequest();
                }
                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }, 0)

        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.FormSubmit', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    FormFilled: function (messageContent) {
        try {
            if (!olPage.Data.PageFlags.FormfillRequestSent) {
                //     setTimeout(function(){
                //         olPage.Data.PageFlags.FormfillRequestSent = false;
                //     }, 1000);

                //send only Form filled message while there is no conformation that the FormfillRequest was success on server side
                var alertContent_ = new olFunctions.AlertContent('MSG Form filled message', 'Sent by page');
                olPage.Messages._internal.DispatchMessage('olFormFilled', messageContent);

                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
            }
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.FormSubmit', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    DocumentReady: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Document ready message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olDocumentReady', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.DocumentReady', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    InsertIntoSubframes: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Insert Into Subframes message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olInsertIntoSubframes', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.InsertIntoSubframes', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ProcessPageCompleted: function (messageContent) {
        try {
            if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                var alertContent_ = new olFunctions.AlertContent('MSG Process page completed message', 'Sent by page');
                olPage.Messages._internal.DispatchMessage('olProcessPageCompleted', messageContent);
            }
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ProcessPageCompleted', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PersonalDetailsChosenRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Personal details chosen message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olPersonalDetailsChosenRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.PersonalDetailsChosenRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PulseRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Pulse request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olPulseRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.PulseRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    LogoutSequenceCompleted: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Logout sequence completed', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olLogoutSequenceCompleted', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.LogoutSequenceCompleted', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set comment request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetCommentRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetCommentRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommentEditRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set comment edit request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetCommentEditRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetCommentEditRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentPersonalDetailsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set current personal details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetCurrentPersonalDetailsRequest', messageContent);

            if (messageContent.Shared) {
                olPage.Messages.SetCurrentSharedPasswordRequest(messageContent);
            }

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetCurrentPersonalDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCurrentSharedPasswordRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set current shared password details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetCurrentSharedPasswordRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetCurrentSharedPasswordRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UnSetCurrentSharedPasswordRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Unset current shared password details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olUnSetCurrentSharedPasswordRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.UnSetCurrentSharedPasswordRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetPersonalDetailsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set personal details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetPersonalDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetPersonalDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SetCommonDetailsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set common details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetCommonDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetCommonDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ToolbarButtonClicked: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Toolbar button clicked message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olToolbarButtonClicked', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ToolbarButtonClicked', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    _tempPersonalDetails: function (requestName) {
        var idParam_ = $('#olPromptLogonDetails').data('Id');

        //Set to null on adding new account because service is set to take NULL as param
        if (idParam_ == 'olAccountIdNewLogon') {
            idParam_ = null;
        }

        var atLeastOneVariableFilled_ = false;
        var variables_ = [];
        for (var i = 0; i < olPage.Data.FoundElements.length; i++) {
            if (olPage.Data.FoundElements[i].element) {

                var variable_ = {
                    Name: olPage.Data.FoundElements[i].definedName,
                    Value: olPage.Data.FoundElements[i].element.value
                };
                variables_.push(variable_);
                if (variable_.Value) {
                    atLeastOneVariableFilled_ = true;
                }
            }
        }
        //Send message if at least one variable is filled
        if (atLeastOneVariableFilled_) {
            var parameters_ = {
                ApplicationSessionId: olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId,
                Id: idParam_,
                Details: {
                    Name: null,
                    Variables: variables_
                }
            };
            switch (requestName) {
                case 'SetTempPersonalDetailsRequest':
                    olPage.Messages._internal.DispatchMessage('olSetTempPersonalDetailsRequest', parameters_);
                    break;
                case 'TempRecordDetailsRequest':
                    olPage.Messages._internal.DispatchMessage('olTempRecordDetailsRequest', parameters_);
                    break;
            }
        }
    },
    SetTempPersonalDetailsRequest: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set temp personal details message', 'Sent by page');

            olPage.Messages._tempPersonalDetails('SetTempPersonalDetailsRequest')

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetTempPersonalDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    TempRecordDetailsRequest: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Тemp record details message', 'Sent by page');

            olPage.Messages._tempPersonalDetails('TempRecordDetailsRequest')

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.TempRecordDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    StorePasswordRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Store password request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olStorePasswordRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.StorePasswordRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    StorePasswordSharedRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Store password shared request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olStorePasswordSharedRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.StorePasswordSharedRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipMatterDetailsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Skip matter details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSkipMatterDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SkipMatterDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    SkipPersonalDetailsRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Skip personal details message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSkipPersonalDetailsRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SkipPersonalDetailsRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    UpdateResponse: function () {
        if (olPage.Data.PageInfo) {
            try {
                olPage.Content._internal.PrepareInjectionParameters();

                var messageContent_ = {
                    Title: document.title,
                    Response: olPage.Data.PageInfo.Response,
                    PageFlags: olPage.Data.PageFlags,
                    PageInfo: olPage.Data.PageInfo,
                    InjectionParameters: olInjection.Parameters,
                    SelectedUser: olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser,
                };

                // DO NOT OPTIMIZE multiple sending of the same message!!!!! 
                // Not sending message may result, 
                // because of unknow time needed for frames to load, 
                // in not injecting into subframes
                olPage.Messages._internal.DispatchMessage('olUpdateResponse', messageContent_);
            } catch {
                olPage.Messages._internal.DispatchMessage('olUpdateResponse', messageContent_);

                var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.UpdateResponse', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        }
    },
    LogoutMemberReceived: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Logout member received message', 'Sent by page');
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

            olPage.Messages._internal.DispatchMessage('olLogoutMemberReceived');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.LogoutMemberReceived', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ValidateSelectedMatterRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olValidateSelectedMatterRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ValidateSelectedMatterRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    ValidateSelectedMatterRequestWithoutResponse: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Validate selected matter request without response message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olValidateSelectedMatterRequestWithoutResponse', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.ValidateSelectedMatterRequestWithoutResponse', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    QuittingResourceSessionRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Quitting resource session request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olQuittingResourceSessionRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.QuittingResourceSessionRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    WindowHashChange: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Window hash change message', 'Sent by page');
            var messageContent_ = {
                Url: document.URL,
                Title: document.title
            };
            olPage.Messages._internal.DispatchMessage('olWindowHashChange', messageContent_);
            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.WindowHashChange', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    //Analysis
    SetFeaturesRequest: function (messageContent) {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Set features request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olSetFeaturesRequest', messageContent);

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.SetFeaturesRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    //WebControl
    StartMessageSeenRequest: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Start message seen request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olStartMessageSeenRequest');

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.StartMessageSeenRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    HideStartMessageRequest: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Hide start message seen request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olHideStartMessageRequest');

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.HideStartMessageRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    WebControlMessageDomContentLoaded: function () {
        try {
            var alertContent_ = new olFunctions.AlertContent('MSG Web control message dom content loaded request message', 'Sent by page');
            olPage.Messages._internal.DispatchMessage('olWebControlMessageDomContentLoaded');

            olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Messages.HideStartMessageRequest', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    }
}

//Messaging
olPage.Listeners.InitiateContentMessageListeners();