//*********** Variable for logging in serviceWorker ************
try {
    var logEverything_ = false;
    function log(message, type) {
        try {
            if (logEverything_) {
                type ? type : type = 'default';
                var today = new Date();
                var date = today.getFullYear() + '.' + ('0' + String(today.getMonth() + 1)).slice(-2) + '.' + ('0' + String(today.getDate())).slice(-2);

                var time = ('0' + String(today.getHours())).slice(-2) + ":" + ('0' + String(today.getMinutes())).slice(-2) + ":" + String('0' + today.getSeconds()).slice(-2) + '.' + String('00' + today.getMilliseconds()).slice(-3)

                var style;
                var style1;
                var style2;
                style = 'line-height: 300%; font-weight: bold; font-size: 14px;';

                switch (type) {
                    case 'error':
                        style1 = style + 'color:#E8523F';
                        break;
                    case 'apimessevent':
                        style1 = style + 'color:#30852c';
                        break;
                    case 'default':
                        style1 = style + 'color:#39A9DC';
                        break;
                }

                style2 = style + 'color:#F5F5F';
                var dt = 'SW:' + date + ' - ' + time + ': ';
                console.log("%c" + dt + "%c" + message, style1, style2);
            }
        } catch (e) {
        }
    }
    //**************************************************************

    // Import background scripts
    try {

        log('IMPORTING SCRIPTS!!!!!!!!!!');
        self.importScripts('olFramework.js');
        self.importScripts('modResourceSpecFunctions.js');
        self.importScripts('modAnalysis.js');
        self.importScripts('modWebControl.js');
        self.importScripts('modWrap.js');
        self.importScripts('modData.js');
        self.importScripts('modOptions.js');
        self.importScripts('modFunctions.js');
        self.importScripts('extension.js');
        self.importScripts('extensionApiService.js');
        self.importScripts('extensionMessaging.js');
        self.importScripts('extensionEvents.js');
    } catch (e) {
        log('IMPORTING SCRIPTS FAILED!!!!!!!!!!');
    }


    //****************** Service Worker register listener
    // First time on extension install runs only
    if ('serviceWorker' in navigator) {
        window.addEventListener('load', function () {
            navigator.serviceWorker.register('/serviceWorker.js').then(function (registration) {
                log('ServiceWorker Registration was successful');
            }, function (err) {
                // registration failed :(
                log('ServiceWorker registration failed', 'error');
            });
        });
    }

    //****************** Service Worker install listener
    self.addEventListener('install', function (event) {
        try {
            log('ServiceWorker install');
        } catch (e) {
            log('ServiceWorker install', 'error');
        }
    });

    //****************** Service Worker activate listener
    self.addEventListener('activate', function (event) {
        try {
            log('ServiceWorker activate');
        } catch (e) {
            log('ServiceWorker activate', 'error');
        }
    });

    callback = function () {
        var allTabsIds_ = [];
        olData.CreatedTabs = [];
        olWrap.tabs.getAll(function (tabs) {
            var olDataTabsIds_ = JSON.parse(JSON.stringify(olData.TabInfoArray.TabMembers));
            for (var i = 0; i < tabs.length; i++) {
                var filterMembers_ = olExtension._internal.TabMember.Filter(null, tabs[i].id, null, null);
                if (olFunctions.IsFilledArray(filterMembers_)) {
                    filterMembers_[0].TargetTab = tabs[i]
                }
                olData.CreatedTabs.push(tabs[i].getId());
                allTabsIds_.push(tabs[i].getId())
            }

            for (var k = 0; k < olDataTabsIds_.length; k++) {
                var currentTabmember_ = olDataTabsIds_[k];
                if (ol$Functions.inArray(currentTabmember_.TabId, allTabsIds_) == -1) {
                    olData.TabInfoArray.TabMembers = ol$Functions.grep(olData.TabInfoArray.TabMembers, function (member) {
                        try {
                            return (member.TabId != currentTabmember_.TabId);
                        } catch (e) {
                        }
                    });
                }
            }

            olExtension.Data.SW_Initialised = true;
            olWrap.storage.asyncSetOlData(olData);
        })
    }

    //Get data from storage
    olWrap.storage.asyncGetOlData(callback);



    //****************** Keeping Service Worker active
    let lifeline;
    ServiceWorkerActive();
    async function ServiceWorkerActive() {
        log('function ServiceWorkerActive');
        try {
            if (lifeline) return;
            for (const tab of await chrome.tabs.query({ url: '*://*/*' })) {
                try {
                    await chrome.scripting.executeScript({
                        target: { tabId: tab.id },
                        func: () => {
                            chrome.runtime.connect({ name: 'ServiceWorkerActive' });
                        },
                    });
                    chrome.tabs.onUpdated.removeListener(retryOnTabUpdate);
                    return;
                } catch (e) { }
            }
            chrome.tabs.onUpdated.removeListener(retryOnTabUpdate);
            chrome.tabs.onUpdated.addListener(retryOnTabUpdate);
        } catch (e) {
            log('ServiceWorkerActive', 'error');
        }
    }

    function ServiceWorkerActiveForced() {
        try {
            log('function ServiceWorkerActiveForced');
            lifeline?.disconnect();
            lifeline = null;
            ServiceWorkerActive();
        } catch (e) {
            log('ServiceWorkerActiveForced', 'error');
        }
    }

    async function retryOnTabUpdate(tabId, info, tab) {
        try {
            log('function retryOnTabUpdate');
            if (info.url && /^(file|https?):/.test(info.url)) {
                ServiceWorkerActive();
            }
        } catch (e) {
            log('ServiceWorker retryOnTabUpdate', 'error');
        }
    }

    var timeout;
    chrome.runtime.onConnect.addListener(port => {
        if (port.name === 'ServiceWorkerActive') {
            lifeline = port;
            if (timeout) {
                log('CLEAR timeout:' + timeout);
            }
            clearTimeout(timeout)
            timeout = setTimeout(
                function () {
                    log('LOG FROM timeout:' + timeout)
                    ServiceWorkerActiveForced();
                }, 295e3); // 5 minutes minus 5 seconds
            log('onConnect.addListener/removeListener port.name ServiceWorkerActive');
            port.onDisconnect.removeListener(ServiceWorkerActiveForced);
            port.onDisconnect.addListener(ServiceWorkerActiveForced);
        }
    });
} catch (error) {

}