// ==UserScript==

/**
 *  OneLog content object
 */
var olPage = {
    Functions: {
        AddDefinedElement: function (element) {
            if (element.element) {
                var found = false;
                for (var i = 0; i < olPage.Data.FoundElements.length; i++) {
                    if (olPage.Data.FoundElements[i].definedName == element.definedName) {
                        found = true;
                        olPage.Data.FoundElements[i] = element;
                        break;
                    }
                }
                if (!found) {
                    olPage.Data.FoundElements.push(element);
                }
            }
        },
        RemoveFramesetTag: function (htmlFrameset) {
            htmlFrameset.parentNode.removeChild(htmlFrameset);
            olPage.Data.FramesetRemoved = true;
        },
        InsertFramesetTag: function (htmlFrameset) {
            var bodyTag = document.getElementsByTagName('body')[0];
            bodyTag.parentNode.insertBefore(htmlFrameset, bodyTag);
            olPage.Data.FramesetRemoved = false;
        },
        SetHasFrameset: function () {
            olPage.Data.HtmlFrameset = document.getElementsByTagName('frameset')[0];
            if ((olWrap.browser.getName() == 'ie') && (olPage.Data.HtmlFrameset)) {
                olPage.Data.LocalPageFlags.HasFrameset = true;
            } else {
                olPage.Data.LocalPageFlags.HasFrameset = false;
            }
        },
        GetLanguageItem: function (key) {
            return olPage.Data.PageInfo.LanguageItemsLabels[key];
        },
        IframeHasVerticalScrollBar: function (iFrame) {
            return (iFrame[0].clientWidth != iFrame[0].contentDocument.body.clientWidth);
        },
        Hide: function (selector, value) {
            if (typeof (value) === 'undefined')
                value = 'display: none !important;visibility:hidden !important;';

            $(selector).css('cssText', value);
        },
        Show: function (selector, value) {
            if (typeof (value) === 'undefined')
                value = 'display: inline-block !important; visibility:visible !important';

            $(selector).css('cssText', value);
        },
        HideToolbar: function () {
            olPage.Functions.Hide('#olToolbar');
            olPage.Functions.Hide('#olToolbarIcon');
            olPage.Functions.Hide('#olToolbarRefresh');
            olPage.Functions.Hide('#olToolbarShare');
            olPage.Functions.Hide('#olToolbarTimer');
            olPage.Functions.Hide('#olToolbarClose');
            olPage.Functions.Hide('#olToolbarMaximized');
            olPage.Functions.Hide('#olToolbarMinimized');
        },
        ShowToolbar: function () {
            olPage.Functions.Show('#olToolbar');
            olPage.Functions.Show('#olToolbarIcon');
            olPage.Functions.Show('#olToolbarRefresh');
            olPage.Functions.Show('#olToolbarShare');
            olPage.Functions.Show('#olToolbarTimer');
            olPage.Functions.Show('#olToolbarClose');

            if (olPage.Data.PageFlags.ToolbarMinimized) {
                olPage.Functions.Show('#olToolbarMinimized');
            } else {
                olPage.Functions.Show('#olToolbarMaximized');
            }
        },
        SwapElements: function (array, index1, index2) {
            var temp_ = array[index1];
            array[index1] = array[index2];
            array[index2] = temp_;
        },
        DateFromISO8601: function (isoDateString) {
            var parts = isoDateString.match(/\d+/g);
            var isoTime = Date.UTC(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]);
            var isoDate = new Date(isoTime);
            return isoDate;
        },
        _parseEventDataPage: function (event) {
            //TODO REMOVE THIS FUNCTION!!!!!!!


            // var clonedEvent_;
            // try {
            //     if (event) {
            //         clonedEvent_ = olFunctions.Clone(event);
            //         try {
            //             clonedEvent_.data = JSON.parse(String(clonedEvent_.data));
            //         } catch (e) {
            //             var alertErrorContent_ = new olFunctions.AlertContent('_parseEventData JSON.parse failed. Using object instead of parsing string! ', e.message + '\n' + e.stack);
            //             olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            //         }
            //     }
            // } catch (e) {
            //     var alertErrorContent1_ = new olFunctions.AlertContent('_parseEventData', e.message + '\n' + e.stack);
            //     olFunctions.Alert(olOptions.Errors(), alertErrorContent1_);
            // } finally {
            //     return clonedEvent_;
            // }
            return event;
        },
        _forcedInject: function (timeout) {
            if (timeout) {
                if (!olInjection.Parameters.ForcedInjected) {
                    var setTimeoutId_ = setTimeout(() => {
                        clearTimeout(setTimeoutId_);
                        olInjection.Parameters.ForcedInjected = true;
                        //Simulating click on olToolbarRefresh but only once!!!
                        olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                        olInjection.Parameters.ElementsWithFiredEvents = [];
                        olInjection.ElementValue._internal.ElementValueSet = false;
                        olInjection._injectElements(document);
                    }, timeout);
                }
            }
        },
    },
    Data: {
        FoundElements: [],
        LocalPageFlags: {
            WindowUnloading: false,
            IECompatibilityMode: null,
            HasFrameset: false,
            //Shared userpasswords
            UsingSharedPasswords: false,
            SubframeEnviroment: false,
            DocumentURI: ''
        },
        PageInfo: null,
        PageFlags: null,
        StartTime: null,
        PauseDuration: null,
        HtmlFrameset: null,
        FramesetRemoved: false,
        nextSelectedLogonParams: null
    },
    Content: {
        _internal: {
            PrepareInjectionParameters: function () {
                try {
                    var bnr0_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                    olInjection.CurrentPrompt = olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt;
                    olInjection.Parameters.SubframeEnviroment = olPage.Data.LocalPageFlags.SubframeEnviroment;
                    olInjection.Parameters.Flags = olPage.Data.PageFlags;
                    olInjection.Parameters.Forms = bnr0_.Forms;
                    olInjection.Parameters.DefinedNames = olPage.Data.PageInfo.DefinedNames;
                    olInjection.Parameters.VariableReplacement = bnr0_.VariableReplacement;
                    olInjection.Parameters.LogonDataArray = olPage.Content.Divs._common.GetLogonData();
                    olInjection.Parameters.InjectFieldColor = olOptions.General.Page.InjectFieldColor();
                    olInjection.Parameters.DebugErrors = olOptions.Errors();
                    olInjection.Parameters.DebugFunctions = olOptions.DebugFunctions();
                    olInjection.Parameters.DebugPageEventsSubmit = olOptions.DebugApiMess();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('PrepareInjectionParameters', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            SetMatterVariables: function () {
                try {
                    var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                    if (beforeNavigateResponse_.VariableReplacement && olFunctions.IsFilledArray(beforeNavigateResponse_.VariableReplacement.Variables)) {
                        for (var i = 0; i < beforeNavigateResponse_.VariableReplacement.Variables.length; i++) {
                            var currentValue_ = beforeNavigateResponse_.VariableReplacement.Variables[i].Value;
                            try {
                                //matter
                                if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.MatterArray) > -1) {
                                    if (beforeNavigateResponse_.MatterDetailsSkippedSpecified && !beforeNavigateResponse_.MatterDetailsSkipped && beforeNavigateResponse_.MatterDetails && (!currentValue_ || currentValue_ === '')) {
                                        olPage.Data.PageFlags.MatterNumber = beforeNavigateResponse_.MatterDetails.MatterNumber;
                                        currentValue_ = beforeNavigateResponse_.MatterDetails.MatterNumber;
                                        // olPage.Data.PageFlags.MatterDone = true;
                                    } else {
                                        olPage.Data.PageFlags.MatterNumber = currentValue_;
                                    }
                                }

                                //time keeper
                                if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.TimeKeeperArray) > -1) {
                                    if (beforeNavigateResponse_.MatterDetailsSkippedSpecified && !beforeNavigateResponse_.MatterDetailsSkipped && beforeNavigateResponse_.MatterDetails && (!currentValue_ || currentValue_ === '')) {

                                        if (olPage.Data.PageFlags.TimekeeperNumberForSite) {
                                            olInjection.Parameters.TimekeeperNumberForSite = olPage.Data.PageFlags.TimekeeperNumberForSite;
                                        }
                                        olPage.Data.PageFlags.TimekeeperNumber = beforeNavigateResponse_.MatterDetails.PersonalCode;
                                        currentValue_ = beforeNavigateResponse_.MatterDetails.PersonalCode;

                                    } else {
                                        if (olPage.Data.PageFlags.TimekeeperNumberForSite) {
                                            olInjection.Parameters.TimekeeperNumberForSite = olPage.Data.PageFlags.TimekeeperNumberForSite;
                                        }
                                        olPage.Data.PageFlags.TimekeeperNumber = currentValue_;
                                    }
                                }

                                //comment
                                if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.CommentArray) > -1) {
                                    if (beforeNavigateResponse_.MatterDetailsSkippedSpecified && !beforeNavigateResponse_.MatterDetailsSkipped && beforeNavigateResponse_.MatterDetails && (!currentValue_ || currentValue_ === '')) {
                                        olPage.Data.PageFlags.Comment = beforeNavigateResponse_.MatterDetails.Comment;
                                        currentValue_ = beforeNavigateResponse_.MatterDetails.Comment;
                                    } else {
                                        olPage.Data.PageFlags.Comment = currentValue_;
                                    }
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckAllForInjection failed to find all variables', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }

                        if (olFunctions.IsFilledArray(beforeNavigateResponse_.Forms)) {
                            olPage.Functions.Show('#olToolbarRefresh', 'display:inline-flex !important; visibility: visible !important');
                        }

                        if (olPage.Data.PageFlags.Unauthorised) {
                            olPage.Functions.Hide('#olToolbarRefresh');
                        }

                        olPage.Content.Divs._internal.PromptMatter._internal.UpdateVariables();
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SetMatterVariables', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            SetToolbarDetails: function () {
                try {
                    //all done, turn off mask and enable toolbar
                    var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                    olPage.Content.Divs._internal.SetMask(false);
                    olPage.Content.Divs._internal.Toolbar.Enable();
                    olPage.Content.Divs._internal.Toolbar._internal.SetTooltip();

                    // // Password sharing
                    if (beforeNavigateResponse_.EnablePasswordSharing) {
                        olPage.Functions.Show('#olToolbarShare', 'display:inline-flex !important; visibility: visible !important');
                    }
                    olPage.Messages.UpdateResponse();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SetToolbarDetails', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            SetToolbarMenuVisibility: function () {
                try {
                    var personalDetail_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail

                    if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                        //Disable manage my password accounts when we are using shared details
                        $('#olToolbarMenuLogon').addClass('ol-disabled');
                    } else {
                        $('#olToolbarMenuLogon').removeClass('ol-disabled');
                    }
                    var personalDetailFiltered_ = [];
                    if (olFunctions.IsFilledArray(personalDetail_)) {
                        personalDetailFiltered_ = $.grep(personalDetail_, function (member) {
                            return (member.Id != 'olEmptyLogon' && member.Id != 'tmpId')
                        })
                    }
                    if (olFunctions.IsFilledArray(personalDetailFiltered_)) {
                        $('#olToolbarMenuShareMyDetails').removeClass('ol-disabled');
                    } else {
                        $('#olToolbarMenuShareMyDetails').addClass('ol-disabled');
                    }

                }
                catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SetToolbarMenuVisibility', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            CheckAllForInjection: function () {
                try {
                    if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                        if (!olPage.Data.PageInfo) {
                            //Hash change event happened
                            return false;
                        }
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt !== '') {
                            return false;
                        }
                        if ((olPage.Data.PageFlags.LicenceLimitReachedNeeded && !olPage.Data.PageFlags.LicenceLimitReachedDone) || (olPage.Data.PageFlags.PooledDetailsLimitReachedNeeded && !olPage.Data.PageFlags.PooledDetailsLimitReachedDone)) {
                            olPage.Content._internal.ProcessLicenceLimitReached();
                            return false;
                        }
                        if (olPage.Data.PageFlags.Unauthorised) {
                            //all done, turn off mask and enable toolbar
                            olPage.Content.Divs._internal.SetMask(false);
                            olPage.Content.Divs._internal.Toolbar.CloseMenu();

                            olPage.Content.Divs._internal.Toolbar.Enable();
                            return true;
                        }

                        if (olPage.Data.PageFlags.MatterNeeded && !olPage.Data.PageFlags.MatterDone && !olPage.Data.PageFlags.UseMatterInScript) {
                            olPage.Content._internal.ProcessMatter();
                            return false;
                        }
                        if ((olPage.Data.PageFlags.LogonNeeded || olPage.Data.PageFlags.LogonCommonNeeded) && !olPage.Data.PageFlags.LogonDone) {
                            olPage.Content._internal.ProcessLogon();
                            return false;
                        }
                    }
                    return true;
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('CheckAllForInjection', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    return false;
                }
            },
            AskToStorePasswordAppended: false,
            ScriptsAppended: false,
            MainPromptsAppended: false,
            ToolbarAppended: false,
            ChooseApplicationAppended: false,
            ResourceTimeoutAppended: false,
            ErrorAppended: false,
            WebControlAppended: false,
            MiscAppended: false,
            // StyleAppended: false,
            ProcessLicenceLimitReached: function () {
                try {
                    //process licence limit reached
                    olPage.Content.Divs.Load.PromptLicenceLimitReached(true);

                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('PromptLicenceLimitReached', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ProcessMatter: function () {
                try {
                    //process matter request and invoke Page when matter validation is complete
                    olPage.Content.Divs.Load.PromptMatter(true);
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ProcessMatter', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ProcessLogon: function () {
                try {
                    //process logons
                    if (olPage.Data.PageFlags.LogonNeeded || olPage.Data.PageFlags.LogonCommonNeeded) {
                        olPage.Content.Divs.Load.PromptLogon(true);
                    } else {
                        olPage.Data.PageFlags.LogonDone = true;
                        olPage.Messages.Flags.LogonDone(true);
                        olPage.Content.Inject();
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ProcessLogon', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ProcessPageInfo: function () {
                try {
                    if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].AppIdSpecified) {
                        olPage.Content.Divs.Initialize();
                        olPage.Content.Divs.BindEvents();

                        olPage.Content.Inject();
                    }
                    olPage.Content.Modules.FinishedResource();
                    olPage.Messages.ProcessPageCompleted();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ProcessPageInfo', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            }
        },
        HtmlAppends: {
            _iconTypeSelection: function () {
            },
            AddMainPrompts: function () {
                olWrap.storage.asyncGetItem('olHtml', function (data) {
                    try {
                        if (!olPage.Content._internal.MainPromptsAppended) {
                            olPage.Content.Divs._internal.Modal._appendToModal(data);
                            olPage.Content._internal.MainPromptsAppended = true;
                        }
                        olPage.Content.HtmlAppends.AddToolbar();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddMainPrompts', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddToolbar: function () {
                olWrap.storage.asyncGetItem('olToolbarDiv', function (data) {
                    try {
                        if (!olPage.Content._internal.ToolbarAppended) {
                            $('body #olToolbarContainer').remove();
                            olPage.Content.Divs._internal.Modal._$backupToolbar.append(data);
                            $('.olOverlay').hide();

                            olPage.Content._internal.ToolbarAppended = true;

                            if (olOptions.DevelopmentVersion()) {
                                //So we see on toolbar as well we are in dev extension!
                                $('#olToolbarMaximized').addClass('ol-dev-extension');
                            }
                        }

                        try {
                            if (olPage && olPage.Data && olPage.Data.PageInfo && olPage.Data.PageInfo.TestingJsonScripts) {
                                $('#olToolbarMaximized').addClass('ol-script-testing-mode');
                            }
                        } catch (error) {

                        }

                        olPage.Content._internal.ProcessPageInfo();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddToolbar', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddChooseApplicationPrompt: function (pageInfo) {
                olWrap.storage.asyncGetItem('olChooseApplication', function (data) {
                    try {
                        if (!olPage.Content._internal.ChooseApplicationAppended) {
                            olPage.Content._internal.ChooseApplicationAppended = true;

                            olPage.Content.Divs._internal.Modal._appendToModal(data);
                            $('.olOverlayChooseApplication').hide();
                            olPage.Content.Divs._internal.ChangeImageSources();
                            olPage.Content.Divs._internal.PromptChooseApplication.BindEvents();
                        }
                        olPage.Data.PageInfo = pageInfo;
                        olPage.Content.Divs.Load.PromptChooseApplication(true);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddChooseApplicationPrompt', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddAskToStorePassword: function () {
                olWrap.storage.asyncGetItem('olStorePassword', function (data) {
                    try {
                        if (!olPage.Content._internal.AskToStorePasswordAppended) {
                            olPage.Content._internal.AskToStorePasswordAppended = true;
                            olPage.Content.Divs._internal.Modal._appendToModal(data);

                            if (olPage.Data.PageFlags.IsNewPassword) {
                                olPage.Functions.Show('#olChkboxNoNeverShowContainer', 'visibility: visible');
                            } else {
                                olPage.Functions.Hide('#olChkboxNoNeverShowContainer');
                            }

                            $('#olStorePassword').hide();
                            olPage.Content.Divs._internal.AskToStorePassword.BindEvents();
                            $('#olStorePasswordH2').empty().append(olPage.Content.Modules._internal.PasswordManagement._parameters.ResponseContent.Title);
                            $('#olStorePasswordContent').empty().append(olPage.Content.Modules._internal.PasswordManagement._parameters.ResponseContent.Body);
                            olPage.Content.Divs._internal.ChangeImageSources();
                        }

                        olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(true);
                        olPage.Content.Divs.Load.AskToStorePassword(true);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddAskToStorePassword', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddTimeoutPrompt: function (receivedMessageContent) {
                olWrap.storage.asyncGetItem('olTimeout', function (data) {
                    try {
                        if (!olPage.Content._internal.ResourceTimeoutAppended) {
                            olPage.Content._internal.ResourceTimeoutAppended = true;
                            olPage.Content.Divs._internal.Modal._appendToModal(data);
                            $('.olOverlayTimeout').hide();
                            olPage.Content.Divs._internal.ChangeImageSources();
                            olPage.Content.Divs._internal.ResourceTimeout.BindEvents();
                        }
                        olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationSessionId = receivedMessageContent.ResponseContent.ApplicationSessionId;
                        olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName = receivedMessageContent.ResponseContent.ApplicationName;
                        olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutText = receivedMessageContent.ResponseContent.ResourceTimeoutText;
                        olPage.Content.Divs.Load.ResourceTimeout(true);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddTimeoutPrompt', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddWebControlMessagePrompt: function () {
                olWrap.storage.asyncGetItem('olWebControlMessage', function (data) {
                    try {
                        if (!olPage.Content._internal.WebControlAppended) {
                            olPage.Content._internal.WebControlAppended = true;
                            olPage.Content.Divs._internal.Modal._appendToModal(data);
                            // olPage.Content.HtmlAppends._iconTypeSelection();
                            $('#olWebControlMessage').hide();
                            olPage.Content.Divs._internal.ChangeImageSources();
                            WebControl.WebControlMessage.BindEvents();
                        }
                        WebControl.ProcessStartMessageWebRules();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddWebControlMessagePrompt', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddErrorPrompt: function (receivedMessageContent) {
                olWrap.storage.asyncGetItem('olError', function (data) {
                    try {
                        if (!olPage.Content._internal.ErrorAppended) {
                            olPage.Content._internal.ErrorAppended = true;
                            olPage.Content.Divs._internal.Modal._appendToModal(data);
                            $('.olOverlayError').hide();
                            olPage.Content.Divs._internal.ChangeImageSources();
                            olPage.Content.Divs._internal.Error.BindEvents();
                        }
                        olPage.Content.Divs.Load.Error(true);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddErrorPrompt', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            },
            AddMisc: function () {
                olWrap.storage.asyncGetItem('olMisc', function (data) {
                    try {
                        //Check if backup is appedned to html
                        if (olPage.Content.Divs._internal.Modal._$backup) {
                            if (!olPage.Content._internal.MiscAppended) {
                                olPage.Content._internal.MiscAppended = true;
                                olPage.Content.Divs._internal.Modal._$backup.append(data);
                            } else {
                                setTimeout
                            }
                        } else {
                            setTimeout(olPage.Content.HtmlAppends.AddMisc, 100)
                        }

                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('AddMisc', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                });
            }
        },
        Modules: {
            _internal: {
                PasswordManagement: {
                    _parameters: null,
                    _processPasswordManagementNeeded: false,
                    ProcessPasswordManagement: function () {
                        var alertContent_ = new olFunctions.AlertContent('ProcessPasswordManagement', 'Page function');
                        olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                        olPage.Content.HtmlAppends.AddAskToStorePassword();
                    }
                },
                Resource: {
                    _processResourceNeeded: false,
                    ProcessResource: function () {
                        var alertContent_ = new olFunctions.AlertContent('ProcessResource', 'Page function');
                        olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                        if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId !== null) {
                            olPage.Content.Divs.AppendDivs();
                            olPage.Content.AttachEventsWithTimeouts();
                        }
                    }
                },
                NeededModulesArray: [],
                _processOngoing: false
            },
            InitializeModulesArray: function () {
                try {
                    if (olFunctions.IsFilledArray(olPage.Data.PageInfo.Response.BeforeNavigateResponses)) {
                        var bnr_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                        if ((bnr_.ShowStartMessageSpecified && bnr_.ShowStartMessage && bnr_.StartMessage != null) || bnr_.WebControlRules) {
                            //WebControl
                            olPage.Content.Modules._internal.NeededModulesArray.push('WebControl');
                        }

                        //Resource
                        olPage.Content.Modules._internal.NeededModulesArray.push('Resource');

                        if (olFunctions.IsFilledArray(bnr_.Features) || (bnr_.AnalysisCode && bnr_.AnalysisCode !== null)) {
                            //Analysis
                            olPage.Content.Modules._internal.NeededModulesArray.push('Analysis');
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('InitializeModulesArray', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ResetShownWebControlMessages: function () {
                try {
                    WebControl._shownWebRulesMessagesArray = [];
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ResetShownWebControlMessages', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ActivatePasswordManagement: function () {
                var alertContent_ = new olFunctions.AlertContent('ActivatePasswordManagement', 'Page function');
                olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                olPage.Content.Modules._internal.PasswordManagement._processPasswordManagementNeeded = true;
            },
            ActivateResource: function () {
                if ($.inArray('Resource', olPage.Content.Modules._internal.NeededModulesArray) > -1) {
                    var alertContent_ = new olFunctions.AlertContent('ActivateResource', 'Page function');
                    olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                    olPage.Content.Modules._internal.Resource._processResourceNeeded = true;
                }
            },
            ProcessModules: function () {
                try {
                    if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                        //Run only in main frame (subframe 0) !!!
                        if (!olPage.Content.Modules._internal._processOngoing && !WebControl._pageBlocked) {
                            var alertContent_ = new olFunctions.AlertContent('ProcessModules', 'Page function');
                            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                            olPage.Content.Modules._internal._processOngoing = true;

                            if (olPage.Content.Modules._internal.PasswordManagement._processPasswordManagementNeeded) {
                                olPage.Content.Modules._internal.PasswordManagement.ProcessPasswordManagement();
                            } else if (WebControl._processWebControlNeeded) {
                                WebControl.ProcessWebControl();
                            } else if (olPage.Content.Modules._internal.Resource._processResourceNeeded) {
                                olPage.Content.Modules._internal.Resource.ProcessResource();
                            } else if (Analysis._processPageAnalysisNeeded) {
                                Analysis.ProcessAnalysis();
                            } else {
                                olPage.Content.Modules._internal._processOngoing = false;
                            }
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ProcessModules', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            FinishedPasswordManagement: function () {
                olPage.Content.Modules._internal._processOngoing = false;
                olPage.Content.Modules._internal.PasswordManagement._processPasswordManagementNeeded = false;
                olPage.Content.Modules.ProcessModules();
            },
            FinishedResource: function () {
                olPage.Content.Modules._internal._processOngoing = false;
                olPage.Content.Modules._internal.Resource._processResourceNeeded = false;
                olPage.Content.Modules.ProcessModules();
            }
        },
        Divs: {
            _common: {
                GetApplicationData: function (searchValue) {
                    if (searchValue) {
                        searchValue = searchValue.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
                    }
                    var applications_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].Applications;

                    var applicationArray_ = [];
                    var appNameLabel_ = '';
                    if (applications_ != null) {
                        var pushElement = function () {
                            var applicationElement_ = {
                                AppId: applications_[i].AppId,
                                Name: appNameLabel_.Title,
                                Label: appNameLabel_.Text
                            };
                            applicationArray_.push(applicationElement_);
                        }
                        for (var i = 0; i < applications_.length; i++) {
                            appNameLabel_ = olPage.Content.Divs._internal.CreateLabels(applications_[i].Name);
                            if (!searchValue) {
                                pushElement();
                            } else {
                                var searchExp_ = new RegExp(searchValue, 'gi');
                                if (appNameLabel_.Title.match(searchExp_)) {
                                    pushElement();
                                }
                            }
                        }
                    }
                    //Sorting of the existing applications array
                    //Not needed since server is sorting data now
                    //olPage.Content.Divs._common.SortApplicationData(applicationArray_);
                    return applicationArray_;
                },
                filteredSharedUsers: [],
                ProcessSharedUsersData: function () {
                    sharedUsers = olPage.Content.Divs._common.filteredSharedUsers;
                    var sharedUsersArray_ = [];
                    var sharedUserNameLabel_ = '';
                    if (sharedUsers != null) {
                        var pushElement = function () {
                            var sharedUserElement_ = {
                                UserId: sharedUsers[i].UserId,
                                Name: sharedUserNameLabel_.Title,
                                Label: sharedUserNameLabel_.Text,
                                UserName: sharedUsers[i].UserName,
                            };
                            sharedUsersArray_.push(sharedUserElement_);
                        }
                        for (var i = 0; i < sharedUsers.length; i++) {
                            if (sharedUsers[i].LastName || sharedUsers[i].FirstName) {
                                sharedUserNameLabel_ = olPage.Content.Divs._internal.CreateLabels(sharedUsers[i].FirstName + ' ' + sharedUsers[i].LastName + ' (' + sharedUsers[i].UserName + ')');
                            } else {
                                sharedUserNameLabel_ = olPage.Content.Divs._internal.CreateLabels(sharedUsers[i].UserName);
                            }
                            pushElement();
                        }
                    }
                    return sharedUsersArray_;
                },
                filteredSharedUsers: [],
                GetSharedUserData: function (searchValue) {
                    if (searchValue) {
                        $("#olPromptChooseSharedUserToUsePasswordsFrom .ol-search-container").val('');
                        searchValue = searchValue.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
                        olPage.Messages.RequestSearchSharedUsersRequest(searchValue);
                    } else {
                        olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.stopScrolling = false;
                        if (olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.pageIndex === 0) {
                            olPage.Content.Divs._common.filteredSharedUsers = [];
                        }

                        paramaters = {
                            pageIndex: ++olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.pageIndex
                        }

                        olPage.Messages.RequestGetSharedUsersRequest(paramaters);
                    }
                },
                LogonDataArray: null,
                GetLogonData: function (searchValue, shared, userdata) {
                    if (searchValue) {
                        searchValue = searchValue.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
                    }
                    var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                    var variableReplacement_;

                    if (shared) {
                        variableReplacement_ = olPage.Data.PageInfo.Response.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement;
                    } else {
                        variableReplacement_ = beforeNavigateResponse_.VariableReplacement;
                    }

                    var logonArray_ = [];
                    if (!(variableReplacement_)) {
                        return logonArray_;
                    }

                    var elementsArray_ = [];
                    for (var p = 0; p < beforeNavigateResponse_.Forms.length; p++) {
                        var currentForm_ = beforeNavigateResponse_.Forms[p];
                        var currentElement_;
                        for (var o = 0; o < currentForm_.Elements.length; o++) {
                            currentElement_ = currentForm_.Elements[o];
                            var Defined = {
                                DefinedName: String(currentElement_.DefinedName),
                                DefinedType: currentElement_.Type
                            };
                            elementsArray_.push(Defined);
                        }
                    }
                    var logonElement_;

                    if (olPage.Data.PageFlags.LogonCommonNeeded || olPage.Data.PageFlags.LogonNeeded) {
                        var details_ = [];
                        if (variableReplacement_.CommonDetail) {
                            details_.push(variableReplacement_.CommonDetail);
                        } else if (olFunctions.IsFilledArray(variableReplacement_.PersonalDetail)) {
                            details_ = variableReplacement_.PersonalDetail;
                        }

                        for (var x = 0; x < details_.length; x++) {
                            logonElement_ = {
                                UserId: userdata ? userdata.UserId : '',
                                UserName: userdata ? userdata.UserName : '',
                                Title: userdata ? userdata.Title : '',
                                Id: '',
                                AccountName: '',
                                AccountNameFull: '',
                                AccountNameEdit: '',
                                AccountNameDelete: '',
                                AccountData: [],
                                Error: false
                            };

                            //Account title
                            var accNameLabel_ = '';
                            if (olPage.Data.PageFlags.LogonNeeded) {
                                if (details_[x].Name) {
                                    accNameLabel_ = olPage.Content.Divs._internal.CreateLabels(details_[x].Name);
                                } else {
                                    accNameLabel_ = olPage.Content.Divs._internal.CreateLabels(olPage.Functions.GetLanguageItem('JS_Default'));
                                }
                            } else if (olPage.Data.PageFlags.LogonCommonNeeded) {
                                accNameLabel_ = olPage.Content.Divs._internal.CreateLabels(olPage.Functions.GetLanguageItem('JS_Common'));
                            }

                            if (accNameLabel_.Title != accNameLabel_.Text) {
                                logonElement_.AccountName = accNameLabel_.Text;
                            } else {
                                logonElement_.AccountName = accNameLabel_.Title;
                            }

                            logonElement_.AccountNameFull = accNameLabel_.Title;

                            var accNameLabelShort_ = '';
                            var title_ = olPage.Functions.GetLanguageItem('JS_EditPassword') + ' (' + logonElement_.AccountNameFull + ')';
                            accNameLabelShort_ = olPage.Content.Divs._internal.CreateLabels(title_);

                            if (accNameLabelShort_.Title != accNameLabelShort_.Text) {
                                logonElement_.AccountNameEdit = accNameLabelShort_.Text + ')';
                            } else {
                                logonElement_.AccountNameEdit = accNameLabelShort_.Text;
                            }

                            var accNameLabelShort2_ = '';
                            var title2_ = olPage.Functions.GetLanguageItem('JS_DeleteAccount') + ' (' + logonElement_.AccountNameFull + ')';
                            accNameLabelShort2_ = olPage.Content.Divs._internal.CreateLabels(title2_);

                            if (accNameLabelShort2_.Title != accNameLabelShort2_.Text) {
                                logonElement_.AccountNameDelete = accNameLabelShort2_.Text + ')';
                            } else {
                                logonElement_.AccountNameDelete = accNameLabelShort2_.Text;
                            }

                            for (var h = 0; h < variableReplacement_.Variables.length; h++) {
                                var canBeModified_ = false;
                                var value_ = variableReplacement_.Variables[h].Value;
                                var label_ = variableReplacement_.Variables[h].Label;
                                //Is personal element or common element
                                if (variableReplacement_.Variables[h].IsPersonal || variableReplacement_.Variables[h].IsCommon) {

                                    if (olFunctions.IsFilledArray(details_[x].Variables)) {
                                        var personalDetailVariable_ = $.grep(details_[x].Variables, function (member) {
                                            return (String(member.DefinedName) == String(variableReplacement_.Variables[h].DefinedName));
                                        });

                                        if (personalDetailVariable_[0]) {
                                            value_ = personalDetailVariable_[0].Value;
                                        }
                                    }

                                    canBeModified_ = true;
                                }
                                var element_ = $.grep(elementsArray_, function (member) {
                                    return (String(member.DefinedName) == String(variableReplacement_.Variables[h].DefinedName));
                                });

                                //Push only username (type 0 ) and password (type 1)
                                if (olFunctions.IsFilledArray(element_) && element_[0].DefinedType <= 1) {
                                    var accountObj_ = {
                                        olAdded: variableReplacement_.Variables[h].olAdded,
                                        DefinedType: element_[0].DefinedType,
                                        DefinedName: String(variableReplacement_.Variables[h].DefinedName),
                                        Value: value_,
                                        Label: label_,
                                        CanBeModified: canBeModified_
                                    };

                                    logonElement_.AccountData.push(accountObj_);
                                }
                            }

                            //Account ID
                            if (variableReplacement_.CommonDetail) {
                                logonElement_.Id = 'olCommonId';
                            } else if (olFunctions.IsFilledArray(variableReplacement_.PersonalDetail)) {
                                logonElement_.Id = details_[x].Id;
                            }

                            logonArray_.push(logonElement_);
                        }
                    }

                    //New element at the end of the list, only for personal accounts if not in offline mode or not PasswordManagementType = Admin
                    if (!(olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) && (logonArray_.length == 0 || !olPage.Data.PageFlags.LogonCommonNeeded) && !olPage.Data.PageFlags.PmtAdmin && !shared) {
                        //new logon
                        var newLogon_ = {
                            Id: 'olAccountIdNewLogon',
                            AccountName: olPage.Functions.GetLanguageItem('JS_ClickNewAccount'),
                            AccountNameFull: '',
                            AccountNameEdit: '',
                            AccountNameDelete: '',
                            AccountData: [],
                            Error: false
                        };
                        var emptyLogon_ = {
                            Id: 'olEmptyLogon',
                            AccountName: '',
                            AccountNameFull: '',
                            AccountNameEdit: '',
                            AccountNameDelete: '',
                            AccountData: [],
                            Error: false
                        };


                        for (var h = 0; h < variableReplacement_.Variables.length; h++) {
                            var canBeModified_ = false;
                            var value_ = variableReplacement_.Variables[h].Value;
                            var label_ = variableReplacement_.Variables[h].Label;

                            //Is personal element or common element
                            if (variableReplacement_.Variables[h].IsPersonal || variableReplacement_.Variables[h].IsCommon) {
                                canBeModified_ = true;
                                value_ = null;
                            }

                            var element_ = $.grep(elementsArray_, function (member) {
                                return (String(member.DefinedName) == String(variableReplacement_.Variables[h].DefinedName));
                            });

                            //Push only username (type 0 ) and password (type 1)
                            if (olFunctions.IsFilledArray(element_) && element_[0].DefinedType <= 1) {
                                var accountObj_ = {
                                    olAdded: variableReplacement_.Variables[h].olAdded,
                                    DefinedType: element_[0].DefinedType,
                                    DefinedName: String(variableReplacement_.Variables[h].DefinedName),
                                    Value: value_ ? value_ : '',
                                    Label: label_ ? label_ : '',
                                    CanBeModified: canBeModified_
                                };
                                newLogon_.AccountData.push(accountObj_);
                                emptyLogon_.AccountData.push(accountObj_);
                            }
                        }

                        if (olPage.Data.PageFlags.UsingSharedPasswords) {
                            if (logonArray_.length == 0) {
                                logonArray_.push(emptyLogon_);
                            }
                        } else {
                            if (!olPage.Data.PageFlags.PmtAutomatic) {
                                logonArray_.push(newLogon_);
                            }
                        }
                    }

                    olPage.Content.Divs._common.LogonDataArray = [];
                    if (!searchValue) {
                        olPage.Content.Divs._common.LogonDataArray = logonArray_;
                    } else {
                        for (var i = 0; i < logonArray_.length; i++) {
                            var searchExp_ = new RegExp(searchValue, 'gi');
                            if (logonArray_[i].AccountNameFull.match(searchExp_)) {
                                olPage.Content.Divs._common.LogonDataArray.push(logonArray_[i]);
                            }
                        }
                    }
                    return olPage.Content.Divs._common.LogonDataArray;
                },
                SortLogonData: function (array) {
                    for (var i = 0; i < array.length - 1; i++) {
                        for (var j = i + 1; j < array.length; j++) {
                            var tmpElement_ = null;
                            if (array[i].AccountNameFull > array[j].AccountNameFull) {
                                tmpElement_ = array[j];
                                array[j] = array[i];
                                array[i] = tmpElement_;
                            }
                        }
                    }
                },
                SortApplicationData: function (array) {
                    for (var i = 0; i < array.length - 1; i++) {
                        for (var j = i + 1; j < array.length; j++) {
                            var tmpElement_ = null;
                            if (array[i].Name > array[j].Name) {
                                tmpElement_ = array[j];
                                array[j] = array[i];
                                array[i] = tmpElement_;
                            }
                        }
                    }
                },
                UpdateLogonData: function (id, parameter) {
                    try {
                        var variableReplacement_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement;

                        switch (parameter) {
                            case 'delete':
                                var newArray_ = $.grep(variableReplacement_.PersonalDetail, function (member) {
                                    return (member.Id != id);
                                });
                                olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail = newArray_;
                                break;
                            case 'add-update':
                                var variables_ = new Array();
                                var arrayUP_ = olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP;

                                for (var i = 0; i < arrayUP_.length; i++) {
                                    if (arrayUP_[i].CanBeModified) {
                                        var variable_ = {
                                            DefinedName: arrayUP_[i].DefinedName,
                                            Label: arrayUP_[i].Label,
                                            Value: arrayUP_[i].Value
                                        };
                                        variables_.push(variable_);
                                    }
                                }
                                if (olPage.Data.PageFlags.LogonNeeded) {
                                    var title_ = $('#olTitleData').val();
                                    var changedLogon_ = new Array();
                                    if (variableReplacement_.PersonalDetail != null) {
                                        changedLogon_ = $.grep(variableReplacement_.PersonalDetail, function (member) {
                                            return (member.Id == id);
                                        });
                                    } else {
                                        olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail = [];
                                    }

                                    var personalDetailElement_;

                                    if (changedLogon_.length > 0) {
                                        personalDetailElement_ = changedLogon_[0];
                                        //edit element data
                                        personalDetailElement_.Name = title_;
                                        personalDetailElement_.Variables = variables_;
                                    } else {
                                        //add new element
                                        personalDetailElement_ = {
                                            Id: id,
                                            Name: title_,
                                            Variables: variables_
                                        };
                                        olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.PersonalDetail.push(personalDetailElement_);
                                    }
                                } else if (olPage.Data.PageFlags.LogonCommonNeeded) {
                                    var commonDetailElement_ = {
                                        Variables: variables_
                                    };
                                    olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].VariableReplacement.CommonDetail = commonDetailElement_;
                                }
                                break;
                        }
                        var alertContent_ = new olFunctions.AlertContent('UpdateLogonData UpdateResponse');
                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                        olPage.Messages.UpdateResponse();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('UpdateLogonData', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                }
            },
            _internal: {
                CheckInputs: function (containerID) {
                    var $formControl = $('#' + containerID).find('.ol-input-control');
                    var values = {};
                    var validate = $formControl.each(function () {
                        if ($(this).val().length > 0) {
                            $(this).closest('.ol-input-element').addClass('filled');
                        }
                        else {
                            $(this).closest('.ol-input-element').removeClass('filled');
                        }
                    });
                },
                EventsForContainerInput: function (containerID, listID) {
                    $('#' + containerID).find('.ol-input-control')
                        .off('focus')
                        .on('focus', function () {
                            $('.ol-select-list').fadeOut(150);
                            $(this).closest('.ol-input-element').addClass('focus');
                        })
                        .off('focusout')
                        .on('focusout', function () {
                            $(this).closest('.ol-input-element').removeClass('focus');
                            if (listID) {
                                $('#' + listID).fadeOut(150);
                            }
                            if ($(this).val().length > 0) {
                                $(this).closest('.ol-input-element').addClass('filled');
                            }
                            else {
                                $(this).closest('.ol-input-element').removeClass('filled');
                            }
                        });
                },
                Modal: {
                    _$backupOverlay: '',
                    _$backupModal: '',
                    _$backupToolbar: '',
                    _$backup: '',
                    _$overlay: '',
                    _$modal: '',
                    _$toolbar: '',
                    _appendToModal: function (data) {
                        var bodyOlModal_ = $('body #olModal');
                        if (bodyOlModal_.length > 0) {
                            $(olPage.Content.Divs._internal.Modal._$backupModal).remove();
                            olPage.Content.Divs._internal.Modal._$backupModal = bodyOlModal_;
                            $(olPage.Content.Divs._internal.Modal._$backup).append(olPage.Content.Divs._internal.Modal._$backupModal);
                        }
                        //TODO check this
                        $(olPage.Content.Divs._internal.Modal._$backupModal).append(data);
                    },
                    _prepareForRendering: function () {
                        try {
                            if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                                if (!olFunctions.IsFilledArray(olInjection.ElementValue._internal.Documents)) {
                                    olInjection.ElementValue.SetDocuments();
                                }

                                var htmlElem_ = $(document).find('html')[0];
                                var headElem_ = $(htmlElem_).find('head');
                                var bodyElem_ = $(htmlElem_).find('body');
                                var backupElem_ = $(htmlElem_).find('#olBackup');

                                if (headElem_.length == 0) {
                                    var headTag_ = document.createElement('head');
                                    $(htmlElem_).prepend(headTag_);
                                    headElem_ = $(htmlElem_).find('head');
                                }

                                if (bodyElem_.length == 0) {
                                    $('<body></body>').insertAfter(headElem_);
                                    $('body').css('height', '0px');
                                    $('body').css('width', '0px');
                                    bodyElem_ = $(htmlElem_).find('body');
                                }

                                if (backupElem_.length == 0) {

                                    $(htmlElem_).append(olPage.Content.Divs._internal.Modal._$backup);
                                }

                                if ($(bodyElem_).find('#olModal').length == 0) {
                                    $(bodyElem_).append($(olPage.Content.Divs._internal.Modal._$backupModal).clone(true));

                                    olPage.Content.Divs._internal.UpdateDivs();
                                    olPage.Content.Divs._internal.PromptComment.BindEvents();
                                    olPage.Content.Divs._internal.PromptLicenceLimitReached.BindEvents();
                                    olPage.Content.Divs._internal.PromptLogon.BindEvents();
                                    olPage.Content.Divs._internal.PromptLogonDetails.BindEvents();
                                    olPage.Content.Divs._internal.PromptMatter.BindEvents();
                                    olPage.Content.Divs._internal.PromptMatterSearch.BindEvents();

                                    olPage.Content.Divs._internal.ResourceTimeout.BindEvents();
                                    olPage.Content.Divs._internal.AskToStorePassword.BindEvents();
                                    olPage.Content.Divs._internal.Error.BindEvents();
                                    olPage.Content.Divs._internal.PromptChooseApplication.BindEvents();
                                    olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.BindEvents();
                                }

                                if ($(bodyElem_).find('#olOverlay').length == 0) {
                                    $(bodyElem_).append($(olPage.Content.Divs._internal.Modal._$backupOverlay).clone(true));
                                }

                                if ($(bodyElem_).find('#olToolbarContainer').length == 0) {
                                    $(bodyElem_).append($(olPage.Content.Divs._internal.Modal._$backupToolbar).clone(true));
                                    if (olPage.Content.Divs._internal.Toolbar._initialized) {
                                        olPage.Content.Divs._internal.Toolbar.Initialize();
                                    }

                                    olPage.Content.Divs._internal.Toolbar.Enable();
                                    olPage.Content.Divs._internal.Toolbar.BindEvents();
                                }

                                olPage.Content.Divs._internal.Modal.Initialize_$();
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('_prepareForRendering', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    _addMaxZindex: function () {
                        olPage.Content.Divs._internal.Modal._$overlay.addClass('ol-max-z-1');
                        olPage.Content.Divs._internal.Modal._$modal.addClass('ol-max-z');
                    },
                    _removeMaxZindex: function () {
                        olPage.Content.Divs._internal.Modal._$overlay.removeClass('ol-max-z-1');
                        olPage.Content.Divs._internal.Modal._$modal.removeClass('ol-max-z');
                    },
                    Open: function (divIdToOverlay, mask) {
                        try {
                            if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != divIdToOverlay) {
                                if (divIdToOverlay != 'olToolbar') {

                                    olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt = divIdToOverlay;
                                    //It is not Toolbar !!
                                    if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != '' && olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != divIdToOverlay) {
                                        //If something is open and it is not the prompt we are trying to  open, close it
                                        //sometimes extension left 2 prompts open instead of only one
                                        //In normal situation this should never happen
                                        olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(mask);
                                    }

                                    // various page fixes
                                    $('[tabindex=-1]').removeAttr('tabindex');

                                    //Due to separation of listeners and page content this check is needed
                                    //Only needed on option page
                                    if (!olPage.Listeners._internal.Events) {
                                        olPage.Listeners._internal.Events = {}
                                    }

                                    olPage.Listeners._internal.Events._currentTabIndex = 0;

                                }

                                olPage.Content.Divs._internal.Modal._prepareForRendering();
                                var div_ = $(olInjection.ElementValue._internal.Documents[0]).find('#' + divIdToOverlay);
                                if (div_.length == 1) {
                                    //OF-25 Login popup not showing on page
                                    //https://www.bing.com/search?q=test&cc=gb
                                    //Not opening without timeout, and timeout isnt a problem so we will fix it with that
                                    setTimeout(function () {
                                        //This part is to always do fade in, which is prettier
                                        //If modal is open then you need to fade in, but if modal is closed, it will fade in
                                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != '') {
                                            $(div_[0]).fadeIn(olOptions.General.Page.TransitionTime());
                                        } else {
                                            $(div_[0]).show();
                                        }

                                        if (divIdToOverlay == 'olToolbar') {
                                            //open Toolbar
                                            olPage.Content.Divs._internal.Modal._$toolbar.show();
                                        } else {
                                            //open prompt
                                            olPage.Content.Divs._internal.Modal._$modal.css({
                                                display: 'none',
                                                width: div_.width || 'auto',
                                                height: div_.height || 'auto'
                                            });
                                            olPage.Content.Divs._internal.SetMask(true);
                                            olPage.Content.Divs._internal.Modal.Center();
                                            olPage.Content.Divs._internal.Modal._$modal.fadeIn(olOptions.General.Page.TransitionTime(), function () {
                                                olPage.Content.Divs._internal.Modal._$modal.click().select().focus();
                                            });
                                            olPage.Content.Divs._internal.Modal._$modal.click().select().focus();
                                        }
                                    }, 0);
                                } else {
                                    setTimeout(function () {
                                        olPage.Content.Divs._internal.Modal.Open(divIdToOverlay, mask);
                                    }, olOptions.General.Page.TransitionTime() + 50);
                                }
                            }

                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Modal Open', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    _prepareDivSizes: function () {
                        try {
                            var logonPromptSize_ = $('#olUsernamePasswordSection').height();
                            if (logonPromptSize_ > 0) {
                                $('#olUsernamePasswordSection').css('height', 'auto');
                                $('#olUsernamePasswordSection').css('overflow-x', 'hidden');
                                $('#olUsernamePasswordSection').css('overflow-y', 'hidden');
                                var maxPromptSize_ = window.innerHeight * 0.33;

                                if (logonPromptSize_ > 0 && logonPromptSize_ > maxPromptSize_) {
                                    $('#olUsernamePasswordSection').css('height', maxPromptSize_ + 'px');
                                    $('#olUsernamePasswordSection').css('overflow-y', 'scroll');
                                }

                                //210 px is size of div with username password and confirm password
                                var minSize_ = 211;
                                if (logonPromptSize_ < minSize_) {
                                    minSize_ = logonPromptSize_;
                                    $('#olUsernamePasswordSection').css('min-height', minSize_ + 'px');
                                }
                            } else {
                                setTimeout(function () {
                                    olPage.Content.Divs._internal.Modal._prepareDivSizes();
                                })
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Prepare div sizes', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    _addTitleToElementWithOverflow: function (SelectorToAddTitleIfNeeded) {
                        $(SelectorToAddTitleIfNeeded).parent().removeAttr('title');
                        $(SelectorToAddTitleIfNeeded).removeAttr('title');

                        if ($(SelectorToAddTitleIfNeeded).innerWidth() < $(SelectorToAddTitleIfNeeded)[0].scrollWidth) {
                            //ellipse should be showing because the text is in overflow, then add title to element
                            var titleToAdd_ = '';
                            if ($(SelectorToAddTitleIfNeeded).text()) {
                                titleToAdd_ = $(SelectorToAddTitleIfNeeded).text();
                            } else {
                                titleToAdd_ = $(SelectorToAddTitleIfNeeded).val();
                            }

                            if (!titleToAdd_) {
                                titleToAdd_ = $(SelectorToAddTitleIfNeeded).attr('olvalue');
                            }

                            if ($(SelectorToAddTitleIfNeeded).prop("tagName").toLowerCase() == "label") {
                                $(SelectorToAddTitleIfNeeded).parent().attr('title', titleToAdd_);
                            } else {
                                $(SelectorToAddTitleIfNeeded).attr('title', titleToAdd_);
                            }
                        }
                    },
                    Center: function () {
                        try {
                            // var alertContent_ = new olFunctions.AlertContent('Center', 'Page function');
                            // olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                            if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != '') {
                                if ($(olPage.Content.Divs._internal.Modal._$modal).width() > 0 && $(olPage.Content.Divs._internal.Modal._$modal).height() > 0) {
                                    var top = Math.min(window.innerHeight * 0.12, Math.max(window.innerHeight - $(olPage.Content.Divs._internal.Modal._$modal).height(), 0) / 2);
                                    var left = Math.max(window.innerWidth - $(olPage.Content.Divs._internal.Modal._$modal).width(), 0) / 2;

                                    $(olPage.Content.Divs._internal.Modal._$modal).css({
                                        top: top,
                                        left: left
                                    });
                                    olPage.Content.Divs._internal.Modal._prepareDivSizes();
                                } else {
                                    //Problems when some browsers did not return correct values of height and width
                                    //so we had to enforce center again when we have correct values for our modal window
                                    setTimeout(function () {
                                        olPage.Content.Divs._internal.Modal.Center();
                                    }, 100)
                                }
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Modal Center', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Close: function () {
                        olPage.Content.Divs._internal.Modal._$modal.hide();
                    },
                    Initialize_$: function () {
                        olPage.Content.Divs._internal.Modal._$overlay = $('body #olOverlay');
                        olPage.Content.Divs._internal.Modal._$modal = $('body #olModal');
                        olPage.Content.Divs._internal.Modal._$toolbar = $('body #olToolbarContainer');

                        //Closing selects when clicking outside of them
                        olPage.Content.Divs._internal.Modal._$modal.on('click', function () { $('.ol-select-list').fadeOut(150) });
                        olPage.Content.Divs._internal.Modal._$overlay.on('click', function () { $('.ol-select-list').fadeOut(150) });
                    },
                    Initialize: function () {
                        try {
                            var alertContent_ = new olFunctions.AlertContent('olPage.Content.Divs._internal.Initialize', 'Page function');
                            olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                            olPage.Content.Divs._internal.Modal._$backupOverlay = $('<div id="olOverlay"></div>');
                            olPage.Content.Divs._internal.Modal._$backupModal = $('<div id="olModal"></div>');
                            olPage.Content.Divs._internal.Modal._$backupToolbar = $('<div id="olToolbarContainer"></div>');
                            olPage.Content.Divs._internal.Modal._$backup = $('<div id="olBackup"></div>');

                            olPage.Content.Divs._internal.Modal._$backupModal.hide();
                            olPage.Content.Divs._internal.Modal._$backupOverlay.hide();
                            olPage.Content.Divs._internal.MaskOn = false;
                            olPage.Content.Divs._internal.Modal._$backupToolbar.hide();

                            $('html').append(olPage.Content.Divs._internal.Modal._$backup);
                            olPage.Content.Divs._internal.Modal._$backup.append(olPage.Content.Divs._internal.Modal._$backupOverlay, olPage.Content.Divs._internal.Modal._$backupModal, olPage.Content.Divs._internal.Modal._$backupToolbar);
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('olPage.Content.Divs._internal.Initialize', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                AlertPrompt: '',
                PromptChooseApplication: {
                    _internal: {
                        CreateDivs: function (applicationDataElement) {
                            try {
                                var appId_ = applicationDataElement.AppId;
                                var name_ = '';
                                var title_ = '';
                                var newDivLabel_ = '';
                                var divElement_;
                                title_ = applicationDataElement.Name;

                                divElement_ = '<div class="ol-interface-container ol-dynamic-content"><div id="olChooseApplication' + appId_ + '" class="ol-list-label ol-interface-row">' + title_ + '</div></div>';

                                $('#olChooseApplication').append(divElement_);

                                $('#olChooseApplication' + appId_).on('mouseover', function () {
                                    olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                });

                                //on click events
                                $('#olChooseApplication' + appId_).click({
                                    AppId: appId_,
                                    ApplicationName: title_
                                }, olPage.Content.Divs._internal.PromptChooseApplication.Events.SelectedApplication_onClick);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateDivs', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        PopulateApplications: function (searchValue) {
                            try {
                                var applicationData_ = olPage.Content.Divs._common.GetApplicationData(searchValue);

                                // clear dynamic content
                                $('#olChooseApplication .ol-dynamic-content').remove();
                                // add dynamic content
                                for (var i = 0; i < applicationData_.length; i++) {
                                    olPage.Content.Divs._internal.PromptChooseApplication._internal.CreateDivs(applicationData_[i]);
                                };
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateApplications', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        SelectedApplication_onClick: function (event) {
                            try {
                                var parameters_ = {
                                    AppId: event.data.AppId,
                                    ApplicationName: event.data.ApplicationName,
                                    ApplicationsSessionId: olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId
                                };

                                olPage.Content.Divs.Close.PromptChooseApplication(false);
                                olPage.Messages.ApplicationRequest(parameters_);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SelectedApplication_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Cancel_onClick: function () {
                            try {
                                $('#olCAImgChooseApplicationCancel').off('click');
                                $('#olCAImgChooseApplicationCancel').on('click', function (event) {
                                    event.stopPropagation();
                                    var applications_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].Applications;
                                    $('#olChooseApplication' + applications_[0].AppId).click();
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Search_onChange: function () {
                            $("#olPromptChooseApplication .ol-search-container input")
                                .off('search keyup')
                                .on('search keyup', function (event) {
                                    var searchValue_ = event.target.value;
                                    olPage.Content.Divs._internal.PromptChooseApplication._internal.PopulateApplications(searchValue_);
                                })
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptChooseApplication.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptChooseApplication.Events.Search_onChange();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptChooseSharedUserToUsePasswordsFrom: {
                    _internal: {
                        selectedUser: {
                            PersnalId: '',
                            Shared: false,
                            UserId: '',
                            UserName: '',
                            Title: '',
                        },
                        CreateDivs: function (sharedUserDataElement) {
                            try {
                                var sharedUserId_ = sharedUserDataElement.UserId;
                                var sharedUserUserName_ = sharedUserDataElement.UserName;
                                var name_ = '';
                                var title_ = '';
                                var newDivLabel_ = '';
                                var divElement_;
                                title_ = sharedUserDataElement.Name;

                                divElement_ = '<div class="ol-interface-container ol-dynamic-content"><div id="olChooseSharedUser' + sharedUserId_ + '" class="ol-list-label ol-interface-row">' + title_ + '</div></div>';

                                $('#olChooseSharedUser').append(divElement_);

                                if (sharedUserId_ != 'NoUser') {
                                    // events
                                    $('#olChooseSharedUser' + sharedUserId_).on('mouseover', function () {
                                        olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                    });

                                    if (olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser.UserId != sharedUserId_) {
                                        $('#olChooseSharedUser' + sharedUserId_).click({
                                            UserId: sharedUserId_,
                                            UserName: sharedUserUserName_,
                                            Title: title_,
                                        }, olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.SelectedSharedUser_onClick);
                                    } else {
                                        $('#olChooseSharedUser' + sharedUserId_).addClass('ol-disabled');
                                    }
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateDivs', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        pageIndex: 0,
                        PopulateSharedUsers: function (sharedUsersDataArr) {
                            try {
                                var sharedUserData_ = sharedUsersDataArr;

                                if (sharedUserData_.length == 0) {
                                    sharedUserData_.push({
                                        UserId: 'NoUser',
                                        Name: olPage.Functions.GetLanguageItem('JS_NoSharedUsers')
                                    })
                                }
                                // clear dynamic content
                                $('#olChooseSharedUser .ol-dynamic-content').remove();
                                // add dynamic content
                                for (var i = 0; i < sharedUserData_.length; i++) {
                                    olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.CreateDivs(sharedUserData_[i]);
                                };
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateSharedUsers', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        SelectedSharedUser_onClick: function (event) {
                            try {
                                olInjection.Parameters.ForcedInjected = false;

                                var parameters_ = {
                                    UserName: event.data.UserName,
                                    UserId: event.data.UserId,
                                    Title: event.data.Title,
                                };
                                olPage.Content.Divs.Close.PromptChooseSharedUserToUsePasswordsFrom(false);
                                olPage.Messages.GetSharedPasswordsRequest(parameters_);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SelectedSharedUser_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Cancel_onClick: function () {
                            try {
                                $('#olImgChoosePasswordSharingCancel').off('click');
                                $('#olImgChoosePasswordSharingCancel').on('click', function (event) {
                                    event.stopPropagation();
                                    olPage.Content.Divs.Close.PromptChooseSharedUserToUsePasswordsFrom(false);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        BackToMyDetails_onClick: function () {
                            try {
                                $('#olBackToMyDetails').off('click');
                                $('#olBackToMyDetails').on('click', function (event) {
                                    $('#olPromptLogonDetails').data('InitialPrompt', true);
                                    event.stopPropagation();
                                    if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                        var bnr0_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                        if (!olFunctions.IsFilledArray(bnr0_.VariableReplacement.PersonalDetail)) {
                                            bnr0_.VariableReplacement.PersonalDetail = [{
                                                Id: 'tmpId', //To have the same structure as request result
                                                Name: 'tmpName',//To have the same structure as request result
                                                Variables: [],
                                            }];
                                        }
                                    }
                                    olPage.Content.Divs.Close.PromptChooseSharedUserToUsePasswordsFrom(false);
                                    olPage.Content.Divs.Load.PromptLogon(true);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        timeoutKeypress: null,
                        Search_onChange: function () {
                            $("#olPromptChooseSharedUserToUsePasswordsFrom .ol-search-container input")
                                .off('search keyup')
                                .on('search keyup', function (event) {

                                    olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.stopScrolling = true;
                                    olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.pageIndex = 0;

                                    clearTimeout(olPage.Content.Divs._internal.PromptChooseApplication.Events.timeoutKeypress);
                                    olPage.Content.Divs._internal.PromptChooseApplication.Events.timeoutKeypress = setTimeout(function () {
                                        var searchValue_ = event.target.value;
                                        olPage.Content.Divs._common.GetSharedUserData(searchValue_);
                                    }, 300)
                                })
                        },
                        scrollExecutionDelay_: null,
                        Scroll: function () {
                            $('#olChooseSharedUser').scroll(function (eventObject) {
                                try {
                                    if (!olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.stopScrolling) {
                                        clearTimeout(olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.scrollExecutionDelay_)
                                        var top_ = $('#olChooseSharedUser').scrollTop();

                                        var numOfChildDivs = $('#olChooseSharedUser').children().length;

                                        var curentMaxScrollHeight_ = numOfChildDivs * 61;

                                        if (curentMaxScrollHeight_ - top_ < 500) {
                                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.scrollExecutionDelay_ = setTimeout(function () {
                                                olPage.Content.Divs._common.GetSharedUserData();
                                            }, 300);
                                        }
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Scroll', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.Search_onChange();
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.BackToMyDetails_onClick();
                            olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom.Events.Scroll();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptComment: {
                    _internal: {
                        PopulateComments: function (searchValue) {
                            try {
                                if (searchValue) {
                                    searchValue = searchValue.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
                                }
                                var comments_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PredefinedComments;
                                var predefinedComments_ = [];
                                if (comments_ != null) {
                                    for (var i = 0; i < comments_.length; i++) {
                                        if (!searchValue) {
                                            predefinedComments_.push(comments_[i]);
                                        } else {
                                            var searchExp_ = new RegExp(searchValue, 'gi');
                                            if (comments_[i].Comment.match(searchExp_)) {
                                                predefinedComments_.push(comments_[i]);
                                            }
                                        }
                                    }
                                }

                                // clear dynamic content
                                $('#olComments .ol-dynamic-content').remove();

                                for (var i = 0; i < predefinedComments_.length; i++) {
                                    var comment_ = predefinedComments_[i].Comment;
                                    var commentUID_ = predefinedComments_[i].UID;
                                    var hoverDiv_ = 'olComInt' + commentUID_;
                                    var divElement_;

                                    divElement_ = '<div class="ol-interface-container ol-dynamic-content"><div id="olComment' + hoverDiv_ + '" class="ol-list-label ol-interface-row ol-dynamic-content">' + comment_ + '</div></div>';

                                    $('#olComments').append(divElement_);

                                    $('#olComments').resize()

                                    $('#olComment' + hoverDiv_).on('mouseover', function () {
                                        olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                    });

                                    //click events
                                    $('#olComment' + hoverDiv_).on('click', function () {
                                        var selectedValue_;
                                        selectedValue_ = $(this).text();

                                        if (selectedValue_) {
                                            $('#olNewComment').val(selectedValue_);
                                        } else {
                                            $('#olNewComment').val('');
                                        }
                                        $('#olNewComment').val($('#olNewComment').val());

                                        olPage.Content.Divs.Close.PromptComment(true);
                                        olPage.Content.Divs.Load.PromptMatter(true);
                                    });
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateComments', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        Cancel_onClick: function () {
                            try {
                                $('#olImgCommentCancel').off('click');
                                $('#olImgCommentCancel').on('click', function (event) {
                                    event.stopPropagation();
                                    olPage.Content.Divs.Close.PromptComment(true);
                                    olPage.Content.Divs.Load.PromptMatter(true);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Search_onChange: function () {
                            $("#olPromptComment .ol-search-container")
                                .off('search keyup')
                                .on('search keyup', function (event) {
                                    var searchValue_ = event.target.value;
                                    olPage.Content.Divs._internal.PromptComment._internal.PopulateComments(searchValue_);
                                })
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptComment.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptComment.Events.Search_onChange();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptLogon: {
                    _internal: {
                        shared: null,
                        userdata: null,
                        searchValue: null,
                        CreateDivs: function (logonDataElement) {
                            try {
                                var personalId_ = logonDataElement.Id;
                                var accountName_ = logonDataElement.AccountName;
                                var accountNameFull_ = logonDataElement.AccountNameFull;

                                if (logonDataElement.Error) {
                                    accountName_ = 'Error on Account! - ' + accountName_;
                                }

                                if (logonDataElement.Id == 'olAccountIdNewLogon') {
                                    var newDivLabel_ = '<div class="ol-interface-container ol-dynamic-content"><div id="olLogonAccount' + personalId_ + '" class="ol-list-label ol-interface-row">' + accountName_ + '</div></div>';
                                    $('#olLogonAccounts').append(newDivLabel_);
                                    $('#olLogonAccount' + personalId_).data('Id', personalId_);

                                    if (olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) {
                                        //hide new logon if we are in offline mode
                                        $('#olLogonAccount').hide();
                                    } else {
                                        //on click events if not in offline mode
                                        $('#olLogonAccount' + personalId_)
                                            .click({
                                                DivId: personalId_
                                            },
                                                olPage.Content.Divs._internal.PromptLogon.Events.Edit_onClick);
                                    }
                                } else {
                                    //Main div
                                    var deleteImgTitle_ = olPage.Functions.GetLanguageItem('JS_DeletePasswordAccount');
                                    var editImgTitle_ = olPage.Functions.GetLanguageItem('JS_EditPassword');

                                    var editDiv_;
                                    var deleteDiv_;

                                    editDiv_ = '<i id="olLogonAccountDetailsEdit' + personalId_ + '" class="ol-fa ol-fa-pencil ol-interface-buttons" aria-hidden="true " title="' + editImgTitle_ + '"></i>';
                                    deleteDiv_ = '<i id="olLogonAccountDetailsDelete' + personalId_ + '" class="ol-fa ol-fa-trash-o ol-interface-buttons" aria-hidden="true " title="' + deleteImgTitle_ + '"></i>';

                                    var buttonEdit_ = editDiv_;
                                    var buttonDelete_;
                                    if (olPage.Data.PageFlags.LogonCommonNeeded) {
                                        buttonDelete_ = '';
                                    } else {
                                        buttonDelete_ = deleteDiv_;
                                    }

                                    var divButtons_ = '';
                                    if (!olPage.Data.PageFlags.PmtAdmin && !olPage.Content.Divs._internal.PromptLogon._internal.shared && !olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                        var divButtons_ = '<div class="ol-div-btn">' + buttonEdit_ + buttonDelete_ + '</div>';
                                    }

                                    var divLabel_ = '<div id="olInterfaceContainer' + personalId_ + '" class="ol-interface-container ol-dynamic-content"><div id="olLogonAccount' + personalId_ + '" class="ol-list-label ol-interface-row">' + accountNameFull_ + '</div>' + divButtons_ + '</div>';

                                    $('#olLogonAccounts').append(divLabel_);
                                    $('#olLogonAccount' + personalId_).on('mouseover', function () {
                                        olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                    });

                                    $('#olLogonAccount' + personalId_).data('Id', personalId_);

                                    var buttonYes_;
                                    var buttonNo_;

                                    var yesImgTitle_ = olPage.Functions.GetLanguageItem('JS_DeletePasswordAccount');
                                    var noImgTitle_ = olPage.Functions.GetLanguageItem('JS_CancelDeletePasswordAccount');

                                    buttonYes_ = '<i id="olLogonAccountConfirmYes' + personalId_ + '" title="' + yesImgTitle_ + '" class="ol-fa ol-fa-check ol-tertiary-text-color ol-interface-buttons" aria-hidden="true "></i>';
                                    buttonNo_ = '<i id="olLogonAccountConfirmNo' + personalId_ + '" title="' + noImgTitle_ + '" class="ol-fa ol-fa-times ol-tertiary-text-color ol-interface-buttons" aria-hidden="true "></i>';

                                    var deleteLabel_ = olPage.Functions.GetLanguageItem('JS_DeleteAccount') + '? - ' + logonDataElement.AccountNameFull;
                                    var confirmDivLabel_ = '<div id="olConfirmDivLabel' + personalId_ + '" class="">' + deleteLabel_ + "'</div>";
                                    var divButtonsConfirm_ = '<div class="ol-div-btn">' + buttonYes_ + buttonNo_ + '</div>';
                                    var confirmDiv_ = '<div id="olInterfaceConfirmContainer' + personalId_ + '" class="ol-interface-container ol-dynamic-content ol-interface-confirm-container"><div id="olConfirm' + personalId_ + '" class="ol-list-label ol-interface-row">' + deleteLabel_ + '</div>' + divButtonsConfirm_ + '</div>';

                                    $('#olLogonAccounts').append(confirmDiv_);
                                    $('#olConfirm' + personalId_).on('mouseover', function () {
                                        olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                    });


                                    $('#olInterfaceConfirmContainer' + personalId_).hide();
                                    $('#olLogonAccountConfirmYes' + personalId_).click({
                                        PersonalId: personalId_
                                    }, olPage.Content.Divs._internal.PromptLogon.Events.ConfirmYes_onClick);
                                    $('#olLogonAccountConfirmNo' + personalId_).click({
                                        PersonalId: personalId_
                                    }, olPage.Content.Divs._internal.PromptLogon.Events.ConfirmNo_onClick);


                                    if (!((olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) || olPage.Data.PageFlags.PmtAdmin)) {
                                        //on hover events if we aren't in offline mode
                                        $('.ol-interface-container').hover(function () {
                                            $(this).find('.ol-div-btn').show();
                                        }, function () {
                                            $(this).find('.ol-div-btn').hide();
                                        });
                                        //on click events if we aren't in offline mode
                                        $('#olLogonAccount' + personalId_).click({
                                            UserId: logonDataElement.UserId,
                                            UserName: logonDataElement.UserName,
                                            PersonalId: personalId_,
                                            Shared: olPage.Content.Divs._internal.PromptLogon._internal.shared,
                                            Title: logonDataElement.Title,
                                        }, olPage.Content.Divs._internal.PromptLogon.Events.SelectedLogon_onClick);

                                        $('#olLogonAccountDetailsEdit' + personalId_).click({
                                            DivId: personalId_
                                        }, olPage.Content.Divs._internal.PromptLogon.Events.Edit_onClick);
                                        $('#olLogonAccountDetailsDelete' + personalId_).click({
                                            DivId: personalId_
                                        }, olPage.Content.Divs._internal.PromptLogon.Events.Delete_onClick);
                                    } else {
                                        //on click events
                                        $('#olLogonAccount' + personalId_).click({
                                            PersonalId: personalId_
                                        }, olPage.Content.Divs._internal.PromptLogon.Events.SelectedLogon_onClick);
                                    }
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateDivs', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        PopulateLogons: function (searchValue, shared, userdata) {
                            olPage.Content.Divs._internal.PromptLogon._internal.shared = shared;
                            olPage.Content.Divs._internal.PromptLogon._internal.userdata = userdata;
                            olPage.Content.Divs._internal.PromptLogon._internal.searchValue = searchValue;

                            var logonData_ = olPage.Content.Divs._common.GetLogonData(
                                searchValue,
                                olPage.Content.Divs._internal.PromptLogon._internal.shared,
                                olPage.Content.Divs._internal.PromptLogon._internal.userdata
                            );

                            // clear dynamic content
                            $('#olLogonAccounts .ol-dynamic-content').remove();
                            // add dynamic content
                            for (var i = 0; i < logonData_.length; i++) {
                                olPage.Content.Divs._internal.PromptLogon._internal.CreateDivs(logonData_[i], olPage.Content.Divs._internal.PromptLogon._internal.shared);
                            }

                            return (
                                {
                                    showPromptLogon: (olPage.Content.Divs._internal.PromptLogon._internal.ShowPromptLogon(logonData_, searchValue, olPage.Content.Divs._internal.PromptLogon._internal.shared)),
                                    showSearchInput: (logonData_.length > 5),
                                    logonData: logonData_
                                }
                            );
                        },
                        ProcessInitialPrompt: function (logonData) {
                            if (olPage.Content.Divs._internal.PromptLogon._internal.searchValue) {
                                return true;
                            } else {
                                if (olPage.Content.Divs._internal.PromptLogon._internal.shared) {
                                    $('#olLogonAccount' + logonData.Id).click();
                                    return false;
                                } else {
                                    if (typeof ($('#olPromptLogonDetails').data('InitialPrompt')) === 'undefined' || ($('#olPromptLogonDetails').data('InitialPrompt'))) {
                                        $('#olPromptLogonDetails').data('InitialPrompt', false);
                                        $('#olLogonAccount' + logonData.Id).click();
                                        //https://henchman.atlassian.net/browse/ON-1721?filter=15200
                                        //Refresh cancel initial 
                                        // olPage.Data.PageFlags.LogonDone = true;
                                        // olPage.Messages.Flags.LogonDone(true);
                                        if (logonData.Id != 'olAccountIdNewLogon') {
                                            olPage.Content.Divs._internal.SetMask(false);
                                        }
                                        return false;
                                    } else {
                                        return true;
                                    }
                                }
                            }
                        },
                        ShowPromptLogon: function (logonData, searchValue) {
                            var returnValue_ = true;
                            var admin_ = olPage.Data.PageFlags.PmtAdmin;

                            if (olPage.Data.PageFlags.PmtAutomatic) {
                                try {
                                    //automatic pass management, only one account detail can exist
                                    returnValue_ = false;

                                    var obj_ = {
                                        data: {
                                            UserId: logonData[0].UserId,
                                            UserName: logonData[0].UserName,
                                            PersonalId: logonData[0].Id,
                                            Shared: olPage.Content.Divs._internal.PromptLogon._internal.shared,
                                            Title: logonData[0].Title,
                                        }
                                    }
                                    olPage.Content.Divs._internal.PromptLogon.Events.SelectedLogon_onClick(obj_);
                                } catch (error) {
                                    //This was initial handling of PMT automatic passwords
                                    //Some sites because of timings fail to create element to click on
                                    //Because of that we tried to fix it with code above, which is failing again on some sites...
                                    //This is why is fixed like this
                                    $('#olPromptLogonDetails').data('Id', null);
                                    if (logonData.length) {
                                        olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared);
                                    }
                                } finally {
                                    olPage.Data.PageFlags.LogonDone = true;
                                    olPage.Messages.Flags.LogonDone(true);
                                    olPage.Content.Divs._internal.SetMask(false);

                                    olPage.Content.Inject();
                                }
                            } else {
                                if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                    if (olPage.Content.Divs._internal.PromptLogon._internal.shared) {
                                        if (logonData.length == 1) {
                                            returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared)
                                        } else {
                                            returnValue_ = - true;
                                        }
                                    } else {
                                        if (logonData.length <= 1) {
                                            returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared)
                                        } else {
                                            returnValue_ = - true;
                                        }
                                    }
                                } else {
                                    if (olPage.Content.Divs._internal.PromptLogon._internal.shared) {
                                        if (logonData.length == 1) {
                                            returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared)
                                        } else {
                                            returnValue_ = - true;
                                        }
                                    } else {
                                        if (logonData.length <= 2 && !olInjection.InjectionHappened) {
                                            if ((olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) || admin_) {
                                                // we are in offline mode or admin managed
                                                if (logonData.length == 0) {
                                                    if (!searchValue) {
                                                        // no logon data, just set flags
                                                        olPage.Data.PageFlags.LogonDone = true;
                                                        olPage.Messages.Flags.LogonDone(true);
                                                        olPage.Content.Divs._internal.SetMask(false);

                                                        olPage.Content.Inject();

                                                        returnValue_ = false;
                                                    } else {
                                                        returnValue_ = true;
                                                    }
                                                } else if (logonData.length == 1) {
                                                    if (!searchValue) {
                                                        returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared);
                                                    } else {
                                                        returnValue_ = true;
                                                    }
                                                }
                                            } else {
                                                // we are NOT in offline mode
                                                if (!searchValue) {
                                                    returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared);
                                                }
                                            }
                                        } else {
                                            if (logonData.length <= 1) {
                                                returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared)
                                                returnValue_ = returnValue_ && !admin_;
                                                olPage.Data.PageFlags.LogonNeeded = olPage.Data.PageFlags.LogonNeeded && !admin_;
                                            } else {
                                                if (logonData.length <= 2 && olPage.Content.Divs._internal.PromptLogon._internal.shared) {
                                                    if (logonData.length == 1) {
                                                        returnValue_ = olPage.Content.Divs._internal.PromptLogon._internal.ProcessInitialPrompt(logonData[0], olPage.Content.Divs._internal.PromptLogon._internal.shared);
                                                    } else {
                                                        returnValue_ = true;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }

                            if (admin_ && logonData.length <= 1 || olPage.Data.PageFlags.LogonCommonNeeded) {
                                //hide manage password accounts button from toolbar menu
                                $('#olToolbarMenuLogon').hide();
                            }

                            return returnValue_;
                        }
                    },
                    Events: {
                        Cancel_onClick: function () {
                            $('#olImgLogonCancel').off('click');
                            $('#olImgLogonCancel').on('click', function (event) {
                                event.stopPropagation();
                                try {
                                    if (!olInjection.InjectionHappened) {
                                        olPage.Messages.SkipPersonalDetailsRequest();
                                    } else {
                                        olPage.Content.Divs.Close.PromptLogon(false);
                                        olPage.Content.Divs._internal.Toolbar.ResetMenu();
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Edit_onClick: function (event) {
                            try {
                                $('#olPromptLogonDetails').data('Id', event.data.DivId);
                                olPage.Content.Divs.Close.PromptLogon(true);

                                olPage.Content.Divs.Load.PromptLogonDetails(true);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Edit_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Delete_onClick: function (event) {
                            try {
                                $('.ol-interface-container').show();
                                $('.ol-interface-confirm-container').removeClass('ol-confirm-interface-toggle').hide();

                                $('#olInterfaceContainer' + event.data.DivId).hide();
                                $('#olInterfaceConfirmContainer' + event.data.DivId).addClass('ol-confirm-interface-toggle').show();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Delete_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        ConfirmNo_onClick: function (event) {
                            try {
                                $('.ol-confirm-interface-toggle').hide();
                                $('.ol-interface-toggle').show().removeClass('ol-interface-toggle');

                                $('#olInterfaceContainer' + event.data.PersonalId).show();
                                $('#olInterfaceConfirmContainer' + event.data.PersonalId).hide();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ConfirmNo_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        ConfirmYes_onClick: function (event) {
                            try {
                                var parameters_ = {
                                    Id: event.data.PersonalId
                                };

                                //Changing logon array, then needs to refresh it
                                olPage.Content.Divs._common.LogonDataArray = null;
                                olPage.Messages.DeletePersonalDetailRequest(parameters_);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ConfirmYes_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        SelectedLogon_onClick: function (event) {
                            try {
                                olInjection.Parameters.ForcedInjected = false;
                                olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser = event.data;
                                var alertContent_ = new olFunctions.AlertContent('SelectedLogon_onClick UpdateResponse', 'Page function');
                                olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                                var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                var variableReplacement_;
                                if (event.data.Shared) {
                                    variableReplacement_ = olPage.Data.PageInfo.Response.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement;
                                } else {
                                    variableReplacement_ = beforeNavigateResponse_.VariableReplacement;
                                }
                                var details_;

                                if (variableReplacement_.CommonDetail != null) {
                                    details_ = [variableReplacement_.CommonDetail];
                                } else if (variableReplacement_.PersonalDetail != null) {
                                    details_ = variableReplacement_.PersonalDetail;
                                }

                                if (details_[0].Id == 'tmpId') {
                                    details_ = null;
                                }

                                if (!event.data.shared && olPage.Data.LocalPageFlags.UsingSharedPasswords && !details_) {
                                    details_ = [{
                                        Id: 'olEmptyLogon',
                                        Name: 'Empty',
                                        Variables: [
                                            {
                                                DefinedName: 'username',
                                                Label: 'Username',
                                                Value: ' '
                                            },
                                            {
                                                DefinedName: 'password',
                                                Label: 'Password',
                                                Value: ' '
                                            },
                                        ]
                                    }]
                                }

                                var selectedAccount_ = $.grep(details_, function (member) {
                                    return (event.data.PersonalId == 'olCommonId' || event.data.PersonalId == 'olEmptyLogon' || event.data.PersonalId == 'tmpId' || member.Id == event.data.PersonalId);
                                });

                                for (var j = 0; j < selectedAccount_[0].Variables.length; j++) {
                                    var definedName_ = selectedAccount_[0].Variables[j].DefinedName;
                                    for (var i = 0; i < beforeNavigateResponse_.VariableReplacement.Variables.length; i++) {
                                        if (String(definedName_).toLowerCase() == String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName).toLowerCase()) {
                                            beforeNavigateResponse_.VariableReplacement.Variables[i].Value = selectedAccount_[0].Variables[j].Value;
                                            break;
                                        }
                                    }
                                }

                                if (!olPage.Data.PageFlags.LogonCommonNeeded && olPage.Data.PageFlags.LogonNeeded) {
                                    var parameters_ = {
                                        Id: selectedAccount_[0].Id,
                                        UserId: event.data.UserId,
                                        UserName: event.data.UserName,
                                        Details: {
                                            Name: selectedAccount_[0].Name,
                                            Variables: selectedAccount_[0].Variables
                                        },
                                        Shared: event.data.Shared ? event.data.Shared : false
                                    };

                                    if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                        olPage.Data.nextSelectedLogonParams = parameters_;
                                        olPage.Messages.UnSetCurrentSharedPasswordRequest();
                                    } else {
                                        olPage.Messages.SetCurrentPersonalDetailsRequest(parameters_);
                                    }
                                } else {
                                    olPage.Data.PageFlags.LogonDone = true;
                                    olPage.Messages.Flags.LogonDone(true);
                                    olPage.Content.Divs.Close.PromptLogon(false);

                                    olPage.Content.Inject();
                                }

                                olPage.Messages.UpdateResponse();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SelectedLogon_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Search_onChange: function () {
                            $("#olPromptLogon .ol-search-container")
                                .off('search keyup')
                                .on('search keyup', function (event) {
                                    var searchValue_ = event.target.value;
                                    olPage.Content.Divs._internal.PromptLogon._internal.PopulateLogons(
                                        searchValue_, olPage.Content.Divs._internal.PromptLogon._internal.shared, olPage.Content.Divs._internal.PromptLogon._internal.userdata
                                    );
                                })
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptLogon.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptLogon.Events.Search_onChange();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptLogonDetails: {
                    _internal: {
                        OkDisabled: '',
                        ArrayElements: [],
                        ArrayUP: [],
                        CreateDivs: function (selectedAccount) {
                            try {
                                olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements = ['olPromptLogonDetailsOK', 'olTitleData', 'olImgPromptLogonDetailsCancel'];
                                olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP = [];

                                var inputTextArea_ = '';
                                var divElement_ = '';
                                var tabindex_ = 0;
                                var heightIE7 = 0;

                                for (var j = 0; j < selectedAccount.AccountData.length; j++) {
                                    if (!selectedAccount.AccountData[j].olAdded) {
                                        var containerID_ = '';
                                        var confirmContainerID_ = '';
                                        var localTrimmedDefinedName_ = selectedAccount.AccountData[j].DefinedName;
                                        localTrimmedDefinedName_ = localTrimmedDefinedName_.replace(/\s+/g, '');

                                        switch (selectedAccount.AccountData[j].DefinedType) {
                                            case 0:
                                                //Username
                                                var inputUserId_ = 'olUsernameData_' + j + '_' + localTrimmedDefinedName_;
                                                tabindex_++;
                                                divElement_ = '';
                                                containerID_ = inputUserId_ + 'FieldContainer';

                                                divElement_ = divElement_ + '<div id="' + containerID_ + '" class="ol-form-elements-container"><div id="' + inputUserId_ + 'ElementContainer" class="ol-input-element ">';

                                                divElement_ = divElement_ + '<label class="ol-control-label">' + selectedAccount.AccountData[j].Label + '</label>';
                                                divElement_ = divElement_ + '<input id="' + inputUserId_ + '" type="ol-text" class="ol-input-control" tabindex="' + tabindex_ + '" autocomplete="off" /></div></div>';

                                                $('#olUsernamePasswordSection').append(divElement_);

                                                $('[id="' + inputUserId_ + '"]').val(selectedAccount.AccountData[j].Value);
                                                if (!selectedAccount.AccountData[j].CanBeModified) {
                                                    $('[id="' + inputUserId_ + '"]').attr('disabled', true);

                                                    $('[id="' + inputUserId_ + '"]').attr('title', olPage.Functions.GetLanguageItem('JS_NoChangeField'));
                                                    $('[id="' + inputUserId_ + '"]').addClass('olCursorNotAllowed');

                                                } else {
                                                    $('[id="' + inputUserId_ + '"]').attr('disabled', false);
                                                }

                                                olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements.push(inputUserId_);
                                                olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP.push({
                                                    Type: 0,
                                                    DefinedName: selectedAccount.AccountData[j].DefinedName,
                                                    Id: inputUserId_,
                                                    Label: selectedAccount.AccountData[j].Label,
                                                    CanBeModified: selectedAccount.AccountData[j].CanBeModified,
                                                    Value: null
                                                });

                                                //events
                                                $('[id="' + inputUserId_ + '"]').off('keyup');
                                                $('[id="' + inputUserId_ + '"]').on('keyup', function (event) {
                                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData();
                                                });

                                                $('[id="' + inputUserId_ + '"]').off('focus');
                                                $('[id="' + inputUserId_ + '"]').on('focus', function (event) {
                                                    olPage.Listeners._internal.Events.ElementFocus(this);
                                                });

                                                break;
                                            case 1:
                                                //Password
                                                tabindex_++;
                                                var inputPasswordId_ = 'olPasswordData_' + j + '_' + localTrimmedDefinedName_;
                                                var inputPasswordConfirmId_ = 'olPasswordConfirmData_' + j + '_' + localTrimmedDefinedName_;

                                                containerID_ = inputPasswordId_ + 'FieldContainer';
                                                confirmContainerID_ = inputPasswordConfirmId_ + 'FieldContainer';
                                                divElement_ = '';

                                                divElement_ = divElement_ + '<div id="' + containerID_ + '" class="ol-form-elements-container"><div id="' + inputPasswordId_ + 'ElementContainer" class="ol-input-element ">';

                                                divElement_ = divElement_ + '<label class="ol-control-label">' + selectedAccount.AccountData[j].Label + '</label>';
                                                divElement_ = divElement_ + '<input id="' + inputPasswordId_ + '" type="ol-password" class="ol-input-control" tabindex="' + tabindex_ + '" autocomplete="off" /></div></div>';

                                                //Confirm Password
                                                tabindex_++;
                                                var confirmLabel_ = olPage.Functions.GetLanguageItem('JS_Confirm') + ' ' + selectedAccount.AccountData[j].Label;

                                                divElement_ = divElement_ + '<div id="' + confirmContainerID_ + '" class="ol-form-elements-container"><div id="' + inputPasswordConfirmId_ + 'ElementContainer" class="ol-input-element ">';

                                                divElement_ = divElement_ + '<label class="ol-control-label">' + confirmLabel_ + '</label>';
                                                divElement_ = divElement_ + '<input id="' + inputPasswordConfirmId_ + '" type="ol-password" class="ol-input-control"  tabindex="' + tabindex_ + '" autocomplete="off" /></div></div>';

                                                $('#olUsernamePasswordSection').append(divElement_);

                                                $('[id="' + inputPasswordId_ + '"]').val(selectedAccount.AccountData[j].Value);
                                                $('[id="' + inputPasswordConfirmId_ + '"]').val(selectedAccount.AccountData[j].Value);

                                                if (!selectedAccount.AccountData[j].CanBeModified) {
                                                    $('[id="' + inputPasswordId_ + '"]').attr('disabled', true);
                                                    $('[id="' + inputPasswordId_ + '"]').attr('title', olPage.Functions.GetLanguageItem('JS_NoChangeField'));
                                                    $('[id="' + inputPasswordConfirmId_ + '"]').attr('disabled', true);
                                                    $('[id="' + inputPasswordConfirmId_ + '"]').attr('title', olPage.Functions.GetLanguageItem('JS_NoChangeField'));
                                                    $('[id="' + inputPasswordId_ + '"]').addClass('olCursorNotAllowed');
                                                    $('[id="' + inputPasswordConfirmId_ + '"]').addClass('olCursorNotAllowed');
                                                } else {
                                                    $('[id="' + inputPasswordId_ + '"]').attr('disabled', false);
                                                    $('[id="' + inputPasswordConfirmId_ + '"]').attr('disabled', false);
                                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements.push(inputPasswordId_);
                                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements.push(inputPasswordConfirmId_);
                                                }

                                                olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP.push({
                                                    Type: 1,
                                                    DefinedName: selectedAccount.AccountData[j].DefinedName,
                                                    Id: inputPasswordId_,
                                                    Label: selectedAccount.AccountData[j].Label,
                                                    CanBeModified: selectedAccount.AccountData[j].CanBeModified,
                                                    PasswordConfirmId: inputPasswordConfirmId_,
                                                    Value: null
                                                });

                                                //events
                                                $('[id="' + inputPasswordId_ + '"]').off('keyup');
                                                $('[id="' + inputPasswordId_ + '"]').on('keyup', function (event) {
                                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData();
                                                });
                                                $('[id="' + inputPasswordConfirmId_ + '"]').off('keyup');
                                                $('[id="' + inputPasswordConfirmId_ + '"]').on('keyup', function (event) {
                                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData();
                                                });

                                                $('[id="' + inputPasswordId_ + '"]').off('focus');
                                                $('[id="' + inputPasswordId_ + '"]').on('focus', function (event) {
                                                    olPage.Listeners._internal.Events.ElementFocus(this);
                                                });

                                                $('[id="' + inputPasswordConfirmId_ + '"]').off('focus');
                                                $('[id="' + inputPasswordConfirmId_ + '"]').on('focus', function (event) {
                                                    olPage.Listeners._internal.Events.ElementFocus(this);
                                                });


                                                break;
                                        }
                                        olPage.Content.Divs._internal.EventsForContainerInput(containerID_);
                                        if (confirmContainerID_) {
                                            olPage.Content.Divs._internal.EventsForContainerInput(confirmContainerID_);
                                        }
                                    }
                                }

                                $('#olUsernamePasswordSection .ol-control-label').off('mouseover');
                                $('#olUsernamePasswordSection .ol-control-label').on('mouseover', function () {
                                    olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                });

                                olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateDivs (PromptLogonDetails)', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckData: function () {
                            try {
                                olPage.Content.Divs._internal.AlertPrompt = 'olPromptLogonDetails';
                                if (olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckTitle() && olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckUP()) {
                                    var infoText_ = '';//olPage.Functions.GetLanguageItem('JS_OKLabel');
                                    olPage.Content.Divs.SetInfoMsg(infoText_);

                                    $('#olPromptLogonDetailsOK').attr('disabled', false);
                                    return true;
                                } else {
                                    $('#olPromptLogonDetailsOK').attr('disabled', true);
                                    return false;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckData', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckUP: function () {
                            var ok_ = true;
                            for (var i = 0; i < olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP.length; i++) {
                                var currentElement_ = olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP[i];
                                var trimmedValue_ = $.trim($('[id="' + currentElement_.Id + '"]').val());

                                switch (currentElement_.Type) {
                                    case 0:
                                        //username
                                        if (olPage.Data.PageFlags.LogonNeededForUsername || olPage.Data.PageFlags.LogonCommonNeededForUsername) {
                                            if (trimmedValue_ == '') {
                                                var infoText_ = olPage.Functions.GetLanguageItem('JS_PleaseInsert').replace('{rep1}', currentElement_.Label);
                                                olPage.Content.Divs.SetInfoMsg(infoText_);
                                                ok_ = false;
                                            } else {
                                                currentElement_.Value = trimmedValue_;
                                            }
                                        } else {
                                            currentElement_.Value = trimmedValue_;
                                        }
                                        break;
                                    case 1:
                                        //password
                                        if (olPage.Data.PageFlags.LogonNeededForPassword || olPage.Data.PageFlags.LogonCommonNeededForPassword) {
                                            if (trimmedValue_ == $.trim($('[id="' + currentElement_.PasswordConfirmId + '"]').val())) {
                                                if (trimmedValue_ == '') {
                                                    var infoText_ = olPage.Functions.GetLanguageItem('JS_PleaseInsert').replace('{rep1}', currentElement_.Label);
                                                    olPage.Content.Divs.SetInfoMsg(infoText_);
                                                    ok_ = false;
                                                } else {
                                                    currentElement_.Value = trimmedValue_;
                                                }
                                            } else {
                                                var infoText_ = olPage.Functions.GetLanguageItem('JS_PasswordsWrong').replace('{rep1}', currentElement_.Label);
                                                olPage.Content.Divs.SetInfoMsg(infoText_);
                                                ok_ = false;
                                            }
                                        } else {
                                            currentElement_.Value = trimmedValue_;
                                        }
                                        break;
                                }
                                if (!ok_) {
                                    break;
                                }
                            }
                            return ok_;
                        },
                        CheckTitle: function () {
                            try {
                                var logonData_ = olPage.Content.Divs._common.GetLogonData();
                                if ($.trim($('#olTitleData').val()) != '') {
                                    var selectedAccount_ = $.grep(logonData_, function (member) {
                                        return (member.Id != $('#olPromptLogonDetails').data('Id'));
                                    });
                                    for (var i = 0; i < selectedAccount_.length; i++) {
                                        if (String($.trim($('#olTitleData').val())).toLowerCase() == String(selectedAccount_[i].AccountNameFull).toLowerCase()) {
                                            var infoText_ = olPage.Functions.GetLanguageItem('JS_AccountExist');
                                            olPage.Content.Divs.SetInfoMsg(infoText_);
                                            return false;
                                        }
                                    }
                                    return true;
                                } else {
                                    var infoText_ = olPage.Functions.GetLanguageItem('JS_InsertAccountName');
                                    olPage.Content.Divs.SetInfoMsg(infoText_);
                                    return false;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckTitle', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                return false;
                            }
                        },
                        _selectedAccountId: null,
                        PopulateLogonDetails: function () {
                            try {
                                var htmlIdValue_ = $('#olPromptLogonDetails').data('Id');
                                if (htmlIdValue_) {
                                    olPage.Content.Divs._internal.PromptLogonDetails._internal._selectedAccountId = htmlIdValue_;
                                }
                                var logonData_ = olPage.Content.Divs._common.GetLogonData();
                                var selectedAccount_ = $.grep(logonData_, function (member) {
                                    return (member.Id == olPage.Content.Divs._internal.PromptLogonDetails._internal._selectedAccountId);
                                });

                                if (selectedAccount_[0].Id == 'olAccountIdNewLogon') {
                                    var infoText_ = olPage.Functions.GetLanguageItem('JS_NewAccount');

                                    document.getElementById("olPromptLogonDetails").getElementsByClassName("ol-caption-message")[0].innerHTML = infoText_;

                                    if (logonData_.length == 1) {
                                        $('#olTitleData').val(olPage.Functions.GetLanguageItem('JS_Default'));
                                    } else {
                                        $('#olTitleData').val(null);
                                    }
                                } else {
                                    document.getElementById("olPromptLogonDetails").getElementsByClassName("ol-caption-message")[0].innerHTML = selectedAccount_[0].AccountNameEdit;

                                    if (olPage.Data.PageFlags.LogonCommonNeeded) {
                                        $('#olTitleData').attr('disabled', true);
                                    }

                                    if (selectedAccount_[0].AccountName) {
                                        $('#olTitleData').val(selectedAccount_[0].AccountNameFull);
                                    } else {
                                        $('#olTitleData').val(olPage.Functions.GetLanguageItem('JS_Default'));
                                    }
                                }

                                olPage.Content.Divs._internal.EventsForContainerInput('olDivTitle');

                                $('#olUsernamePasswordSection').html(null);
                                olPage.Content.Divs._internal.PromptLogonDetails._internal.CreateDivs(selectedAccount_[0]);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateLogonDetails', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        Cancel_onClick: function () {
                            try {
                                $('#olImgPromptLogonDetailsCancel').off('click');
                                $('#olImgPromptLogonDetailsCancel').on('click', function (event) {
                                    event.stopPropagation();
                                    var logonData_ = olPage.Content.Divs._common.GetLogonData();
                                    if (logonData_.length > 1 || (olPage.Data.PageFlags.LogonCommonNeeded && logonData_.length == 1)) {
                                        olPage.Content.Divs.Close.PromptLogonDetails(true);
                                        olPage.Content.Divs.Load.PromptLogon(true);
                                    } else {
                                        olPage.Content.Divs.Close.PromptLogonDetails(false);
                                        $('#olImgLogonCancel').click();
                                    }
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        OK_onClick: function () {
                            try {
                                $('#olPromptLogonDetailsOK').off('click');
                                $('#olPromptLogonDetailsOK').on('click', function (event) {
                                    if (olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData()) {
                                        olPage.Content.Divs._internal.DisableElements(olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements);

                                        var newParam_ = false;
                                        var initialRequestParam_ = !olInjection.InjectionHappened;
                                        var idParam_ = $('#olPromptLogonDetails').data('Id');

                                        //Set  to null on adding new account because service is set to take NULL as param
                                        if (idParam_ == 'olAccountIdNewLogon') {
                                            idParam_ = null;
                                            newParam_ = true;
                                        }
                                        var titleValue_ = $.trim($('#olTitleData').val());
                                        //setting trimmed value back into title input box
                                        $('#olTitleData').val(titleValue_);

                                        if (titleValue_ == olPage.Functions.GetLanguageItem('JS_Default')) {
                                            titleValue_ = '';
                                        }

                                        var variables_ = new Array();
                                        var arrayUP_ = olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP;
                                        for (var i = 0; i < arrayUP_.length; i++) {
                                            if (arrayUP_[i].CanBeModified) {
                                                var variable_ = {
                                                    Name: arrayUP_[i].DefinedName,
                                                    Value: arrayUP_[i].Value
                                                };
                                                variables_.push(variable_);
                                            }
                                        }
                                        //Send message
                                        var parameters_ = {
                                            ApplicationSessionId: olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId
                                        };

                                        if (olPage.Data.PageFlags.LogonCommonNeeded) {
                                            parameters_.Variable = variables_;

                                            if (initialRequestParam_) {
                                                parameters_.InitialRequest = true;
                                                parameters_.InitialRequestSpecified = true;
                                            } else {
                                                parameters_.InitialRequestSpecified = false;
                                            }

                                            olPage.Messages.SetCommonDetailsRequest(parameters_);
                                        } else if (olPage.Data.PageFlags.LogonNeeded) {
                                            parameters_.Id = idParam_;
                                            parameters_.New = newParam_;
                                            parameters_.Details = {
                                                Name: titleValue_,
                                                Variables: []
                                            };

                                            parameters_.Details.Variables = variables_;

                                            if (initialRequestParam_) {
                                                parameters_.InitialRequest = true;
                                                parameters_.InitialRequestSpecified = true;
                                            } else {
                                                parameters_.InitialRequestSpecified = false;
                                            }
                                            olPage.Messages.SetPersonalDetailsRequest(parameters_);
                                        }
                                    }
                                    event.stopImmediatePropagation();
                                    event.preventDefault();
                                    event.stopPropagation();
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('OK_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Data_onChange: function () {
                            try {
                                $('#olTitleData').off('keyup');
                                $('#olTitleData').on('keyup', function (event) {
                                    olPage.Content.Divs._internal.PromptLogonDetails._internal.CheckData();
                                });
                                $('#olTitleData').off('focus');
                                $('#olTitleData').on('focus', function (event) {
                                    olPage.Listeners._internal.Events.ElementFocus(this);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Data_onChange', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptLogonDetails.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptLogonDetails.Events.Data_onChange();
                            olPage.Content.Divs._internal.PromptLogonDetails.Events.OK_onClick();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Initialize: function () {
                        try {
                            olPage.Content.Divs._internal.CreateLabels($('body #olTitle label').text());
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Initialize Logon Details', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptLicenceLimitReached: {
                    Events: {
                        OK_onClick: function () {
                            try {
                                $('#olPromptLicenceLimitReachedOK').off('click');
                                $('#olPromptLicenceLimitReachedOK').on('click', function (event) {
                                    event.stopPropagation();
                                    olPage.Content.Divs.Close.PromptLicenceLimitReached(false);
                                    if (olPage.Data.PageFlags.LicenceLimitReachedNeeded) {
                                        olPage.Data.PageFlags.LicenceLimitReachedDone = true;
                                    }
                                    if (olPage.Data.PageFlags.PooledDetailsLimitReachedNeeded) {
                                        olPage.Data.PageFlags.PooledDetailsLimitReachedDone = true;
                                    }
                                    var alertContent_ = new olFunctions.AlertContent('OK_onClick UpdateResponse', 'Page function');
                                    olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');


                                    olPage.Messages.UpdateResponse();

                                    olPage.Content.Inject();
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('OK_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptLicenceLimitReached.Events.OK_onClick();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Initialize: function () {
                        try {
                            if (olPage.Data.PageFlags.LicenceLimitReachedNeeded) {
                                var title_ = $.trim($('#olLicenceLimitReachedInfoText').text())
                                $('#olLicenceLimitReachedInfoText').text(title_);
                                olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt = olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt;
                                olPage.Content.Divs._internal.ResourceTimeout._internal._previousMask = olPage.Content.Divs._internal.MaskOn;
                                $('#olLicenceLimitReachedInfoText').show();
                                $('#olLicenceLimitReachedInfoSubText').show();

                                $('#olPooledLicenceLimitReachedInfoText').hide();
                                $('#olPooledLicenceLimitReachedInfoSubText').hide();
                            }

                            if (olPage.Data.PageFlags.PooledDetailsLimitReachedNeeded) {

                                var appNameLabel_ = '';
                                var title_ = $.trim($('#olPooledLicenceLimitReachedInfoText').text()) + ' (' + olPage.Data.ApplicationName + ')';
                                // appNameLabel_ = olPage.Content.Divs._internal.CreateLabels(title_, 590, null, 'olFontBig');
                                appNameLabel_ = olPage.Content.Divs._internal.CreateLabels(title_);

                                // if (appNameLabel_.Text != appNameLabel_.Title) {
                                //     appNameLabel_.Text = appNameLabel_.Text + ')';
                                //     $('#olPooledLicenceLimitReachedInfoText').attr('title', appNameLabel_.Title);
                                // }
                                // $('#olPooledLicenceLimitReachedInfoText').text(appNameLabel_.Text);

                                $('#olPooledLicenceLimitReachedInfoText').text(title_);

                                // $('#olPooledLicenceLimitReachedInfoText').text($('#olPooledLicenceLimitReachedInfoText').text() + ' (' + $.trim(olPage.Data.ApplicationName) + ')');
                                $('#olPooledLicenceLimitReachedInfoText').show();
                                $('#olPooledLicenceLimitReachedInfoSubText').show();

                                $('#olLicenceLimitReachedInfoText').hide();
                                $('#olLicenceLimitReachedInfoSubText').hide();
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Initialize Licence limit reached', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptMatter: {
                    _internal: {
                        ArrayElements: ['olMatterOK', 'olNewMatter', 'olMatterSearch', 'olMatterDropDownArrow', 'olMatterList', 'olDivMatterList', 'olTimekeeperList', 'olDivTimekeeperList', 'olNewTimekeeper', 'olTimekeeperDropDownArrow', 'olCommentSelect', 'olNewComment'],
                        CopyMatterListValue: function () {
                            try {
                                if ($('select#olMatterList').val()) {
                                    var selectedValue_ = $('select#olMatterList').val();
                                    if (selectedValue_) {
                                        $('#olNewMatter').val(selectedValue_);
                                    } else {
                                        $('#olNewMatter').val('');
                                    }
                                    $('#olNewMatter').select().focus();
                                    $("#olNewMatter").val($.trim($("#olNewMatter").val()));
                                    $("#olNewMatter").keyup();

                                    $('#olMatterList').val([]);
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CopyMatterListValue', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        ValidatingInterval: null,
                        ValidatingInfoMsg: '',
                        SetValidatingInterval: function () {
                            olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInterval = setInterval(function () {
                                if (olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg == '') {
                                    olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg = olPage.Functions.GetLanguageItem('JS_Validating');
                                }
                                if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olPromptMatter') {
                                    if (olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg.length < String(olPage.Functions.GetLanguageItem('JS_Validating')).length + 5) {
                                        olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg += '.';
                                    } else {
                                        olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg = olPage.Functions.GetLanguageItem('JS_Validating');
                                    }
                                    olPage.Content.Divs.SetInfoMsg(olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg);
                                } else {
                                    olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                                }
                            }, 500);
                        },
                        ClearValidatingInterval: function () {
                            try {
                                olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInfoMsg = olPage.Functions.GetLanguageItem('JS_Validating');
                                clearInterval(olPage.Content.Divs._internal.PromptMatter._internal.ValidatingInterval);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ClearValidatingInterval', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckData: function (matter, timekeeper, comment) {
                            try {
                                olPage.Content.Divs._internal.AlertPrompt = 'olPromptMatter';

                                olPage.Content.Divs._internal.PromptMatter._internal.SetMatterFlags(matter, timekeeper, comment);
                                if (olPage.Content.Divs._internal.PromptMatter._internal.CheckMatter() && olPage.Content.Divs._internal.PromptMatter._internal.CheckTimekeeper() && olPage.Content.Divs._internal.PromptMatter._internal.CheckComment()) {
                                    if (!olInjection.InjectionHappened || olPage.Data.PageFlags.MatterChanged || olPage.Data.PageFlags.TimekeeperChanged || olPage.Data.PageFlags.CommentChanged) {
                                        $('#olMatterOK')
                                            .attr('disabled', false)
                                            .removeClass('ol-disabled');
                                        olPage.Listeners._internal.Events._processingKey = false;
                                        olPage.Content.Divs.SetInfoMsg('');
                                        return true;
                                    } else {
                                        $('#olMatterOK').attr('disabled', true);
                                        olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_NoChange'));
                                        return false;
                                    }
                                } else {
                                    $('#olMatterOK').attr('disabled', true);
                                    return false;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckData', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckMatter: function () {
                            try {
                                if (olPage.Data.PageFlags.MatterNeeded) {
                                    var currentMatterValue_ = $.trim($('#olNewMatter').val());
                                    if (currentMatterValue_) {
                                        olPage.Content.Divs.SetInfoMsg('');
                                        return true;
                                    } else {
                                        olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_InsertMatterNumber'));
                                        return false;
                                    }
                                } else {
                                    olPage.Content.Divs.SetInfoMsg('');
                                    return true;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckMatter', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckTimekeeper: function () {
                            try {
                                if (olPage.Data.PageFlags.PersonalCodeNeeded) {
                                    var timeKeeper_ = $.trim($('#olNewTimekeeper').val());
                                    if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].TimekeeperLengthSpecified) {
                                        if (timeKeeper_.length >= olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].TimekeeperLength) {
                                            olPage.Content.Divs.SetInfoMsg('');
                                            return true;
                                        } else {
                                            var message_ = olPage.Functions.GetLanguageItem('JS_PersonalCodeLengthWrong');
                                            message_ = message_.replace('{rep1}', olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].TimekeeperLength)
                                            olPage.Content.Divs.SetInfoMsg(message_);
                                            // olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_TimekeeperShort'));
                                            return false;
                                        }
                                    } else {
                                        olPage.Content.Divs.SetInfoMsg('');
                                        return true;
                                    }
                                } else {
                                    olPage.Content.Divs.SetInfoMsg('');
                                    return true;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckTimekeeper', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CheckComment: function () {
                            try {
                                if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].RequireComment || olPage.Data.PageFlags.CommentRequest) {
                                    var comment_ = $.trim($('#olNewComment').val());
                                    var bnr_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                    if (olFunctions.IsFilledArray(bnr_.PredefinedComments)) {
                                        // predefined comments
                                        if (comment_.length > 0) {
                                            return true;
                                        } else {
                                            olPage.Content.Divs.SetInfoMsg(olPage.Functions.GetLanguageItem('JS_SelectComment'));
                                            return false;
                                        }
                                    } else {
                                        // manual comments
                                        if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].CommentLengthSpecified && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].CommentLength != 0) {
                                            if (comment_.length >= olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].CommentLength) {
                                                return true;
                                            } else {
                                                var message_ = olPage.Functions.GetLanguageItem('JS_CommentLengthWrong').replace('{rep1}', olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].CommentLength);
                                                olPage.Content.Divs.SetInfoMsg(message_);
                                                return false;
                                            }
                                        } else {
                                            return true;
                                        }
                                    }
                                } else {
                                    return true;
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CheckComment', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                return false;
                            }
                        },
                        SetMatterFlags: function (matter, timekeeper, comment) {
                            try {
                                if (olPage.Data.PageFlags.MatterNeeded) {
                                    var currentMatterValue_ = $.trim(matter);
                                    if (!currentMatterValue_) {
                                        currentMatterValue_ = $.trim($('#olNewMatter').val());
                                    }
                                    if (currentMatterValue_) {
                                        var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                        if (beforeNavigateResponse_.VariableReplacement && olFunctions.IsFilledArray(beforeNavigateResponse_.VariableReplacement.Variables)) {
                                            var previousMatterValue_ = '';
                                            if (olPage.Data.PageFlags.MatterNumber) {
                                                previousMatterValue_ = olPage.Data.PageFlags.MatterNumber;
                                            }

                                            olPage.Data.PageFlags.MatterChanged = (olInjection.InjectionHappened && (previousMatterValue_ != currentMatterValue_));
                                        }
                                    }
                                }
                                if (olPage.Data.PageFlags.PersonalCodeNeeded) {
                                    var timeKeeper_ = $.trim(timekeeper);
                                    if (timeKeeper_ == null || timeKeeper_ == '') {
                                        timeKeeper_ = $.trim($('#olNewTimekeeper').val());
                                    }
                                    if (timeKeeper_ != null) {
                                        olPage.Data.PageFlags.TimekeeperChanged = (!!olInjection.InjectionHappened && (timeKeeper_ != olPage.Data.PageFlags.TimekeeperNumber));
                                    }
                                }
                                if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].RequireComment || olPage.Data.PageFlags.CommentRequest) {
                                    var comment_ = $.trim(comment);
                                    if (comment_ == null || comment_ == '') {
                                        comment_ = $.trim($('#olNewComment').val());
                                    }
                                    if (comment_ != null) {
                                        olPage.Data.PageFlags.CommentChanged = (olInjection.InjectionHappened && (comment_ != olPage.Data.PageFlags.Comment));
                                    }
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SetMatterFlags', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CopyTimekeeperListValue: function () {
                            try {
                                var selectedValue_ = $('select#olTimekeeperList').val();
                                if (selectedValue_) {
                                    $('#olNewTimekeeper').val(selectedValue_);
                                } else {
                                    $('#olNewTimekeeper').val('');
                                }
                                $('#olNewTimekeeper').select().focus();
                                $('#olNewTimekeeper').val($('#olNewTimekeeper').val());
                                $("#olNewTimekeeper").keyup();

                                $('#olTimekeeperList').val([]);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CopyTimekeeperListValue', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        EnableComment: function () {
                            try {
                                olPage.Content.Divs._internal.EnableElements(['olCommentSelect', 'olMatterReset']);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('EnableComment', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        FillMatterValues: function () {
                            var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                            olPage.Data.PageFlags.MatterNumber = $.trim($('#olNewMatter').val());

                            if (olPage.Data.PageFlags.PersonalCodeNeeded) {
                                olPage.Data.PageFlags.TimekeeperNumber = $.trim($('#olNewTimekeeper').val());
                            } else {
                                olPage.Data.PageFlags.TimekeeperNumber = null;
                            }
                            if (beforeNavigateResponse_.RequireComment || olPage.Data.PageFlags.CommentRequest) {
                                olPage.Data.PageFlags.Comment = $.trim($('#olNewComment').val());
                            } else {
                                olPage.Data.PageFlags.Comment = null;
                            }

                            olPage.Content.Divs._internal.Toolbar._internal.SetTooltip();
                        },
                        HideComment: function () {
                            try {
                                $('#olMatterDivComment').hide();
                                $('#olMatterReset').hide().attr('olStyleFixed', 'display: none');
                                $('#olNewComment').removeAttr('tabindex');
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('HideComment', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        HideTimekeeper: function () {
                            try {
                                $('#olMatterDivTimekeeper').hide();
                                $('#olNewTimekeeper').removeAttr('tabindex');
                                $('#olNewComment').attr('tabindex', 2);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('HideTimekeeper', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        ShowComment: function () {
                            try {
                                $('#olMatterReset').show().attr('olStyleFixed', 'display: inline-block');
                                $('#olMatterDivComment').show(olOptions.General.Page.TransitionTime());
                                olPage.Content.Divs._internal.EventsForContainerInput('olDivComment');
                                // $('#olNewComment').attr('disabled', false);
                                // $('#olNewComment').removeClass('ol-disabled');

                                var bnr_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                if (olFunctions.IsFilledArray(bnr_.PredefinedComments)) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.SetCommentSelect();
                                    $('#olCommentInfo').text(olPage.Functions.GetLanguageItem('JS_SelectComment'));
                                } else {
                                    olPage.Content.Divs._internal.PromptMatter._internal.SetCommentInput();
                                    if (bnr_.CommentLengthSpecified && bnr_.CommentLength != 0) {

                                        var infoText_ = olPage.Functions.GetLanguageItem('JS_CommentLengthWrong').replace('{rep1}', bnr_.CommentLength);

                                        $('#olCommentInfo').text(infoText_);
                                    } else {
                                        $('#olCommentInfo').text('');
                                    }
                                }

                                olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ShowComment', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        CreateSelectList: function (listID, inputID, containerID, dropdownArrowID, listDataArray) {
                            try {
                                if ($('#' + listID)) {
                                    $('#' + listID).html('');
                                }

                                var options_ = '';
                                for (var i = 0; i < listDataArray.length; i++) {
                                    options_ += '<div class="ol-select-option">' + listDataArray[i] + '</div>';

                                }

                                $('#' + listID).css('background-color', 'white');
                                $('#' + listID).append(options_);

                                $('#' + containerID).find('.ol-select-option').off('mouseover');
                                $('#' + containerID).find('.ol-select-option').on('mouseover', function () {
                                    olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                                });

                                $('#' + containerID).find('.ol-select-option').off('click');
                                $('#' + containerID).find('.ol-select-option').on('click', function () {
                                    try {
                                        $('#' + inputID).val(String($($(this)[0]).text()));
                                        $('#' + inputID).focus();
                                        $('#' + inputID).closest('.ol-input-element').addClass('filled');
                                        $('#' + inputID).keyup();
                                        $('#' + listID).fadeOut(150);
                                    } catch (e) {

                                    }
                                });

                                olPage.Content.Divs._internal.EventsForContainerInput(containerID, listID);
                                $('#' + listID).hide();
                                $('#' + dropdownArrowID)
                                    .off('click')
                                    .on('click', function (event) {
                                        if ($(this).hasClass('ol-disabled')) {
                                            return;
                                        }
                                        $('.ol-select-list').each(function (index) {
                                            if (listID != $($('.ol-select-list')[index]).attr('id')) {
                                                $(this).fadeOut(150);
                                            }
                                        }
                                        );
                                        event.stopPropagation();
                                        event.preventDefault();

                                        $('#' + listID).fadeToggle(150);
                                    });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateMatterSelect', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        PopulateMatterDropDownList: function () {
                            try {
                                var itemsToAdd_ = [];
                                for (var i = 0; i < olPage.Data.PageInfo.Response.CheckMatterResponse.MatterDetails.length; i++) {
                                    itemsToAdd_.push(olPage.Data.PageInfo.Response.CheckMatterResponse.MatterDetails[i].MatterNumber);
                                };

                                olPage.Content.Divs._internal.PromptMatter._internal.CreateSelectList('olMatterList', 'olNewMatter', 'olDivMatterList', 'olMatterDropDownArrow', itemsToAdd_);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateMatterDropDownList', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        UnselectMatterDropDownList: function () {
                            try {
                                $('#olMatterList').val([]);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('UnselectMatterDropDownList', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        PopulateTimekeeperDropDownList: function () {
                            try {
                                var itemsToAdd_ = [];
                                for (var i = 0; i < olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes.length; i++) {
                                    itemsToAdd_.push(olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes[i]);
                                };
                                olPage.Content.Divs._internal.PromptMatter._internal.CreateSelectList('olTimekeeperList', 'olNewTimekeeper', 'olDivTimekeeperList', 'olTimekeeperDropDownArrow', itemsToAdd_);

                                if (!$('#olNewTimekeeper').val()) {
                                    $('#olNewTimekeeper').val(itemsToAdd_[0]);
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('PopulateTimekeeperDropDownList', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        UnselectTimekeeperDropDownList: function () {
                            try {
                                $('#olTimekeeperList').val([]);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('UnselectTimekeeperDropDownList', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        UpdateVariables: function () {
                            try {
                                var matterFilled_ = false;
                                var timekeeperFilled_ = false;
                                var commentFilled_ = false;
                                var matterValue_ = $.trim($('#olNewMatter').val());
                                var timekeeperValue_ = $.trim($('#olNewTimekeeper').val());
                                var commentValue_ = '';
                                var definedMatterName_ = 'matter';
                                var definedTimeKeeperName_ = 'timekeeper';
                                var definedCommentName_ = 'comment';

                                var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                if (beforeNavigateResponse_.RequireComment || olPage.Data.PageFlags.CommentRequest) {
                                    commentValue_ = $.trim($('#olNewComment').val());
                                }

                                if (beforeNavigateResponse_.VariableReplacement && olFunctions.IsFilledArray(beforeNavigateResponse_.VariableReplacement.Variables)) {
                                    for (var i = 0; i < beforeNavigateResponse_.VariableReplacement.Variables.length; i++) {
                                        if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.MatterArray) > -1) {
                                            beforeNavigateResponse_.VariableReplacement.Variables[i].Value = matterValue_;
                                            definedMatterName_ = beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName;
                                            matterFilled_ = true;
                                        }
                                        if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.TimeKeeperArray) > -1) {
                                            beforeNavigateResponse_.VariableReplacement.Variables[i].Value = timekeeperValue_;
                                            definedTimeKeeperName_ = beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName;
                                            timekeeperFilled_ = true;
                                        }
                                        if ($.inArray(String(beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.CommentArray) > -1) {
                                            beforeNavigateResponse_.VariableReplacement.Variables[i].Value = commentValue_;
                                            definedCommentName_ = beforeNavigateResponse_.VariableReplacement.Variables[i].DefinedName;
                                            commentFilled_ = true;
                                        }
                                    }
                                }
                                var alertContent_ = new olFunctions.AlertContent('UpdateVariables UpdateResponse');
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                olPage.Messages.UpdateResponse();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('UpdateVariables', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        RequestNewSession: function () {
                            try {
                                return (olPage.Data.PageFlags.MatterChanged || olPage.Data.PageFlags.TimekeeperChanged || olPage.Data.PageFlags.CommentChanged);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('RequestNewSession', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        SetCommentSelect: function () {
                            try {
                                $('#olNewComment').show();
                                $('#olCommentSelect').show();
                                $('#olNewComment').attr('disabled', true);
                                $('#olNewComment').addClass('ol-disabled');

                                olPage.Content.Divs._internal.EventsForContainerInput('olDivComment');

                                $('#olDivComment').on('mouseover', function () {
                                    olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($('#olNewComment'));
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SetCommentSelect', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        SetCommentInput: function () {
                            try {
                                olPage.Content.Divs._internal.EventsForContainerInput('olDivComment');
                                $('#olNewComment').show();
                                $('#olNewComment').attr('disabled', false);
                                $('#olNewComment').removeClass('ol-disabled');
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SetCommentInput', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        Cancel_onClick: function () {
                            $('#olImgMatterCancel').off('click');
                            $('#olImgMatterCancel').on('click', function (event) {
                                event.stopPropagation();
                                try {
                                    var skipMatterDetails_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].SkipMatterDetails;
                                    if (!olPage.Data.PageFlags.MatterDone && skipMatterDetails_) {
                                        olPage.Messages.SkipMatterDetailsRequest();
                                        olPage.Messages.Flags.MatterDone(true, true);
                                        olPage.Content.Divs.Close.PromptMatter(true);
                                        olPage.Content.Inject();
                                        olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                                        olPage.Content.Divs._internal.PromptMatter.Initialize();
                                    } else {
                                        olPage.Content.Divs.Close.PromptMatter(false);
                                        olPage.Content.Divs._internal.Toolbar.ResetMenu();
                                        olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                                        olPage.Content.Divs._internal.PromptMatter.Initialize();
                                        olPage.Content.Divs._internal.UpdateDivs();
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Data_onChange: function () {
                            try {
                                // keyup
                                $('#olNewMatter').off('keyup');
                                $('#olNewMatter').on('keyup', function (event) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.CheckData(event.target.value, null, null);
                                });
                                $('#olNewTimekeeper').off('keyup');
                                $('#olNewTimekeeper').on('keyup', function (event) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.CheckData(null, event.target.value, null);
                                });
                                $('#olNewComment').off('keyup');
                                $('#olNewComment').on('keyup', function (event) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.CheckData(null, null, event.target.value);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Data_onChange', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        MatterList_onChange: function () {
                            $('#olMatterList').off('change');
                            $('#olMatterList').on('change', function () {
                                if ($(this).hasClass('ol-disabled')) {
                                    return;
                                }
                                try {
                                    olPage.Content.Divs._internal.PromptMatter._internal.CopyMatterListValue();
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('MatterList_onChange', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        TimekeeperList_onChange: function () {
                            $('#olTimekeeperList').off('change');
                            $('#olTimekeeperList').on('change', function () {
                                if ($(this).hasClass('ol-disabled')) {
                                    return;
                                }
                                try {
                                    olPage.Content.Divs._internal.PromptMatter._internal.CopyTimekeeperListValue();
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('TimekeeperList_onChange', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        OK_onClick: function () {
                            $('#olMatterOK').off('click');
                            $('#olMatterOK').on('click', function (event) {
                                event.stopPropagation();
                                if ($(this).hasClass('ol-disabled')) {
                                    return;
                                }
                                try {
                                    if (olPage.Content.Divs._internal.PromptMatter._internal.CheckData()) {
                                        olPage.Content.Divs._internal.PromptMatter._internal.SetValidatingInterval();

                                        olPage.Content.Divs._internal.DisableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);

                                        var selectedMatterValue_ = $.trim($('#olNewMatter').val());
                                        var selectedTimekeeperValue_ = null;
                                        var selectedCommentValue_ = null;
                                        var selectedPredefinedComment_ = null;

                                        var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];

                                        if (olPage.Data.PageFlags.PersonalCodeNeeded) {
                                            selectedTimekeeperValue_ = $.trim($('#olNewTimekeeper').val());
                                        }

                                        if (beforeNavigateResponse_.RequireComment || olPage.Data.PageFlags.CommentRequest) {
                                            selectedCommentValue_ = $.trim($('#olNewComment').val());
                                            if (olFunctions.IsFilledArray(olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PredefinedComments)) {
                                                selectedPredefinedComment_ = $.grep(olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PredefinedComments, function (member) {
                                                    return (member.Comment == selectedCommentValue_);
                                                });
                                                selectedPredefinedComment_ = selectedPredefinedComment_[0];
                                            }
                                        }

                                        var requestNewSession_ = olPage.Content.Divs._internal.PromptMatter._internal.RequestNewSession();
                                        var RequestNewSessionSpecified_ = true;

                                        var parameters_ = {
                                            Comment: selectedCommentValue_,
                                            MatterName: null,
                                            MatterNumber: selectedMatterValue_,
                                            PersonalCode: selectedTimekeeperValue_,
                                            PredefinedComment: selectedPredefinedComment_,
                                            RequestNewSession: requestNewSession_,
                                            RequestNewSessionSpecified: RequestNewSessionSpecified_
                                        };

                                        if (!olPage.Data.PageFlags.MatterChanged && olPage.Data.PageFlags.CommentRequest) {
                                            if (requestNewSession_) {
                                                olPage.Messages.SetCommentEditRequest(parameters_);
                                            } else {
                                                olPage.Messages.SetCommentRequest(parameters_);
                                            }
                                        } else {
                                            olPage.Messages.ValidateSelectedMatterRequest(parameters_);
                                        }
                                    }

                                    olInjection.Parameters.ForcedInjected = false;
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('OK_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        CommentSelect_onClick: function () {
                            $('#olCommentSelect').off('click');
                            $('#olCommentSelect').on('click', function (event) {
                                event.stopPropagation();
                                if ($(this).hasClass('ol-disabled')) {
                                    return;
                                }
                                try {
                                    olPage.Content.Divs.Close.PromptMatter(true);
                                    olPage.Content.Divs.Load.PromptComment(true);
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('CommentSelect_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Search_onClick: function () {
                            $('#olMatterSearch').off('click');
                            $('#olMatterSearch').on('click', function (event) {
                                event.stopPropagation();
                                if ($(this).hasClass('ol-disabled')) {
                                    return;
                                }
                                try {
                                    var searchInputTypeValue_ = 'mNumber';
                                    //Set value of previous selected matter search type
                                    //Even it is not needed, for clearer insight how it works, it has both cases
                                    if ($('#olMatterSearchByNumber').hasClass('ol-active')) {
                                        searchInputTypeValue_ = 'mNumber'
                                    }
                                    if ($('#olMatterSearchByName').hasClass('ol-active')) {
                                        searchInputTypeValue_ = 'mName'
                                    }

                                    $('#olMatterSearchType').val(searchInputTypeValue_);

                                    olPage.Content.Divs.Close.PromptMatter(true);
                                    olPage.Content.Divs.Load.PromptMatterSearch(true, $.trim($('#olNewMatter').val()));
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.Request(false);
                                    olPage.Content.Divs._internal.ChangeImageSources();

                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Search_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Reset_onClick: function () {
                            $('#olMatterReset').off('click');
                            $('#olMatterReset').on('click', function (event) {
                                event.stopPropagation();
                                try {
                                    olPage.Content.Divs.Close.PromptMatter(true);
                                    olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptMatter._internal.ArrayElements);
                                    olPage.Content.Divs._internal.PromptMatter.Initialize();
                                    olPage.Content.Divs._internal.PromptMatter._internal.CheckData();
                                    olPage.Content.Divs.Load.PromptMatter(true);
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Reset_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Labels_onHover: function () {
                            $('#olMatterFormContainer .ol-control-label').on('mouseover', function () {
                                olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                            });
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptMatter.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptMatter.Events.CommentSelect_onClick();
                            olPage.Content.Divs._internal.PromptMatter.Events.Data_onChange();
                            olPage.Content.Divs._internal.PromptMatter.Events.MatterList_onChange();
                            olPage.Content.Divs._internal.PromptMatter.Events.TimekeeperList_onChange();
                            olPage.Content.Divs._internal.PromptMatter.Events.OK_onClick();
                            olPage.Content.Divs._internal.PromptMatter.Events.Search_onClick();
                            olPage.Content.Divs._internal.PromptMatter.Events.Reset_onClick();
                            olPage.Content.Divs._internal.PromptMatter.Events.Labels_onHover();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Initialize: function () {
                        try {
                            var tabindex_ = 0;
                            if (olPage.Data.PageInfo.Response.CheckMatterResponse && olPage.Data.PageInfo.Response.CheckMatterResponse.MatterDetails) {
                                olPage.Content.Divs._internal.PromptMatter._internal.PopulateMatterDropDownList();
                                olPage.Content.Divs._internal.PromptMatter._internal.UnselectMatterDropDownList();

                                tabindex_++;
                                $('#olNewMatter').attr('tabindex', tabindex_);
                            }

                            var bnr_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                            if (olPage.Data.PageFlags.PersonalCodeNeeded) {
                                if (olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse && olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.PopulateTimekeeperDropDownList();
                                    var timekeeperValue_ = $.trim($('#olNewTimekeeper').val());

                                    if (!timekeeperValue_ && !($('#olNewTimekeeper').data('InitialPromptForTimeKeeperDone'))) {
                                        $('#olNewTimekeeper').data('InitialPromptForTimeKeeperDone', true);
                                        olPage.Content.Divs._internal.PromptMatter._internal.CopyTimekeeperListValue();
                                    }

                                    olPage.Content.Divs._internal.PromptMatter._internal.UnselectTimekeeperDropDownList();
                                    if (bnr_.TimekeeperLengthSpecified && bnr_.TimekeeperLength && bnr_.TimekeeperLength != 0) {
                                        $('#olTimekeeperInfo').text($('#olTimekeeperInfo').text().replace('{rep1}', bnr_.TimekeeperLength));
                                    } else {
                                        $('#olTimekeeperInfo').text('');
                                    }
                                }
                                tabindex_++;
                                $('#olNewTimekeeper').attr('tabindex', tabindex_);
                            } else {
                                olPage.Content.Divs._internal.PromptMatter._internal.HideTimekeeper();
                            }

                            if (bnr_.RequireComment) {
                                if (olFunctions.IsFilledArray(bnr_.PredefinedComments)) {
                                    olPage.Content.Divs._internal.PromptMatter._internal.SetCommentSelect();
                                    $('#olCommentInfo').text(olPage.Functions.GetLanguageItem('JS_SelectComment'));
                                } else {
                                    olPage.Content.Divs._internal.PromptMatter._internal.SetCommentInput();
                                    if (bnr_.CommentLengthSpecified && bnr_.CommentLength && bnr_.CommentLength != 0) {
                                        $('#olCommentInfo').text($('#olCommentInfo').text().replace('{rep1}', bnr_.CommentLength));
                                    } else {
                                        $('#olCommentInfo').text('');
                                    }
                                }
                                tabindex_++;
                                $('#olNewComment').attr('tabindex', tabindex_);
                            } else {
                                olPage.Content.Divs._internal.PromptMatter._internal.HideComment();
                            }

                            $('#olMatterReset').hide().attr('olStyleFixed', 'display: none');
                            olPage.Data.PageFlags.CommentRequest = false;

                            if (olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) {
                                // hide this button if we are in offline mode
                                $('#olMatterSearch').hide().attr('olStyleFixed', 'display: none');
                            }

                            //At the end so the changes in text values for timekeeper and comment would be taken into consideration
                            olPage.Content.Divs._internal.Modal._prepareForRendering();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Initialize Prompt matter', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptMatterSearch: {
                    _internal: {
                        SelectedMatterNumber: '',
                        SelectedMatterName: '',
                        Table: null,
                        TableInitialized: false,
                        InputTimerStarted: false,
                        PageTimerStarted: false,
                        PageTotal: 0,
                        RequestPageNumberSpecified: false,
                        checkMatterResponse_: {},
                        ClearSearchTable: function () {
                            try {
                                olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_ = {};
                                olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.MatterDetails = [];
                                olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.PageCount = 0;
                                olPage.Content.Divs._internal.PromptMatterSearch._internal.CreateSearchTable(olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ClearSearchTable', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        SortTableElements: function () {
                            var matterDetails_ = olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.MatterDetails;
                            var asc_ = true;
                            if ($('#olFirstColumnName').data('olSort') == 'desc' || $('#olSecondColumnName').data('olSort') == 'desc') {
                                asc_ = false;
                            }

                            var mNumber_ = ($('#olMatterSearchType').val() == 'mNumber');

                            if (matterDetails_) {
                                var swapped_;
                                do {
                                    swapped_ = false;
                                    if (mNumber_) {
                                        for (var i = 0; i <= matterDetails_.length - 2; i++) {
                                            if (matterDetails_[i].MatterNumber > matterDetails_[i + 1].MatterNumber) {
                                                olPage.Functions.SwapElements(matterDetails_, i, i + 1);
                                                swapped_ = true;
                                            }
                                        }
                                        if (!swapped_) {
                                            break;
                                        }
                                        for (var i = matterDetails_.length - 2; i >= 0; i--) {
                                            if (matterDetails_[i].MatterNumber > matterDetails_[i + 1].MatterNumber) {
                                                olPage.Functions.SwapElements(matterDetails_, i, i + 1);
                                                swapped_ = true;
                                            }
                                        }
                                    } else {
                                        for (var i = 0; i <= matterDetails_.length - 2; i++) {
                                            if (matterDetails_[i].MatterName > matterDetails_[i + 1].MatterName) {
                                                olPage.Functions.SwapElements(matterDetails_, i, i + 1);
                                                swapped_ = true;
                                            }
                                        }
                                        if (!swapped_) {
                                            break;
                                        }
                                        for (var i = matterDetails_.length - 2; i >= 0; i--) {
                                            if (matterDetails_[i].MatterName > matterDetails_[i + 1].MatterName) {
                                                olPage.Functions.SwapElements(matterDetails_, i, i + 1);
                                                swapped_ = true;
                                            }
                                        }
                                    }
                                } while (swapped_);

                                if (!asc_) {
                                    matterDetails_.reverse();
                                }

                            }
                            olPage.Content.Divs._internal.PromptMatterSearch._internal.PopulateSearchTable();
                            olPage.Content.Divs._internal.PromptMatterSearch.Events.TableElements_onClick();
                        },
                        PopulateSearchTable: function () {
                            var matterSearchTable_ = $('#olTblMatterSearchTable');
                            var mNumber_ = ($('#olMatterSearchType').val() == 'mNumber');

                            matterSearchTable_.find('tbody tr').each(function () {
                                if ($(this).attr('id') != 'olTableZeroRecords') {
                                    $(this).remove();
                                }
                            });

                            var matterDetails_ = olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.MatterDetails;
                            if (olFunctions.IsFilledArray(matterDetails_)) {
                                $('#olTableZeroRecords').css('cssText', 'display: none !important');

                                for (var i = 0; i < matterDetails_.length; i++) {
                                    var tableRow_ = $(document.createElement('tr'));
                                    var tableFirstColumn_ = $(document.createElement('td')).addClass('ol-first-cell');
                                    var tableSecondColumn_ = $(document.createElement('td')).addClass('ol-second-cell');

                                    if (i % 2 == 0) {
                                        tableRow_.addClass('ol-table-even-row');
                                    } else {
                                        tableRow_.addClass('ol-table-odd-row');
                                    }

                                    var matterNumber_ = olPage.Content.Divs._internal.CreateLabels(matterDetails_[i].MatterNumber);
                                    var matterName_ = olPage.Content.Divs._internal.CreateLabels(matterDetails_[i].MatterName);

                                    if (mNumber_) {
                                        tableFirstColumn_.text(matterNumber_.Text);
                                        tableFirstColumn_.attr('olValue', matterNumber_.Title);
                                        tableSecondColumn_.text(matterName_.Text);
                                        tableSecondColumn_.attr('olValue', matterName_.Title);

                                        if (matterNumber_.Title != matterNumber_.Text) {
                                            tableFirstColumn_.attr('title', matterNumber_.Title);
                                        }

                                        if (matterName_.Title != matterName_.Text) {
                                            tableSecondColumn_.attr('title', matterName_.Title);
                                        }
                                    } else {
                                        tableFirstColumn_.text(matterName_.Title);
                                        tableFirstColumn_.attr('olValue', matterName_.Title);
                                        tableSecondColumn_.text(matterNumber_.Title);
                                        tableSecondColumn_.attr('olValue', matterNumber_.Title);

                                        tableFirstColumn_.text(matterName_.Text);
                                        if (matterName_.Title != matterName_.Text) {
                                            tableFirstColumn_.attr('title', matterName_.Title);
                                        }
                                        tableSecondColumn_.text(matterNumber_.Text);
                                        if (matterNumber_.Title != matterNumber_.Text) {
                                            tableSecondColumn_.attr('title', matterNumber_.Title);
                                        }
                                    }

                                    tableRow_.append(tableFirstColumn_);
                                    tableRow_.append(tableSecondColumn_);
                                    matterSearchTable_.append(tableRow_);

                                    // $('.ol-first-cell').css('cssText', 'border-radius: 5px !important;                                    border-left-width: 5px !important;                                    border-left-style: solid !important;');

                                }
                            } else {
                                $('#olTableZeroRecords').css('cssText', 'display: table-row !important');
                            }

                            $('.ol-first-cell').addClass('ol-first-cell-css');
                            $('.ol-second-cell').addClass('ol-second-cell-css');

                            matterSearchTable_.find('td').each(function () {
                                olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                            });
                        },
                        CreateSearchTable: function (checkMatterResponse) {
                            try {
                                olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_ = checkMatterResponse;

                                var mNumber_ = ($('#olMatterSearchType').val() == 'mNumber');

                                var firstColumnName_ = $('#olFirstColumnName');
                                var secondColumnName_ = $('#olSecondColumnName');
                                if (!firstColumnName_.data('olSort')) {
                                    firstColumnName_.data('olSort', 'asc');
                                    secondColumnName_.data('olSort', 'unsorted');
                                }
                                var firstIconClass_, secondIconClass_;
                                switch (firstColumnName_.data('olSort')) {
                                    case 'asc':
                                        firstIconClass_ = '.ol-down-arrow';
                                        break;
                                    case 'desc':
                                        firstIconClass_ = '.ol-up-arrow';
                                        break;
                                    case 'unsorted':
                                        firstIconClass_ = '.ol-double-arrow';
                                        break;
                                };
                                switch (secondColumnName_.data('olSort')) {
                                    case 'asc':
                                        secondIconClass_ = '.ol-down-arrow';
                                        break;
                                    case 'desc':
                                        secondIconClass_ = '.ol-up-arrow';
                                        break;
                                    case 'unsorted':
                                        secondIconClass_ = '.ol-double-arrow';
                                        break;
                                };

                                firstColumnName_.find('.ol-down-arrow, .ol-up-arrow, .ol-double-arrow').hide();
                                secondColumnName_.find('.ol-down-arrow, .ol-up-arrow, .ol-double-arrow').hide();

                                firstColumnName_.find(firstIconClass_).show();
                                secondColumnName_.find(secondIconClass_).show();

                                if (mNumber_) {
                                    $('#olFirstColumnNameTitle').text(olPage.Functions.GetLanguageItem('JS_MatterNumberLabel'));
                                    $('#olSecondColumnNameTitle').text(olPage.Functions.GetLanguageItem('JS_MatterNameLabel'));
                                } else {
                                    $('#olFirstColumnNameTitle').text(olPage.Functions.GetLanguageItem('JS_MatterNameLabel'));
                                    $('#olSecondColumnNameTitle').text(olPage.Functions.GetLanguageItem('JS_MatterNumberLabel'));
                                }
                                //Scroll section
                                if (!olPage.Content.Divs._internal.PromptMatterSearch._internal.RequestPageNumberSpecified) {
                                    if (olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.PageCount == 0) {
                                        $('#olMatterSearchPage').text(0);
                                    } else {
                                        $('#olMatterSearchPage').text(1);
                                    }
                                    if (olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.PageCount > 1) {
                                        $('#olMatterSearchFakeScrContent').css('width', 100 * olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.PageCount + '%');
                                        $('#olMatterSearchScr').show();
                                    } else {
                                        $('#olMatterSearchScr').hide();
                                    }
                                }

                                olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTotal = olPage.Content.Divs._internal.PromptMatterSearch._internal.checkMatterResponse_.PageCount;
                                $("#olMatterSearchPageTotal").text(olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTotal);

                                olPage.Content.Divs._internal.PromptMatterSearch._internal.SortTableElements();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CreateSearchTable', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Request: function (pageNumberSpecified) {
                            try {
                                var value_ = $('#olMatterSearchInp').val();
                                if (value_ && value_ != '') {
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.RequestPageNumberSpecified = pageNumberSpecified;
                                    var searchType_;
                                    searchType_ = $('#olMatterSearchType').val();

                                    var parameters_ = {};
                                    switch (searchType_) {
                                        case 'mNumber':
                                            parameters_.MatterNumber = value_;
                                            parameters_.MatterName = null;
                                            break;
                                        case 'mName':
                                            parameters_.MatterNumber = null;
                                            parameters_.MatterName = value_;
                                            break;
                                    }
                                    if ($('#olMatterSearchPage').text() != '') {
                                        parameters_.PageNumber = parseInt($('#olMatterSearchPage').text());
                                    } else {
                                        parameters_.PageNumber = 1;
                                    }
                                    parameters_.PageNumberSpecified = olPage.Content.Divs._internal.PromptMatterSearch._internal.RequestPageNumberSpecified;

                                    olPage.Messages.CheckMatterGlobalRequest(parameters_);
                                } else {
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.ClearSearchTable();
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Request', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        StartInputTimer: function () {
                            try {
                                $('#olMatterSearchInp').idleTimer(250);
                                $('#olMatterSearchInp').off('idle.idleTimer');
                                $('#olMatterSearchInp').on('idle.idleTimer', function () {
                                    $('#olMatterSearchInp').idleTimer('destroy');
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.InputTimerStarted = false;
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.Request(false);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('StartInputTimer', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        StartPageTimer: function () {
                            try {
                                $('#olMatterSearchPage').idleTimer(250);
                                $('#olMatterSearchPage').off('idle.idleTimer');
                                $('#olMatterSearchPage').on('idle.idleTimer', function () {
                                    $('#olMatterSearchPage').idleTimer('destroy');
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTimerStarted = false;
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.Request(true);
                                });
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('StartPageTimer', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        SearchInp_onChange: function () {
                            $('#olMatterSearchInp').off('input');
                            $('#olMatterSearchInp').on('input', function (event) {
                                try {
                                    if (!olPage.Content.Divs._internal.PromptMatterSearch._internal.InputTimerStarted) {
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.InputTimerStarted = true;
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.StartInputTimer();
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('SearchInp_onChange', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        SearchPageChange: function () {
                            try {
                                if (!olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTimerStarted) {
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTimerStarted = true;
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.StartPageTimer();
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('SearchPageChange', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Cancel_onClick: function () {
                            $('#olImgMatterSearchCancel').off('click');
                            $('#olImgMatterSearchCancel').on('click', function (event) {
                                event.stopPropagation();
                                try {
                                    olPage.Content.Divs.Close.PromptMatterSearch(true);
                                    olPage.Content.Divs.Load.PromptMatter(true);
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Cancel_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Scroll: function () {
                            $('#olMatterSearchScr').scroll(function (eventObject) {
                                try {
                                    var width_ = $('#olMatterSearchFakeScrContent').width();
                                    var left_ = $('#olMatterSearchScr').scrollLeft();
                                    var pageTotal_ = olPage.Content.Divs._internal.PromptMatterSearch._internal.PageTotal;

                                    var pageWidth_ = width_ / pageTotal_;
                                    var pageNumber_ = Math.round(left_ / pageWidth_ + 1);
                                    var currentPageNumber_ = $('#olMatterSearchPage').text();

                                    if (currentPageNumber_ != pageNumber_) {
                                        $('#olMatterSearchPage').text(pageNumber_);
                                        olPage.Content.Divs._internal.PromptMatterSearch.Events.SearchPageChange();
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Scroll', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        MatterSearchType_onClick: function () {
                            $('#olMatterSearchByNumber, #olMatterSearchByName')
                                .off('click')
                                .on('click', function (event) {
                                    $('.ol-active').removeClass('ol-active');
                                    var clickedItem_ = $(event.target);

                                    if (!clickedItem_.attr('setValue')) {
                                        var parentList_ = clickedItem_.parents();
                                        for (var i = 0; i < parentList_.length; i++) {
                                            if ($(parentList_[i]).hasClass('ol-svg')) {
                                                clickedItem_ = parentList_[i];
                                                break;
                                            }
                                        }
                                    }

                                    $(clickedItem_).addClass('ol-active');
                                    var setValue_ = $(clickedItem_).attr('setValue');
                                    var title_ = $(clickedItem_).attr('title');
                                    $('#olMatterSearchType').val(setValue_);
                                    $('#olDivMatterSearch label').text(title_);
                                    olPage.Content.Divs._internal.PromptMatterSearch._internal.Request(false);
                                    $('#olMatterSearchInp').select().focus();
                                });
                        },
                        TableElements_onClick: function () {
                            var searchTable_ = $('#olTblMatterSearchTable');
                            var mNumber_ = ($('#olMatterSearchType').val() == 'mNumber');

                            //Headers events
                            $('#olFirstColumnName, #olSecondColumnName').each(function () {
                                var th = $(this);

                                th.off('click');
                                th.on('click', function () {
                                    try {
                                        var secondTh;
                                        if (th.attr('id') == 'olFirstColumnName') {
                                            secondTh = $('#olSecondColumnName');
                                        } else {
                                            secondTh = $('#olFirstColumnName');
                                        }
                                        secondTh.data('olSort', 'unsorted');
                                        // secondTh.find('span').removeClass('ol-up-arrow ol-down-arrow').addClass('ol-double-arrow');
                                        secondTh.find('.ol-up-arrow, .ol-down-arrow').hide();
                                        secondTh.find('.ol-double-arrow').show();

                                        if (th.data('olSort') != 'asc') {
                                            // sort ascending
                                            th.data('olSort', 'asc');
                                            // th.find('span').removeClass('ol-double-arrow ol-up-arrow').addClass('ol-down-arrow');
                                            th.find('.ol-double-arrow, .ol-up-arrow').hide();
                                            th.find('.ol-down-arrow').show();
                                        } else {
                                            // sort descending
                                            th.data('olSort', 'desc');
                                            th.find('.ol-double-arrow, .ol-down-arrow').hide();
                                            th.find('.ol-up-arrow').show();
                                        }

                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.SortTableElements();
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('TableElements_onClick', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                });
                            });

                            //Row events
                            searchTable_.find('tbody tr').off('click');
                            searchTable_.find('tbody tr').on('click', function () {
                                if ($(this).attr('id') != 'ol-table-zero-records') {
                                    if (mNumber_) {
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterNumber = $(this).find('.ol-first-cell').attr('olValue');
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterName = $(this).find('.ol-second-cell').attr('olValue');
                                    } else {
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterName = $(this).find('.ol-first-cell').attr('olValue');
                                        olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterNumber = $(this).find('.ol-second-cell').attr('olValue');
                                    }
                                    olPage.Content.Divs.Close.PromptMatterSearch(true);
                                    olPage.Content.Divs.Load.PromptMatter(true, true);
                                } else {
                                    olPage.Content.Divs.Close.PromptMatterSearch(true);
                                    olPage.Content.Divs.Load.PromptMatter(true);
                                }
                            });
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.PromptMatterSearch.Events.SearchInp_onChange();
                            olPage.Content.Divs._internal.PromptMatterSearch.Events.MatterSearchType_onClick();
                            olPage.Content.Divs._internal.PromptMatterSearch.Events.Cancel_onClick();
                            olPage.Content.Divs._internal.PromptMatterSearch.Events.Scroll();
                            // table events have to be inside CreateSearchTable
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Initialize: function () {
                        // $('#olMatterSearchInp').val(olPage.Functions.GetLanguageItem('JS_Search'));
                        // $('#olMatterSearchInp').addClass('olFontSmall olFontGray');
                    }
                },
                AskToStorePassword: {
                    _internal: {
                        _previousPrompt: '',
                        _previousMask: false
                    },
                    Events: {
                        _internal: {
                            buttonClick: function (storePassword, neverStore) {
                                var parameters_ = {
                                    ApplicationSessionId: olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId,
                                    Store: storePassword,
                                    NeverStore: neverStore ? neverStore : false
                                };

                                if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                    olPage.Messages.StorePasswordSharedRequest(parameters_);
                                } else {
                                    olPage.Messages.StorePasswordRequest(parameters_);
                                }

                                olPage.Content.Divs.Close.AskToStorePassword(false);

                                olPage.Content.Modules.FinishedPasswordManagement();
                            }
                        },
                        Cancel_onClick: function () {
                            $('#olASPImgStorePasswordCancel').off('click');
                            $('#olASPImgStorePasswordCancel').on('click', function (event) {
                                olPage.Content.Divs._internal.AskToStorePassword.Events._internal.buttonClick(false);
                            });
                        },
                        No_onClick: function () {
                            $('#olStorePasswordNo').off('click');
                            $('#olStorePasswordNo').on('click', function (event) {
                                olPage.Content.Divs._internal.AskToStorePassword.Events._internal.buttonClick(false, $('#olChkboxNoNeverShow').is(":checked"));
                                olPage.Content.Inject();
                            });
                        },
                        NoNeverChkBox_onClick: function () {
                            $('#olChkboxNoNeverShow').off('click');
                            $('#olChkboxNoNeverShow').on('click', function (event) {
                                if ($('#olChkboxNoNeverShow').is(":checked")) {
                                    $('#olStorePasswordYes').attr('disabled', 'disabled')
                                } else {
                                    $('#olStorePasswordYes').removeAttr('disabled')
                                }
                            });
                        },
                        Yes_onClick: function () {
                            $('#olStorePasswordYes').off('click');
                            $('#olStorePasswordYes').on('click', function (event) {
                                olPage.Data.PageFlags.IsNewPassword = false;
                                olPage.Content._internal.AskToStorePasswordAppended = false;
                                olPage.Content.Divs._internal.AskToStorePassword.Events._internal.buttonClick(true);

                                var variableReplacement_;
                                var bnr0_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];

                                if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                    var spr_ = olPage.Data.PageInfo.Response.SharedPasswordsResponse.SharedPasswordsUser;
                                    variableReplacement_ = spr_.VariableReplacement;

                                    //copy automatic value from bnr0_.VariableReplacement to olPage.Data.PageInfo.Response.SharedPasswordsResponse.SharedPasswordsUser.VariableReplacement

                                    for (var i = 0; i < bnr0_.VariableReplacement.Variables.length; i++) {
                                        if (bnr0_.VariableReplacement.Variables[i].IsPersonal || olPage.Data.PageFlags.PmtAutomatic) {
                                            if (bnr0_.VariableReplacement.Variables[i].AutomaticValue) {

                                                spr_.VariableReplacement.Variables[i].AutomaticValue = bnr0_.VariableReplacement.Variables[i].AutomaticValue;
                                            }
                                        }
                                    }
                                } else {
                                    variableReplacement_ = bnr0_.VariableReplacement;

                                    if (!olFunctions.IsFilledArray(variableReplacement_.PersonalDetail)) {
                                        variableReplacement_.PersonalDetail = [];
                                    }

                                    if (olFunctions.IsFilledArray(variableReplacement_.PersonalDetail) && variableReplacement_.PersonalDetail.length == 1 && variableReplacement_.PersonalDetail[0].Id == 'tmpId') {
                                        variableReplacement_.PersonalDetail = [];
                                    }

                                    if (!olFunctions.IsFilledArray(variableReplacement_.PersonalDetail)) {
                                        variableReplacement_.PersonalDetail = [{
                                            Id: 'newId', //To have the same structure as request result
                                            Name: 'newName',//To have the same structure as request result
                                            Variables: [
                                                {
                                                    DefinedName: 'username',
                                                    Label: 'Username',
                                                    Value: null
                                                },
                                                {
                                                    DefinedName: 'password',
                                                    Label: 'Password',
                                                    Value: null
                                                }
                                            ],
                                        }];
                                    }
                                }

                                if (olPage.Data.LocalPageFlags.UsingSharedPasswords) {
                                    //only pass can be changed for shared user
                                    //olPage.Data.PageInfo.DefinedNames.PasswordArray

                                    for (var i = 0; i < variableReplacement_.Variables.length; i++) {
                                        if (variableReplacement_.Variables[i].IsPersonal || olPage.Data.PageFlags.PmtAutomatic) {
                                            if (variableReplacement_.Variables[i].AutomaticValue && $.inArray(String(variableReplacement_.Variables[i].DefinedName), olPage.Data.PageInfo.DefinedNames.PasswordArray) > -1) {
                                                variableReplacement_.Variables[i].Value = variableReplacement_.Variables[i].AutomaticValue;

                                                //values we are storing into sbr variables
                                                //also had to be stored into bnr0 variables 
                                                //cause injection is looking at that object
                                                bnr0_.VariableReplacement.Variables[i].Value = variableReplacement_.Variables[i].AutomaticValue;

                                                for (var j = 0; j < variableReplacement_.PersonalDetail.length; j++) {
                                                    var personalDetail_ = $.grep(variableReplacement_.PersonalDetail[j].Variables, function (member) {
                                                        // return (member.DefinedName == variableReplacement_.Variables[i].DefinedName);
                                                        return ($.inArray(String(member.DefinedName).toLowerCase(), olPage.Data.PageInfo.DefinedNames.PasswordArray) > -1)
                                                    })
                                                    if (personalDetail_.length) {
                                                        personalDetail_[0].Value = variableReplacement_.Variables[i].AutomaticValue
                                                    }
                                                }
                                            }
                                        }
                                    }
                                } else {
                                    for (var i = 0; i < variableReplacement_.Variables.length; i++) {
                                        if (variableReplacement_.Variables[i].IsPersonal || olPage.Data.PageFlags.PmtAutomatic) {
                                            if (variableReplacement_.Variables[i].AutomaticValue) {
                                                variableReplacement_.Variables[i].Value = variableReplacement_.Variables[i].AutomaticValue;

                                                for (var j = 0; j < variableReplacement_.PersonalDetail.length; j++) {
                                                    var personalDetail_ = $.grep(variableReplacement_.PersonalDetail[j].Variables, function (member) {
                                                        return (member.DefinedName == variableReplacement_.Variables[i].DefinedName);
                                                    })
                                                    if (personalDetail_.length) {
                                                        personalDetail_[0].Value = variableReplacement_.Variables[i].AutomaticValue
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }

                                olPage.Content.Inject();

                                // share changes with all tabs
                                var alertContent_ = new olFunctions.AlertContent('Yes_onClick UpdateResponse');
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                olPage.Messages.UpdateResponse();
                            });
                        }
                    },
                    BindEvents: function () {
                        olPage.Content.Divs._internal.AskToStorePassword.Events.Cancel_onClick();
                        olPage.Content.Divs._internal.AskToStorePassword.Events.Yes_onClick();
                        olPage.Content.Divs._internal.AskToStorePassword.Events.No_onClick();
                        olPage.Content.Divs._internal.AskToStorePassword.Events.NoNeverChkBox_onClick();
                    }
                },
                ResourceTimeout: {
                    _internal: {
                        _previousPrompt: '',
                        _previousMask: false,
                        ApplicationSessionId: null,
                        ApplicationName: null,
                        ResourceTimeoutText: null,
                        originalPageTitle: null,
                        _blink: function () {
                            if (document.title == olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName) {
                                document.title = olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutText;
                            } else {
                                document.title = olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName;
                            }
                        },
                        ClearTitle: function () {
                            document.title = olPage.Content.Divs._internal.ResourceTimeout._internal.originalPageTitle;
                        },
                        Yes_onClick: function () {
                            olPage.Content.Divs.Close.ResourceTimeout(false);

                            var closeTab_ = false;
                            if (olPage.Data.PageInfo && olPage.Data.PageInfo.Response && olPage.Data.PageInfo.Response.BeforeNavigateResponses && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0] && olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ApplicationsSessionId == olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationSessionId) {
                                //inactivity, we are on resource so... close tab
                                closeTab_ = true;
                            }

                            var sessionInfo_ = {
                                ApplicationSessionId: olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationSessionId,
                                ApplicationName: olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName,
                                CloseTab: closeTab_
                            };
                            olPage.Messages.QuittingResourceSessionRequest(sessionInfo_);
                        },
                        No_onClick: function () {
                            olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime = null;
                            olPage.Content.Divs._internal.ResourceTimeout._internal.ClearTitle();
                            olPage.Content.Divs.Close.ResourceTimeout(false);

                            var sessionInfo_ = {
                                ApplicationSessionId: olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationSessionId,
                                ApplicationName: olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName
                            };
                            olPage.Messages.ContinueSessionRequest(sessionInfo_);
                        },
                        timeoutInfoText_: null,
                        ResourceTimeoutStartTime: null,
                        Timer: function () {
                            try {
                                if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olResourceTimeout') {
                                    var now_ = new Date().getTime();
                                    //Rounded in seconds
                                    now_ = Math.floor(now_ / 1000);

                                    var timeResourceTimeoutStarted_;
                                    try {
                                        if (olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime) {
                                            timeResourceTimeoutStarted_ = olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime
                                        } else {
                                            timeResourceTimeoutStarted_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ResourceTimeoutStartTime;
                                        }
                                    } catch {
                                        olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime = now_;

                                        timeResourceTimeoutStarted_ = now_;
                                    }

                                    var counterInSecs_ = 60 - (now_ - timeResourceTimeoutStarted_);

                                    if (counterInSecs_ >= 0) {
                                        if (!olPage.Content.Divs._internal.ResourceTimeout._internal.timeoutInfoText_) {
                                            olPage.Content.Divs._internal.ResourceTimeout._internal.timeoutInfoText_ = $('#olTimeoutInfoText').text();
                                        }
                                        var infoText_ = String(olPage.Content.Divs._internal.ResourceTimeout._internal.timeoutInfoText_);
                                        infoText_ = infoText_.replace('{rep1}', counterInSecs_);
                                        $('#olTimeoutInfoText').text(infoText_);

                                        olPage.Content.Divs._internal.ResourceTimeout._internal._blink();

                                        setTimeout(function () {
                                            olPage.Content.Divs._internal.ResourceTimeout._internal.Timer();
                                        }, 1000);
                                    } else {
                                        olPage.Content.Divs._internal.ResourceTimeout._internal.Yes_onClick();
                                    }
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Resource timeout Timer', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                    },
                    Events: {
                        No_onClick: function () {
                            $('#olResourceNo').off('click');
                            $('#olResourceNo').on('click', function () {
                                olPage.Content.Divs._internal.ResourceTimeout._internal.No_onClick();
                            });
                        },
                        Yes_onClick: function () {
                            $('#olResourceYes').off('click');
                            $('#olResourceYes').on('click', function (event) {
                                olPage.Content.Divs._internal.ResourceTimeout._internal.Yes_onClick();
                            });
                        }
                    },
                    BindEvents: function () {
                        olPage.Content.Divs._internal.ResourceTimeout.Events.No_onClick();
                        olPage.Content.Divs._internal.ResourceTimeout.Events.Yes_onClick();
                    }
                },
                Error: {
                    Events: {
                        OK_onClick: function () {
                            $('#olErrorOK').off('click');
                            $('#olErrorOK').on('click', function (event) {
                                event.stopPropagation();
                                location.reload();
                            });
                        }
                    },
                    BindEvents: function () {
                        olPage.Content.Divs._internal.Error.Events.OK_onClick();
                    }
                },
                Toolbar: {
                    _internal: {
                        MenuOpened: false,
                        ChromeInvertedTime: null,
                        CurrentPrompt: '',
                        CloseCurrentPrompt: function (mask) {
                            try {
                                switch (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt) {
                                    case 'olPromptMatter':
                                        olPage.Content.Divs.Close.PromptMatter(mask);
                                        break;
                                    case 'olPromptMatterSearch':
                                        olPage.Content.Divs.Close.PromptMatterSearch(mask);
                                        break;
                                    case 'olPromptLogon':
                                        olPage.Content.Divs.Close.PromptLogon(mask);
                                        break;
                                    case 'olPromptLogonDetails':
                                        olPage.Content.Divs.Close.PromptLogonDetails(mask);
                                        break;
                                    case 'olPromptChooseApplication':
                                        olPage.Content.Divs.Close.PromptChooseApplication(mask);
                                        break;
                                    case 'olPromptChooseSharedUserToUsePasswordsFrom':
                                        olPage.Content.Divs.Close.PromptChooseSharedUserToUsePasswordsFrom(mask);
                                        break;
                                    case 'olResourceTimeout':
                                        olPage.Content.Divs.Close.ResourceTimeout(mask);
                                        break;
                                    case 'olPromptComment':
                                        olPage.Content.Divs.Close.PromptComment(mask);
                                        break;
                                    case 'olPromptLicenceLimitReached':
                                        olPage.Content.Divs.Close.PromptLicenceLimitReached(mask);
                                        break;
                                    case 'olWebControlMessage':
                                        olPage.Content.Divs.Close.WebControlMessage(mask);
                                        break;
                                    case 'olError':
                                        olPage.Content.Divs.Close.Error(mask);
                                        break;
                                    case 'olStorePassword':
                                        olPage.Content.Divs.Close.AskToStorePassword(mask);
                                        break;
                                    default:
                                        olPage.Content.Divs._internal.SetMask(mask);
                                        break;
                                }

                                olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt = '';
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('CloseCurrentPrompt', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        SetTooltip: function () {
                            var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                            var toolTip_ = $.trim(olPage.Data.ApplicationName);

                            if (beforeNavigateResponse_.ShowActiveMatterNumberSpecified && beforeNavigateResponse_.ShowActiveMatterNumber && olPage.Data.PageFlags.MatterNumber) {
                                toolTip_ = toolTip_ + ' ' + olPage.Data.PageFlags.MatterNumber;
                            }

                            // if (toolTip_ && toolTip_ != '') {
                            //     olPage.Content.Divs._internal.Toolbar._internal.SetTooltip(toolTip_);
                            // } else {
                            //     olPage.Content.Divs._internal.Toolbar._internal.SetTooltip('Onelog');
                            // }


                            $('#olToolbarIcon').attr('title', toolTip_ ? toolTip_ : 'Onelog');
                            $('#olToolbarIcon').data('titleVal', toolTip_ ? toolTip_ : 'Onelog');
                            // $('#olToolbarIcon').attr('title', toolTip);
                            // $('#olToolbarIcon').data('titleVal', toolTip);
                        },
                        Timer: function () {
                            try {
                                if (olPage.Data.PageInfo) {
                                    var bnr0_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
                                    var dt_ = new Date();
                                    dt_ = dt_.getTime();

                                    if (!olPage.Data.StartTime) {
                                        var st_ = new Date(bnr0_.StartTime);
                                        // IE compatibility issue
                                        // resource: http://www.beck.de/  (link )
                                        if (isNaN(st_)) {
                                            var st_ = new Date(olPage.Functions.DateFromISO8601(bnr0_.StartTime));
                                        }
                                        olPage.Data.StartTime = st_.getTime();
                                    }

                                    var now_ = dt_ - olPage.Data.StartTime;
                                    if (bnr0_.PauseDuration) {
                                        now_ = now_ - bnr0_.PauseDuration * 1000;
                                    }

                                    // patching chrome date issue
                                    if (now_ < 0) {
                                        if (!olPage.Content.Divs._internal.Toolbar._internal.ChromeInvertedTime) {
                                            olPage.Content.Divs._internal.Toolbar._internal.ChromeInvertedTime = Math.abs(now_);
                                        }
                                        now_ = olPage.Content.Divs._internal.Toolbar._internal.ChromeInvertedTime + now_;
                                    }

                                    var hour_ = Math.floor(now_ / 3600000);
                                    now_ = now_ % 3600000;
                                    var min_ = Math.floor(now_ / 60000);
                                    now_ = now_ % 60000;
                                    var sec_ = Math.floor(now_ / 1000);

                                    if (min_ <= 9) {
                                        min_ = '0' + min_;
                                    }
                                    if (sec_ <= 9) {
                                        sec_ = '0' + sec_;
                                    }
                                    if (hour_ <= 9) {
                                        hour_ = '0' + hour_;
                                    }
                                    $('#olToolbarTimer').text(hour_ + ':' + min_ + ':' + sec_ + ' ');
                                }
                                setTimeout(function () {
                                    olPage.Content.Divs._internal.Toolbar._internal.Timer();
                                }, 1000);
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Timer', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        TurnAllMenuButtonsOff: function () {
                            try {
                                $('#olToolbar .olSelectableMenuSelected').removeClass('olSelectableMenuSelected');
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('TurnAllMenuButtonsOff', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        ToolbarIconsSetDisabled: function (DisabledEnabled) {
                            try {
                                $('#olToolbarIcon').attr('disabled', DisabledEnabled);
                                $('#olToolbarRefresh').attr('disabled', DisabledEnabled);
                                $('#olToolbarShare').attr('disabled', DisabledEnabled);
                                olPage.Content.Divs._internal.ChangeImageSources();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('DisableToolbarIcons', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                    },
                    Events: {
                        Close_onClick: function () {
                            $('#olToolbarClose').off('click');
                            $('#olToolbarClose').on('click', function (event) {
                                event.stopImmediatePropagation();
                                event.preventDefault();
                                event.stopPropagation();
                                olPage.Content.Divs.Load._toolbarClosed = true;
                                olPage.Functions.HideToolbar();
                                olPage.Data.PageFlags.ToolbarMinimized = false;
                                var alertContent_ = new olFunctions.AlertContent('Close_onClick UpdateResponse');
                                olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                olPage.Messages.UpdateResponse();
                            });
                        },
                        Icon_onClick: function () {
                            $('#olToolbarIcon').off('click');
                            $('#olToolbarIcon').on('click', function (event) {
                                event.stopImmediatePropagation();
                                event.preventDefault();
                                event.stopPropagation();
                                try {
                                    olPage.Content._internal.SetToolbarMenuVisibility();

                                    var somethingVisible_ = (!($('#olToolbarMenuLogon').css('display') == 'none') || !($('#olToolbarMenuMatter').css('display') == 'none') || !($('#olToolbarMenuShareMyDetails').css('display') == 'none') || !($('#olToolbarMenuUseSharedDetails').css('display') == 'none'));
                                    if ((
                                        olPage.Data.PageFlags.MatterNeeded
                                        || olPage.Data.PageFlags.LogonNeeded
                                        || olPage.Data.PageFlags.LogonCommonNeeded
                                        || olPage.Data.PageFlags.LogonSharingDetailsPossible
                                        || olPage.Data.PageFlags.LogonUsingSharedDetailsPossible
                                    )
                                        && somethingVisible_) {
                                        $('#olToolbarMenu').toggle(olOptions.General.Page.TransitionTime());
                                        olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = !olPage.Content.Divs._internal.Toolbar._internal.MenuOpened;
                                        if (!olPage.Content.Divs._internal.Toolbar._internal.MenuOpened) {
                                            olPage.Content.Divs._internal.Toolbar.ResetMenu();
                                            $('#olToolbarIcon').attr('title', $('#olToolbarIcon').data('titleVal'));
                                        } else {
                                            $('#olToolbarIcon').attr('title', '');
                                        }
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Icon_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        Maximize_onClick: function () {
                            $('.left-side-max, .right-side-max').each(function () {
                                $(this).off('click');
                                $(this).on('click', function (event) {
                                    event.preventDefault();
                                    event.stopPropagation();
                                    try {
                                        $('#olToolbarMinimized').fadeOut(olOptions.General.Page.TransitionTime(), function () {
                                            switch (olOptions.General.Page.ToolbarWidth()) {
                                                case 0:
                                                    break;
                                                case 1:
                                                    $('#olToolbar').css({
                                                        width: '99%'
                                                    });
                                                    break;
                                            }
                                            $('#olToolbarMaximized').fadeIn(olOptions.General.Page.TransitionTime());
                                        });

                                        olPage.Data.PageFlags.ToolbarMinimized = false;
                                        var alertContent_ = new olFunctions.AlertContent('Maximize_onClick UpdateResponse');
                                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                        olPage.Messages.UpdateResponse();
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('Maximize_onClick', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                });
                            });
                        },
                        Minimize_onClick: function () {
                            $('.left-side-min, .right-side-min').each(function () {
                                $(this).off('click');
                                $(this).on('click', function (event) {
                                    event.preventDefault();
                                    event.stopPropagation();
                                    try {
                                        $('#olToolbarMaximized').fadeOut(olOptions.General.Page.TransitionTime(), function () {
                                            $('#olToolbarMinimized').fadeIn(olOptions.General.Page.TransitionTime());
                                        });

                                        olPage.Data.PageFlags.ToolbarMinimized = true;
                                        var alertContent_ = new olFunctions.AlertContent('Minimize_onClick UpdateResponse');
                                        olFunctions.Alert(olOptions.DebugApiMess(), alertContent_, 'apimessevent');

                                        olPage.Messages.UpdateResponse();
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('Minimize_onClick', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                });
                            });
                        },
                        MenuButton_onClick: function () {
                            $('.olSelectableMenu').off('click');
                            $('.olSelectableMenu').on('click', function () {
                                try {
                                    if ($(this).hasClass('olSelectableMenuSelected')) {
                                        olPage.Content.Divs._internal.Toolbar._internal.TurnAllMenuButtonsOff();
                                    } else {
                                        olPage.Content.Divs._internal.Toolbar._internal.TurnAllMenuButtonsOff();
                                        $(this).addClass('olSelectableMenuSelected');
                                    }
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('MenuButton_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        MenuMatterClicked_: false,
                        MenuMatter_onClick: function () {
                            $('#olToolbarMenuMatter').off('click');
                            $('#olToolbarMenuMatter').on('click', function () {
                                if (!olPage.Content.Divs._internal.Toolbar.Events.MenuMatterClicked_) {
                                    olPage.Content.Divs._internal.Toolbar.Events.MenuMatterClicked_ = true;
                                    try {
                                        olInjection.ElementValue._internal.ElementValueSet = false;
                                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == '') {
                                            olPage.Content.Divs.Load.PromptMatter(true);
                                        } else {
                                            if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptMatter' && olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptMatterSearch' && olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptComment') {
                                                olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(true);
                                                olPage.Content.Divs.Load.PromptMatter(true);
                                            } else {
                                                olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                                            }
                                        }
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('MenuMatter_onClick', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                    setTimeout(function () {
                                        olPage.Content.Divs._internal.Toolbar.Events.MenuMatterClicked_ = false;
                                    }, 200);
                                }
                            });
                        },
                        MenuLogonClicked_: false,
                        MenuLogon_onClick: function () {
                            $('#olToolbarMenuLogon').off('click');
                            $('#olToolbarMenuLogon').on('click', function () {
                                if (!$('#olToolbarMenuLogon').hasClass('ol-disabled')) {
                                    if (!olPage.Content.Divs._internal.Toolbar.Events.MenuLogonClicked_) {
                                        olPage.Content.Divs._internal.Toolbar.Events.MenuLogonClicked_ = true;
                                        try {
                                            olInjection.ElementValue._internal.ElementValueSet = false;
                                            if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == '') {
                                                olPage.Content.Divs.Load.PromptLogon(true);
                                            } else {
                                                if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptLogon' && olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptLogonDetails') {
                                                    olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(true);
                                                    olPage.Content.Divs.Load.PromptLogon(true);
                                                } else {
                                                    olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                                                }
                                            }
                                        } catch (e) {
                                            var alertErrorContent_ = new olFunctions.AlertContent('MenuLogon_onClick', e.message + '\n' + e.stack);
                                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                        }
                                        setTimeout(function () {
                                            olPage.Content.Divs._internal.Toolbar.Events.MenuLogonClicked_ = false;
                                        }, 200);
                                    }
                                }
                            });
                        },
                        MenuUseSharedDetailsClicked_: false,
                        MenuUseSharedDetails_onClick: function () {
                            $('#olToolbarMenuUseSharedDetails').off('click');
                            $('#olToolbarMenuUseSharedDetails').on('click', function (event) {
                                olPage.Content.Divs._internal.Toolbar.Events.shareOnClick_(event);
                            });
                        },
                        // MenuShareMyDetailsClicked_: false,
                        MenuShareMyDetails_onClick: function () {
                            $('#olToolbarMenuShareMyDetails').off('click');
                            $('#olToolbarMenuShareMyDetails').on('click', function () {
                                if (!$('#olToolbarMenuShareMyDetails').hasClass('ol-disabled')) {
                                    window.open(olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].SharedPasswordURL)
                                }
                            });
                        },
                        Refresh_onClick: function () {
                            $('#olToolbarRefresh').off('click');
                            $('#olToolbarRefresh').on('click', function (event) {
                                var alertContent_ = new olFunctions.AlertContent('Toolbar Inject/Refresh clicked', 'Page function');
                                olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                                event.preventDefault();
                                event.stopPropagation();
                                try {
                                    olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                                    olInjection.Parameters.ElementsWithFiredEvents = [];
                                    olInjection.ElementValue._internal.ElementValueSet = false;
                                    olPage.Content.Inject();
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('Refresh_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        },
                        shareOnClick_: function (event) {
                            event.preventDefault();
                            event.stopPropagation();
                            try {
                                olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.pageIndex = 0;
                                if (!olPage.Content.Divs._internal.Toolbar.Events.MenuUseSharedDetailsClicked_) {
                                    olPage.Content.Divs._internal.Toolbar.Events.MenuUseSharedDetailsClicked_ = true;
                                    try {
                                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == '') {
                                            olPage.Content.Divs.Load.PromptChooseSharedUserToUsePasswordsFrom(true);
                                        } else {
                                            if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olPromptChooseSharedUserToUsePasswordsFrom') {
                                                olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(true);
                                                olPage.Content.Divs.Load.PromptChooseSharedUserToUsePasswordsFrom(true);
                                            } else {
                                                olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                                            }
                                        }
                                    } catch (e) {
                                        var alertErrorContent_ = new olFunctions.AlertContent('Share_onClick', e.message + '\n' + e.stack);
                                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                    }
                                    setTimeout(function () {
                                        olPage.Content.Divs._internal.Toolbar.Events.MenuUseSharedDetailsClicked_ = false;
                                    }, 200);
                                }
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('Share_onClick', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        },
                        Share_onClick: function () {
                            $('#olToolbarShare').off('click');
                            $('#olToolbarShare ').on('click', function (event) {
                                olPage.Content.Divs._internal.Toolbar.Events.shareOnClick_(event);
                            });
                        },
                        ChangePosition_onClick: function () {
                            $('#olToolbarPositionChange').off('click');
                            $('#olToolbarPositionChange').on('click', function (event) {
                                event.preventDefault();
                                event.stopPropagation();
                                try {
                                    var newPosition_;
                                    newPosition_ = (olOptions.General.Page.ToolbarPosition() + 1) % 4;

                                    olOptions._internal.SetOptionByName('GeneralPageToolbarPosition', newPosition_);
                                    olWrap.storage.asyncSetItem('olOptions', olOptions._internal.OptionsArray);
                                    olPage.Content.Divs.Load.Toolbar(false);
                                } catch (e) {
                                    var alertErrorContent_ = new olFunctions.AlertContent('ChangePosition_onClick', e.message + '\n' + e.stack);
                                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                                }
                            });
                        }
                    },
                    _toolbarEnabled: false,
                    Disable: function () {
                        try {
                            $('#olToolbar').hide();
                            olPage.Content.Divs._internal.Toolbar._toolbarEnabled = false;
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Disable', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    Enable: function () {
                        try {
                            if (!WebControl._pageBlocked) {
                                $('#olToolbarContainer').show();
                                $('#olToolbar').show();
                            }
                            olPage.Content.Divs._internal.Toolbar._toolbarEnabled = true;
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Enable', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    _initialized: false,
                    Initialize: function (toolbarEnabled) {
                        if (typeof (toolbarEnabled) === 'undefined') {
                            toolbarEnabled = false;
                        }

                        olPage.Content.Divs._internal.Toolbar._initialized = true;
                        try {
                            //display toolbar
                            if (olOptions.General.Page.ToolbarDisplay()) {
                                olPage.Content.Divs.Load.Toolbar(false);
                                $('#olToolbarTimer').data('ShowTimer', false);
                                if (!toolbarEnabled) {
                                    olPage.Content.Divs._internal.Toolbar.Disable();
                                }
                            }

                            $('#olToolbarMenuMatter').hide();
                            $('#olToolbarMenuLogon').hide();
                            if (olPage.Data.PageFlags.MatterNeeded) {
                                $('#olToolbarMenuMatter').show();
                            }
                            var logonData_ = olPage.Content.Divs._common.GetLogonData();
                            if ((!olPage.Data.PageFlags.PmtAdmin || logonData_.length > 1) && (olPage.Data.PageFlags.LogonNeeded || olPage.Data.PageFlags.LogonCommonNeeded) && (!olPage.Data.PageFlags.PmtAutomatic)) {
                                try {
                                    $('#olToolbarMenuLogon').show();
                                } catch (e) {
                                }
                            }

                            if (!olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].EnablePasswordSharing) {
                                olPage.Functions.Hide('#olToolbarMenuUseSharedDetails');
                            }

                            if (!olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ShowPasswordSharingLink) {
                                olPage.Functions.Hide('#olToolbarMenuShareMyDetails');
                            }

                            olPage.Content.Divs._internal.ChangeImageSources();
                            //No Forms, no FormFill, no RefreshButton
                            if (!olFunctions.IsFilledArray(olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].Forms)) {
                                olPage.Functions.Hide('#olToolbarRefresh');
                            }

                            //No Share
                            if (!olFunctions.IsFilledArray(olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].EnablePasswordSharing)) {
                                olPage.Functions.Hide('#olToolbarShare');
                            }

                            //toolbar settings
                            $('#olToolbarTimer').data('ShowTimer', olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].ShowTimeTicker);
                            if (!$('#olToolbarTimer').data('ShowTimer')) {
                                olPage.Functions.Hide('#olToolbarTimer');
                            } else {
                                olPage.Content.Divs._internal.Toolbar._internal.Timer();
                            }

                            // var toolTip_ = $.trim(olPage.Data.ApplicationName);
                            // if (toolTip_ && toolTip_ != '') {
                            //     olPage.Content.Divs._internal.Toolbar._internal.SetTooltip(toolTip_);
                            // } else {
                            //     olPage.Content.Divs._internal.Toolbar._internal.SetTooltip('Onelog');
                            // }

                            olPage.Content.Divs._internal.Toolbar._internal.SetTooltip();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('Initialize Toolbar', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    BindEvents: function () {
                        try {
                            olPage.Content.Divs._internal.Toolbar.Events.Close_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.Icon_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.Maximize_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.Minimize_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.Refresh_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.ChangePosition_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.Share_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.MenuButton_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.MenuMatter_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.MenuLogon_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.MenuUseSharedDetails_onClick();
                            olPage.Content.Divs._internal.Toolbar.Events.MenuShareMyDetails_onClick();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('BindEvents Toolbar', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    CloseMenu: function () {
                        try {
                            $('#olToolbarMenu').hide(olOptions.General.Page.TransitionTime());
                            olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('CloseMenu', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    ResetMenu: function () {
                        try {
                            olPage.Content.Divs._internal.Toolbar._internal.TurnAllMenuButtonsOff();
                            olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
                            olPage.Content.Divs._internal.Toolbar.CloseMenu();
                            $('#olToolbarIcon').attr('title', $('#olToolbarIcon').data('titleVal'));
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('ResetMenu', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                ArrayDivs: [
                    'olPrompt',
                    'olPromptMatter',
                    'olPromptMatterSearch',
                    'olPromptLogon',
                    'olPromptLogonDetails',
                    'olPromptComment',
                    'olPromptChooseSharedUserToUsePasswordsFrom',
                    'olToolbar'

                ],
                GetOptions: function () {
                    olWrap.storage.asyncGetItem('olOptions', function (data) {
                        try {
                            olOptions._internal.OptionsArray = data;

                            // olPage.Content.HtmlAppends._iconTypeSelection();
                            olPage.Content.HtmlAppends.AddMainPrompts();
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('GetOptions', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    });
                },
                ChangeImageSources: function () {
                    try {
                        var currentElement_ = $('#olToolbarIcon');
                        currentElement_.removeClass('ol-onelog-icon-color-blue');
                        currentElement_.removeClass('ol-onelog-icon-color-green');
                        currentElement_.removeClass('ol-onelog-icon-color-unauth');
                        currentElement_.removeClass('ol-onelog-icon-color-gray');

                        if (olPage.Data.PageInfo) {
                            if (olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].TurnAway) {
                                //If licence limit is reached and server is set not to record unauthorised access then set icon to grey
                                currentElement_.addClass('ol-onelog-icon-color-gray');
                                olPage.Functions.Hide('#olToolbarRefresh');
                            } else if (olPage.Data.PageFlags.Unauthorised) {
                                //Unauthorised
                                currentElement_.addClass('ol-onelog-icon-color-unauth');
                                olPage.Functions.Hide('#olToolbarRefresh');
                            } else if (olPage.Data.PageFlags && olPage.Data.PageFlags.InOfflineMode) {
                                currentElement_.addClass('ol-onelog-icon-color-green');
                            } else {
                                currentElement_.addClass('ol-onelog-icon-color-blue');
                            }
                        } else {
                            currentElement_.addClass('ol-onelog-icon-color-blue');
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('ChangeImageSources', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                CreateLabels: function (labelText) {
                    try {
                        var label_ = {
                            Text: labelText,
                            Title: labelText
                        };

                        return label_;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('CreateLabels, on label text = ' + labelText + ' labelSelector = ' + labelSelector, e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                DisableElements: function (listOfElementsIdToDisable) {
                    try {
                        olPage.Listeners._internal.Events._processingKey = true;
                        for (var i = 0; i < listOfElementsIdToDisable.length; i++) {
                            var element_ = $('#' + listOfElementsIdToDisable[i]);
                            element_
                                .attr('disabled', true)
                                .addClass('ol-disabled');
                        }
                        olPage.Content.Divs._internal.ChangeImageSources();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('DisableElements', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        olPage.Listeners._internal.Events._processingKey = false;
                    }
                },
                EnableElements: function (listOfElementsIdToEnable) {
                    try {
                        for (var i = 0; i < listOfElementsIdToEnable.length; i++) {
                            var element_ = $('#' + listOfElementsIdToEnable[i]);
                            element_
                                .attr('disabled', false)
                                .removeClass('ol-disabled');
                        }
                        olPage.Content.Divs._internal.ChangeImageSources();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('EnableElements', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                    olPage.Listeners._internal.Events._processingKey = false;
                },
                MaskOn: false,
                _maskOpacity: 0.7,
                SetMask: function (mask) {
                    try {
                        olPage.Content.Divs._internal.Modal._prepareForRendering();

                        if (WebControl._pageBlocked || mask) {
                            olPage.Content.Divs._internal.Modal._addMaxZindex();
                            if (WebControl._pageBlocked) {
                                olPage.Content.Divs._internal.Modal._$overlay.css('opacity', '0.85');
                                olPage.Content.Divs._internal.Modal._$toolbar.hide();
                            } else {
                                olPage.Content.Divs._internal.Modal._$overlay.css('opacity', olPage.Content.Divs._internal._maskOpacity);
                            }
                            if ((olPage.Data.LocalPageFlags.HasFrameset) && (!olPage.Data.FramesetRemoved)) {
                                olPage.Functions.RemoveFramesetTag(olPage.Data.HtmlFrameset);
                            }
                            olPage.Content.Divs._internal.Modal._$overlay.show();
                            $(document).trigger('olFormOpening');
                            olPage.Content.Divs._internal.MaskOn = true;
                        } else {
                            olPage.Content.Divs._internal.Modal._removeMaxZindex();
                            if ((olPage.Data.LocalPageFlags.HasFrameset) && (olPage.Data.FramesetRemoved)) {
                                olPage.Functions.InsertFramesetTag(olPage.Data.HtmlFrameset);
                            }
                            olPage.Content.Divs._internal.Modal._$overlay.hide();
                            $(document).trigger('olFormClosing');
                            olPage.Content.Divs._internal.MaskOn = false;
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('SetMask', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                UpdateDivs: function () {
                    try {
                        if (olPage.Data.PageInfo) {
                            //Prompt matter
                            $('#olNewMatter').val(olPage.Data.PageFlags.MatterNumber);
                            if (olPage.Data.PageFlags.TimekeeperNumber != null) {
                                $('#olNewTimekeeper').val(olPage.Data.PageFlags.TimekeeperNumber);
                            }
                            $('#olNewComment').val(olPage.Data.PageFlags.Comment);
                            olPage.Content.Divs._internal.PromptMatter._internal.SetMatterFlags();
                        }
                        ;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('UpdateDivs', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                }
            },
            AppendDivs: function () {
                try {
                    olPage.Content.Divs._internal.GetOptions();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('AppendDivs', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            RemoveDivs: function () {
                try {
                    var aDivs_ = olPage.Content.Divs._internal.ArrayDivs;
                    for (var i = 0; i < aDivs_.length; i++) {
                        try {
                            $('#' + aDivs_[i]).remove();
                        } catch (e) {
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('RemoveDivs', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            BindEvents: function () {
                try {
                    olPage.Content.Divs._internal.PromptComment.BindEvents();
                    olPage.Content.Divs._internal.PromptLicenceLimitReached.BindEvents();
                    olPage.Content.Divs._internal.PromptLogon.BindEvents();
                    olPage.Content.Divs._internal.PromptLogonDetails.BindEvents();
                    olPage.Content.Divs._internal.PromptMatter.BindEvents();
                    olPage.Content.Divs._internal.PromptMatterSearch.BindEvents();

                    olPage.Content.Divs._internal.Toolbar.BindEvents();
                    olPage.Content.Divs._internal.UpdateDivs();
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('BindEvents', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            _olPromptCheckInterval: null,
            _olPromptChecker: function () {
                try {
                    olPage.Content.Divs._internal.Modal._prepareForRendering();
                    if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt && $('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).css('display') != 'block') {
                        $('#' + olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt).show();
                        olPage.Content.Divs._internal.Modal.Center();
                    }

                    if (olPage.Content.Divs._internal.Toolbar._toolbarEnabled && olPage.Content.Divs.Load._toolbarLoaded && !olPage.Content.Divs.Load._toolbarClosed) {
                        olPage.Content.Divs._internal.Toolbar.Enable();
                    }

                    $('#olBackup').hide();

                    if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != '') {
                        // max z index fix
                        $('*').filter(function () {
                            if ($(this).css('z-index') >= 2147483646) {
                                if ($(this).hasClass('ol-max-z') || $(this).hasClass('ol-max-z-1') || $(this).hasClass('olInherit') || $(this).hasClass('olLogoutDivLook') || $(this).hasClass('olToolbarDivLook') || $(this).hasClass('olPromptDivLookOptions')) {
                                    //our element, do nothing
                                    return false;
                                } else {
                                    return true;
                                }
                            }
                            return false;
                        }).each(function () {
                            $(this).css('cssText', 'z-index:2147483645 !important');
                        });
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('_olPromptChecker', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
                // }
            },
            Initialize: function () {
                try {
                    //change img sources
                    olPage.Content.Divs._internal.ChangeImageSources();

                    olPage.Content.Divs._internal.PromptLicenceLimitReached.Initialize();
                    olPage.Content.Divs._internal.PromptMatter.Initialize();
                    olPage.Content.Divs._internal.PromptLogonDetails.Initialize();
                    olPage.Content.Divs._internal.PromptMatterSearch.Initialize();
                    olPage.Content.Divs._internal.Toolbar.Initialize();

                    olPage.Content.Divs._olPromptChecker();
                    olPage.Content.Divs._internal._olPromptCheckInterval = setInterval(function () {
                        olPage.Content.Divs._olPromptChecker();
                    }, 2000);

                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('Initialize Divs', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            SetInfoMsg: function (msgText, type) {
                try {
                    if (olPage.Content.Divs._internal.AlertPrompt != '') {
                        if (typeof (type) === 'undefined')
                            type = 'i';
                        var infoText_ = '';
                        if (msgText == '') {
                            msgText = infoText_;
                            type = 'h';
                        }

                        var color_ = '';
                        switch (type) {
                            case 'a':
                                //alert
                                color_ = 'red';
                                break;
                            case 'i':
                                //info
                                color_ = '#014c8e';
                                break;
                            case 'w':
                                //warning
                                color_ = 'yellow';
                                break;
                            case 'h':
                                //hidden
                                color_ = 'white';
                        }

                        var infoTextId_ = olPage.Content.Divs._internal.AlertPrompt + ' #olInfoText';
                        $('#' + infoTextId_).text(msgText);
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('SetInfoMsg', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            Load: {
                // _firstOverlay : true,
                _internal: {
                    SortMatterDetails: function (matterNumber, matterName) {
                        try {
                            //sort matterDetails
                            var matterDetails_ = olPage.Data.PageInfo.Response.CheckMatterResponse.MatterDetails;
                            var matterDetail_;
                            var matterIndex_ = -1;

                            for (var i = 0; i < matterDetails_.length; i++) {
                                if (matterDetails_[i].MatterNumber == matterNumber) {
                                    matterIndex_ = i;
                                    break;
                                }
                            }

                            if (matterIndex_ > -1) {
                                matterDetail_ = matterDetails_.splice(matterIndex_, 1)[0];
                            } else {
                                matterDetail_ = {
                                    MatterName: matterName,
                                    MatterNumber: matterNumber
                                };
                            }

                            matterDetails_.reverse();
                            matterDetails_.push(matterDetail_);
                            matterDetails_.reverse();
                            while (matterDetails_.length > 10) {
                                matterDetails_.pop();
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('SortMatterDetails', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    },
                    SortTimekeeperDetails: function () {
                        try {
                            //sort timekeeper details
                            var timekeeper_ = olPage.Data.PageFlags.TimekeeperNumber;
                            var timekeeperDetails_ = olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes;
                            var timekeeperIndex_ = -1;

                            if (timekeeper_) {
                                for (var i = 0; i < timekeeperDetails_.length; i++) {
                                    if (timekeeperDetails_[i] == timekeeper_) {
                                        timekeeperIndex_ = i;
                                        break;
                                    }
                                }

                                if (timekeeperIndex_ > -1) {
                                    timekeeperDetails_.splice(timekeeperIndex_, 1);
                                }

                                timekeeperDetails_.reverse();
                                timekeeperDetails_.push(timekeeper_);
                                timekeeperDetails_.reverse();
                                while (timekeeperDetails_.length > 10) {
                                    timekeeperDetails_.pop();
                                }
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('SortTimekeeperDetails', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptById: function (divIdToOverlay, mask) {
                    if (typeof (mask) === 'undefined')
                        mask = true;

                    try {
                        switch (divIdToOverlay) {
                            case 'olPromptLogon':
                                olPage.Content.Divs.Load.PromptLogon(mask);
                                break;
                            case 'olPromptLogonDetails':
                                olPage.Content.Divs.Load.PromptLogonDetails(mask);
                                break;
                            case 'olPromptComment':
                                olPage.Content.Divs.Load.PromptComment(mask);
                                break;
                            case 'olPromptMatterSearch':
                                olPage.Content.Divs.Load.PromptMatterSearch(mask);
                                break;
                            case 'olStorePassword':
                                olPage.Content.Divs.Load.AskToStorePassword(mask);
                                break;
                            case 'olError':
                                olPage.Content.Divs.Load.Error(mask);
                                break;
                            case 'olPromptChooseApplication':
                                olPage.Content.Divs.Load.PromptChooseApplication(mask);
                                break;
                            case 'olPromptChooseSharedUserToUsePasswordsFrom':
                                olPage.Content.Divs.Load.PromptChooseSharedUserToUsePasswordsFrom(mask);
                                break;
                            case 'olPromptLicenceLimitReached':
                                olPage.Content.Divs.Load.PromptLicenceLimitReached(mask);
                                break;
                            case 'olPromptMatter':
                                olPage.Content.Divs.Load.PromptMatter(mask);
                                break;
                            case 'olResourceTimeout':
                                olPage.Content.Divs.Load.ResourceTimeout(mask);
                                break;
                            case 'olToolbar':
                                olPage.Content.Divs.Load.Toolbar(mask);
                                break;
                            case 'olWebControlMessage':
                                olPage.Content.Divs.Load.WebControlMessage(mask);
                                break;
                            default:
                                olPage.Content.Divs._internal.Modal.Open(divIdToOverlay, mask);
                                break;
                        }

                        divIdToOverlay = '';
                        mask = false;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptById', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptChooseApplication: function (mask) {
                    try {
                        //Clear div from existing data if there is anything
                        $('#olChooseApplication').empty();
                        olPage.Content.Divs._internal.PromptChooseApplication._internal.PopulateApplications();

                        olPage.Content.Divs._internal.Modal.Open('olPromptChooseApplication', mask);

                        olPage.Content.Divs._internal.CheckInputs('olPromptChooseApplication');
                        olPage.Content.Divs._internal.EventsForContainerInput('olPromptChooseApplication');

                        var applications_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].Applications;
                        if (!applications_ || applications_.length <= 5) {
                            $("#olPromptChooseApplication .ol-search-container").hide();
                            olPage.Functions.Hide("body #olPromptChooseApplication .ol-search-container");
                        } else {
                            $("#olPromptChooseApplication .ol-search-container").val('');
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptChooseApplication', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptChooseSharedUserToUsePasswordsFrom: function (mask) {
                    try {
                        $('#olChooseSharedUser').empty();
                        olPage.Content.Divs._common.GetSharedUserData();
                        olPage.Content.Divs._internal.Modal.Open('olPromptChooseSharedUserToUsePasswordsFrom', mask);

                        olPage.Content.Divs._internal.CheckInputs('olPromptChooseSharedUserToUsePasswordsFrom');
                        olPage.Content.Divs._internal.EventsForContainerInput('olPromptChooseSharedUserToUsePasswordsFrom');

                        olPage.Content.Divs._internal.AlertPrompt = 'olPromptChooseSharedUserToUsePasswordsFrom';

                        var message_ = '';
                        if (olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser.Title) {
                            message_ = olPage.Functions.GetLanguageItem('JS_CurrentlyUsing') + ': ' + olPage.Content.Divs._internal.PromptChooseSharedUserToUsePasswordsFrom._internal.selectedUser.Title;
                            // $('#olBackToMyDetails').removeAttr('disabled');
                            $('#olBackToMyDetails').show();
                        } else {
                            message_ = olPage.Functions.GetLanguageItem('JS_CurrentlyUsing') + ': ' + olPage.Functions.GetLanguageItem('JS_MyPassword');
                            // $('#olBackToMyDetails').attr('disabled', true);
                            $('#olBackToMyDetails').hide();
                        }
                        olPage.Content.Divs.SetInfoMsg(message_);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptChooseSharedUserToUsePasswordsFrom', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptComment: function (mask) {
                    try {
                        //Clear div from existing data
                        $('#olComments').empty();
                        olPage.Content.Divs._internal.PromptComment._internal.PopulateComments();

                        olPage.Content.Divs._internal.Modal.Open('olPromptComment', mask);

                        olPage.Content.Divs._internal.CheckInputs('olPromptComment');
                        olPage.Content.Divs._internal.EventsForContainerInput('olPromptComment');

                        var comments_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].PredefinedComments;
                        if (comments_.length <= 5) {
                            olPage.Functions.Hide("body #olPromptComment .ol-search-container");
                        } else {
                            $("#olPromptComment .ol-search-container").val('');
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptComment', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLogon: function (mask, shared, userdata) {
                    try {
                        //Clear existing data from div
                        $('#olLogonAccounts').empty();

                        var populateLogons_ = olPage.Content.Divs._internal.PromptLogon._internal.PopulateLogons(null, shared, userdata);
                        if (populateLogons_.showPromptLogon) {
                            olPage.Content.Divs._internal.Modal.Open('olPromptLogon', mask);

                            olPage.Content.Divs._internal.CheckInputs('olPromptLogon');
                            olPage.Content.Divs._internal.EventsForContainerInput('olPromptLogon');

                            if (populateLogons_.showSearchInput) {
                                olPage.Functions.Show('body #olPromptLogon .ol-search-container', 'display:flex !important; visibility: visible !important');
                                $('#olPromptLogon .ol-search-container input').val('');
                            } else {
                                olPage.Functions.Hide('body #olPromptLogon .ol-search-container');
                            }
                        } else {
                            var logonDataWithOutCreateNew_ = [];
                            if (olFunctions.IsFilledArray(populateLogons_.logonData)) {
                                logonDataWithOutCreateNew_ = $.grep(populateLogons_.logonData, function (member) {
                                    return (member.Id != 'olAccountIdNewLogon');
                                })
                            }

                            //Then it means we have at least one logon
                            if (olFunctions.IsFilledArray(logonDataWithOutCreateNew_)) {
                                olPage.Data.PageFlags.LogonDone = true;
                                olPage.Messages.Flags.LogonDone(true);
                            }

                            olPage.Content.Inject();
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptLogon', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLogonDetails: function (mask) {
                    try {
                        olPage.Content.Divs._internal.PromptLogonDetails._internal.PopulateLogonDetails();

                        $('#olPromptLogonDetails .ol-caption-message').on('mouseover', function () {
                            olPage.Content.Divs._internal.Modal._addTitleToElementWithOverflow($(this));
                        });

                        olPage.Content.Divs._internal.Modal.Open('olPromptLogonDetails', mask);
                        if ($('#olTitleData').val() == '') {
                            $('#olTitleData').select().focus();
                        } else {
                            var arrayUP_ = olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayUP;
                            if (olFunctions.IsFilledArray(arrayUP_)) {
                                for (var i = 0; i < arrayUP_.length; i++) {
                                    if (arrayUP_[i].CanBeModified) {
                                        $('#' + arrayUP_[i].Id).select().focus();
                                    }
                                    break;
                                }
                            }
                        }
                        olPage.Content.Divs._internal.CheckInputs('olLogonDetailsFormContainer');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptLogonDetails', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLicenceLimitReached: function (mask) {
                    try {
                        olPage.Content.Divs._internal.Modal.Open('olPromptLicenceLimitReached', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptLicenceLimitReached', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptMatter: function (mask, selectedRow) {
                    try {
                        if (typeof (selectedRow) === 'undefined') {
                            selectedRow = false;
                        }

                        if (selectedRow && olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterNumber) {
                            olPage.Content.Divs.Load._internal.SortMatterDetails(olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterNumber, olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterName);

                            olPage.Content.Divs._internal.PromptMatter._internal.PopulateMatterDropDownList();
                            $('#olNewMatter').val(olPage.Content.Divs._internal.PromptMatterSearch._internal.SelectedMatterNumber);
                        }

                        if (olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse && olFunctions.IsFilledArray(olPage.Data.PageInfo.Response.GetLocalPersonalCodeListResponse.LocalPersonalCodes)) {
                            olPage.Content.Divs.Load._internal.SortTimekeeperDetails();
                            olPage.Content.Divs._internal.PromptMatter._internal.PopulateTimekeeperDropDownList();
                        }

                        var skipMatterDetails_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0].SkipMatterDetails;
                        if (skipMatterDetails_ || olPage.Data.PageFlags.MatterDone) {
                            $('#olImgMatterCancel').show();
                        } else {
                            $('#olImgMatterCancel').hide();
                        }

                        //deselect all lists so change event can fire.
                        olPage.Content.Divs._internal.PromptMatter._internal.UnselectMatterDropDownList();
                        olPage.Content.Divs._internal.PromptMatter._internal.UnselectTimekeeperDropDownList();
                        olPage.Content.Divs._internal.PromptMatter._internal.CheckData();
                        olPage.Content.Divs._internal.Modal.Open('olPromptMatter', mask);

                        olPage.Content.Divs._internal.CheckInputs('olMatterFormContainer');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptMatter', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptMatterSearch: function (mask, selectedMatterNumber) {
                    try {
                        if (typeof (selectedMatterNumber) === 'undefined') {
                            selectedMatterNumber = '';
                        }

                        if (!olPage.Content.Divs._internal.PromptMatterSearch._internal.TableInitialized) {
                            olPage.Content.Divs._internal.PromptMatterSearch._internal.ClearSearchTable();
                        }

                        olPage.Content.Divs._internal.Modal.Open('olPromptMatterSearch', mask);
                        olPage.Content.Divs._internal.EventsForContainerInput('olPromptMatterSearch');

                        //This should be done after event initialization on inputs (focus event is not defined before this)
                        $('#olMatterSearchInp').val(selectedMatterNumber).select().focus();

                        //After value is filled
                        olPage.Content.Divs._internal.CheckInputs('olPromptMatterSearch');
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load PromptMatterSearch', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                AskToStorePassword: function (mask) {
                    try {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olStorePassword') {
                            //disable toolbar buttons during ask for password store
                            olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(true);
                            $('#olToolbarMenu').hide(olOptions.General.Page.TransitionTime());
                            olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;
                            olPage.Content.Divs._internal.Modal.Open('olStorePassword', mask);
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load AskToStorePassword Load', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                ResourceTimeout: function (mask) {
                    try {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != 'olResourceTimeout') {
                            //disable toolbar buttons during resource timeout choosing
                            olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(true);
                            $('#olToolbarMenu').hide(olOptions.General.Page.TransitionTime());
                            olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;

                            var appNameLabel_ = '';
                            var title_ = olPage.Content.Divs._internal.ResourceTimeout._internal.ApplicationName;
                            appNameLabel_ = olPage.Content.Divs._internal.CreateLabels(title_);
                            $('#olResourceName').text(appNameLabel_.Text);
                            if (appNameLabel_.Text != appNameLabel_.Title) {
                                $('#olResourceName').attr('title', appNameLabel_.Title);
                            }

                            olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt = olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt;
                            olPage.Content.Divs._internal.ResourceTimeout._internal._previousMask = olPage.Content.Divs._internal.MaskOn;
                            if (olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt != '') {
                                olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(mask);
                            }
                            olPage.Content.Divs._internal.Modal.Open('olResourceTimeout', mask);


                            olPage.Content.Divs._internal.ResourceTimeout._internal.Timer();
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load ResourceTimeout', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                WebControlMessage: function (mask) {
                    try {
                        //disable toolbar buttons
                        olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(true);
                        $('#olToolbarMenu').hide(olOptions.General.Page.TransitionTime());
                        olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;

                        WebControl.WebControlMessage._internal._previousPrompt = olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt;
                        WebControl.WebControlMessage._internal._previousMask = olPage.Content.Divs._internal.MaskOn;
                        // if (WebControl.WebControlMessage._internal._previousPrompt != '') {
                        //     olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(mask);
                        // }

                        olPage.Content.Divs._internal._maskOpacity = 0.85;
                        olPage.Content.Divs._internal.Modal.Open('olWebControlMessage', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load WebControlMessage', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                Error: function (mask) {
                    try {
                        //disable toolbar buttons during
                        olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(true);
                        $('#olToolbarMenu').hide();
                        olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;

                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt != '') {
                            olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(mask);
                        }
                        olPage.Content.Divs._internal.Modal.Open('olError', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load Error prompt:', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                _toolbarLoaded: false,
                Toolbar: function (mask) {
                    try {
                        olPage.Content.Divs._internal.Toolbar.Enable();
                        olPage.Content.Divs._internal.Modal.Open('olToolbar', mask);
                        olPage.Content.Divs.Load._toolbarLoaded = true;

                        switch (olOptions.General.Page.ToolbarPosition()) {
                            case 0:
                                $('#olToolbar').css({
                                    top: 0,
                                    bottom: '',
                                    left: 0,
                                    right: ''
                                })
                                    .find('.right-side-min, .right-side-max')
                                    .each(function () {
                                        olPage.Functions.Hide(this);
                                    })
                                break;
                            case 1:
                                $('#olToolbar')
                                    .css({
                                        top: '',
                                        bottom: 0,
                                        left: 0,
                                        right: ''
                                    })
                                    .find('.right-side-min, .right-side-max')
                                    .each(function () {
                                        olPage.Functions.Hide(this);
                                    })
                                break;
                            case 2:
                                $('#olToolbar').css({
                                    top: '',
                                    bottom: 0,
                                    left: '',
                                    right: 0
                                })
                                    .find('.left-side-min, .left-side-max')
                                    .each(function () {
                                        olPage.Functions.Hide(this);
                                    })
                                break;
                            case 3:
                                $('#olToolbar').css({
                                    top: 0,
                                    bottom: '',
                                    left: '',
                                    right: 0
                                })
                                    .find('.left-side-min, .left-side-max')
                                    .each(function () {
                                        olPage.Functions.Hide(this);
                                    })
                                break;
                        }

                        switch (olOptions.General.Page.ToolbarWidth()) {
                            case 0:
                                break;
                            case 1:
                                $('#olToolbar').css({
                                    width: '99%'
                                });
                                break;
                        }

                        //on first page appearance olPage.Data.PageFlags.ToolbarMinimized is null and then default setting for toolbar is used
                        if (olPage.Data.PageFlags.ToolbarMinimized == null) {
                            olPage.Data.PageFlags.ToolbarMinimized = olOptions.General.Page.ToolbarMinimized();
                        }

                        switch (olPage.Data.PageFlags.ToolbarMinimized) {
                            case true:
                                $('#olToolbarMaximized').hide();
                                $('#olToolbarMinimized').show();
                                break;
                            case false:
                                $('#olToolbarMinimized').hide();
                                $('#olToolbarMaximized').show();
                                break;
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Load Toolbar', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                }
            },
            Close: {
                _internal: {
                    CloseOverlay: function (divIdToCloseOverlay, mask) {
                        try {
                            var prompt_ = $('#' + divIdToCloseOverlay);
                            prompt_.hide();

                            olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt = '';
                            olPage.Content.Divs._internal.Modal.Close();
                            olPage.Content.Divs._internal.SetMask(mask);
                            olPage.Content.Divs._common.LogonDataArray = null;

                            if (olPage.Content.Divs.Load._toolbarClosed) {
                                olPage.Functions.HideToolbar();
                            }
                        } catch (e) {
                            var alertErrorContent_ = new olFunctions.AlertContent('CloseOverlay', e.message + '\n' + e.stack);
                            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                        }
                    }
                },
                PromptChooseApplication: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptChooseApplication', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptChooseApplication', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptChooseSharedUserToUsePasswordsFrom: function (mask) {
                    try {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olPromptChooseSharedUserToUsePasswordsFrom') {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olPromptChooseSharedUserToUsePasswordsFrom', mask);
                        }
                        olPage.Content.Divs._internal.Toolbar.CloseMenu();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptChooseSharedUserToUsePasswordsFrom', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptComment: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptComment', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptComment', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLogon: function (mask) {
                    try {
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olPromptLogon') {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olPromptLogon', mask);
                        }
                        olPage.Content.Divs._internal.Toolbar.CloseMenu();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptLogon', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLogonDetails: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptLogonDetails', mask);
                        olPage.Content.Divs._internal.EnableElements(olPage.Content.Divs._internal.PromptLogonDetails._internal.ArrayElements);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptLogonDetails', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptLicenceLimitReached: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptLicenceLimitReached', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptLicenceLimitReached', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptMatter: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptMatter', mask);
                        olPage.Content.Divs._internal.Toolbar.CloseMenu();
                        olPage.Content.Divs._internal.PromptMatter._internal.ClearValidatingInterval();
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptMatter', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                PromptMatterSearch: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olPromptMatterSearch', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close PromptMatterSearch', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                AskToStorePassword: function (mask) {
                    try {
                        //enable toolbar buttons
                        olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(false);

                        if (olPage.Content.Divs._internal.AskToStorePassword._internal._previousPrompt != '') {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olStorePassword', olPage.Content.Divs._internal.AskToStorePassword._internal._previousMask);

                            olPage.Content.Divs.Load.PromptById(olPage.Content.Divs._internal.AskToStorePassword._internal._previousPrompt, olPage.Content.Divs._internal.AskToStorePassword._internal._previousMask);
                        } else {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olStorePassword', mask);
                        }
                        olPage.Content.Divs._internal.AskToStorePassword._internal._previousPrompt = '';
                        olPage.Content.Divs._internal.AskToStorePassword._internal._previousMask = false;
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close AskToStorePassword', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                ResourceTimeout: function (mask) {
                    try {
                        //enable toolbar buttons during resource timeout choosing
                        olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(false);
                        if (olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt != '') {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olResourceTimeout', olPage.Content.Divs._internal.ResourceTimeout._internal._previousMask);

                            olPage.Content.Divs.Load.PromptById(olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt, olPage.Content.Divs._internal.ResourceTimeout._internal._previousMask);
                        } else {
                            olPage.Content.Divs.Close._internal.CloseOverlay('olResourceTimeout', mask);
                        }

                        setTimeout(function () {
                            olPage.Content.Divs._internal.ResourceTimeout._internal._previousPrompt = '';
                            olPage.Content.Divs._internal.ResourceTimeout._internal._previousMask = false;

                            olPage.Content.Divs._internal.ResourceTimeout._internal.ClearTitle();
                        }, 150)

                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close ResourceTimeout', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                WebControlMessage: function (mask) {
                    try {
                        olPage.Content.Divs._internal._maskOpacity = 0.7;
                        if (olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt == 'olWebControlMessage') {
                            //enable toolbar buttons
                            olPage.Content.Divs._internal.Toolbar._internal.ToolbarIconsSetDisabled(false);
                            olPage.Content.Divs._internal.Toolbar.Enable();

                            if (WebControl.WebControlMessage._internal._previousPrompt != '') {
                                olPage.Content.Divs.Close._internal.CloseOverlay('olWebControlMessage', olPage.Content.Divs._internal.WebControlMessage._internal._previousMask);
                                olPage.Content.Divs.Load.PromptById(olPage.Content.Divs._internal.WebControlMessage._internal._previousPrompt, WebControl.WebControlMessage._internal._previousMask);
                            } else {
                                olPage.Content.Divs.Close._internal.CloseOverlay('olWebControlMessage', mask);
                            }
                            WebControl.WebControlMessage._internal._previousPrompt = '';
                            WebControl.WebControlMessage._internal._previousMask = false;
                        }
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close WebControlMessage', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                },
                Error: function (mask) {
                    try {
                        olPage.Content.Divs.Close._internal.CloseOverlay('olError', mask);
                    } catch (e) {
                        var alertErrorContent_ = new olFunctions.AlertContent('Close Error prompt', e.message + '\n' + e.stack);
                        olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                    }
                }
            }
        },
        Logout: {
            Flags: {
                _IFrameReady: null,
                // _IterationDone: null,
                _ScriptIndex: null,
                _IFrameLoaded: false
            },
            IFrame: {
                Load: function (url) {
                    olPage.Content.Logout.Flags._IFrameLoaded = false;
                    var iframe_ = document.getElementById('olFrame');

                    //?????
                    // var tmpSrc_;
                    // if (url.indexOf("?") != -1) {
                    //     tmpSrc_ = url + '&onelog="' + fakeParam + '"';
                    // } else {
                    //     tmpSrc_ = url + '?onelog="' + fakeParam + '"';
                    // }
                    // iframe_.contentWindow.location.href = tmpSrc_;

                    iframe_.contentWindow.location.href = url;
                    return true;
                }
            },
            _iOlFrame: null,
            ProcessCurrentScript: function () {
                var currentScript_ = olPage.Content.Logout.Flags._closingResponses.LogoutScript[olPage.Content.Logout.Flags._ScriptIndex];
                var closingResponses_ = olPage.Content.Logout.Flags._closingResponses;
                // var applicationName_ = closingResponses_.ApplicationName;
                var applicationSessionId_ = closingResponses_.ApplicationSessionId;
                // var lastSessionWindow_ = closingResponses_.LastSessionWindow;
                // var lastSessionWindowSpecified_ = closingResponses_.LastSessionWindowSpecified;
                var lastURL_ = closingResponses_.LastURL;

                var type_ = '';

                if (currentScript_.ClickLink) {
                    type_ = 'ClickLink';
                } else if (currentScript_.Form) {
                    type_ = 'Form';
                } else if (currentScript_.GoToURL) {
                    type_ = 'GoToURL';
                }
                $('iframe').each(function (i, frame_) {
                    if (frame_.id == 'olFrame') {
                        olPage.Content.Logout._iOlFrame = frame_.contentDocument ? frame_.contentDocument : frame_.contentWindow.document;
                    }
                });

                // contain all inspections to olFrame document
                olInjection.ElementValue.SetDocuments(olPage.Content.Logout._iOlFrame);

                switch (type_) {
                    case 'ClickLink':
                        var match_ = currentScript_.ClickLink.Match;
                        var elements_ = new Array();

                        for (var l = 0; l < olInjection.ElementValue._internal.Documents.length; l++) {
                            var allElements_ = olInjection.ElementValue._internal.Documents[l].getElementsByTagName('*');

                            for (var m = 0; m < allElements_.length; m++) {
                                if (allElements_[m].outerHTML.indexOf(match_) !== -1) {
                                    elements_.push(allElements_[m]);
                                }
                            }
                        }
                        for (var i = elements_.length - 1; i >= 0; i--) {
                            try {
                                elements_[i].click();
                            } catch (e) {
                                var alertErrorContent_ = new olFunctions.AlertContent('ClickLink', e.message + '\n' + e.stack);
                                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                            }
                        }
                        break;
                    case 'Form':
                        var currentForm_ = currentScript_.Form;

                        if (olFunctions.IsFilledArray(currentForm_.URL)) {
                            for (var j = 0; j < currentForm_.URL.length; j++) {
                                if (lastURL_.toLowerCase().indexOf(currentForm_.URL[j].toLowerCase()) >= 0) {
                                    var formAccessType_ = null;
                                    var formAccessParam_ = null;

                                    if (currentForm_.UseForm) {
                                        formAccessType_ = olDictionaries.Dictionaries.FormAccessType(currentForm_.Id, currentForm_.Name, currentForm_.IndexSpecified);
                                        switch (formAccessType_) {
                                            case 'byIndex':
                                                formAccessParam_ = currentForm_.Index;
                                                break;
                                            case 'byID':
                                                formAccessParam_ = currentForm_.Id;
                                                break;
                                            case 'byName':
                                                formAccessParam_ = currentForm_.Name;
                                                break;
                                        }
                                    }

                                    if (olFunctions.IsFilledArray(currentForm_.Elements)) {
                                        //click elements
                                        for (var k = 0; k < currentForm_.Elements.length; k++) {
                                            var currentElement_ = currentForm_.Elements[k];
                                            var elElementType_ = olDictionaries.Dictionaries.ElElementType(currentElement_.ElementTypeSpecified, currentElement_.ElementType);
                                            var elAccessType_ = olDictionaries.Dictionaries.ElAccessType(currentElement_.Id, currentElement_.Name, currentElement_.IndexSpecified);
                                            var elCustomTagName_ = currentElement_.TagName;

                                            var elAccessParam_ = null;
                                            switch (elAccessType_) {
                                                case 'byIndex':
                                                    elAccessParam_ = currentElement_.Index;
                                                    break;
                                                case 'byID':
                                                    elAccessParam_ = currentElement_.Id;
                                                    break;
                                                case 'byName':
                                                    elAccessParam_ = currentElement_.Name;
                                                    break;
                                            }

                                            olInjection.ElementValue.Click(elAccessParam_, elAccessType_, currentElement_.Instance, elElementType_, elCustomTagName_, formAccessParam_, formAccessType_);
                                        }
                                    }
                                    break;
                                }
                            }
                        }
                        break;
                    case 'GoToURL':
                        var gotoUrl = currentScript_.GoToURL;
                        if (gotoUrl && gotoUrl.charAt(0) == '~') {
                            gotoUrl = olFunctions.GetDomainFromUrlWithProtocol(lastURL_) + gotoUrl.substring(1);
                        }
                        olPage.Content.Logout.IFrame.Load(gotoUrl);
                        break;
                    default:
                        break;
                }
            },
            NewIteration: function () {
                try {
                    olPage.Content.Logout.Flags._ScriptIndex++;
                    if (olPage.Content.Logout.Flags._closingResponses.LogoutScript[olPage.Content.Logout.Flags._ScriptIndex]) {
                        try {
                            olPage.Content.Logout.ProcessCurrentScript();
                        } catch (e) {
                            olPage.Messages.LogoutSequenceCompleted(olPage.Content.Logout.Flags._closingResponses.ApplicationSessionId);
                            if (!olOptions.DebugApiMess()) {
                                // if not debugging close tab immediately
                                olPage.Messages.CloseTab(10);
                            }
                        }
                    } else {
                        olPage.Messages.LogoutSequenceCompleted(olPage.Content.Logout.Flags._closingResponses.ApplicationSessionId);
                        if (!olOptions.DebugApiMess()) {
                            // if not debugging close tab immediately                            
                            olPage.Messages.CloseTab(10);
                        }
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('NewIteration', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            },
            ProcessLogoutSequence: function (closingResponses) {
                try {
                    if (closingResponses.LogoutScript && olFunctions.IsFilledArray(closingResponses.LogoutScript)) {

                        //olPage.Content.Divs._internal.Modal._$backup.append('<iframe id="olFrame" sandbox="allow-same-origin allow-scripts allow-popups allow-forms" width=500 height=500 frameborder=0 marginheight=0 marginwidth=0 scrolling=no ></iframe>');
                        $('html').append('<iframe id="olFrame" sandbox="allow-same-origin allow-scripts allow-popups allow-forms" width=500 height=500 frameborder=0 marginheight=0 marginwidth=0 scrolling=no ></iframe>');

                        olPage.Content.Logout.Flags._ScriptIndex = -1;
                        olPage.Content.Logout.Flags._closingResponses = closingResponses;

                        $('iframe#olFrame').on('load', function (event) {
                            event.preventDefault();
                            event.stopPropagation();
                            event.stopImmediatePropagation();
                            olPage.Content.Logout.NewIteration();
                        });

                        var lastURL_ = olPage.Content.Logout.Flags._closingResponses.LastURL;
                        olPage.Content.Logout.IFrame.Load(lastURL_);
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('ProcessLogoutSequence', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            }
        },
        _initializeAttachEventsWithTimeoutsDone: false,
        AttachEventsWithTimeouts: function () {
            if (!olPage.Content._initializeAttachEventsWithTimeoutsDone) {
                olPage.Content._initializeAttachEventsWithTimeoutsDone = true;
                olPage.Content.AttachEvents();
                olPage.Content.FormFillMode();
                olPage.intervalID = setInterval(function () {
                    if (olPage.Data.PageInfo) {
                        olPage.Content.AttachEvents();
                        olPage.Content.FormFillMode();
                    }
                }, 1000);
                setTimeout(function () {
                    clearInterval(olPage.intervalID);
                }, 15000);
            }
        },
        AttachEvents: function (attachEventsObject, bAnalysis, feature) {
            // var alertContent_ = new olFunctions.AlertContent('AttachEvents', 'Page function');
            // olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
            if (typeof (attachEventsObject) === 'undefined')
                attachEventsObject = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];

            if (typeof (bAnalysis) === 'undefined')
                bAnalysis = false;

            if (typeof (feature) === 'undefined')
                feature = [];

            var attachEvents_ = attachEventsObject.AttachEvents;
            if (olFunctions.IsFilledArray(attachEvents_)) {
                for (var i = 0; i < attachEvents_.length; i++) {
                    var urls_ = [];
                    if (bAnalysis) {
                        urls_ = attachEventsObject.URLS;
                    } else {
                        urls_ = attachEvents_[i].URLs;
                    }
                    if (olFunctions.CheckUrls(urls_)) {
                        var elements_ = attachEvents_[i].Elements;
                        if (olFunctions.IsFilledArray(elements_)) {
                            for (var k = 0; k < elements_.length; k++) {
                                var currentElement_ = elements_[k];
                                var elElementType_ = olDictionaries.Dictionaries.ElElementType(currentElement_.ElementTypeSpecified, currentElement_.ElementType);
                                var elAccessType_ = olDictionaries.Dictionaries.ElAccessType(currentElement_.Id, currentElement_.Name, currentElement_.IndexSpecified);
                                var elCustomTagName_ = currentElement_.TagName;
                                var elAttributes_ = currentElement_.Attributes;
                                var elAttachEvents_ = currentElement_.AttachEvents;
                                var elAccessParam_ = null;

                                switch (elAccessType_) {
                                    case 'byIndex':
                                        elAccessParam_ = currentElement_.Index;
                                        break;
                                    case 'byID':
                                        elAccessParam_ = currentElement_.Id;
                                        break;
                                    case 'byName':
                                        elAccessParam_ = currentElement_.Name;
                                        break;
                                }
                                if (elAccessType_ != 'other') {
                                    olInjection.ElementValue.AttachEvent(elAccessParam_, elAccessType_, currentElement_.Instance, elElementType_, elCustomTagName_, null, null, elAttachEvents_, bAnalysis, feature);
                                } else {
                                    //other
                                    //checking attributes
                                    if (olFunctions.IsFilledArray(elAttributes_)) {
                                        for (var l = 0; l < elAttributes_.length; l++) {
                                            if (elAttributes_[l].IsMatch) {
                                                for (var m = 0; m < olInjection.ElementValue._internal.Documents.length; m++) {
                                                    var currentDocument_ = olInjection.ElementValue._internal.Documents[m];
                                                    $(currentDocument_).find("[" + elAttributes_[l].Name + "*='" + elAttributes_[l].Value + "']").each(function (i) {
                                                        if (olFunctions.IsFilledArray(elAttachEvents_)) {
                                                            for (var m = 0; m < elAttachEvents_.length; m++) {
                                                                if (bAnalysis) {
                                                                    olInjection.BindElementsForAnalysis(this, elAttachEvents_[m], feature);
                                                                } else {
                                                                    olInjection.BindElementsWithTimeout(this, elAttachEvents_[m]);
                                                                }
                                                            }
                                                        } else {
                                                            olInjection.BindElementsWithTimeout(this, 'click');
                                                        }
                                                    });
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        break;
                    }
                }
            }
        },
        FormFillMode: function () {
            var beforeNavigateResponse_ = olPage.Data.PageInfo.Response.BeforeNavigateResponses[0];
            if (beforeNavigateResponse_.FormFillMode && beforeNavigateResponse_.FormFillMode == 1) {
                // var alertContent_ = new olFunctions.AlertContent('FormFillMode', 'Page function');
                // olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                //attach globally... don't know if this is good enough
                $("[src]").each(function (i) {
                    olInjection.BindElementsWithTimeout(this, 'load');
                });
                $('iframe').each(function (j) {
                    olInjection.BindElementsWithTimeout(this, 'load');
                });
                $('frame').each(function (j) {
                    olInjection.BindElementsWithTimeout(this, 'load');
                });
                $("[href]").each(function (i) {
                    olInjection.BindElementsWithTimeout(this, 'click');
                });

                setTimeout(function () {
                    if (!olInjection.ElementValue._internal.ElementValueSet) {
                        olPage.Content.Inject();
                    }
                }, 3000);

                setTimeout(function () {
                    if (!olInjection.ElementValue._internal.ElementValueSet) {
                        olPage.Content.Inject();
                    }
                }, 5000);
            }
        },
        count: 0,
        ProcessPage: function () {
            try {
                var alertContent_ = new olFunctions.AlertContent('ProcessPage', 'Page function');
                olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);
                if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                    olPage.Content.Modules.InitializeModulesArray();
                    try {
                        Analysis.ActivateAnalysis(olPage);
                        WebControl.ActivateWebControl(olPage);
                        olPage.Content.Modules.ActivateResource();
                        olPage.Content.Modules.ProcessModules();
                    } catch (error) {
                        // This is only for start of the page content
                        // after multiple tries on inject this will work
                        // Analysis or WebControl sometimes are not defined
                    }
                }
            } catch (e) {
                var alertErrorContent_ = new olFunctions.AlertContent('ProcessPage', e.message + '\n' + e.stack);
                olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
            }
        },
        Inject: function () {
            // ON-1093
            if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                document.indexJSDone = {};
                olPage.Content._internal.PrepareInjectionParameters();
                if (olPage.Content._internal.CheckAllForInjection()) {
                    olPage.Content._internal.SetMatterVariables();

                    olPage.Content._internal.SetToolbarDetails();
                    olInjection.InjectElements(document);
                    // olPage.Messages.UpdateResponse();

                    //Send message to extension to insert data into subframes
                    if (olPage.Data.PageFlags.ProcessSubframes) {
                        olPage.Messages.InsertIntoSubframes(olInjection.Parameters)
                    }
                }
            }
        }
    },
    _optionsInitialized: false,
    Initialize: function () {
        try {
            //Initialize options
            olOptions.InitializeOptionsData(function () {
                try {
                    //data initialization
                    olData.Initialize();

                    var alertContent_ = new olFunctions.AlertContent('olPage.Initialize !START!', 'Page function');
                    olFunctions.Alert(olOptions.DebugFunctions(), alertContent_);

                    //Setting up environment
                    olPage.Data.LocalPageFlags.SubframeEnviroment = (window.self !== window.top);
                    olPage.Data.LocalPageFlags.DocumentURI = document.documentURI;
                    olInjection.ElementValue._internal.Documents.push(document);
                    //Initialize initial href of the page
                    olPage.currentLocation = window.location.href;

                    //Initialize title of the page for resource timeout
                    olPage.Content.Divs._internal.ResourceTimeout._internal.originalPageTitle = document.title

                    //Initialize options on page
                    olOptions.InitializeOptionNameValueArray();

                    if (!olPage.Data.LocalPageFlags.SubframeEnviroment) {
                        olPage.Content.Divs._internal.Modal.Initialize();
                        //Inject misc
                        olPage.Content.HtmlAppends.AddMisc();
                    }
                } catch (e) {
                    var alertErrorContent_ = new olFunctions.AlertContent('Initialize', e.message + '\n' + e.stack);
                    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
                }
            });
        } catch (e) {
            var alertErrorContent_ = new olFunctions.AlertContent('Initialize', e.message + '\n' + e.stack);
            olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
        }
    },
    PageReset: function () {
        olInjection.InjectionHappened = false;
        olInjection.Parameters.ElementsWithFiredEvents = [];
        olInjection.ElementValue._internal.SetTimeoutForInjectElements = false;
        olPage.Content.Modules._internal.NeededModulesArray = [];
        olPage.Content.Modules._internal._processOngoing = false;
        olPage.Content.Divs._internal.MaskOn = false;
        olPage.Content.Divs._internal._maskOpacity = 0.7;
        olPage.Content.Divs._internal.AlertPrompt = '';

        try {
            WebControl._pageBlocked = false;
            WebControl._processWebControlNeeded = false;
            WebControl._currentWebRuleIndex = 0;
            WebControl._shownWebRulesMessagesArray = [];
        } catch (error) {

        }

        try {
            Analysis._processPageAnalysisNeeded = false;
            Analysis.FeaturesArray = false;
        } catch (error) {

        }

        olPage.Content.Modules._internal.Resource._processResourceNeeded = false;
        olPage.Content.Divs._internal.ResourceTimeout._internal.ResourceTimeoutStartTime = null;

        olPage.Content.Divs._internal.Toolbar._internal.CloseCurrentPrompt(false);
        olPage.Content.Divs._internal.Toolbar.CloseMenu();
        olPage.Content.Divs._internal.Toolbar.Disable();
        olPage.Content.Divs._internal.Toolbar._internal.MenuOpened = false;
        olPage.Content.Divs._internal.Toolbar._internal.ChromeInvertedTime = null;

        olPage.Content.Divs._internal.Toolbar._internal.CurrentPrompt = '';
        $('#olPromptLogonDetails').data('InitialPrompt', true);
        olPage.Data.PageInfo = null;
    }
};

/**
 *  one time page content initialization
 */
try {
    olPage.Initialize();
} catch (e) {
    var alertErrorContent_ = new olFunctions.AlertContent('Page initialization error:', e.message + '\n' + e.stack);
    olFunctions.Alert(olOptions.Errors(), alertErrorContent_, 'error');
}
